Package: hydroGOF
Type: Package
Title: Goodness-of-Fit Functions for Comparison of Simulated and
        Observed Hydrological Time Series
Version: 0.7-0
Authors@R: c( person("Mauricio Zambrano-Bigiarini", email = "mzb.devel@gmail.com", role=c("aut", "cre", "cph"), comment=c(ORCID = "0000-0002-9536-643X")) )
Maintainer: Mauricio Zambrano-Bigiarini <mzb.devel@gmail.com>
Description: S3 functions implementing both statistical and graphical goodness-of-fit measures between observed and simulated values, mainly oriented to be used during the calibration, validation, and application of hydrological models. Missing values in observed and/or simulated values can be removed before computations. Comments / questions / collaboration of any kind are very welcomed.
License: GPL (>= 2)
Depends: R (>= 2.10.0), zoo (>= 1.7-2)
Imports: hydroTSM (>= 0.8-6), xts (>= 0.8-2), methods, stats
Suggests: knitr, rmarkdown, testthat
VignetteBuilder: knitr
URL: https://hzambran.github.io/hydroGOF/,
        https://github.com/hzambran/hydroGOF,
        https://CRAN.R-project.org/package=hydroGOF
MailingList: https://stat.ethz.ch/mailman/listinfo/r-sig-ecology
BugReports: https://github.com/hzambran/hydroGOF/issues
LazyLoad: yes
NeedsCompilation: no
Repository: CRAN
Packaged: 2026-04-30 19:52:31 UTC; hzambran
Author: Mauricio Zambrano-Bigiarini [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0002-9536-643X>)
Date/Publication: 2026-05-01 05:10:38 UTC
Built: R 4.6.0; ; 2026-05-01 21:29:12 UTC; unix

import(methods)
importFrom("grDevices", "xy.coords")
importFrom("graphics", "Axis", "abline", "axis", "barplot", "box", "grid", "layout", "legend", "lines", "par", "plot", "plot.new", "points", "polygon", "hist")
importFrom("stats", "coefficients", "cor", "lm", "sd", "time", "window", "na.omit", "median", "quantile", "start", "end", "density")
importFrom("xts", .index, periodicity, axTicksByTime)
importFrom("zoo", is.zoo, as.zoo, coredata, plot.zoo, "time<-", "merge.zoo", "MATCH")
importFrom("hydroTSM", sfreq, vector2zoo, daily2monthly, daily2annual, monthly2annual, dm2seasonal, drawTimeAxis, time2season, seasonalfunction, fdc, fdc.default, fdc.zoo, fdc.matrix, fdc.data.frame, shiftyears)

exportPattern("^[^\\.]")

S3method(KGE, data.frame) 
S3method(KGE, default) 
S3method(KGE, matrix) 
S3method(KGE, zoo) 
S3method(KGElf, data.frame) 
S3method(KGElf, default) 
S3method(KGElf, matrix) 
S3method(KGElf, zoo) 
S3method(sKGE, data.frame) 
S3method(sKGE, default) 
S3method(sKGE, matrix) 
S3method(sKGE, zoo) 
S3method(KGEnp, data.frame) 
S3method(KGEnp, default) 
S3method(KGEnp, matrix) 
S3method(KGEnp, zoo) 
S3method(KGEkm, data.frame) 
S3method(KGEkm, default) 
S3method(KGEkm, matrix) 
S3method(KGEkm, zoo) 
S3method(NSE, data.frame)
S3method(NSE, default) 
S3method(NSE, matrix) 
S3method(NSE, zoo) 
S3method(VE, data.frame)
S3method(VE, default) 
S3method(VE, matrix) 
S3method(VE, zoo) 
S3method(APFB, data.frame) 
S3method(APFB, default) 
S3method(APFB, matrix) 
S3method(APFB, zoo)
S3method(HFB, data.frame) 
S3method(HFB, default) 
S3method(HFB, matrix) 
S3method(HFB, zoo)  
S3method(br2, data.frame) 
S3method(br2, default) 
S3method(br2, matrix)
S3method(br2, zoo) 
S3method(cp, data.frame) 
S3method(cp, default) 
S3method(cp, matrix) 
S3method(cp, zoo) 
S3method(d, data.frame)
S3method(d, default) 
S3method(d, matrix) 
S3method(d, zoo) 
S3method(dr, data.frame)
S3method(dr, default) 
S3method(dr, matrix) 
S3method(dr, zoo) 
S3method(gof, data.frame) 
S3method(gof, default) 
S3method(gof, matrix) 
S3method(gof, zoo)
S3method(mNSE, data.frame) 
S3method(mNSE, default) 
S3method(mNSE, matrix) 
S3method(mNSE, zoo) 
S3method(mae, data.frame)
S3method(mae, default) 
S3method(mae, matrix) 
S3method(mae, zoo) 
S3method(md, data.frame) 
S3method(md, default) 
S3method(md, matrix)
S3method(md, zoo) 
S3method(me, data.frame) 
S3method(me, default) 
S3method(me, matrix) 
S3method(me, zoo) 
S3method(mse, data.frame)
S3method(mse, default) 
S3method(mse, matrix) 
S3method(mse, zoo) 
S3method(nrmse, data.frame) 
S3method(nrmse, default)
S3method(nrmse, matrix) 
S3method(nrmse, zoo) 
S3method(pbias, data.frame) 
S3method(pbias, default) 
S3method(pbias, matrix)
S3method(pbias, zoo) 
S3method(pbiasfdc, data.frame) 
S3method(pbiasfdc, default) 
S3method(pbiasfdc, matrix)
S3method(pbiasfdc, zoo) 
S3method(pfactor, data.frame) 
S3method(pfactor, default)
S3method(pfactor, matrix)
S3method(rNSE, data.frame) 
S3method(rNSE, default) 
S3method(rNSE, matrix) 
S3method(rNSE, zoo) 
S3method(R2, data.frame)
S3method(R2, default) 
S3method(R2, matrix)
S3method(R2, zoo) 
S3method(rPearson, data.frame)
S3method(rPearson, default) 
S3method(rPearson, matrix)
S3method(rPearson, zoo) 
S3method(rSD, data.frame)
S3method(rSD, default) 
S3method(rSD, matrix) 
S3method(rSD, zoo) 
S3method(rSpearman, data.frame)
S3method(rSpearman, default) 
S3method(rSpearman, matrix)
S3method(rSpearman, zoo) 
S3method(rd, data.frame) 
S3method(rd, default) 
S3method(rd, matrix)
S3method(rd, zoo) 
S3method(rfactor, data.frame) 
S3method(rfactor, default) 
S3method(rfactor, matrix)
S3method(rmse, data.frame) 
S3method(rmse, default) 
S3method(rmse, matrix) 
S3method(rmse, zoo) 
S3method(rsr, data.frame)
S3method(rsr, default) 
S3method(rsr, matrix) 
S3method(rsr, zoo) 
S3method(ssq, data.frame) 
S3method(ssq, default) 
S3method(ssq, matrix)
S3method(ssq, zoo)
S3method(ubRMSE, data.frame) 
S3method(ubRMSE, default)
S3method(ubRMSE, matrix) 
S3method(ubRMSE, zoo) 
S3method(valindex, default) 
S3method(valindex, matrix)
S3method(wsNSE, data.frame) 
S3method(wsNSE, default) 
S3method(wsNSE, matrix) 
S3method(wsNSE, zoo) 
S3method(wNSE, data.frame) 
S3method(wNSE, default) 
S3method(wNSE, matrix) 
S3method(wNSE, zoo) 
S3method(PMR, data.frame)
S3method(PMR, default) 
S3method(PMR, matrix) 
S3method(PMR, zoo) 
S3method(JDKGE, data.frame)
S3method(JDKGE, default) 
S3method(JDKGE, matrix) 
S3method(JDKGE, zoo) 
S3method(LME, data.frame)
S3method(LME, default) 
S3method(LME, matrix) 
S3method(LME, zoo) 
S3method(LCE, data.frame)
S3method(LCE, default) 
S3method(LCE, matrix) 
S3method(LCE, zoo) 

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)

## ----installation1, eval=FALSE------------------------------------------------
# install.packages("hydroGOF")

## ----installation2, eval=FALSE------------------------------------------------
# if (!require(devtools)) install.packages("devtools")
# library(devtools)
# install_github("hzambran/hydroGOF")

## ----LoadingPkg---------------------------------------------------------------
library(hydroGOF)

## ----Example1-----------------------------------------------------------------
obs <- 1:10
sim <- 1:10
NSE(sim, obs)

obs <- 1:10
sim <- 2:11
NSE(sim, obs)

## ----Example2-----------------------------------------------------------------
obs <- 1:10 + 0.1
sim <- 1:10 +0.1
NSE(sim, obs)

obs <- 1:10 + 0.1
sim <- 2:11 + 0.1
NSE(sim, obs)

## ----Example3-Loading---------------------------------------------------------
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

## ----Example3-1---------------------------------------------------------------
sim <- obs 

## ----Example3-2, fig.width=8, fig.height=5------------------------------------
ggof(sim, obs)

## ----Example3-3---------------------------------------------------------------
NSE(sim=sim, obs=obs)

## ----Example4-1, fig.width=8, fig.height=5------------------------------------
sim[1:1826] <- obs[1:1826] + rnorm(1826, mean=10)
ggof(sim, obs)

NSE(sim=sim, obs=obs)

## ----Example4-2, fig.width=8, fig.height=5------------------------------------
mNSE(sim=sim, obs=obs)                 # Modified NSE
rNSE(sim=sim, obs=obs)                 # Relative NSE
wNSE(sim=sim, obs=obs)                 # Weighted NSE
wsNSE(sim=sim, obs=obs)                # Weighted Seasonal NSE

KGE(sim=sim, obs=obs)                  # Kling-Gupta efficiency (KGE), 2009
KGE(sim=sim, obs=obs, method="2012")   # Kling-Gupta efficiency (KGE), 2012
KGE(sim=sim, obs=obs, method="2021")   # Kling-Gupta efficiency (KGE), 2021
KGElf(sim=sim, obs=obs)                # KGE for low flows
KGEnp(sim=sim, obs=obs)                # Non-parametric KGE
sKGE(sim=sim, obs=obs)                 # Split KGE
KGEkm(sim=sim, obs=obs)                # Knowable Moments KGE
JDKGE(sim=sim, obs=obs)                # Joint Divergence KGE

d(sim=sim, obs=obs)                    # Index of Agreement
dr(sim=sim, obs=obs)                   # Refined Index of Agreement
md(sim=sim, obs=obs)                   # Modified Index of Agreement
rd(sim=sim, obs=obs)                   # Relative Index of Agreement

VE(sim=sim, obs=obs)                   # Volumetric Efficiency
cp(sim=sim, obs=obs)                   # Coefficient of Persistence
APFB(sim=sim, obs=obs)                 # Annual Peak Flow Bias
HFB(sim=sim, obs=obs)                  # High Flow Bias
LME(sim=sim, obs=obs)                  # Liu-Mean Efficiency
LCE(sim=sim, obs=obs)                  # Lee and Choi Efficiency
PMR(sim=sim, obs=obs)                  # Proxy for Model Robustness

pbias(sim=sim, obs=obs)                # Percent bias (PBIAS)
pbiasfdc(sim=sim, obs=obs)             # PBIAS in the slope of the midsegment of the FDC

me(sim=sim, obs=obs)                   # Mean Error
mae(sim=sim, obs=obs)                  # Mean Absolute Error
mse(sim=sim, obs=obs)                  # Mean Squared Error 
rmse(sim=sim, obs=obs)                 # Root Mean Square Error (RMSE)
ubRMSE(sim=sim, obs=obs)               # Unbiased RMSE
nrmse(sim=sim, obs=obs, norm="sd")     # Normalised Root Mean Square Error
nrmse(sim=sim, obs=obs, norm="maxmin") # Normalised Root Mean Square Error
nrmse(sim=sim, obs=obs, norm="mean")   # Normalised Root Mean Square Error
nrmse(sim=sim, obs=obs, norm="IQR")    # Normalised Root Mean Square Error

rPearson(sim=sim, obs=obs)             # Pearson correlation coefficient
rSpearman(sim=sim, obs=obs)            # Spearman rank correlation coefficient
R2(sim=sim, obs=obs)                   # Coefficient of determination (R2)
br2(sim=sim, obs=obs)                  # R2 multiplied by the slope of the regression line

## ----Example5-1---------------------------------------------------------------
NSE(sim=sim, obs=obs, fun=log)

## ----Example5-2---------------------------------------------------------------
lsim <- log(sim)
lobs <- log(obs)
NSE(sim=lsim, obs=lobs)

## ----Example5-3, fig.width=8, fig.height=5------------------------------------
mNSE(sim=sim, obs=obs)                 # Modified NSE
rNSE(sim=sim, obs=obs)                 # Relative NSE
wNSE(sim=sim, obs=obs)                 # Weighted NSE
wsNSE(sim=sim, obs=obs)                # Weighted Seasonal NSE

KGE(sim=sim, obs=obs)                  # Kling-Gupta efficiency (KGE), 2009
KGE(sim=sim, obs=obs, method="2012")   # Kling-Gupta efficiency (KGE), 2012
KGE(sim=sim, obs=obs, method="2021")   # Kling-Gupta efficiency (KGE), 2021
KGElf(sim=sim, obs=obs)                # KGE for low flows
KGEnp(sim=sim, obs=obs)                # Non-parametric KGE
sKGE(sim=sim, obs=obs)                 # Split KGE
KGEkm(sim=sim, obs=obs)                # Knowable Moments KGE
JDKGE(sim=sim, obs=obs)                # Joint Divergence KGE

d(sim=sim, obs=obs)                    # Index of Agreement
dr(sim=sim, obs=obs)                   # Refined Index of Agreement
md(sim=sim, obs=obs)                   # Modified Index of Agreement
rd(sim=sim, obs=obs)                   # Relative Index of Agreement

VE(sim=sim, obs=obs)                   # Volumetric Efficiency
cp(sim=sim, obs=obs)                   # Coefficient of Persistence
APFB(sim=sim, obs=obs)                 # Annual Peak Flow Bias
HFB(sim=sim, obs=obs)                  # High Flow Bias
LME(sim=sim, obs=obs)                  # Liu-Mean Efficiency
LCE(sim=sim, obs=obs)                  # Lee and Choi Efficiency
PMR(sim=sim, obs=obs)                  # Proxy for Model Robustness

pbias(sim=sim, obs=obs)                # Percent bias (PBIAS)
pbiasfdc(sim=sim, obs=obs)             # PBIAS in the slope of the midsegment of the FDC

me(sim=sim, obs=obs)                   # Mean Error
mae(sim=sim, obs=obs)                  # Mean Absolute Error
mse(sim=sim, obs=obs)                  # Mean Squared Error 
rmse(sim=sim, obs=obs)                 # Root Mean Square Error (RMSE)
ubRMSE(sim=sim, obs=obs)               # Unbiased RMSE
nrmse(sim=sim, obs=obs, norm="sd")     # Normalised Root Mean Square Error
nrmse(sim=sim, obs=obs, norm="maxmin") # Normalised Root Mean Square Error
nrmse(sim=sim, obs=obs, norm="mean")   # Normalised Root Mean Square Error
nrmse(sim=sim, obs=obs, norm="IQR")    # Normalised Root Mean Square Error

rPearson(sim=sim, obs=obs)             # Pearson correlation coefficient
rSpearman(sim=sim, obs=obs)            # Spearman rank correlation coefficient
R2(sim=sim, obs=obs)                   # Coefficient of determination (R2)
br2(sim=sim, obs=obs)                  # R2 multiplied by the slope of the regression line

## ----Example6-1---------------------------------------------------------------
NSE(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012")

## ----Example6-2---------------------------------------------------------------
eps  <- mean(obs, na.rm=TRUE)/100
lsim <- log(sim+eps)
lobs <- log(obs+eps)
NSE(sim=lsim, obs=lobs)

## ----Example6-3---------------------------------------------------------------
gof(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012", do.spearman=TRUE, do.pbfdc=TRUE, do.pmr=TRUE)

## ----Example7-1---------------------------------------------------------------
eps <- 0.01
NSE(sim=sim, obs=obs, fun=log, epsilon.type="otherValue", epsilon.value=eps)

## ----Example7-2---------------------------------------------------------------
lsim <- log(sim+eps)
lobs <- log(obs+eps)
NSE(sim=lsim, obs=lobs)

## ----Example7-3---------------------------------------------------------------
gof(sim=sim, obs=obs, fun=log, epsilon.type="otherValue", epsilon.value=eps, do.spearman=TRUE, do.pbfdc=TRUE, do.pmr=TRUE)

## ----Example8-1---------------------------------------------------------------
fact <- 1/50
NSE(sim=sim, obs=obs, fun=log, epsilon.type="otherFactor", epsilon.value=fact)

## ----Example8-2---------------------------------------------------------------
fact <- 1/50
eps  <- fact*mean(obs, na.rm=TRUE)
lsim <- log(sim+eps)
lobs <- log(obs+eps)
NSE(sim=lsim, obs=lobs)

## ----Example8-3---------------------------------------------------------------
gof(sim=sim, obs=obs, fun=log, epsilon.type="otherFactor", epsilon.value=fact, do.spearman=TRUE, do.pbfdc=TRUE, do.pmr=TRUE)

## ----Example9-1---------------------------------------------------------------
fun1 <- function(x) {sqrt(x+1)}
NSE(sim=sim, obs=obs, fun=fun1)

## ----Example9-2---------------------------------------------------------------
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
NSE(sim=sim1, obs=obs1)

## ----Example9-3---------------------------------------------------------------
gof(sim=sim, obs=obs, fun=fun1, do.spearman=TRUE, do.pbfdc=TRUE, do.pmr=TRUE)

## ----LoadingEgaEnEstellaQts---------------------------------------------------
require(zoo)
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

## ----SettingSim---------------------------------------------------------------
sim <- obs 

## ----ggof-default1, fig.width=8, fig.height=5---------------------------------
ggof(sim, obs)

## ----ggof-userdefined1, fig.width=8, fig.height=5-----------------------------
ggof(sim, obs, 
     gofs=c( "PBIAS", "dr", "R2",  "NSE", "KGE",  "LCE", "JDKGE", "APFB", "HFB"))

## ----ComputingGOFs------------------------------------------------------------
gof(sim=sim, obs=obs, do.spearman=TRUE, do.pbfdc=TRUE, do.pmr=TRUE)

## ----AddingNoiseToSim---------------------------------------------------------
sim[1:1826] <- obs[1:1826] + rnorm(1826, mean=10)

## ----ggof-default2, fig=TRUE, pdf=TRUE, eps=FALSE, fig.width=10, fig.height=7----
ggof(sim=sim, obs=obs, ftype="dm", FUN=mean)

## ----ggof-userdefined2, fig.width=8, fig.height=5-----------------------------
ggof(sim=sim, obs=obs, ftype="dm", FUN=mean,
     gofs=c( "PBIAS", "dr", "R2",  "NSE", "KGE",  "LCE", "JDKGE", "APFB", "HFB"))

## ----ggof2, fig=TRUE, pdf=TRUE, eps=FALSE, fig.width=10, fig.height=7---------
ggof(sim=sim, obs=obs, ftype="dm", FUN=mean, cal.ini="1963-01-01")

## ----ComputingGOF-------------------------------------------------------------
sim <- window(sim, start="1963-01-01")
obs <- window(obs, start="1963-01-01")

gof(sim, obs)

## ----ubands1, fig.width=8, fig.height=5---------------------------------------
lband <- obs - 5
uband <- obs + 5

## ----ubands2, fig.width=8, fig.height=5---------------------------------------
plotbands(obs, lband, uband)

## ----ubands3------------------------------------------------------------------
sim <- obs + rnorm(length(obs), mean=3)

## ----ubands4, fig.width=8, fig.height=5---------------------------------------
plotbands(obs, lband, uband, sim)

## ----P-Factor, fig.width=8, fig.height=5--------------------------------------
( pfactor(x=obs, lband=lband, uband=uband) )

## ----R-Factor, fig.width=8, fig.height=5--------------------------------------
( rfactor(x=obs, lband=lband, uband=uband) )

## ----Computing_r1-------------------------------------------------------------
r <- sim-obs

## ----Computing_r2-------------------------------------------------------------
library(hydroTSM)
smry(r) 

## ----hydroplot2, fig=TRUE, pdf=TRUE, fig.width=10, fig.height=12--------------
# daily, monthly and annual plots, boxplots and histograms
hydroplot(r, FUN=mean)

## ----hydroplo3, fig=TRUE, eval=TRUE, pdf=TRUE, eps=FALSE, fig.width=8, fig.height=8----
# daily, monthly and annual plots, boxplots and histograms
hydroplot(r, FUN=mean, pfreq="seasonal")

## ----echo=FALSE---------------------------------------------------------------
sessionInfo()$platform
sessionInfo()$R.version$version.string 
paste("hydroGOF", sessionInfo()$otherPkgs$hydroGOF$Version)

# File rsr.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2010-2023 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'rsr': Ratio of RMSE to the Standard Deviation of the Observations           #
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 03-Feb-2010;                                                        #
# Updates: 16-Jan-2023                                                         #
################################################################################

# 'obs'   : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim'   : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 'Result': Ratio of RMSE to the Standard Deviation of the Observations
#           It varies from 0 (its optimal value), which means zero RMSE and 
#           therefore a perfect model simulation, to +Inf. The lower the RSR, 
#           the better the model performance. Moriasi+al2007 suggest that 
#           a good performance is obtained for RSR < 0.7

# Ref: Moriasi, D.N., Arnold, J.G., Van Liew, M.W., Bingner, R.L., Harmel, 
#      R.D., Veith, T.L. 2007. Model evaluation guidelines for systematic 
#      quantification of accuracy in watershed simulations. 
#      Transactions of the ASABE. 50(3):885-900.

rsr <-function(sim, obs, ...) UseMethod("rsr")

rsr.default <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                        epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                        epsilon.value=NA){

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo"))) |
       is.na(match(class(obs), c("integer", "numeric", "ts", "zoo")))
  ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo')")


  epsilon.type <- match.arg(epsilon.type)  

  # index of those elements that are present both in 'sim' and 'obs' (NON- NA values)
  vi <- valindex(sim, obs)
   
  if (length(vi) > 0) {	 
    # Filtering 'obs' and 'sim', selecting only those pairs of elements 
    # that are present both in 'x' and 'y' (NON- NA values)
    obs <- obs[vi]
    sim <- sim[vi]

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end     
 
     #Root mean squared error
     rmse    <- rmse(sim=sim, obs=obs, na.rm=na.rm, fun=NULL, ...,
                     epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                     epsilon.value=NA)
     
     #Standard deviation of the observations
     sd.obs <- sd(obs, na.rm=na.rm)
     
     if ( sd.obs > 0 ) {     
       rsr <- rmse / sd.obs     
     } else {
         rsr <- NA
         warning("'sd(obs)=0' -> it is not possible to compute 'RSR' !")  
       } 
  } else {
         rsr <- NA
         warning("There are no pairs of 'sim' and 'obs' without missing values !")
    } # ELSE end
     
  return( rsr )
     
} # 'rsr.default' end
  

################################################################################
# 'rsr': Ratio of RMSE to the Standard Deviation of the Observations           #
################################################################################
# Started: 03-Feb-2010;                                                        #
# Updates: 16-Jan-2023                                                         #
################################################################################  
rsr.matrix <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                       epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                       epsilon.value=NA){

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
    stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
          paste(dim(sim), collapse=" "), "] != [", 
          paste(dim(obs), collapse=" "), "] )", sep="") )

    rsr <- rep(NA, ncol(obs))       
          
    rsr <- sapply(1:ncol(obs), function(i,x,y) { 
                 rsr[i] <- rsr.default( x[,i], y[,i], na.rm=na.rm, fun=fun, ..., 
                                        epsilon.type=epsilon.type,  
                                        epsilon.value=epsilon.value)
            }, x=sim, y=obs )            
           
    return(rsr)  
     
  } # 'rsr.matrix' end
  

################################################################################
# 'rsr': Ratio of RMSE to the Standard Deviation of the Observations           #
################################################################################
# Started: 03-Feb-2010;                                                        #
# Updates: 16-Jan-2023                                                         #
################################################################################
rsr.data.frame <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                           epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                           epsilon.value=NA){ 
 
  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
   
  rsr.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
             epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'rsr.data.frame' end


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 16-Jan-2023                                                         #
################################################################################
rsr.zoo <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                    epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                    epsilon.value=NA){
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       rsr.matrix(sim, obs, na.rm=na.rm, ...)
    } else NextMethod(sim, obs, na.rm=na.rm, ...)
     
} # 'rsr.zoo' end

test_that("NSE returns one for perfect agreement and matches a hand-computed case", {
  obs <- c(1, 2, 3, 4)
  sim <- c(1, 2, 2, 5)

  expect_equal(NSE(obs, obs), 1)
  expect_equal(NSE(sim, obs), 0.6)
})

test_that("error and agreement metrics match hand-computed values", {
  obs <- c(1, 2, 3, 4)
  sim <- c(1, 2, 2, 5)

  expect_equal(me(obs, obs), 0)
  expect_equal(me(sim, obs), 0)

  expect_equal(mae(obs, obs), 0)
  expect_equal(mae(sim, obs), 0.5)

  expect_equal(mse(obs, obs), 0)
  expect_equal(mse(sim, obs), 0.5)

  expect_equal(ubRMSE(obs, obs), 0)
  expect_equal(ubRMSE(sim, obs), sqrt(0.5), tolerance = 1e-7)

  expect_equal(nrmse(sim, obs), 54.8)
  expect_equal(rsr(sim, obs), 0.5477226, tolerance = 1e-7)
  expect_equal(rSD(sim, obs), 1.3416408, tolerance = 1e-7)

  expect_equal(mNSE(obs, obs), 1)
  expect_equal(mNSE(sim, obs), 0.5)

  expect_equal(rNSE(obs, obs), 1)
  expect_equal(rNSE(sim, obs), 0.7829861, tolerance = 1e-7)

  expect_equal(wNSE(obs, obs), 1)
  expect_equal(wNSE(sim, obs), 0.44, tolerance = 1e-12)

  expect_equal(md(obs, obs), 1)
  expect_equal(md(sim, obs), 0.7777778, tolerance = 1e-7)

  expect_equal(rd(obs, obs), 1)
  expect_equal(rd(sim, obs), 0.9598122, tolerance = 1e-7)

  expect_equal(cp(obs, obs), 1)
  expect_equal(cp(sim, obs), 0.3333333, tolerance = 1e-7)
})

test_that("correlation and efficiency decomposition metrics behave as expected", {
  obs <- c(1, 2, 3, 4)
  sim <- c(1, 2, 2, 5)

  expect_equal(rPearson(obs, obs), 1)
  expect_equal(rPearson(sim, obs), 0.8944272, tolerance = 1e-7)

  expect_equal(R2(obs, obs), 1)
  expect_equal(R2(sim, obs), 0.6)

  expect_equal(br2(obs, obs), 1)
  expect_equal(br2(sim, obs), 0.5806452, tolerance = 1e-7)

  expect_equal(VE(obs, obs), 1)
  expect_equal(VE(sim, obs), 0.8, tolerance = 1e-12)

  expect_true(is.finite(KGElf(obs, obs)))
  expect_true(is.finite(KGElf(sim, obs)))

  expect_equal(KGEnp(obs, obs), 1)
  expect_equal(KGEnp(sim, obs), 0.8876016, tolerance = 1e-7)
})

test_that("KGE returns the expected 2012 components", {
  obs <- c(1, 2, 3, 4)
  sim <- c(1, 2, 2, 5)

  out <- KGE(sim, obs, method = "2012", out.type = "full")

  expect_true(is.finite(out$KGE.value))
  expect_equal(unname(out$KGE.elements["r"]), 0.8944272, tolerance = 1e-7)
  expect_equal(unname(out$KGE.elements["Beta"]), 1, tolerance = 1e-12)
  expect_equal(unname(out$KGE.elements["Gamma"]), 1.3416408, tolerance = 1e-7)
  expect_true(is.finite(KGE(obs, obs, method = "2012")))
})

test_that("KGE returns the optimum value for perfect agreement, including constant series", {
  x <- c(1, 1, 1, 1)
  z <- c(0, 0, 0, 0)

  out_2012 <- KGE(x, x, method = "2012", out.type = "full")
  out_2009 <- KGE(x, x, method = "2009", out.type = "full")
  out_2021 <- KGE(x, x, method = "2021", out.type = "full")
  out_zero <- KGE(z, z, method = "2012", out.type = "full")

  expect_equal(out_2012$KGE.value, 1)
  expect_equal(unname(out_2012$KGE.elements), c(1, 1, 1))

  expect_equal(out_2009$KGE.value, 1)
  expect_equal(unname(out_2009$KGE.elements), c(1, 1, 1))

  expect_equal(out_2021$KGE.value, 1)
  expect_equal(unname(out_2021$KGE.elements), c(1, 0, 1))

  expect_equal(out_zero$KGE.value, 1)
  expect_equal(unname(out_zero$KGE.elements), c(1, 1, 1))
})

test_that("KGE returns NA instead of NaN when 2009/2012 bias terms are undefined", {
  obs <- c(-1, 1)
  sim <- c(-2, 2)

  expect_warning(out_2012 <- KGE(sim, obs, method = "2012", out.type = "full"))
  expect_warning(out_2009 <- KGE(sim, obs, method = "2009", out.type = "full"))

  expect_true(is.na(out_2012$KGE.value))
  expect_true(is.na(out_2009$KGE.value))
  expect_equal(unname(out_2012$KGE.elements), c(1, NA, NA))
  expect_equal(unname(out_2009$KGE.elements), c(1, NA, 2))
})

test_that("PBIAS matches a simple bias calculation", {
  obs <- c(1, 2, 3)
  sim <- c(2, 3, 4)

  expect_equal(pbias(obs, obs), 0)
  expect_equal(pbias(sim, obs), 50)
})

test_that("KGEkm matches the expected 2012 components and score", {
  obs <- c(1, 2, 3, 4)
  sim <- c(1, 2, 2, 5)

  out <- KGEkm(sim, obs, method = "2012", out.type = "full")

  expect_equal(out$KGEkm.value, 0.8915774, tolerance = 1e-7)
  expect_equal(unname(out$KGEkm.elements["r"]), 0.8944272, tolerance = 1e-7)
  expect_equal(unname(out$KGEkm.elements["Beta"]), 1, tolerance = 1e-12)
  expect_equal(unname(out$KGEkm.elements["Gamma"]), 1.0246951, tolerance = 1e-7)
})

test_that("zoo-only flow diagnostics return ideal values for perfect agreement", {
  skip_if_not_installed("hydroTSM")
  suppressPackageStartupMessages(library(hydroTSM))

  dates <- seq.Date(as.Date("2000-01-01"), by = "day", length.out = 365 * 3)
  base <- 10 + sin(seq_along(dates) / 20) + (seq_along(dates) %% 30) / 30
  obs <- zoo::zoo(base, dates)
  sim <- obs

  expect_equal(wsNSE(sim, obs), 1)
  expect_true(is.finite(sKGE(sim, obs)))
  expect_equal(APFB(sim, obs), 0)
  expect_equal(HFB(sim, obs), 0)
  expect_equal(pbiasfdc(sim, obs, plot = FALSE), 0)
})

test_that("d and dr match hand-computed values", {
  obs <- c(1, 2, 3, 4)
  sim <- c(1, 2, 2, 5)

  expect_equal(d(obs, obs), 1)
  expect_equal(d(sim, obs), 0.9259259, tolerance = 1e-7)

  expect_equal(dr(obs, obs), 1)
  expect_equal(dr(sim, obs), 0.75, tolerance = 1e-12)
})

test_that("RMSE matches the root mean squared error formula", {
  obs <- c(1, 2, 3, 4)
  sim <- c(1, 2, 2, 5)

  expect_equal(rmse(obs, obs), 0)
  expect_equal(rmse(sim, obs), sqrt(0.5), tolerance = 1e-12)
})

test_that("sKGE returns internally consistent yearly output", {
  dates <- seq.Date(as.Date("2001-01-01"), by = "day", length.out = 365 * 3)
  pattern <- seq_len(365)
  obs <- zoo::zoo(rep(pattern, 3), dates)
  sim <- obs

  out <- sKGE(sim, obs, out.PerYear = TRUE)

  expect_equal(names(out), c("sKGE.value", "KGE.PerYear"))
  expect_length(out$KGE.PerYear, 3)
  expect_true(all(is.finite(out$KGE.PerYear)))
  expect_equal(unname(out$sKGE.value), mean(unname(out$KGE.PerYear)), tolerance = 1e-12)
})

test_that("pfactor matches scalar and matrix expectations", {
  x <- c(1, 2, 3, 4)
  lband <- c(0, 1, 2, 3)
  uband <- c(2, 3, 4, 5)

  expect_equal(pfactor(x, lband, uband), 1)

  x_mat <- matrix(c(5, 1, 5, 1), 2, 2)
  l_mat <- matrix(0, 2, 2)
  u_mat <- matrix(c(10, 0, 10, 0), 2, 2)

  expect_equal(pfactor(x_mat, l_mat, u_mat), c(0.5, 0.5))
})

test_that("rfactor matches scalar and matrix expectations", {
  x <- c(1, 2, 3, 4)
  lband <- c(0, 1, 2, 3)
  uband <- c(2, 3, 4, 5)

  expect_equal(rfactor(x, lband, uband), 1.549193, tolerance = 1e-6)

  x_mat <- matrix(c(5, 1, 5, 1), 2, 2)
  l_mat <- matrix(0, 2, 2)
  u_mat <- matrix(c(10, 0, 10, 0), 2, 2)

  expect_equal(rfactor(x_mat, l_mat, u_mat), c(1.767767, 1.767767), tolerance = 1e-6)
})

# File R2.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2024-2024 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

# The coefficient of determination (R2) is the proportion of the variation in the dependent 
# variable that is predictable from the independent variable(s).

# It is a statistic used in the context of statistical models whose main purpose is either 
# the prediction of future outcomes or the testing of hypotheses, on the basis of other 
# related information. It provides a measure of how well observed outcomes are replicated 
# by the model, based on the proportion of total variation of outcomes explained by the model.

# The coefficient of determination is a statistical measure of how well the regression 
# predictions approximate the real data points. An R2 of 1 indicates that the regression 
# predictions perfectly fit the data.

# Values of R2 outside the range 0 to 1 occur when the model fits the data worse than the 
# worst possible least-squares predictor (equivalent to a horizontal hyperplane at a 
# height equal to the mean of the observed data). This occurs when a wrong model was chosen,
# or nonsensical constraints were applied by mistake.

# References:
#1) https://en.wikipedia.org/wiki/Coefficient_of_determination

#2) Box, G. E. (1966). Use and abuse of regression. Technometrics, 8(4), 625-629. 
#   doi:10.1080/00401706.1966.10490407.

#3) Hahn, G. J. (1973). The coefficient of determination exposed. Chemtech, 3(10), 609-612. 
#   Aailable online at: \url{https://www2.hawaii.edu/~cbaajwe/Ph.D.Seminar/Hahn1973.pdf}.

#4) Barrett, J. P. (1974). The coefficient of determination-some limitations. 
#   The American Statistician, 28(1), 19-20. doi:10.1080/00031305.1974.10479056.

################################################################################
# 'R2': coefficient of determination                                           #
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# It was originated in the following github issue:                             #
#   https://github.com/hzambran/hydroGOF/issues/16#issue-1736556320            #
################################################################################
# Started: 29-Nov-2023                                                         #
# Updates: 19-Jan-2024                                                         #
################################################################################
R2 <-function(sim, obs, ...) UseMethod("R2")

R2.default <- function(sim, obs, fun=NULL, ..., 
                       epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                       epsilon.value=NA) {

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo"))) |
          is.na(match(class(obs), c("integer", "numeric", "ts", "zoo")))
     ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo')")

     
  # index of those elements that are present both in 'sim' and 'obs' (NON- NA values)
  vi <- valindex(sim, obs)
   
  if (length(vi) > 0) {	 
    # Filtering 'obs' and 'sim', selecting only those pairs of elements 
    # that are present both in 'x' and 'y' (NON- NA values)
    obs <- obs[vi]
    sim <- sim[vi]

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end 

    Om    <- mean(obs)
    SSres <- sum( (obs - sim)^2 )
    SStot <- sum( (obs - Om)^2 )
    R2    <- 1 - SSres/SStot
  
  } else {
           R2 <- NA
           warning("There are no pairs of 'sim' and 'obs' without missing values !")
         } # ELSE end
  
  return(R2)
  
} # 'R2.default' end


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 20-Jan-2024                                                         #
# Updates:                                                                     #
################################################################################
R2.matrix <- function(sim, obs, na.rm=TRUE, fun=NULL, ..., 
                      epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                      epsilon.value=NA){

    R2 <- rep(NA, ncol(obs))       
          
    R2 <- sapply(1:ncol(obs), function(i,x,y) { 
                        R2[i] <- R2.default( x[,i], y[,i], na.rm=na.rm, fun=fun, ..., 
                                             epsilon.type=epsilon.type, epsilon.value=epsilon.value)
                 }, x=sim, y=obs )            
           
    return(R2)
     
} # 'R2.matrix' END
  

################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 20-Jan-2024                                                         #
# Updates:                                                                     #
################################################################################  
R2.data.frame <- function(sim, obs, na.rm=TRUE, fun=NULL, ..., 
                          epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                          epsilon.value=NA){

    sim <- as.matrix(sim)
    obs <- as.matrix(obs)
	
    R2.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
              epsilon.type=epsilon.type, epsilon.value=epsilon.value)        
     
} # 'R2.data.frame' END
  
 
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 20-Jan-2024                                                         #
# Updates:                                                                     #
################################################################################
R2.zoo <- function(sim, obs, na.rm=TRUE, fun=NULL, ..., 
                   epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                   epsilon.value=NA){
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       R2.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
                       epsilon.type=epsilon.type, epsilon.value=epsilon.value)
    } else NextMethod(sim, obs, na.rm=na.rm, fun=fun, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'R2.zoo' end

# File plot2.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/
# Copyright 2010-2026 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'plot2':     Plots 2 time series on the same graph                           #
#              It is a wrapper for the 'plot.zoo'                              #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: March 04, 2009                                                      #
# Updates: May 2009                                                            #
#          2010                                                                #
#          21-Jan-2011 ; 15-Apr-2011 ;                                         #
#          25-Aug-2011 ; 31-Aug-2011 ; 14-Sep-2011                             #
#          23-Jan-2012                                                         #
#          15-Apr-2013 ; 15-May-2013                                           #
#          06-Aug-2017                                                         #
#          28-Dec-2022                                                         #
#          22-Mar-2024 ; 23-Mar-204 ; 08-May-2024                              #
#          01-Nov-2025                                                         #   
#          29-Apr-2026                                                         #                         
################################################################################
                
plot2 <- function (x, y, 
                   plot.type="multiple", 
                   
                   tick.tstep="auto", 
                   lab.tstep="auto", 
                   lab.fmt=NULL,
                   
                   main, 
                   xlab="Time", 
                   ylab,
                   
                   cal.ini=NA, 
                   val.ini=NA, 
                   date.fmt="%Y-%m-%d",                   
                   
                   gof.leg= FALSE, 
                   gof.digits=2, 
                   gofs=c( "ME",  "MAE",  "RMSE", "NRMSE", "PBIAS", 
                          "NSE",    "d",    "dr",     "r",    "R2",  
                          "KGE",  "LCE", "JDKGE",    "VE"),
                   
                   legend,
                   leg.cex=1,                       
                        
                   col = c("black","blue"),
                   
                   cex=c(0.5, 0.5),
                   cex.axis=1.2,
                   cex.lab=1.2,
                   
                   lwd= c(1,1), 
                   lty= c(1,3), 
                   pch= c(1,9),   
                   
                   pt.style = "ts",
                   add=FALSE,                   
                   
                    ...) {
                 
  # Saving the current graphical parameter settings,
  # and restoring them on exit
  #old.par <- par(no.readonly = TRUE)
  #on.exit(par(old.par))
  
  # Checking that the user provided 'x'
  if ( missing(x) ) stop("Missing argument: 'x'")
         
  # Checking that the user provided 'y'
  if ( missing(y) ) stop("Missing argument: 'y'")

  # Checking 'gofs'.  'rSpearman', 'pbiasFDC' and 'PMR' are not computed
  gofs.all=c(   "ME",    "MAE",    "MSE",  "RMSE", "ubRMSE", 
             "NRMSE",  "PBIAS",   "RSR",    "rSD",    "NSE",  
             "mNSE" ,   "rNSE",  "wNSE",  "wsNSE",      "d",     
                "dr",     "md",    "rd",     "cp",      "r",     
                "R2",    "bR2",    "VE",    "KGE",  "KGElf",  
             "KGEnp",  "KGEkm", "JDKGE",    "LME",    "LCE", 
              "sKGE",    "HFB",  "APFB")  

  # Removing 'sKGE', 'APFB' and 'HFB' when 'x' and 'y' are not zoo objects
  if ( !( zoo::is.zoo(x) & zoo::is.zoo(y) ) )
    gofs.all <- gofs.all[ -c( (length(gofs.all)-2):(length(gofs.all)) ) ]

  # Checking the sampling frequency of 'x' and 'y'
  x.sfreq <- NULL
  y.sfreq <- NULL
  if ( zoo::is.zoo(x) & zoo::is.zoo(y) ) {
    x.sfreq <- hydroTSM::sfreq(x)
    y.sfreq <- hydroTSM::sfreq(y)
    if ( x.sfreq != y.sfreq)
      stop("Invalid arguments: sampling frequency of 'x' and 'y' is not the same ! (", 
           x.sfreq, " != ", y.sfreq, ")")

    # Removing 'sKGE', 'APFB' and 'HFB' when 'x' and 'y' are annual zoo objects
    if ( x.sfreq == "annual" ) {
      index    <- pmatch( c("sKGE", "APFB", "HFB"), gofs.all )
      gofs.all <- gofs.all[-index]
    } # IF end
  } # IF end

  # Checking 'gofs' 
  noNms.index <- which( !(gofs %in% gofs.all) )
  if (length(noNms.index) > 0) {
    noNms <- gofs[noNms.index]
    warning("[Unknown names in 'gofs': ", paste(noNms, collapse = ", "), " (not used) !]")
  } # IF end	   
  gofs.index <- which( (gofs %in% gofs.all) )
  gofs       <- gofs[gofs.index]

  # 'xname' and 'yname' values
  xname <- deparse(substitute(x))
  yname <- deparse(substitute(y))

  # 'legend' value
  if (missing(legend)) legend <- c(xname, yname)

  # 'ylab' value
  if (missing(ylab)) ylab <- c(xname, yname)
  
  # Checking that the user provided a valid argument for 'x' and 'y'
  valid.class <- c("xts", "zoo", "ts", "numeric", "integer")       
  if (length(which(!is.na(match(class(x), valid.class )))) <= 0) 
         stop("Invalid argument: 'class(x)' must be in c('integer', 'numeric', 'ts', 'zoo', 'xts')")
  if (length(which(!is.na(match(class(y), valid.class )))) <= 0)
         stop("Invalid argument: 'class(y)' must be in c('integer', 'numeric', 'ts', 'zoo', 'xts')")
         
  # Checking that the user provided a valid argument for 'plot.type'       
  if (is.na(match(plot.type, c("single", "multiple") ) ) ) 
         stop("Invalid argument: 'plot.type' must be in c('single', 'multiple')")
         
  # If the user wants to draw a legend, it checks that the type of plot is 'single'
  if (gof.leg & (plot.type == "multiple") )
    stop("Invalid argument: For drawing a legend, 'plot.type' must be 'single'")
         
  # Checking that the user provided a valid argument for 'pt.style'       
  if (is.na(match(pt.style, c("ts", "bar") ) ) ) 
         stop("Invalid argument: 'pt.style' must be in c('ts', 'bar')")
         
  # If 'x' is 'ts' or 'zoo' and 'y' is only a vector, y is transformed into 
  # the same class of 'x', with the same times
  if ( (length(which(!is.na(match(class(x), c("ts", "zoo", "xts") )))) <= 0) & 
       (length(which(!is.na(match(class(y), c("integer", "numeric") )))) <= 0) ) {  
  
    # class(time(x))== "Date" for 'daily' and 'monthly' time series
    # class(time(x))== "character" for 'annual' time series
    if ( inherits(time(x), "Date" ) ) {
        y <- vector2zoo(y, dates=time(x)) # hydroTSM::vector2zoo
    } else if ( inherits(time(x), "character") ) {
        y <- vector2zoo(y, dates=time(x), date.fmt="%Y") # hydroTSM::vector2zoo
        time(x) <- time(y) #'annual' time series
    } # ELSE END
    
  } # IF END

         
  # Checking that the user provied the same length for 'sim' and 'obs'      
  #if ( length(x) != length(y) )  
  #       stop("Invalid argument: 'obs' and 'sim' must have the same length")
         
  # If the user didn't provide a title for the plot, the default is used 
  if ( missing(main) ) main <- "Observed vs Simulated"   
  
  # If the user provided a value for 'cal.ini', it is transformed into a Date class
  if ( !missing(cal.ini) ) cal.ini <- as.Date(cal.ini, format=date.fmt)
    
  # If the user provided a value for 'val.ini', it is transformed into a Date class
  if ( !missing(val.ini) ) val.ini <- as.Date(val.ini, format=date.fmt)
  
  # If the legend has to be plotted AND no other plots will be added
  # IF 'add' is TRUE, the layout of the screen is set up by the calling procedure (usually 'ggof')
  if (gof.leg & add==FALSE) {  
            def.par <- par(no.readonly = TRUE) # save default, for resetting...     
            #par(mar=c(5, 2, 4, 0.5) + 0.1)
            # Setting up the screen with 1 rows and 2 columns
            layout( matrix( c(1,1,1,1,1,1,1,1,1,2,2), ncol=11, byrow=TRUE) ) 
            par(mar=c(5, 4, 4, 0) + 0.1)    
            on.exit(par(def.par))      
  } # ELSE end    
  
  # If the legend will not be plotted, the marginns are set to 'almost' the default values
  if (!gof.leg)
    par(mar=c(5, 4, 4, 2) + 0.1) # default values are par(mar=c(5, 4, 4, 4) + 0.1)
  
  # If the plot type is "time series"
  if (pt.style=="ts") {
  
    # If both time series have to be ploted in the same plot area
    if (plot.type == "single") {

      if (length(which(!is.na(match(class(x), c("ts", "zoo", "xts") )))) > 0) x <- zoo::as.zoo(x) 
      if (length(which(!is.na(match(class(y), c("ts", "zoo", "xts") )))) > 0) y <- zoo::as.zoo(y) 

      # Y axis limits
      if (!hasArg(ylim)) ylim <- range( range(x[is.finite(x)]), range(y[is.finite(y)]) )

      # Plotting the Observed Time Series. 
      # It calls to 'plot' or 'plot.zoo'  depending on 'x' class
      if (!hasArg(ylim)) {
         zoo::plot.zoo(x, xaxt = "n", yaxt = "n",
                       type="o", lwd=lwd[1], lty= lty[1], col= col[1], pch= pch[1], 
                       cex = cex[1], cex.axis=cex.axis, cex.lab=cex.lab,
                       main=main, xlab=xlab, ylab= ylab, ylim=ylim, ... )
      } else zoo::plot.zoo(x, xaxt = "n", yaxt = "n", 
                      type="o", lwd=lwd[1], lty= lty[1], col= col[1], pch= pch[1], 
                      cex = cex[1], cex.axis=cex.axis, cex.lab=cex.lab,
                      main=main, xlab=xlab, ylab= ylab, ... )
      axis(2, cex.axis=cex.axis, cex.lab=cex.lab)
     
      lines(y, type="o", lwd=lwd[2], lty= lty[2], col= col[2], pch= pch[2], cex = cex[2])      
               
      # If the user provided a value for 'cal.ini', a vertical line is drawn
      if ( !missing(cal.ini) ) abline(v=as.POSIXct(cal.ini), col="red", lty=1, lwd=2)
      
      # If the user provided a value for 'val.ini', a vertical line is drawn
      if ( !missing(val.ini) ) abline(v=as.POSIXct(val.ini), col="red", lty=1, lwd=2)
               
      # Drawing a legend with 'Obs' vs 'Sim' 
      # y.intersp=0.5, is for the vertical spacin in the legend
      # bty="n" => no box around the legend
      # 'inset=0.03' is usefult when plot.type= "multiple" for having a nice margin to the legend
      legend("topright", legend=legend, y.intersp=0.8, inset=0.03,
             bty="n", cex = leg.cex, col = col, lwd= lwd, lty= lty, pch=pch )  
      
      # Drawing the 'x' axis
      # If the user provided, in some way, valid values for being used as dates, 
      # they will be used, if not, only a numeric index will be used
      if ( !is.null(x.sfreq)  & !is.null(y.sfreq) ) {

        if ( ( !is.integer( class( time(x) ) ) & !is.integer( class( time(y) ) ) ) ) {

          # if 'x' and 'y' are subdaily ts
          if (x.sfreq %in% c("minute", "hourly") ) {
            nmonths <- hydroTSM::mip(from=stats::start(x), to=stats::end(x), out.type="nmbr")

            if (nmonths <= 40) { # 40 months or less
              if (tick.tstep=="auto") tick.tstep <- "days"
              if (lab.tstep=="auto") lab.tstep <- "months"
              if ( is.null(lab.fmt) ) lab.fmt <- "%Y-%b"
            } else {
                if (tick.tstep=="auto") tick.tstep <- "months"
                if (lab.tstep=="auto") lab.tstep <- "years"
                if ( is.null(lab.fmt) ) lab.fmt <- "%Y"
              } # ELSE end     

          } # IF end

          # Draws ticks in the X axis, but labels only in years
          hydroTSM::drawTimeAxis(x, tick.tstep=tick.tstep, lab.tstep= lab.tstep, 
                               lab.fmt=lab.fmt, cex.axis=cex.axis, cex.lab=cex.lab) 

          # manually adding a grid
          grid(nx=NA, ny=NULL)
          abline(v=time(x)[xts::axTicksByTime(x)], col = "lightgray", lty = "dotted")
      
        } 
      } else { # When 'numeric' or 'integer' values (not 'zoo' or 'xts') are plotted
             Axis(side = 1, labels = TRUE, cex.axis=cex.axis, cex.lab=cex.lab)
             box()
             # manually adding a grid
             grid()
             }
               
    } else  #plot.type == "multiple"  
          {       
            # all the work (mainly Time axis) is made automatically be the 'plot.zoo' function 
            zoo::plot.zoo(cbind(x, y), plot.type=plot.type, type=c("o","o"), 
                         lwd=lwd, lty= lty, col= col, pch= pch, 
                         cex = cex, 
                         cex.axis=cex.axis, 
                         cex.lab=cex.lab,
                         main=main, xlab=xlab, ylab= ylab,...)
                         
            # If the user provided a value for 'cal.ini', a vertical line is drawn
            if ( !missing(cal.ini) ) abline(v=as.POSIXct(cal.ini), col="red", lty=1, lwd=2)
      
            # If the user provided a value for 'val.ini', a vertical line is drawn
            if ( !missing(val.ini) ) abline(v=as.POSIXct(val.ini), col="red", lty=1, lwd=2)
                         
      } # ELSE end 
      
  } else if (pt.style=="bar") {
    
        # Creation of the table that will be plotted as barplot
        b <- rbind(coredata(x),coredata(y))
        
        # Giving the as name to each bar the YEAR, because the 
        # bar plot is thought for being used ONLY for annual time series
        colnames(b) <- format( time(x), "%Y")
        
        # Barplot  
        barplot(b, beside=TRUE, axis.lty=1, col=col, density=25, angle=c(45,-45), 
                main=main, xlab=xlab, ylab= ylab, legend.text=legend, 
                args.legend=list(x="topleft", y.intersp=0.8, inset=0.00, bty="n", 
                                 cex= cex.axis, col = col), # lwd= lwd, lty= lty, pch=pch),
                cex.axis=cex.axis, cex.lab=cex.lab, cex = cex.lab, ...)  
       
        if ( !missing(cal.ini) ) {
          # Index of the bar corresponding to 'cal.ini'.
          # It is necessary to multiply it by 3 because for each year there are 3 vertical lines
          # It is necessary to substract 2, for shifting the line form the 3 line to the first one
          cal.index <- 3*which(colnames(b) == format( cal.ini, "%Y")) - 2
          # If the user provided a value for 'cal.ini', a vertical line is drawn
          if ( !missing(cal.ini) ) {
           abline(v=cal.index, col="red", lty=1, lwd=2)
          } # IF end
        } # IF end
       
        if ( !missing(val.ini) ) {
          # Index of the bar corresponding to 'val.ini'.
          # It is necessary to multiply it by 3 because for each year there are 3 vertical lines
          # It is necessary to substract 2, for shifting the line form the 3 line to the first one
          val.index <- 3*which(colnames(b) == format( val.ini, "%Y")) - 2
          # If the user provided a value for 'val.ini', a vertical line is drawn
          if ( !missing(val.ini) ) {
            abline(v=val.index, col="red", lty=1, lwd=2)
          } # IF end
        } # IF end
      
    }  # ELSE end        
  
  
  # If the Goodness-of-fit indexes have to be computed and plotted:
  if (gof.leg & plot.type == "single" ) {
  
   # If the user provided 'cal.ini' and 'x' & 'y' are zoo objects, 
   # the warming up period is removed from the computation of the goodness-of-fit
   # measures => all the values before 'cal.ini' are ignored but plotted
   if ( is.zoo(x) & is.zoo(y) ) {
     if ( !is.na(cal.ini) ) {
       x <- window(x, start=cal.ini)
       y <- window(y, start=cal.ini)
     } # IF end 
   } # IF end

   gof.index <- pmatch(gofs, gofs.all)
   gof.index <- gof.index[!is.na(gof.index)]  
   
   ######################
   # Computing the GoFs #
   ######################
   gof.xy <- gof(sim=x, obs=y, do.spearman=FALSE, do.pbfdc=FALSE, do.pmr=FALSE, digits=gof.digits, ...)

   gofs.stg  <- gofs.all[gof.index] 
   gofs.num  <- gof.xy[gof.index, 1] 

   leg.text <- paste(gofs.stg, " = ", gofs.num, sep="")
   
   legend.position <- "center"
   par( mar=c(0.5, 0.5, 0.5, 0.5) ) # mar=c(bottom, left, top, right). Default values are: mar=c(5,4,4,2) + 0.1)
   plot.new() 
          
   # 'inset':  The optional 'inset' argument specifies how far the legend is inset from the plot margins.  
   #           If a single value is given, it is used for both margins; 
   #           if two values are given, the first is used for 'x'-distance, the second for 'y'-distance.
	 
   legend(legend.position,  y.intersp=1.2, cex =leg.cex, # bty="n", #inset=0.01,  
          leg.text, 
#          c( paste( "ME =", gof.xy["ME", 1], sep=" "),
#             paste( "MAE =", gof.xy["MAE", 1], sep=" "),
#             #paste( "MSE =", gof.xy["MSE", 1], sep=" "),
#             paste( "RMSE =", gof.xy["RMSE", 1], sep=" "),
#             paste( "NRMSE% =", gof.xy["NRMSE %", 1], sep=" "),
#             paste( "PBIAS% =", gof.xy["PBIAS %", 1], sep=" "),
#             #paste( "pbiasFDC% =", gof.xy["pbiasFDC %", 1], sep=" "),
#             paste( "RSR =", gof.xy["RSR", 1], sep=" "),
#             paste( "rSD =", gof.xy["rSD", 1], sep=" "),             
#             paste( "NSE =", gof.xy["NSE", 1], sep=" "),
#             paste( "mNSE =", gof.xy["mNSE", 1], sep=" "),
#             paste( "rNSE =", gof.xy["rNSE", 1], sep=" "),
#             paste( "d =", gof.xy["d", 1], sep=" "),
#             paste( "md =", gof.xy["md", 1], sep=" "),
#             paste( "rd =", gof.xy["rd", 1], sep=" "),
#             #paste( "cp =", gof.xy["cp", 1], sep=" "),
#             paste( "r =", gof.xy["r", 1], sep=" "),
#             paste( "R2 =", gof.xy["R2", 1], sep=" "), 
#             paste( "bR2 =", gof.xy["bR2", 1], sep=" "),
#             paste( "KGE =", gof.xy["KGE", 1], sep=" "), 
#             paste( "VE =", gof.xy["VE", 1], sep=" ")               
#            ), 
            title="GoF's:", title.col="darkblue",
            bg="azure"
           )
         
  } #IF END
  
} # 'plot2' end

# File VE.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2011-2023 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'VE': Volumetric Efficiency                                                  #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
# Started: 26-Aug-2011                                                         #
# Updates: 26-Aug-2011                                                         #
#          16-Jan-2023                                                         #
#          20-Jan-2024                                                         #
################################################################################
# Reference: Criss, R. E. and Winston, W. E. (2008),                           #
#            Do Nash values have value? Discussion and alternate proposals.    #
#            Hydrological Processes, 22: 2723-2725. doi: 10.1002/hyp.7072      #
################################################################################
# 'obs'   : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim'   : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 'Result': Mean Absolute Error between 'sim' and 'obs', in the same units of 'sim' and 'obs' 

VE <-function(sim, obs, ...) UseMethod("VE")

VE.default <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                       epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                       epsilon.value=NA){

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo", "xts"))) |
          is.na(match(class(obs), c("integer", "numeric", "ts", "zoo", "xts")))
     ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo', 'xts')")    
      
  if ( length(obs) != length(sim) ) 
	 stop("Invalid argument: 'sim' & 'obs' doesn't have the same length !")
	 
  epsilon.type <- match.arg(epsilon.type)  

  # index of those elements that are present both in 'sim' and 'obs' (NON- NA values)
  vi <- valindex(sim, obs)
   
  if (length(vi) > 0) {	 
    # Filtering 'obs' and 'sim', selecting only those pairs of elements 
    # that are present both in 'x' and 'y' (NON- NA values)
    obs <- obs[vi]
    sim <- sim[vi]

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end  
  
    denominator <- sum(obs, na.rm=na.rm)
  
    if ( (denominator != 0) & (!is.na(denominator)) ) {      
      ve <- 1 - ( sum( abs(sim-obs) ) / denominator )     
    } else {
       ve <- NA
       warning("'sum((obs)=0' => it is not possible to compute 'VE' !")  
      } 
  } else {
       ve <- NA
       warning("There are no pairs of 'sim' and 'obs' without missing values !")
    } # ELSE end
     
  return(ve)      
     
} # 'VE.default' end
  


################################################################################
# 'VE': Volumetric Efficiency                                                  #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
# Started: 26-Aug-2011                                                         #
# Updates: 26-Aug-2011                                                         #
#          16-Jan-2023                                                         #
################################################################################  
VE.matrix <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                      epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                      epsilon.value=NA){

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
    stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
          paste(dim(sim), collapse=" "), "] != [", 
          paste(dim(obs), collapse=" "), "] )", sep="") )

  ve <- rep(NA, ncol(obs))       
          
  ve <- sapply(1:ncol(obs), function(i,x,y) { 
                 ve[i] <- VE.default( x[,i], y[,i], na.rm=na.rm, fun=fun, ..., 
                                      epsilon.type=epsilon.type,  
                                      epsilon.value=epsilon.value)
               }, x=sim, y=obs )    
                     
  names(ve) <- colnames(obs)
                 
  return(ve)
     
} # 've.matrix' end
  

################################################################################
# 'VE': Volumetric Efficiency                                                  #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
# Started: 26-Aug-2011                                                         #
# Updates: 26-Aug-2011                                                         #
#          16-Jan-2023                                                         #
################################################################################    
VE.data.frame <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                          epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                          epsilon.value=NA){

  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
   
  VE.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
            epsilon.type=epsilon.type, epsilon.value=epsilon.value)  
     
} # 'VE.data.frame' end



################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 16-Jan-2023                                                         #
################################################################################
VE.zoo <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                   epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                   epsilon.value=NA){
    
  sim <- zoo::coredata(sim)
  if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
  if (is.matrix(sim) | is.data.frame(sim)) {
     VE.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
               epsilon.type=epsilon.type, epsilon.value=epsilon.value)
  } else NextMethod(sim, obs, na.rm=na.rm, fun=fun, ..., 
                    epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'VE.zoo' end

# File KGEkm.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2024-2024 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'KGEkm': Kling-Gupta Efficiency with knowable-moments                        #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 06-May-2024                                                         #
# Updates: 07-May-2024                                                         #
#          28-Apr-2026                                                         #
################################################################################
# The optimal value of KGEkm is 1

# Ref1:
# Pizarro, A. and Jorquera, J. (2024). Advancing objective functions in 
# hydrological modelling: Integrating knowable moments for improved simulation 
# accuracy. Journal of Hydrology, 634, 131071. doi:10.1016/j.jhydrol.2024.131071

# Ref2:
# Kling, H., M. Fuchs, and M. Paulin (2012), Runoff conditions in the upper
# Danube basin under an ensemble of climate change scenarios, 
# Journal of Hydrology, Volumes 424-425, 6 March 2012, Pages 264-277, 
# DOI:10.1016/j.jhydrol.2012.01.011.

# Ref3:
# Hoshin V. Gupta, Harald Kling, Koray K. Yilmaz, Guillermo F. Martinez, 
# Decomposition of the mean squared error and NSE performance criteria: 
# Implications for improving hydrological modelling, 
# Journal of Hydrology, Volume 377, Issues 1-2, 20 October 2009, Pages 80-91, 
# DOI: 10.1016/j.jhydrol.2009.08.003. ISSN 0022-1694, 

# Ref4: Tang, G.; Clark, M. P.; Papalexiou, S. M. (2021).  
# SC-earth: a station-based serially complete earth dataset from 1950 to 2019. 
# Journal of Climate, 34(16), 6493-6511.
# DOI: 10.1175/JCLI-D-21-0067.1.


# 'obs' : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim' : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 's'   : scaling factors.

# 'Result': Kling-Gupta Efficiency between 'sim' and 'obs'

KGEkm <- function(sim, obs, ...) UseMethod("KGEkm")

KGEkm.default <- function(sim, obs, s=c(1,1,1), na.rm=TRUE, 
                          method=c("2012", "2009", "2021"), out.type=c("single", "full"), 
                          fun=NULL, ...,
                          epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                          epsilon.value=NA) { 

  # If the user provided a value for 's'
  if (!identical(s, c(1,1,1)) )  {
     if ( length(s) != 3 ) stop("Invalid argument: lenght(s) must be equal to 3 !")
     if ( sum(s) != 1 )    warning("sum(s) != 1.0. Is this correct for you?")
  } # IF end
     
  method   <- match.arg(method)
  out.type <- match.arg(out.type)  

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo"))) |
       is.na(match(class(obs), c("integer", "numeric", "ts", "zoo")))
  ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo')")      
   
  vi <- valindex(sim, obs)
     
  if (length(vi) > 0) {
	 
    obs <- as.numeric(obs[vi])
    sim <- as.numeric(sim[vi])

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end

    # Mean values
    mean.sim <- mean(sim, na.rm=na.rm)
    mean.obs <- mean(obs, na.rm=na.rm)

    # r: Pearson product-moment correlation coefficient.
    # It measures linear association between paired observations at identical time indices.
    # Sorting 'sim and 'obs' before computation of 'r' destroys that pairing structure and 
    # therefore alters the stochastic dependence being measured.
    r <- rPearson(sim, obs)

    # The computation of the second knowable moment: K2 (dispersion-related quantity) 
    # require 'sim' and 'obs' be sorted in ascending order 
    sim <- sort(sim)
    obs <- sort(obs)

    # Dispersion measures (~ standard deviation)
    n         <- length(vi)
    i         <- seq(from=1, to=n, by=1) 
    K2sim     <- sum( 2*(i-1)*sim / (n*(n-1)) )
    K2obs     <- sum( 2*(i-1)*obs / (n*(n-1)) )
    sigma.sim <- sqrt(2*K2sim)
    sigma.obs <- sqrt(2*K2obs)
         
    
    # Alpha is a measure of relative variability between simulated and observed values (See Ref1)
    Alpha <- sigma.sim / sigma.obs

    # Beta is the ratio between the mean of the simulated values to the mean of observations
    Beta <- mean.sim / mean.obs

    # Beta.2021 is the bias term proposed by Tang et al. (2021) to avoid the 
    # anomalously negative KE or KGEkm' values when the mean value is close to zero 
    Beta.2021 <- (mean.sim - mean.obs) / sigma.obs
       
    # CV.sim is the coefficient of variation of the simulated values [dimensionless]
    # CV.obs is the coefficient of variation of the observations [dimensionless]
    CV.sim <- sigma.sim / mean.sim
    CV.obs <- sigma.obs / mean.obs
       
    # Gamma is the variability ratio, which is used instead of Alpha (See Ref2)
    Gamma <- CV.sim / CV.obs
       
    # Variability ratio depending on 'method'
    if (method=="2012") {
      br     <- Beta
      br.stg <- "Beta"
      vr     <- Gamma
      vr.stg <- "Gamma"
    } else if (method=="2009") {
        br     <- Beta
        br.stg <- "Beta"
        vr     <- Alpha
        vr.stg <- "Alpha"
      } else if (method=="2021") {
          br     <- Beta.2021
          br.stg <- "Beta.2021"
          vr     <- Alpha
          vr.stg <- "Alpha"
        } # ELSE end

    # KGEkm Computation
    if ( (mean.obs != 0) & (sigma.obs != 0) ) {
        KGEkm <- 1 - sqrt( (s[1]*(r-1))^2 + (s[2]*(vr-1))^2 + (s[3]*(br-1))^2 )
    } else {
        if ( mean.obs != 0)  warning("Warning: 'mean(obs)==0'. Beta = Inf")
        if ( sigma.obs != 0) warning("Warning: 'sd(obs)==0'. ", vr.stg, " = Inf")
        KGEkm <- NA
      } # ELSE end  
            
  } else {
      r    <- NA
      Beta <- NA
      vr   <- NA
      br   <- NA
      if (method=="2012") {
        br.stg <- "Beta"
        vr.stg <- "Gamma"
      } else if (method=="2009") {
          br.stg <- "Beta"
          vr.stg <- "Alpha" 
        } else {
            br.stg <- "Beta.2021"
            vr.stg <- "Alpha" 
          } # ELSE end
      KGEkm <- NA
      warning("There are no pairs of 'sim' and 'obs' without missing values !")
    } # ELSE end

  if (out.type=="single") {
        out <- KGEkm
  } else {
      out <- list(KGEkm.value=KGEkm, KGEkm.elements=c(r, br, vr))
      names(out[[2]]) <- c("r", br.stg, vr.stg)
    } # ELSE end    
 
  return(out)
     
} # 'KGEkm.default' end


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 06-May-2024                                                         #
# Updates: 07-May-2024                                                         #
################################################################################
KGEkm.matrix <- function(sim, obs, s=c(1,1,1), na.rm=TRUE, 
                         method=c("2012", "2009", "2021"), out.type=c("single", "full"), 
                         fun=NULL, ...,
                         epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                         epsilon.value=NA) { 

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
     stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
           paste(dim(sim), collapse=" "), "] != [", 
           paste(dim(obs), collapse=" "), "] )", sep="") )
           
  # If the user provided a value for 's'
  if (!all.equal(s, c(1,1,1)) )  {
     if ( length(s) != 3 ) stop("Invalid argument: lenght(s) must be equal to 3 !")
     if ( sum(s) != 1 )    warning("sum(s) != 1.0. Is this correct for you?")
  } # IF end
           
  method   <- match.arg(method)
  out.type <- match.arg(out.type) 

  ifelse(method=="2012", vr.stg <- "Gamma", vr.stg <- "Alpha")

  KGEkm                <- rep(NA, ncol(obs))       
  elements           <- matrix(NA, nrow=3, ncol=ncol(obs))
  rownames(elements) <- c("r", "Beta", vr.stg)
  colnames(elements) <- colnames(obs)
          
  if (out.type=="single") {
    out <- sapply(1:ncol(obs), function(i,x,y) { 
                   KGEkm[i] <- KGEkm.default( x[,i], y[,i], s=s, na.rm=na.rm, 
                                         method=method, out.type=out.type, 
                                         fun=fun, ..., epsilon.type=epsilon.type, 
                                         epsilon.value=epsilon.value )
                 }, x=sim, y=obs )  
    names(out) <- colnames(obs) 
  } else { out <- lapply(1:ncol(obs), function(i,x,y) { 
                         KGEkm.default( x[,i], y[,i], s=s, na.rm=na.rm, method=method, 
                                      out.type=out.type, fun=fun, ..., 
                                      epsilon.type=epsilon.type, 
                                      epsilon.value=epsilon.value )
                       }, x=sim, y=obs ) 
            for (i in 1:length(out) ) {
               KGEkm[i] <- out[[i]][[1]]
               elements[,i] <- as.numeric(out[[i]][[2]])
            } # FOR end 
            out <- list(KGEkm.value=KGEkm, KGEkm.elements=elements)
          } # ELSE end                     
  
  return(out)
     
} # 'KGEkm.matrix' end


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 06-May-2024                                                         #
# Updates: 07-May-2024                                                         #
################################################################################
KGEkm.data.frame <- function(sim, obs, s=c(1,1,1), na.rm=TRUE, 
                             method=c("2012", "2009", "2021"), out.type=c("single", "full"), 
                             fun=NULL, ...,
                             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                             epsilon.value=NA) { 
 
  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
  
  method   <- match.arg(method)
  out.type <- match.arg(out.type) 
   
  KGEkm.matrix(sim, obs, s=s, na.rm=na.rm, method=method, out.type=out.type, 
             fun=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'KGEkm.data.frame' end


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 06-May-2024                                                         #
# Updates: 07-May-2024                                                         #
################################################################################
KGEkm.zoo <- function(sim, obs, s=c(1,1,1), na.rm=TRUE, 
                      method=c("2012", "2009", "2021"), out.type=c("single", "full"), 
                      fun=NULL, ...,
                      epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                      epsilon.value=NA) { 
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       KGEkm.matrix(sim, obs, s=s, na.rm=na.rm, method=method, out.type=out.type, 
                  fun=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value)
    } else NextMethod(sim, obs, s=s, na.rm=na.rm, method=method, out.type=out.type, 
                      fun=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
  } # 'KGEkm.zoo' end

# File wNSE.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/
# Copyright 2021-2024 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

##################################################
# 'wNSE': weighted Nash-Sutcliffe Efficiency     #
##################################################
# Started: March 2021                            #
##################################################
# Author: sluedtke (github user)                 #
##################################################
# Updates: ( by Mauricio Zambrano-Bigiarini)     #
#          19-Jan-2024 ; 20-Jan-2024             #
##################################################

# References:

#\cite{Nash, J. E. and J. V. Sutcliffe (1970), 
#      River flow forecasting through conceptual models part I - A discussion of principles, 
#      Journal of Hydrology, 10 (3), 282-290} \cr

#\cite{Hundecha, Y., B\'{a}rdossy, A. (2004). 
#      Modeling of the effect of land use changes on the runoff generation of a 
#      river basin through parameter regionalization of a watershed model. 
#      Journal of hydrology, 292(1-4), 281-295. 
#      doi:10.1016/j.jhydrol.2004.01.002} \cr

#\cite{Hundecha, Y., Ouarda, T. B., B\'{a}rdossy, A. (2008). 
#      Regional estimation of parameters of a rainfall-runoff model at ungauged 
#      watersheds using the 'spatial' structures of the parameters within a canonical 
#      physiographic-climatic space. Water Resources Research, 44(1). 
#      doi:10.1029/2006WR005439} \cr

#\cite{Hundecha, Y. and Merz, B. (2012), 
#      Exploring the Relationship between Changes in Climate and Floods Using a 
#      Model-Based Analysis, Water Resour. Res., 48(4), 1-21, 
#      doi:10.1029/2011WR010527}. 


# 'obs' : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim' : numeric 'data.frame', 'matrix' or 'vector' with simulated values

# 'Result': Modified Nash-sutcliffe Efficiency between 'sim' and 'obs'

wNSE <- function(sim, obs, ...) UseMethod("wNSE")

wNSE.default <- function(sim, obs, na.rm = TRUE, fun=NULL, ..., 
                         epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                         epsilon.value=NA) {

  # Checking 'epsilon.type'
  epsilon.type <- match.arg(epsilon.type) 

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo", "xts"))) |
         is.na(match(class(obs), c("integer", "numeric", "ts", "zoo", "xts")))
      ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo', 'xts')")

  vi <- valindex(sim, obs)

  if (length(vi) > 0) {	 
    # Filtering 'obs' and 'sim', selecting only those pairs of elements 
    # that are present both in 'x' and 'y' (NON- NA values)
    obs <- obs[vi]
    sim <- sim[vi]

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end    

    # Testing for zero values in obs, which leads to -Inf as result
    zero.index <- which(obs == 0)
    if (length(zero.index > 0)) {
        warning("'wNSE' can not be computed: some elements in 'obs' are zero !",
                call. = FALSE)
    } # IF end

    denominator <- sum(obs * ((obs - mean(obs))^2))

    if ( (denominator != 0) & (!is.na(denominator)) ) {      
      wNSE <- 1 - (sum(obs * ((obs - sim)^2)) / denominator)
    } else {
        NS <- NA
        warning("'sum( obs * ( ( obs - mean(obs) ) )^2 ) = 0', it is not possible to compute 'wNSE'")
      } 
  } else {
       NS <- NA
       warning("There are no pairs of 'sim' and 'obs' without missing values !")
    } # ELSE end

  return(wNSE)

} # 'wNSE.default' end


wNSE.matrix <- function(sim, obs, na.rm = TRUE, fun=NULL, ..., 
                        epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                        epsilon.value=NA) {

  # Checking 'epsilon.type'
  epsilon.type <- match.arg(epsilon.type) 

  # Checking that 'sim' and 'obs' have the same dimensions
  if (all.equal(dim(sim), dim(obs)) != TRUE)
    stop( paste("Invalid argument: dim(sim) != dim(obs) ([",
          paste(dim(sim), collapse = " "), "] != [",
          paste(dim(obs), collapse = " "), "])", sep = ""))

  wNSE <- rep(NA, ncol(obs))

  wNSE <- sapply(1:ncol(obs), function(i, x, y) {
                 wNSE[i] <- wNSE.default(x[, i], y[, i], na.rm = na.rm, fun=fun, ..., 
                                         epsilon.type=epsilon.type, epsilon.value=epsilon.value)
               }, x = sim, y = obs)

  names(wNSE) <- colnames(obs)
  return(wNSE)

} # 'wNSE.matrix' end


wNSE.data.frame <- function(sim, obs, na.rm = TRUE, fun=NULL, ..., 
                            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                            epsilon.value=NA) { 

  # Checking 'epsilon.type'
  epsilon.type <- match.arg(epsilon.type) 

  sim <- as.matrix(sim)
  obs <- as.matrix(obs)

  wNSE.matrix(sim, obs, na.rm = na.rm, fun=fun, ..., 
              epsilon.type=epsilon.type, epsilon.value=epsilon.value)

} # 'wNSE.data.frame' end


################################################################################
wNSE.zoo <- function(sim, obs, na.rm=TRUE, fun=NULL, ..., 
                     epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                     epsilon.value=NA) {

    # Checking 'epsilon.type'
    epsilon.type <- match.arg(epsilon.type) 

    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)

    if (is.matrix(sim) | is.data.frame(sim)) {
       wNSE.matrix(sim, obs, na.rm = na.rm, fun=fun, ..., 
                   epsilon.type=epsilon.type, epsilon.value=epsilon.value)
    } else NextMethod(sim, obs, na.rm = na.rm, fun=fun, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)

  } # 'wNSE.zoo' end

# File sKGE.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/
# Copyright 2022-2025 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'sKGE': split Kling-Gupta Efficiency                                         #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 12-Jul-2022                                                         #
# Updates: 13-Jul-2022 ; 14-Jul-2022                                           #
#          16-Jan-2023                                                         #
#          06-May-2024 ; 08-May-2024                                           # 
#          26-Dec-2025                                                         #
################################################################################
# The optimal value of sKGE is 1

# Ref:
# Fowler, K., Coxon, G., Freer, J., Peel, M., Wagener, T., 
# Western, A., Woods, R. and Zhang, L. (2018). Simulating runoff under 
# changing climatic conditions: A framework for model improvement.
# Water Resources Research, 54(12), pp.9812-9832. doi:https://doi.org/10.1029/2018WR023989

sKGE <- function(sim, obs, ...) UseMethod("sKGE")

# epsilon: By default it is set at one hundredth of the mean flow. See Pushpalatha et al. (2012)
sKGE.default <- function(sim, obs, s=c(1,1,1), na.rm=TRUE, 
                         method=c("2009", "2012", "2021"),
                         start.month=1, out.PerYear=FALSE,
                         fun=NULL,
                         ...,
                         epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                         epsilon.value=NA
                         ) { 

  lKGE <- function(i, lsim, lobs, s=c(1,1,1), na.rm=TRUE, 
                   method=c("2009", "2012", "2021"), out.type="single",
                   fun1=NULL,
                   ...,
                   epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                   epsilon.value=NA) {
    llsim <- lsim[[i]]
    llobs <- lobs[[i]]

    out <- KGE(sim=llsim, obs=llobs, s=s, na.rm=na.rm, method=method, out.type=out.type,
               fun=fun1, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value)
    return(out)
  } #'lKGE' END


  # Function for shifting a time vector by 'nmonths' number of months.
  # This function is taken from the hydroTSM R package (internal function)
  shiftyears <- function(ltime,       # vector with the date/times of each element 
                                    # of a zoo object
                       lstart.month # numeric in [2,..,12], 2:Feb, 12:Dec, 
                                    # It represents the starting month to be 
                                    # used in the computation of annual values.
                       ) {
  syears.bak        <- as.numeric(format( ltime, "%Y" ))
  syears            <- syears.bak
  smonths           <- as.numeric(format( ltime, "%m"))
  months2moveback   <- 1:(lstart.month-1)
  N                 <- length(months2moveback)
  for (i in 1:N) {
    m.index          <- which(smonths == months2moveback[i])
    syears[m.index]  <- syears[m.index] - 1
  } # FOR end

  return(syears)
} # 'shiftyears' END
   
    
  # Checking 'method' and 'epsilon.type'
  method       <- match.arg(method)
  epsilon.type <- match.arg(epsilon.type)

  if ( !inherits(sim, "zoo") | !inherits(obs, "zoo"))
    stop("Invalid argument: 'sim' and 'obs' must be 'zoo' objects !")

  # Selecting only valid paris of values
  vi <- valindex(sim, obs)     
  if (length(vi) > 0) {	 
    obs <- obs[vi]
    sim <- sim[vi]

    if (!is.null(fun)) {
      fun <- match.fun(fun)
      new <- preproc(sim=sim, obs=obs, fun=fun, ..., 
                     epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim <- new[["sim"]]
      obs <- new[["obs"]]
    } # IF end
  } else stop("There are no points with simultaneous values of 'sim' and 'obs' !!")

  # Annual index for 'x'
  dates.sim  <- time(sim)
  dates.obs  <- time(obs)
  years.sim  <- format( dates.sim, "%Y")
  years.obs  <- format( dates.obs, "%Y")
  if (!all.equal(years.sim, years.obs)) {
    stop("Invalid argument: 'sim' and 'obs' must have the same dates !")
  } else {

      if (start.month !=1) 
        years.obs <- shiftyears(dates.obs, start.month)

      years.unique <- unique(years.obs)
      nyears       <- length(years.unique)
    } # ELSE end


  # Getting a list of 'sim' and 'obs' values for each year
  sim.PerYear <- split(coredata(sim), years.obs)
  obs.PerYear <- split(coredata(obs), years.obs) # years.sim == years.obs


  # Computing Annual KGE values
  #if (!is.null(fun)) {
  KGE.yr <- sapply(1:nyears, FUN=lKGE, lsim=sim.PerYear, lobs=obs.PerYear, s=s, 
                   na.rm= na.rm, method=method, out.type="single", 
                   fun1=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value)

  names(KGE.yr) <- as.character(years.unique)

  sKGE <- mean(KGE.yr, na.rm=na.rm)

  if (out.PerYear) {
    out <- list(sKGE.value=sKGE, KGE.PerYear=KGE.yr)
  } else out <- sKGE
    
  return(out)
} # 'sKGE.default' END


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 12-Jul-2022                                                         #
# Updates: 14-Jul-2022                                                         #
#          16-Jan-2023                                                         #
#          06-May-2024 ; 08-May-2024                                           # 
################################################################################
sKGE.matrix <- function(sim, obs, s=c(1,1,1), na.rm=TRUE, 
                         method=c("2009", "2012", "2021"),
                         start.month=1, out.PerYear=FALSE, 
                         fun=NULL,
                         ...,
                         epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                         epsilon.value=NA) { 

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
     stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
           paste(dim(sim), collapse=" "), "] != [", 
           paste(dim(obs), collapse=" "), "] )", sep="") )
           
  # If the user provided a value for 's'
  if (!all.equal(s, c(1,1,1)) )  {
     if ( length(s) != 3 ) stop("Invalid argument: lenght(s) must be equal to 3 !")
     if ( sum(s) != 1 )    stop("Invalid argument: sum(s) must be equal to 1.0 !")
  } # IF end
           
  method       <- match.arg(method)
  epsilon.type <- match.arg(epsilon.type)

  ifelse(method=="2012", vr.stg <- "Gamma", vr.stg <- "Alpha")

 # Annual index for 'sim' and 'obs'
  dates.sim  <- time(sim)
  dates.obs  <- time(obs)
  years.sim  <- format( dates.sim, "%Y")
  years.obs  <- format( dates.obs, "%Y")
  if (!all.equal(years.sim, years.obs)) {
    stop("Invalid argument: 'sim' and 'obs' must have the same dates !")
  } 
  nyears <- length(unique(years.obs))

  sKGE               <- rep(NA, ncol(obs))       
  elements           <- matrix(NA, nrow=nyears, ncol=ncol(obs))
  rownames(elements) <- unique(years.obs)
  colnames(elements) <- colnames(obs)
          
  out.single <- sapply(1:ncol(obs), function(i,x,y) { 
                       sKGE[i] <- sKGE.default( x[,i], y[,i], s=s, na.rm=na.rm, 
                                                method=method, 
                                                start.month=start.month, 
                                                out.PerYear=out.PerYear, 
                                                fun=fun, ..., 
                                                epsilon.type=epsilon.type, 
                                                epsilon.value=epsilon.value )[[1]]
                 }, x=sim, y=obs )  
   names(out.single) <- names(obs)

   if (out.PerYear) {        
    out.yr <- sapply(1:ncol(obs), function(i,x,y) { 
                    elements[,i] <-  sKGE.default( x[,i], y[,i], s=s, na.rm=na.rm, 
                                                method=method, 
                                                start.month=start.month, 
                                                out.PerYear=out.PerYear, 
                                                fun=fun, ..., 
                                                epsilon.type=epsilon.type, 
                                                epsilon.value=epsilon.value )[[2]]
                   }, x=sim, y=obs ) 
 
    colnames(out.yr) <- names(obs)                     
  } # IF end

  if (out.PerYear) {
    out <- list(sKGE.value=out.single, sKGE.PerYear=out.yr)
  } else out <- out.single
  
  return(out) 
     
} # 'sKGE.matrix' end


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 12-Jul-2022                                                         #
# Updates: 14-Jul-2022                                                         #
#          16-Jan-2023                                                         #
#          08-May-2024                                                         # 
################################################################################
sKGE.data.frame <- function(sim, obs, s=c(1,1,1), na.rm=TRUE, 
                            method=c("2009", "2012", "2021"),
                            start.month=1, out.PerYear=FALSE,  
                            fun=NULL,
                            ...,
                            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                            epsilon.value=NA) { 
 
  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
  
  method       <- match.arg(method)
  epsilon.type <- match.arg(epsilon.type) 
   
  sKGE.matrix(sim, obs, s=s, na.rm=na.rm, method=method, 
              start.month=start.month, out.PerYear=out.PerYear, fun=fun, ...,  
              epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'sKGE.data.frame' end


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 12-Jul-2022                                                         #
# Updates: 14-Jul-2022                                                         #
#          16-Jan-2023                                                         #
#          08-May-2024                                                         # 
################################################################################
sKGE.zoo <- function(sim, obs, s=c(1,1,1), na.rm=TRUE, 
                     method=c("2009", "2012", "2021"),
                     start.month=1, out.PerYear=FALSE,   
                     fun=NULL,
                     ...,
                     epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                     epsilon.value=NA) { 

  #sim <- zoo::coredata(sim)
  #if (is.zoo(obs)) obs <- zoo::coredata(obs)    

  if (is.matrix(sim) | is.data.frame(sim)) {
    sKGE.matrix(sim, obs, s=s, na.rm=na.rm, method=method, 
                start.month=start.month, out.PerYear=out.PerYear, fun=fun, ..., 
                epsilon.type=epsilon.type, epsilon.value=epsilon.value)
  } else NextMethod(sim, obs, s=s, na.rm=na.rm, method=method, 
                    start.month=start.month, out.PerYear=out.PerYear, fun=fun, ..., 
                    epsilon.type=epsilon.type, epsilon.value=epsilon.value)  
     
} # 'sKGE.zoo' end

# File pfactor.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/
# Copyright 2010-2026 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

##########################################################################
# pfactor: % of observations that are within the given uncertainty bounds#
##########################################################################
#	                       Date: 24-Jan-2010                             #
##########################################################################
# 'x'        : ts or 'zoo' object with the simulated values
# 'lband'    : ts or 'zoo' object with the values of the lower uncertainty bound
# 'uband'    : ts or 'zoo' object with the values of the upper uncertainty bound

# Ideally, i.e., with a combination of model structure and parameter values 
# that perfectly represents the catchment under study, and in absence of 
# measurement errors and other additional sources of uncertainty, all the 
# simulated values should be in a perfect match with the observations, 
# leading to a P-factor equal to 1, and an R-factor equal to zero. 
# However, in real-world applications we aim at encompassing as much 
# observations as possible within the given uncertainty bounds 
# (P-factor close to 1) while keeping the width of the uncertainty bounds 
# as small as possible (R-factor close to 0), in order to avoid obtaining 
# a good bracketing of observations at expense of uncertainty bounds too 
# wide to be informative for the decision-making process.

# Refs:
# Abbaspour, K. C., M. Faramarzi, S. S. Ghasemi, and H. Yang (2009), 
# Assessing the impact of climate change on water resources in Iran, 
# Water Resour. Res., 45(10), W10,434, doi:10.1029/2008WR007615. \cr

# Abbaspour, K. C., J. Yang, I. Maximov, R. Siber, K. Bogner, J. Mieleitner, 
# J. Zobrist, and R. Srinivasan (2007), Modelling hydrology and water quality 
# in the pre-alpine/alpine Thur watershed using SWAT, Journal of Hydrology, 
# 333(2-4), 413-430, doi:10.1016/j.jhydrol.2006.09.014.

# Schuol, J., K. Abbaspour, R. Srinivasan, and H. Yang (2008b), 
# Estimation of freshwater availability in the West African sub-continent 
# using the SWAT hydrologic model, Journal of Hydrology, 352(1-2), 30, 
# doi:10.1016/j.jhydrol.2007.12.025. \cr

# Abbaspour, C., Karim (2007), User manual for SWAT-CUP, SWAT calibration 
# and uncertainty analysis programs, 93pp, Eawag: Swiss Fed. Inst. of Aquat. Sci. and 
# Technol. Dubendorf, Switzerland, Available at http://www.eawag.ch/organisation/abteilungen/siam/software/swat/index_EN

pfactor <- function(x, ...) UseMethod("pfactor")

pfactor.default <- function(x, lband, uband, na.rm=TRUE, ...)  {

    # Just in case 'some' of them be ts or 'zoo'
    x     <- as.numeric(x)
    lband <- as.numeric(lband)
    uband <- as.numeric(uband)
        
    # Getting the row index in 'q95' of all the observations that are within L95PPU and U95PPU
    within.index <- which((lband <= x) & (x <= uband) )
    
    L <- length( x ) 
    
    if ( L > 0) {     
      pfactor <- length( within.index ) / L
    } else {
         pfactor <- NA 
         warning("'length(x)=0', it is not possible to compute 'pfactor'") 
      } # ELSE end
    
    return(pfactor)

} # 'pfactor.default' end


pfactor.matrix <- function (x, lband, uband, na.rm=TRUE, ...){

    # Checking that 'x' and 'lband', 'uband' have the same dimensions
    if ( !identical(dim(x), dim(lband)) | !identical(dim(x), dim(uband)) )
    stop( paste("Invalid argument: 'dim(x)', 'dim(lband)', and/or 'dim(uband)' doesn't match ( [", 
          paste(dim(x), collapse=" "), "], [", 
          paste(dim(lband), collapse=" "), "], [", 
          paste(dim(uband), collapse=" "), "] )", sep="") )

    pfactor <- rep(NA, ncol(x))       
          
    pfactor <- sapply(1:ncol(x), function(i,x,l,u) { 
                 pfactor[i] <- pfactor.default( x[,i], l[,i], u[,i], na.rm=na.rm, ... )
            }, x=x, l=lband, u=uband )            
           
    return(pfactor)  
     
  } # 'pfactor.matrix' end
  

pfactor.data.frame <- function (x, lband, uband, na.rm=TRUE, ...){ 
 
  x     <- as.matrix(x)
  lband <- as.matrix(lband)
  uband <- as.matrix(uband)
   
  pfactor.matrix(x, lband, uband, na.rm=na.rm, ...)
     
} # 'pfactor.data.frame' end 

# File ggof.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/
# Copyright 2009-2025 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'ggof': Graphical comparison between two vectors (numeric, ts, zoo, xts),    #
#         with several numerical goodness-of-fit measures as a legend          #
################################################################################
#  Started:  03 Mar 2009                                                       #
#  Updates:  Apr, May 2009                                                     #
#            2010                                                              #
#            17-Apr-2011                                                       # 
#            15-Oct-2012                                                       #
#            15-Apr-2013 ; 15-May-2013                                         #
#            20-Jan-2024 ; 22-Mar-2024 ; 23-Mar-2024 ; 08-May-2024             #
#            01-Nov-2025                                                       #
#            26-Apr-2026 ;29-Apr-2026                                          #
################################################################################     
                                          
      
ggof <- function (sim, obs, 
                  na.rm=TRUE, 
                  dates, 
                  date.fmt="%Y-%m-%d",

                  pt.style="ts",
                  ftype="o", 
                  FUN,

                  stype="default", 
                  season.names=c("Winter", "Spring", "Summer", "Autumn"),
                  
                  gof.leg = TRUE, 
                  digits=2, 
                  gofs=c( "ME",  "MAE",  "RMSE", "NRMSE", "PBIAS", 
                         "NSE",    "d",    "dr",     "r",    "R2",  
                         "KGE",  "LCE", "JDKGE",    "VE"),
                  
                  legend,
                  leg.cex=1,
                  
                  tick.tstep= "auto", 
                  lab.tstep= "auto",  
                  lab.fmt=NULL,
                  
                  cal.ini=NA, 
                  val.ini=NA,                
                  
                  main, 
                  xlab="Time", 
                  ylab=c("Q, [m3/s]"),  
                  
                  col= c("blue", "black"), 
                  
                  cex= c(0.5,0.5),
                  cex.axis=1.2,
                  cex.lab=1.2,
                  
                  lwd= c(1,1), 
                  lty= c(1,3), 
                  pch= c(1,9),                
                   
                   ...) {

  # Saving the current graphical parameter settings,
  # and restoring them on exit
  oldpars <- par(no.readonly=TRUE)

  on.exit({
    layout(1)
    par(oldpars)
  }, add=TRUE)

  # Checking class 'sim' &'obs'   
  valid.class <- c("xts", "zoo", "numeric", "integer")    
  if (length(which(!is.na(match(class(sim), valid.class )))) <= 0)  
         stop("Invalid argument: 'class(sim)' must be in c('xts', 'zoo', 'numeric', 'integer')")
  if (length(which(!is.na(match(class(obs), valid.class )))) <= 0)
         stop("Invalid argument: 'class(obs)' must be in c('xts', 'zoo', 'numeric', 'integer')")	
         
  # Checking length
  if ( length(sim) != length(obs) )  
     stop("Invalid argument: 'obs' and 'sim' must have the same length ! (", 
          length(obs), " vs ", length(sim), ")")

  # Checking 'gofs'.  'rSpearman', 'pbiasFDC' and 'PMR' are not computed
  gofs.all=c(   "ME",    "MAE",    "MSE",  "RMSE", "ubRMSE", 
             "NRMSE",  "PBIAS",   "RSR",    "rSD",    "NSE",  
             "mNSE" ,   "rNSE",  "wNSE",  "wsNSE",      "d",     
                "dr",     "md",    "rd",     "cp",      "r",     
                "R2",    "bR2",    "VE",    "KGE",  "KGElf",  
             "KGEnp",  "KGEkm", "JDKGE",    "LME",    "LCE", 
              "sKGE",    "HFB",  "APFB")   

  # Removing 'sKGE', 'APFB' and 'HFB' when 'sim' and 'obs' are not zoo objects
  if ( !( zoo::is.zoo(sim) & zoo::is.zoo(obs) ) )
    gofs.all <- gofs.all[ -c( (length(gofs.all)-2):(length(gofs.all)) ) ]

  # Checking the sampling frequency of 'sim' and 'obs'
  sim.sfreq <- NULL
  obs.sfreq <- NULL
  if ( zoo::is.zoo(sim) & zoo::is.zoo(obs) ) {
    sim.sfreq <- hydroTSM::sfreq(sim)
    obs.sfreq <- hydroTSM::sfreq(obs)
    if ( sim.sfreq != obs.sfreq)
      stop("Invalid arguments: sampling frequency of 'sim' and 'obs' is not the same ! (", 
           sim.sfreq, " != ", obs.sfreq, ")")
  } # IF end

  # Removing 'sKGE', 'APFB' and 'HFB' when 'sim' and 'obs' are annual zoo objects
  if ( !is.null(sim.sfreq) ) {
    if ( sim.sfreq == "annual" ) {
      index    <- pmatch( c("sKGE", "APFB", "HFB"), gofs.all )
      gofs.all <- gofs.all[-index]
    } # IF end
  } # IF end

  # Checking 'gofs' 
  noNms.index <- which( !(gofs %in% gofs.all) )
  if (length(noNms.index) > 0) {
    noNms <- gofs[noNms.index]
    warning("[Unknown names in 'gofs': ", paste(noNms, collapse = ", "), " (not used) !]")
  } # IF end     
  gofs.index  <- which( (gofs %in% gofs.all) )
  gofs        <- gofs[gofs.index]
                
  # 'xname' and 'yname' values
  sim.name <- deparse(substitute(sim))
  obs.name <- deparse(substitute(obs))

  # 'legend' value
  if (missing(legend)) legend <- c(sim.name, obs.name)
                   
  # Checking same sampling frequency
  if ( zoo::is.zoo(obs) & zoo::is.zoo(sim)) {
      if (all.equal(time(obs), time(sim)) != TRUE)
        stop("Invalid argument: 'obs' and 'sim' have different time stamps !")
  } # IF end    
          
  # If the user provided values 'for 'dates'
  if (!missing(dates)) {
  
    # Checking that 'dates' have the same length than 'sim' ( and 'obs')      
    if ( length(dates) != length(sim) )  
        stop("Invalid argument: 'dates' and 'sim' must have the same length")
  
    # Checking that 'dates' have the right class
    if (is.na(match(class(dates), c("character", "factor", "Date", "POSIXct")))) 
        stop("Invalid argument: 'class(dates)' must be in c('character', 'factor', 'Date', 'POSIXct')")
        
    # If 'dates' is a factor or character, it have to be converted into 'Date' class, 
    # using the date format  specified by 'date.fmt'
     if ( class(dates)[1] %in% c("factor", "character") ) {
        ifelse ( grepl("%H", date.fmt, fixed=TRUE) | grepl("%M", date.fmt, fixed=TRUE) |
             grepl("%S", date.fmt, fixed=TRUE) | grepl("%I", date.fmt, fixed=TRUE) |
             grepl("%p", date.fmt, fixed=TRUE) | grepl("%X", date.fmt, fixed=TRUE),
             subdaily <- TRUE, subdaily <- FALSE )
        ifelse(subdaily, dates <- as.POSIXct(dates, format= date.fmt), 
                         dates <- as.Date(dates, format= date.fmt) )  
     } # IF end  
    
    # If 'obs' is 'zoo' and the user provides the dates (probably new dates)
    if ( zoo::is.zoo(obs) ) time(obs) <- dates
    # If 'sim' is 'zoo' and the user provides the dates  (probably new dates)
    if ( zoo::is.zoo(sim) ) time(sim) <- dates   
    
  } else if (!zoo::is.zoo(obs)) 
            message("[ Note: You did not provide dates, so only a numeric index will be used in the time axis ]")    
  
  # If 'class(obs)' is not 'zoo' and the user provides the dates, then we turn it into a zoo class
  if ( !zoo::is.zoo(obs) & !missing(dates) ) { 
    obs <- vector2zoo(x=obs, dates=dates, date.fmt=date.fmt) # hydroTSM::vector2zoo       
  } # If 'class(obs)' is 'zoo' and 'dates' are missing, dates are extracted from 'obs'
    else if ( zoo::is.zoo(obs) & missing(dates) ) {  
      if ( class(time(obs))[1] %in% c("Date", "POSIXct") ) { 
         dates <- time(obs) 
      } else if ( class(time(obs))[1] == "character" )  
                 dates <- as.Date(time(obs), format="%Y")      
    } #ELSE END
  
  # If 'class(sim)' is not 'zoo' and the user provides the dates, then we turn it into a zoo class
  if ( !zoo::is.zoo(sim) & !missing(dates) ) { 
    sim <- vector2zoo(x=sim, dates=dates, date.fmt=date.fmt) # hydroTSM::vector2zoo
  # If 'class(sim)' is 'zoo' and 'dates' are missing, dates are extracted from 'sim'
  } else if ( zoo::is.zoo(sim) & zoo::is.zoo(obs) & missing(dates) ) {
      if ( class(time(sim))[1]  %in% c("Date", "POSIXct") ) { 
         dates <- time(obs) 
      } else if ( class(time(sim))[1] == "character" ) {  
             dates <- as.Date(time(sim), format="%Y") }
    } #ELSE END    
    
  # Checking 'ftype'       
  if (is.na(match(ftype, c("o", "dm", "ma", "dma", "seasonal") ) ) ) 
      stop("Invalid argument: 'ftype' must be in c('o', 'dm', 'ma, 'dma', 'seasonal')")
  
  # If 'obs' and 'sim' are not zoo objects, the only possible value for 'ftype' is 'o'     
  if ( !zoo::is.zoo(sim) & !zoo::is.zoo(obs) ) {
     if (!is.na(match(ftype, c("dm", "ma", "dma", "seasonal") ) ) ) 
      message("[ Note: 'sim' & 'obs' are not zoo objects => 'ftype' was changed to 'o' ]")
      ftype <- "o"
  } else if ( zoo::is.zoo(sim) ) 
          sim.freq <- xts::periodicity(sim)$scale
         
  # Checking FUN, when 'ftype' involves monthly or annual values     
  if (!is.na(match(ftype, c("dm", "ma", "dma", "seasonal") ) ) & missing(FUN) ) 
         stop("Missing argument: 'FUN' must be provided when 'ftype' is in c('dm', 'ma, 'dma', 'seasonal')")

  # If the user did not provide a title for the plot, the default is used 
  if ( missing(main) ) main <- "Observations vs Simulations"     
  
  #Plotting according to the 'ftype' value:  
  if (ftype == "o") {
        
   # Drawing the original time series against time
   plot2(x=sim, y=obs, plot.type="single",
         main= main, 
         col= col, lwd= lwd, lty=lty, pch=pch,
         xlab= xlab, ylab= ylab, pt.style= pt.style,
         add= FALSE,
         tick.tstep, lab.tstep, lab.fmt=lab.fmt,
         cex = cex, cex.axis=cex.axis, cex.lab=cex.lab, 
         gof.leg = gof.leg, gof.digits=digits, gofs=gofs,
         legend=legend, leg.cex=leg.cex,
         cal.ini=cal.ini, val.ini=val.ini, date.fmt=date.fmt, ...)
         
  } else if (ftype=="dm") {

      # if 'sim' and 'obs' are subdaily ts
      if (sim.sfreq %in% c("minute", "hourly") ) {
        sim <- hydroTSM::subdaily2daily(sim, FUN=FUN, na.rm=na.rm)
        obs <- hydroTSM::subdaily2daily(obs, FUN=FUN, na.rm=na.rm)

        sim.freq <- "daily"
      } # END IF

    
      if (sim.freq != "daily") {      
        stop("Invalid argument: 'sim' has to have a 'daily' sampling frequency")       
      } else {
          # Generating a Monthly time series
          obs.monthly <- hydroTSM::daily2monthly(obs, FUN, na.rm) 
          sim.monthly <- hydroTSM::daily2monthly(sim, FUN, na.rm)
          
          # If the user wants a legend, the screen is split into 2 rows and 2 columns, 
          # where the proportion of width of the 1st column to the 2nd one is 9:2
          if (gof.leg) {           
            layout( matrix( c(1,1,1,1,1,1,1,1,1,2,2,3,3,3,3,3,3,3,3,3,4,4), ncol=11, byrow=TRUE) ) 
          } else {
             # Setting up the screen with 2 rows and 1 column
             par(mfrow=c(2,1))
            } #ELSE end
          
          par(mar=c(5, 4, 4, 0) + 0.1) # mar=c(bottom, left, top, right). Default values are: mar=c(5,4,4,2) + 0.1)  
          # Drawing the original daily time series against time
          plot2(x=sim, y=obs, plot.type="single",
                main=paste("Daily", main, sep=" "), 
                tick.tstep=tick.tstep, lab.tstep= lab.tstep, lab.fmt=lab.fmt,
                cex = cex, cex.axis=cex.axis, cex.lab=cex.lab, 
                col = col, lwd= lwd, lty=lty, pch=pch,  
                xlab= xlab, ylab= ylab, 
                pt.style= "ts", 
                add= TRUE,  
                gof.leg = gof.leg, gof.digits=digits, gofs=gofs,
                legend=legend, leg.cex=leg.cex,
                cal.ini=cal.ini, val.ini=val.ini, date.fmt=date.fmt, ... )
          
          # It is necessary to set up the margins again, after the previous call to plot2
          par(mar=c(5, 4, 4, 0) + 0.1) # mar=c(bottom, left, top, right). Default values are: mar=c(5,4,4,2) + 0.1)           
          # Drawing the Monthly time series against time
          plot2(x=sim.monthly, y=obs.monthly, plot.type="single",
                main=paste("Monthly", main, sep=" "), 
                tick.tstep=tick.tstep, lab.tstep= lab.tstep, lab.fmt=lab.fmt,
                cex = cex, cex.axis=cex.axis, cex.lab=cex.lab, 
                col = col, lwd= lwd, lty=lty, pch=pch, 
                xlab= xlab, ylab= ylab, 
                pt.style= "ts", 
                add= TRUE, 
                gof.leg = gof.leg, gof.digits=digits, gofs=gofs,
                legend=legend, leg.cex=leg.cex,
                cal.ini=cal.ini, val.ini=val.ini, date.fmt=date.fmt, ... )
                   
            
        } # ELSE end
  } # ELSE if (ftype=="dm") END
  
  else if (ftype=="ma") {

    # if 'sim' and 'obs' are subdaily ts
    if (sim.sfreq %in% c("minute", "hourly") ) {
      sim <- hydroTSM::subdaily2daily(sim, FUN=FUN, na.rm=na.rm)
      obs <- hydroTSM::subdaily2daily(obs, FUN=FUN, na.rm=na.rm)

      sim.freq <- "daily"
    } # END IF
  
    if  ( is.na( match( sim.freq, c("daily", "monthly") ) ) ) {      
      stop("Invalid argument: the sampling frequency of 'sim' has to be in c('daily', 'monthly'")       
    } else {
        if ( sim.freq == "daily" ) {
           # Generating a Monthly time series 
           obs <- hydroTSM::daily2monthly(obs, FUN, na.rm) # hydroTSM::daily2monthly
           sim <- hydroTSM::daily2monthly(sim, FUN, na.rm) # hydroTSM::daily2monthly
        } # IF end
        
        # Generating Annual time series
        obs.annual <- hydroTSM::monthly2annual(obs, FUN, na.rm, out.fmt="%Y-%m-%d") # hydroTSM::monthly2annual
        sim.annual <- hydroTSM::monthly2annual(sim, FUN, na.rm, out.fmt="%Y-%m-%d") # hydroTSM::monthly2annual
        
        #def.par <- par(no.readonly = TRUE) # save default, for resetting... 
        #on.exit(par(def.par)) 
        
        # If the user wants a legend, the screen is split into 2 rows and 2 columns, 
        # where the proportion of width of the 1st column to the 2nd one is 9:2
        if (gof.leg) {     
          layout( matrix( c(1,1,1,1,1,1,1,1,1,2,2,3,3,3,3,3,3,3,3,3,4,4), ncol=11, byrow=TRUE) )
        } else {
           # Setting up the screen with 2 rows and 1 column
           par(mfrow=c(2,1))
          } #ELSE end
        
        par(mar=c(5, 4, 4, 0) + 0.1) # mar=c(bottom, left, top, right). Default values are: mar=c(5,4,4,2) + 0.1)   
        # Drawing the Monthly time series against time
        plot2(x=sim, y=obs, plot.type="single",
              main=paste("Monthly", main, sep=" "), 
              tick.tstep=tick.tstep, lab.tstep= lab.tstep, lab.fmt=lab.fmt,
              cex = cex, cex.axis=cex.axis, cex.lab=cex.lab, 
              col = col, lwd= lwd, lty=lty, pch=pch,
              xlab= xlab, ylab= ylab, pt.style= "ts", 
              add= TRUE, 
              gof.leg = gof.leg, gof.digits=digits, gofs=gofs,
              legend=legend, leg.cex=leg.cex,
              cal.ini=cal.ini, val.ini=val.ini, date.fmt=date.fmt, ... )
        
        # It is necessary to set up the margins again, after the previous call to plot2
        par(mar=c(5, 4, 4, 0) + 0.1)                
        # Drawing the Annual time series against time
        plot2(x=sim.annual, y=obs.annual, plot.type="single",
              main=paste("Annual", main, sep=" "), 
              tick.tstep="years", lab.tstep= "years", 
              cex = cex, cex.axis=cex.axis, cex.lab=cex.lab, lab.fmt=lab.fmt,
              col = col, lwd= lwd, lty=lty, pch=pch, 
              xlab= xlab, ylab= ylab, pt.style= pt.style, 
              add= TRUE, 
              gof.leg = gof.leg, gof.digits=digits, gofs=gofs,
              legend=legend, leg.cex=leg.cex,
              cal.ini=cal.ini, val.ini=val.ini, date.fmt=date.fmt, ... )
      } # ELSE end      
   
  } # ELSE if (ftype=="ma") END
  
  else if (ftype=="dma") {

    # if 'sim' and 'obs' are subdaily ts
    if (sim.sfreq %in% c("minute", "hourly") ) {
      sim <- hydroTSM::subdaily2daily(sim, FUN=FUN, na.rm=na.rm)
      obs <- hydroTSM::subdaily2daily(obs, FUN=FUN, na.rm=na.rm)

      sim.freq <- "daily"
    } # END IF
        
    if (sim.freq != "daily") {      
      stop("Invalid argument: 'sim' has to have a 'daily' sampling frequency")      
    } else {       
          # Generating Monthly time series 
          obs.monthly <- daily2monthly(obs, FUN, na.rm) # hydroTSM::daily2monthly
          sim.monthly <- daily2monthly(sim, FUN, na.rm) # hydroTSM::daily2monthly
          
          # Generating Annual time series 
          obs.annual <- daily2annual(obs, FUN, na.rm, out.fmt = "%Y-%m-%d") # hydroTSM::daily2annual
          sim.annual <- daily2annual(sim, FUN, na.rm, out.fmt = "%Y-%m-%d") # hydroTSM::daily2annual
          
          #def.par <- par(no.readonly = TRUE) # save default, for resetting... 
          #on.exit(par(def.par)) 
          
          # If the user wants a legend, the screen is split into 2 rows and 2 columns, 
          # where the proportion of width of the 1st column to the 2nd one is 9:2
          if (gof.leg) {   
            # Setting up a screen with 3 rows and 2 columns 
            layout( matrix( c(1,1,1,1,1,1,1,1,1,2,2,3,3,3,3,3,3,3,3,3,4,4,5,5,5,5,5,5,5,5,5,6,6), ncol=11, byrow=TRUE) ) 
          } else {
             # Setting up the screen with 3 rows and 1 column
             par(mfrow=c(3,1))
            } #ELSE end  
          
          par(mar=c(5, 4, 4, 0) + 0.1) # mar=c(bottom, left, top, right). Default values are: mar=c(5,4,4,2) + 0.1) 
          # Drawing the original daily time series against time
          plot2(x=sim, y=obs, plot.type="single",
                main=paste("Daily", main, sep=" "), 
                tick.tstep=tick.tstep, lab.tstep= lab.tstep, lab.fmt=lab.fmt,
                cex = cex, cex.axis=cex.axis, cex.lab=cex.lab, 
                col = col, lwd= lwd, lty=lty, pch=pch,
                xlab= xlab, ylab= ylab, pt.style= "ts", 
                add= TRUE, 
                gof.leg = gof.leg, gof.digits=digits, gofs=gofs,
                legend=legend, leg.cex=leg.cex,
                cal.ini=cal.ini, val.ini=val.ini, date.fmt=date.fmt, ... )
          
          # It is necessary to set up the margins again, after the previous call to plot2
          par(mar=c(5, 4, 4, 0) + 0.1) # mar=c(bottom, left, top, right). Default values are: mar=c(5,4,4,2) + 0.1)        
          # Drawing the Monthly time series against time
          plot2(x=sim.monthly, y=obs.monthly, plot.type="single",  
                main=paste("Monthly", main, sep=" "), 
                tick.tstep=tick.tstep, lab.tstep= lab.tstep, lab.fmt=lab.fmt,
                cex = cex, cex.axis=cex.axis, cex.lab=cex.lab, 
                col = col, lwd= lwd, lty=lty, pch=pch, 
                xlab= xlab, ylab= ylab, pt.style= "ts", 
                add= TRUE, 
                gof.leg = gof.leg, gof.digits=digits, gofs=gofs,
                legend=legend, leg.cex=leg.cex,
                cal.ini=cal.ini, val.ini=val.ini, date.fmt=date.fmt, ... )
           
          # It is necessary to set up the margins again, after the previous call to plot2
          par(mar=c(5, 4, 4, 0) + 0.1) # mar=c(bottom, left, top, right). Default values are: mar=c(5,4,4,2) + 0.1)        
          # Drawing the Annual time series against time
          plot2(x=sim.annual, y=obs.annual, plot.type="single",
                  main=paste("Annual", main, sep=" "), 
                  tick.tstep="years", lab.tstep= "years", lab.fmt=lab.fmt,
                  cex = cex, cex.axis=cex.axis, cex.lab=cex.lab, 
                  col = col, lwd= lwd, lty=lty, pch=pch,
                  xlab= xlab, ylab= ylab, pt.style= pt.style, 
                  add= TRUE, 
                  gof.leg = gof.leg, gof.digits=digits, gofs=gofs,
                  legend=legend, leg.cex=leg.cex,
                  cal.ini=cal.ini, val.ini=val.ini, date.fmt=date.fmt, ... )
      } # ELSE end
            
  } else if (ftype=="seasonal") {

     # For seasonal plot a maximum of 9 GoFs are allowed.
     # If the user does not provide gofs, a defualt set is used
     # If the user provides more than 9 GoFs, only the first 9 are used 
     fn.gofs <- match.call()$gofs
     if (is.null(fn.gofs)) {
       gofs.default <- c("ME", "RMSE", "PBIAS", "RSR", "NSE", "d", "R2", "KGE", "VE") 
     } else if (length(gofs) > 9) {
         gofs <- gofs[1:9]
       } # ELSE end
     
     gof.index <- pmatch(gofs, gofs.all)
     gof.index <- gof.index[!is.na(gof.index)]  
     gofs      <- gofs.all[gof.index] 
        
    if (sim.freq %in% c("quarterly", "yearly")) {      
      stop("Invalid argument: 'sim' has to have a 'sub-daily', 'daily' or 'monthly' ts. However, 'sim' is a '", sim.freq, "' ts !")  
           
    } else {       
          # Checking that the user provied a valid value for 'stype'   
          valid.types <- c("default", "FrenchPolynesia")    
          if (length(which(!is.na(match(stype, valid.types )))) <= 0)  
            stop("Invalid argument: 'stype' must be in c('default', 'FrenchPolynesia')")

          # Labels for the seasons
          if (stype=="default") { 
            seasons.lab <- c("DJF",  "MAM", "JJA", "SON")
          } else if (stype=="FrenchPolynesia") { 
              seasons.lab <- c("DJFM", "AM",  "JJAS", "ON")
            } # ELSE end

          # Computing the seasonal values
          sim.winter <- dm2seasonal(sim, season=seasons.lab[1], FUN=FUN, out.fmt="%Y-%m-%d")
          sim.spring <- dm2seasonal(sim, season=seasons.lab[2], FUN=FUN, out.fmt="%Y-%m-%d")
          sim.summer <- dm2seasonal(sim, season=seasons.lab[3], FUN=FUN, out.fmt="%Y-%m-%d")
          sim.autumm <- dm2seasonal(sim, season=seasons.lab[4], FUN=FUN, out.fmt="%Y-%m-%d")
          
          obs.winter <- dm2seasonal(obs, season=seasons.lab[1], FUN=FUN, out.fmt="%Y-%m-%d")
          obs.spring <- dm2seasonal(obs, season=seasons.lab[2], FUN=FUN, out.fmt="%Y-%m-%d")
          obs.summer <- dm2seasonal(obs, season=seasons.lab[3], FUN=FUN, out.fmt="%Y-%m-%d")
          obs.autumm <- dm2seasonal(obs, season=seasons.lab[4], FUN=FUN, out.fmt="%Y-%m-%d")

          # Transforming the seasonal values into zoo objects
          sim.winter <- as.zoo(sim.winter)
          sim.spring <- as.zoo(sim.spring)
          sim.summer <- as.zoo(sim.summer)
          sim.autumm <- as.zoo(sim.autumm)
          
          obs.winter <- as.zoo(obs.winter)
          obs.spring <- as.zoo(obs.spring)
          obs.summer <- as.zoo(obs.summer)
          obs.autumm <- as.zoo(obs.autumm)
    
          #def.par <- par(no.readonly = TRUE) # save default, for resetting... 
          #on.exit(par(def.par)) 
          
          # If the user wants a legend, the screen is split into 2 rows and 2 columns, 
          # where the proportion of width of the 1st column to the 2nd one is 9:2
          if (gof.leg) {   
            # Setting up a screen with 4 rows and 2 columns 
            layout( matrix( c(1,1,1,1,1,1,1,1,1,2,2,3,3,3,3,3,3,3,3,3,4,4,5,5,5,5,5,5,5,5,5,6,6,7,7,7,7,7,7,7,7,7,8,8), ncol=11, byrow=TRUE) ) 
          } else {
             # Setting up the screen with 3 rows and 1 column
             par(mfrow=c(4,1))
            } #ELSE end  
          
          par(mar=c(5, 4, 4, 0) + 0.1) # mar=c(bottom, left, top, right). Default values are: mar=c(5,4,4,2) + 0.1) 
          # Drawing the 'winter' time series against time
          plot2(x=sim.winter, y=obs.winter, plot.type="single",
                main=paste(season.names[1], " (", seasons.lab[1], ")", sep=""),
                tick.tstep=tick.tstep, lab.tstep= lab.tstep, lab.fmt=lab.fmt,
                cex = cex, cex.axis=cex.axis, cex.lab=cex.lab, 
                col = col, lwd= lwd, lty=lty, pch=pch,
                xlab= xlab, ylab= ylab, pt.style= "ts", 
                add= TRUE, 
                gof.leg = gof.leg, gof.digits=digits, gofs=gofs,
                legend=legend, leg.cex=0.75, # leg.cex=leg.cex,
                cal.ini=cal.ini, val.ini=val.ini, date.fmt=date.fmt, ... )
          
          # It is necessary to set up the margins again, after the previous call to plot2
          par(mar=c(5, 4, 4, 0) + 0.1) # mar=c(bottom, left, top, right). Default values are: mar=c(5,4,4,2) + 0.1)        
          # Drawing the 'spring' time series against time
          plot2(x=sim.spring, y=obs.spring, plot.type="single",  
                main=paste(season.names[2], " (", seasons.lab[2], ")", sep=""),
                tick.tstep=tick.tstep, lab.tstep= lab.tstep, lab.fmt=lab.fmt,
                cex = cex, cex.axis=cex.axis, cex.lab=cex.lab, 
                col = col, lwd= lwd, lty=lty, pch=pch, 
                xlab= xlab, ylab= ylab, pt.style= "ts", 
                add= TRUE, 
                gof.leg = gof.leg, gof.digits=digits, gofs=gofs,
                legend=legend, leg.cex=0.75, # leg.cex=leg.cex,
                cal.ini=cal.ini, val.ini=val.ini, date.fmt=date.fmt, ... )
           
          # It is necessary to set up the margins again, after the previous call to plot2
          par(mar=c(5, 4, 4, 0) + 0.1) # mar=c(bottom, left, top, right). Default values are: mar=c(5,4,4,2) + 0.1)        
          # Drawing the 'summer' time series against time
          plot2(x=sim.summer, y=obs.summer, plot.type="single",
                  main=paste(season.names[3], " (", seasons.lab[3], ")", sep=""),
                  tick.tstep="years", lab.tstep= "years", lab.fmt=lab.fmt,
                  cex = cex, cex.axis=cex.axis, cex.lab=cex.lab, 
                  col = col, lwd= lwd, lty=lty, pch=pch,
                  xlab= xlab, ylab= ylab, pt.style= pt.style, 
                  add= TRUE, 
                  gof.leg = gof.leg, gof.digits=digits, gofs=gofs,
                  legend=legend, leg.cex=0.75, # leg.cex=leg.cex,
                  cal.ini=cal.ini, val.ini=val.ini, date.fmt=date.fmt, ... )

          # It is necessary to set up the margins again, after the previous call to plot2
          par(mar=c(5, 4, 4, 0) + 0.1) # mar=c(bottom, left, top, right). Default values are: mar=c(5,4,4,2) + 0.1)        
          # Drawing the 'autumm' time series against time
          plot2(x=sim.autumm, y=obs.autumm, plot.type="single",
                  main=paste(season.names[4], " (", seasons.lab[4], ")", sep=""),
                  tick.tstep="years", lab.tstep= "years", lab.fmt=lab.fmt,
                  cex = cex, cex.axis=cex.axis, cex.lab=cex.lab, 
                  col = col, lwd= lwd, lty=lty, pch=pch,
                  xlab= xlab, ylab= ylab, pt.style= pt.style, 
                  add= TRUE, 
                  gof.leg = gof.leg, gof.digits=digits, gofs=gofs,
                  legend=legend, leg.cex=0.75, # leg.cex=leg.cex,
                  cal.ini=cal.ini, val.ini=val.ini, date.fmt=date.fmt, ... )
      } # ELSE end
            
  } # ELSE if (ftype=="seasonal")
  
} # 'ggof' end

test_that("ggof restores graphical parameters after a basic plot", {
  pngfile <- tempfile(fileext = ".png")
  grDevices::png(pngfile)
  on.exit(grDevices::dev.off(), add = TRUE)

  graphics::par(mfrow = c(2, 2), mar = c(2, 2, 2, 2), las = 2)
  before <- graphics::par(c("mfrow", "mar", "las"))

  ggof(1:20, 1:20, gof.leg = FALSE)

  after <- graphics::par(c("mfrow", "mar", "las"))
  expect_identical(after, before)
})

test_that("ggof restores graphical parameters after a multi-panel plot", {
  skip_if_not_installed("zoo")
  skip_if_not_installed("hydroTSM")
  suppressPackageStartupMessages(library(zoo))

  dates <- seq.Date(as.Date("2000-01-01"), by = "day", length.out = 800)
  obs <- zoo::zoo(abs(sin(seq_along(dates) / 20)) + 1, dates)
  sim <- obs * 1.1

  pngfile <- tempfile(fileext = ".png")
  grDevices::png(pngfile)
  on.exit(grDevices::dev.off(), add = TRUE)

  graphics::par(mfrow = c(2, 2), mar = c(2, 2, 2, 2), las = 2)
  before <- graphics::par(c("mfrow", "mar", "las"))

  ggof(sim, obs, ftype = "dm", FUN = mean, gof.leg = FALSE)

  after <- graphics::par(c("mfrow", "mar", "las"))
  expect_identical(after, before)
})

# File pbiasfdc.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2010-2023 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'pbiasfdc': PBIAS in the slope of the midsegment of the Flow Duration Curve  #
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 03-Feb-2010                                                         #
################################################################################
# Updates: 15-Apr-2013                                                         #
#          16-Jan-2023                                                         #
#          08-May-2024                                                         #
################################################################################
# 'obs'   : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim'   : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 'lQ.thr': numeric, used to classify low flows. All the streamflows with a probaility of exceedence larger or equal to 'lQ.thr' are classified as low flows
# 'hQ.thr': numeric, used to classify high flows. All the streamflows with a probaility of exceedence lower or equal to 'hQ.thr' are classified as high flows
# 'plot'  : a logical value indicating if the flow duration curves corresponding to 'obs' and 'sim' have to be  plotted or not.

# 'Result': Percent Bias in the slope of the midsegment of the flow duration curve [%]
#           It measures the vertical soil moisture redistribution

# Ref:  Yilmaz, K. K., H. V. Gupta, and T. Wagener  (2008), 
#       A process-based diagnostic approach to model evaluation: 
#       Application to the NWS distributed hydrologic model, 
#       Water Resour. Res., 44, W09417, doi:10.1029/2007WR006716.


pbiasfdc <-function(sim, obs, ...) UseMethod("pbiasfdc")

pbiasfdc.default <- function(sim, obs, lQ.thr=0.6, hQ.thr=0.1, na.rm=TRUE, 
                             plot=TRUE, verbose=FALSE, fun=NULL, ...,
                             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                             epsilon.value=NA){

   # Returns the position in the vector 'x' where the scalar 'Q' is located
   Qposition <- function(x, Q) {     
     Q.dist  <- abs(x - Q)
     Q.index <- which.min( Q.dist ) 
     return(Q.index)       
   } # end

  epsilon.type <- match.arg(epsilon.type)  

  # index of those elements that are present both in 'sim' and 'obs' (NON- NA values)
  vi <- valindex(sim, obs)
   
  if (length(vi) > 0) {	 
    # Filtering 'obs' and 'sim', selecting only those pairs of elements 
    # that are present both in 'x' and 'y' (NON- NA values)
    obs <- obs[vi]
    sim <- sim[vi]

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end   


     		      
    # Computing the FDC for simulations and observations
    obs.fdc <- fdc(obs, plot=FALSE) # hydroTSM::fdc
    sim.fdc <- fdc(sim, plot=FALSE) # hydroTSM::fdc
     
    # Finding the flow value corresponding to the 'lQ.thr' pbb of excedence
    obs.lQ <- obs[Qposition(obs.fdc, lQ.thr)]
    obs.hQ <- obs[Qposition(obs.fdc, hQ.thr)]
     
    sim.lQ <- sim[Qposition(sim.fdc, lQ.thr)]
    sim.hQ <- sim[Qposition(sim.fdc, hQ.thr)]     
     
    denominator <- ( log(obs.hQ) -  log(obs.lQ) )
     
    if ( (denominator > 0) & (!is.na(denominator)) ) {      
      pbiasfdc <- 100 * ( ( ( log(sim.hQ) -  log(sim.lQ) ) / denominator ) - 1 )
    } else {
         pbiasfdc <- NA 
         warning("'log(obs.hQ) -  log(obs.lQ) = 0' => it is not possible to compute 'pbiasfdc' !") 
      } 
   } else {
       pbiasfdc <- NA
       warning("There are no pairs of 'sim' and 'obs' without missing values !")
     } # ELSE end
     
   if (plot) {
     tmp <- as.matrix(cbind(obs, sim))
     fdc(tmp, lQ.thr=lQ.thr, hQ.thr=hQ.thr, verbose=verbose, ...)
     legend("bottomleft", legend=paste("BiasFDCms=", round(pbiasfdc,1), "%", sep=""), bty="n")
   } # IF end 
     
   return( pbiasfdc )
     
} # 'pbiasfdc.default' end
  
  

################################################################################
# 'pbiasfdc': PBIAS in the slope of the midsegment of the Flow Duration Curve  #
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 03-Feb-2010                                                         #
################################################################################
# Updates: 15-Apr-2013                                                         #
#          16-Jan-2023                                                         #
#          08-May-2024                                                         #
################################################################################
pbiasfdc.matrix <- function(sim, obs, lQ.thr=0.6, hQ.thr=0.1, na.rm=TRUE, 
                            plot=TRUE, verbose=FALSE, fun=NULL, ...,
                            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                            epsilon.value=NA){

    # Checking that 'sim' and 'obs' have the same dimensions
    if ( all.equal(dim(sim), dim(obs)) != TRUE )
    stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
          paste(dim(sim), collapse=" "), "] != [", 
          paste(dim(obs), collapse=" "), "] )", sep="") )

    pbiasfdc <- rep(NA, ncol(obs))       
          
    pbiasfdc <- sapply(1:ncol(obs), function(i,x,y) { 
                 pbiasfdc[i] <- pbiasfdc.default( x[,i], y[,i], lQ.thr=lQ.thr, hQ.thr=hQ.thr, 
                                                  na.rm=na.rm, plot=plot, verbose=verbose,
                                                  fun=fun, ..., 
                                                  epsilon.type=epsilon.type,  
                                                  epsilon.value=epsilon.value)
            }, x=sim, y=obs )            
           
    return(pbiasfdc)  
     
} # 'pbiasfdc.matrix' end
  


################################################################################
# 'pbiasfdc': PBIAS in the slope of the midsegment of the Flow Duration Curve  #
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 03-Feb-2010                                                         #
################################################################################
# Updates: 15-Apr-2013                                                         #
#          16-Jan-2023                                                         #
#          08-May-2024                                                         #
################################################################################
pbiasfdc.data.frame <- function(sim, obs, lQ.thr=0.6, hQ.thr=0.1, na.rm=TRUE, 
                                plot=TRUE, verbose=FALSE, fun=NULL, ...,
                                epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                                epsilon.value=NA){ 
 
  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
   
  pbiasfdc.matrix(sim, obs, lQ.thr=lQ.thr, hQ.thr=hQ.thr, na.rm=na.rm, plot=plot, verbose=verbose,
                  fun=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'pbiasfdc.data.frame' end 




################################################################################
# 'pbiasfdc': PBIAS in the slope of the midsegment of the Flow Duration Curve  #
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 03-Feb-2010                                                         #
################################################################################
# Updates: 15-Apr-2013                                                         #
#          16-Jan-2023                                                         #
################################################################################
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 08-May-2024                                                         #
################################################################################
pbiasfdc.zoo <- function(sim, obs, lQ.thr=0.6, hQ.thr=0.1, na.rm=TRUE, 
                         plot=TRUE, verbose=FALSE, fun=NULL, ...,
                         epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                         epsilon.value=NA){
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       pbiasfdc.matrix(sim, obs, lQ.thr=lQ.thr, hQ.thr=hQ.thr, na.rm=na.rm, plot=FALSE, verbose=verbose,
                       fun=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value)
    } else NextMethod(sim, obs, lQ.thr=lQ.thr, hQ.thr=hQ.thr, na.rm=na.rm, plot=plot, verbose=verbose,
                      fun=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'pbiasfdc.zoo' end

# File nrmse.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2008-2025 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'nrmse': Normalized Root Mean Square Error                                   #
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 15-Dic-2008                                                         #
# Updates: 06-Sep-2009                                                         #
#          03-Jul-2017                                                         #
#          16-Jan-2023                                                         #
#          21-Dec-2025                                                         #
################################################################################
# 'obs'   : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim'   : numeric 'data.frame', 'matrix' or 'vector' with simulated values

# 'norm'  : character, indicating the value to be used to normalise the RMS. Valid values are:
#           -) 'sd'    : standard deviation of observations.
#           -) 'maxmin': difference between maximum and minimum observed values
#           -) 'mean'  : arithmetic mean of observed values
#           -) 'IQR'   : interquantile range of observed values, computed using the \code{stats::IQR} function with \code{type=7}.

# 'Result': Normalized Root Mean Square Error between 'sim' and 'obs', 
#           when multiplied by 100 its units is %

nrmse <-function(sim, obs, ...) UseMethod("nrmse")
 
nrmse.default <- function(sim, obs, na.rm=TRUE, norm=c("sd", "maxmin", "mean", "IQR"), fun=NULL, ...,
                          epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                          epsilon.value=NA) {

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo", "xts"))) |
       is.na(match(class(obs), c("integer", "numeric", "ts", "zoo", "xts")))
     ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo', 'xts')")     

  # Checking the 'norm' argument
  norm <- match.arg(norm)   

  # Checking the 'epsilon.type' argument
  epsilon.type <- match.arg(epsilon.type) 
 
  # index of those elements that are present both in 'sim' and 'obs' (NON- NA values)
  vi <- valindex(sim, obs)
   
  if (length(vi) > 0) {	 
    # Filtering 'obs' and 'sim', selecting only those pairs of elements 
    # that are present both in 'x' and 'y' (NON- NA values)
    obs <- obs[vi]
    sim <- sim[vi]

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end     

    cte = switch(  
            norm,  
            "sd"= sd(obs, na.rm=na.rm), 
            "maxmin"= ( max(obs, na.rm= na.rm) - min(obs, na.rm =na.rm) ),  
            "mean"= mean(obs, na.rm=na.rm),  
            "IQR"= stats::IQR(obs, na.rm= na.rm, type=7),
          )  

    rmse <- rmse(sim, obs, na.rm) 
     
    if (cte != 0) {     
       nrmse <- rmse / cte     
    } else {
        nrmse <- NA
        warning("'obs' is constant -> it is not possible to compute 'nrmse' !")  
      } # ELSE end

  } else {
      nrmse <- NA
      warning("There are no pairs of 'sim' and 'obs' without missing values !")
    } # ELSE end
     
  return( round( 100*nrmse, 1) )
     
} # 'nrmse.default' end
  
 
################################################################################
# 'nrmse': Normalized Root Mean Square Error                                   #
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 15-Dic-2008                                                         #
# Updates: 06-Sep-2009 ; 05-Nov-2012                                           #
#          21-Dec-2025                                                         #
################################################################################
nrmse.matrix <- function(sim, obs, na.rm=TRUE, norm=c("sd", "maxmin", "mean", "IQR"), fun=NULL, ...,
                         epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                         epsilon.value=NA) {

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
    stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
          paste(dim(sim), collapse=" "), "] != [", 
          paste(dim(obs), collapse=" "), "] )", sep="") )

  nrmse <- rep(NA, ncol(obs))       
          
  nrmse <- sapply(1:ncol(obs), function(i,x,y) { 
                 nrmse[i] <- nrmse.default( x[,i], y[,i], na.rm=na.rm, norm=norm, 
                                            fun=fun, ..., 
                                            epsilon.type=epsilon.type,  
                                            epsilon.value=epsilon.value)
               }, x=sim, y=obs )    
                     
  names(nrmse) <- colnames(obs)
  
  return(nrmse)
     
} # 'nrms.matrix' end


################################################################################
# 'nrmse': Normalized Root Mean Square Error                                   #
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 15-Dic-2008                                                         #
# Updates: 06-Sep-2009                                                         #
#          21-Dec-2025                                                         #
################################################################################
nrmse.data.frame <- function(sim, obs, na.rm=TRUE, norm=c("sd", "maxmin", "mean", "IQR"), fun=NULL, ...,
                             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                             epsilon.value=NA) {

  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
   
  nrmse.matrix(sim, obs, na.rm=na.rm, norm=norm, fun=fun, ..., 
               epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'nrmse.data.frame' end
  
  
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 21-Dec-2025                                                         #
################################################################################
nrmse.zoo <- function(sim, obs, na.rm=TRUE, norm=c("sd", "maxmin", "mean", "IQR"), fun=NULL, ...,
                      epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                      epsilon.value=NA){
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       nrmse.matrix(sim, obs, na.rm=na.rm, norm=norm, ...)
    } else NextMethod(sim, obs, na.rm=na.rm, norm=norm, ...)
     
} # 'nrmse.zoo' end

# File KGE.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2011-2026 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'KGE': Kling-Gupta Efficiency                                                #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 18-Jan-2011                                                         #
# Updates: 25-Aug-2011                                                         #
#          10-Oct-2012                                                         #
#          18-Oct-2012 ; 19-Oct-2012                                           #
#          24-Jan-2014                                                         #
#          28-Feb-2016 ; 17-Jul-2016                                           #
#          12-Jul-2022 ; 13-Jul-2022                                           #
#          11-Jul-2023 ; 08-Nov-2023                                           #
################################################################################
# References:

# Ref1:
# Gupta, H.V.; Kling, H.; Yilmaz, K.K.; Martinez, G.F. (2009).
# Decomposition of the mean squared error and NSE performance criteria: 
# Implications for improving hydrological modelling, 
# Journal of Hydrology, Volume 377, Issues 1-2, 20 October 2009, Pages 80-91, 
# DOI: 10.1016/j.jhydrol.2009.08.003. ISSN 0022-1694, 

# Ref2:
# Kling, H.; Fuchs, M.; Paulin, M. (2012). Runoff conditions in the upper 
# Danube basin under an ensemble of climate change scenarios. 
# Journal of Hydrology, 424, 264-277. DOI:10.1016/j.jhydrol.2012.01.011.

# Ref3: Tang, G., Clark, M. P., & Papalexiou, S. M. (2021).  
# SC-earth: a station-based serially complete earth dataset from 1950 to 2019. 
# Journal of Climate, 34(16), 6493-6511. DOI: 10.1175/JCLI-D-21-0067.1.
################################################################################
# The optimal value of KGE is 1

# This goodness-of-fit measure was developed by Gupta et al. (2009) to provide a 
# diagnostically interesting decomposition of the Nash-Sutcliffe efficiency 
# (and hence MSE), which facilitates the analysis of the relative importance of  
# its different components (correlation, bias and variability) in the context of 
# hydrological modelling. 

# Kling et al. (2012) proposed a revised version of this index (KGE') to 
# ensure that the bias and variability ratios are not cross-correlated.

# Tang et al. (2021) proposed a revised version of this index to avoid the 
# anomalously negative KGE' or KGE values when the mean value is close to zero.
################################################################################

# 'obs' : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim' : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 's'   : scaling factors.

# 'Result': Kling-Gupta Efficiency between 'sim' and 'obs'

KGE <- function(sim, obs, ...) UseMethod("KGE")

KGE.default <- function(sim, obs, s=c(1,1,1), na.rm=TRUE, 
                        method=c("2009", "2012", "2021"), out.type=c("single", "full"), 
                        fun=NULL, ...,
                        epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                        epsilon.value=NA) { 

  # If the user provided a value for 's'
  if (!identical(s, c(1,1,1)) )  {
     if ( length(s) != 3 ) stop("Invalid argument: lenght(s) must be equal to 3 !")
     if ( sum(s) != 1 )    stop("Invalid argument: sum(s) must be equal to 1.0 !")
  } # IF end
     
  method   <- match.arg(method)
  out.type <- match.arg(out.type)  

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo"))) |
       is.na(match(class(obs), c("integer", "numeric", "ts", "zoo")))
  ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo')")      
   
  vi <- valindex(sim, obs)
     
  if (length(vi) > 0) {
	 
    obs <- as.numeric(obs[vi])
    sim <- as.numeric(sim[vi])

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end

    # Perfect agreement should return the optimum KGE even when some
    # intermediate moments are undefined (e.g. constant identical series).
    if (isTRUE(all.equal(sim, obs, check.attributes=FALSE))) {
      r <- 1
      if (method == "2012") {
        br <- 1
        br.stg <- "Beta"
        vr <- 1
        vr.stg <- "Gamma"
      } else if (method == "2009") {
        br <- 1
        br.stg <- "Beta"
        vr <- 1
        vr.stg <- "Alpha"
      } else {
        br <- 0
        br.stg <- "Beta.2021"
        vr <- 1
        vr.stg <- "Alpha"
      }
      KGE <- 1
    } else {

      # Mean values
      mean.sim <- mean(sim, na.rm=na.rm)
      mean.obs <- mean(obs, na.rm=na.rm)

      # Standard deviations
      sigma.sim <- sd(sim, na.rm=na.rm)
      sigma.obs <- sd(obs, na.rm=na.rm)
         
      # Pearson product-moment correlation coefficient
      r     <- rPearson(sim, obs)

      # Alpha is a measure of relative variability between simulated and observed values (See Ref1)
      Alpha <- sigma.sim / sigma.obs

      # Beta is the ratio between the mean of the simulated values to the mean of observations
      Beta <- mean.sim / mean.obs

      # Beta.2021 is the bias term proposed by Tang et al. (2021) to avoid the 
      # anomalously negative KE or KGE' values when the mean value is close to zero 
      Beta.2021 <- (mean.sim - mean.obs) / sigma.obs
       
      # CV.sim is the coefficient of variation of the simulated values [dimensionless]
      # CV.obs is the coefficient of variation of the observations [dimensionless]
      CV.sim <- sigma.sim / mean.sim
      CV.obs <- sigma.obs / mean.obs
       
      # Gamma is the variability ratio, which is used instead of Alpha (See Ref2)
      Gamma <- CV.sim / CV.obs
       
      # Variability ratio depending on 'method'
      if (method=="2012") {
        br     <- Beta
        br.stg <- "Beta"
        vr     <- Gamma
        vr.stg <- "Gamma"
      } else if (method=="2009") {
          br     <- Beta
          br.stg <- "Beta"
          vr     <- Alpha
          vr.stg <- "Alpha"
        } else if (method=="2021") {
            br     <- Beta.2021
            br.stg <- "Beta.2021"
            vr     <- Alpha
            vr.stg <- "Alpha"
          } # ELSE end

      # KGE Computation
      valid.r    <- is.finite(r)
      valid.beta <- is.finite(br)
      valid.vr   <- is.finite(vr)

      if (valid.r && valid.beta && valid.vr) {
          if ( (method=="2009") | (method=="2012") ) {
            KGE <- 1 - sqrt( (s[1]*(r-1))^2 + (s[2]*(vr-1))^2 + (s[3]*(Beta-1))^2 )
          } else KGE <- 1 - sqrt( (s[1]*(r-1))^2 + (s[2]*(vr-1))^2 + (s[3]*(Beta.2021))^2 )
      } else {
          if (!valid.r) {
            warning("Warning: Pearson correlation coefficient is undefined")
            r <- NA_real_
          } # IF end
          if (!valid.beta) {
            warning("Warning: ", br.stg, " is undefined")
            br <- NA_real_
          } # IF end
          if (!valid.vr) {
            warning("Warning: ", vr.stg, " is undefined")
            vr <- NA_real_
          } # IF end
          KGE <- NA
        } # ELSE end
    }
            
  } else {
      r    <- NA
      Beta <- NA
      vr   <- NA
      br   <- NA
      if (method=="2012") {
        br.stg <- "Beta"
        vr.stg <- "Gamma"
      } else if (method=="2009") {
          br.stg <- "Beta"
          vr.stg <- "Alpha" 
        } else {
            br.stg <- "Beta.2021"
            vr.stg <- "Alpha" 
          } # ELSE end
      KGE <- NA
      warning("There are no pairs of 'sim' and 'obs' without missing values !")
    } # ELSE end

  if (out.type=="single") {
        out <- KGE
  } else {
      out <- list(KGE.value=KGE, KGE.elements=c(r, br, vr))
      names(out[[2]]) <- c("r", br.stg, vr.stg)
    } # ELSE end    
 
  return(out)
     
} # 'KGE.default' end


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 18-Jan-2011                                                         #
# Updates: 25-Aug-2011                                                         #
#          10-Oct-2012                                                         #
#          18-Oct-2012 ; 19-Oct-2012                                           #
#          12-Jul-2022 ; 13-Jul-2022                                           #
#          11-Jul-2023                                                         #
################################################################################
KGE.matrix <- function (sim, obs, s=c(1,1,1), na.rm=TRUE, 
                        method=c("2009", "2012", "2021"), out.type=c("single", "full"), 
                        fun=NULL, ...,
                        epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                        epsilon.value=NA) { 

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
     stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
           paste(dim(sim), collapse=" "), "] != [", 
           paste(dim(obs), collapse=" "), "] )", sep="") )
           
  # If the user provided a value for 's'
  if (!all.equal(s, c(1,1,1)) )  {
     if ( length(s) != 3 ) stop("Invalid argument: lenght(s) must be equal to 3 !")
     if ( sum(s) != 1 )    stop("Invalid argument: sum(s) must be equal to 1.0 !")
  } # IF end
           
  method   <- match.arg(method)
  out.type <- match.arg(out.type) 

  ifelse(method=="2012", vr.stg <- "Gamma", vr.stg <- "Alpha")

  KGE                <- rep(NA, ncol(obs))       
  elements           <- matrix(NA, nrow=3, ncol=ncol(obs))
  rownames(elements) <- c("r", "Beta", vr.stg)
  colnames(elements) <- colnames(obs)
          
  if (out.type=="single") {
    out <- sapply(1:ncol(obs), function(i,x,y) { 
                   KGE[i] <- KGE.default( x[,i], y[,i], s=s, na.rm=na.rm, 
                                         method=method, out.type=out.type, 
                                         fun=fun, ..., epsilon.type=epsilon.type, 
                                         epsilon.value=epsilon.value )
                 }, x=sim, y=obs )  
    names(out) <- colnames(obs) 
  } else { out <- lapply(1:ncol(obs), function(i,x,y) { 
                         KGE.default( x[,i], y[,i], s=s, na.rm=na.rm, method=method, 
                                      out.type=out.type, fun=fun, ..., 
                                      epsilon.type=epsilon.type, 
                                      epsilon.value=epsilon.value )
                       }, x=sim, y=obs ) 
            for (i in 1:length(out) ) {
               KGE[i] <- out[[i]][[1]]
               elements[,i] <- as.numeric(out[[i]][[2]])
            } # FOR end 
            out <- list(KGE.value=KGE, KGE.elements=elements)
          } # ELSE end                     
  
  return(out)
     
} # 'KGE.matrix' end


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 18-Jan-2011                                                         #
# Updates: 25-Aug-2011                                                         #
#          10-Oct-2012                                                         #
#          18-Oct-2012 ; 19-Oct-2012                                           #
#          12-Jul-2022 ; 13-Jul-2022                                           #
#          11-Jul-2023                                                         #
################################################################################
KGE.data.frame <- function (sim, obs, s=c(1,1,1), na.rm=TRUE, 
                            method=c("2009", "2012", "2021"), out.type=c("single", "full"), 
                            fun=NULL, ...,
                            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                            epsilon.value=NA) { 
 
  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
  
  method   <- match.arg(method)
  out.type <- match.arg(out.type) 
   
  KGE.matrix(sim, obs, s=s, na.rm=na.rm, method=method, out.type=out.type, 
             fun=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'KGE.data.frame' end


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 16-Aug-2016                                                         #
#          12-Jul-2022 ; 13-Jul-2022                                           #
#          11-Jul-2023                                                         #
################################################################################
KGE.zoo <- function(sim, obs, s=c(1,1,1), na.rm=TRUE, 
                    method=c("2009", "2012", "2021"), out.type=c("single", "full"), 
                    fun=NULL, ...,
                    epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                    epsilon.value=NA) { 
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       KGE.matrix(sim, obs, s=s, na.rm=na.rm, method=method, out.type=out.type, 
                  fun=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value)
    } else NextMethod(sim, obs, s=s, na.rm=na.rm, method=method, out.type=out.type, 
                      fun=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
  } # 'KGE.zoo' end

# File rNSE.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2010-2023 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

##################################################
# 'rNSE': Relative Nash-sutcliffe Efficiency     #
##################################################
# Started: April 2010                            #
# Updates: 01-Jun-2011                           #
#          14-Jan-2023                           #
##################################################
# Ref:
# Krause, P., Boyle, D. P., and Base, F.: Comparison of different efficiency 
#                           criteria for hydrological model assessment, Adv. Geosci., 5, 89-97, 2005 
# Legates and McCabe, 1999. Evaluating the use of "goodness-of-fit" measures 
#                           in hydrologic and hydroclimatic model validation. 
#                           Water Resources Research. v35 i1. 233-241.

# Nash-Sutcliffe efficiency not "inflated" by squared values
# Essentially, the closer the model efficiency is to 1, the more accurate the model is.  

# 'obs' : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim' : numeric 'data.frame', 'matrix' or 'vector' with simulated values

# 'Result': Modified Nash-sutcliffe Efficiency between 'sim' and 'obs'

rNSE <-function(sim, obs, ...) UseMethod("rNSE")

rNSE.default <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                         epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                         epsilon.value=NA){ 

   if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo", "xts"))) |
          is.na(match(class(obs), c("integer", "numeric", "ts", "zoo", "xts")))
     ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo', 'xts')")    

   epsilon.type <- match.arg(epsilon.type)  

   vi <- valindex(sim, obs)
   
   if (length(vi) > 0) {	 
     # Filtering 'obs' and 'sim', selecting only those pairs of elements 
     # that are present both in 'x' and 'y' (NON- NA values)
     obs <- obs[vi]
     sim <- sim[vi]

     if (!is.null(fun)) {
       fun1 <- match.fun(fun)
       new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                       epsilon.type=epsilon.type, epsilon.value=epsilon.value)
       sim  <- new[["sim"]]
       obs  <- new[["obs"]]
     } # IF end
	 
     # Testing for zero values in obs, which leads to -Inf as result
     zero.index <- which(obs==0)
     if (length(zero.index > 0) ) {
       warning("'rNSE' can not be computed: some elements in 'obs' are zero !", call.=FALSE)
     } # IF end
	 
     denominator <- sum( ( ( obs - mean(obs) ) / mean(obs) )^2 )
	 
     if ( (denominator != 0) & (!is.na(denominator)) ) {      
	     rNSE <- 1 - ( sum( ( (obs - sim) / obs )^2 ) / denominator )
	   } else {
         rNSE <- NA
         warning("'sum( ( ( obs - mean(obs) ) / mean(obs) )^2 ) = 0' -> it is not possible to compute 'rNSE' !")  
       } # ELSE end
   } else {
         rNSE <- NA
         warning("There are no pairs of 'sim' and 'obs' without missing values !")
     } # ELSE end
	 
   return(rNSE)
     
} # 'rNSE.default' end


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 14-Jan-2023                                                         #
################################################################################
rNSE.matrix <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                        epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                        epsilon.value=NA){ 

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
    stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
          paste(dim(sim), collapse=" "), "] != [", 
          paste(dim(obs), collapse=" "), "] )", sep="") )

  rNSE <- rep(NA, ncol(obs))       
          
  rNSE <- sapply(1:ncol(obs), function(i,x,y) { 
                 rNSE[i] <- rNSE.default( x[,i], y[,i], na.rm=na.rm, fun=fun, ..., 
                                          epsilon.type=epsilon.type,  epsilon.value=epsilon.value)
               }, x=sim, y=obs )    
                     
  names(rNSE) <- colnames(obs)
  return(rNSE)
     
} # 'rNSE.matrix' end


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 14-Jan-2023                                                         #
################################################################################
rNSE.data.frame <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                            epsilon.value=NA){ 
 
  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
   
  rNSE.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
              epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'rNSE.data.frame' end


rNSeff <-function(sim, obs, ...) UseMethod("rNSE")



################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 14-Jan-2023                                                         #
################################################################################
rNSE.zoo <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                     epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                     epsilon.value=NA){
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       rNSE.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
                   epsilon.type=epsilon.type, epsilon.value=epsilon.value)
    } else NextMethod(sim, obs, na.rm=na.rm, fun=fun, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
  } # 'rNSE.zoo' end

# File KGEnp.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 http://cran.r-project.org/web/packages/hydroGOF/
#                                 http://www.rforge.net/hydroGOF/ ; 
#                                 
# Copyright 2023-2023 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'KGEnp': non-parametric version of the Kling-Gupta Efficiency                #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 13-Jan-2023                                                         #
# Updates: 16-Jan-2023                                                         #
################################################################################
# This function is based on the description provided by Pool et al. (2018) at:
# https://www.tandfonline.com/doi/suppl/10.1080/02626667.2018.1552002?scroll=top&role=tab

# The optimal value of KGEnp is 1

# Ref:
# Pool, S., Vis, M. and Seibert, J. (2018). 
# Evaluating model performance: towards a non-parametric variant of the Kling-Gupta efficiency. 
# Hydrological Sciences Journal, 63(13-14), pp.1941-1953.
# doi:/10.1080/02626667.2018.1552002.


# 'obs' : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim' : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 's'   : scaling factors.

# 'Result': non-parametric Kling-Gupta between 'sim' and 'obs'

KGEnp <- function(sim, obs, ...) UseMethod("KGEnp")

KGEnp.default <- function(sim, obs, na.rm=TRUE, 
                          out.type=c("single", "full"), 
                          fun=NULL, ...,
                          epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                          epsilon.value=NA) { 

  out.type <- match.arg(out.type)  

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo"))) |
       is.na(match(class(obs), c("integer", "numeric", "ts", "zoo")))
  ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo')")      
   
  epsilon.type <- match.arg(epsilon.type)  

  # index of those elements that are present both in 'sim' and 'obs' (NON- NA values)
  vi <- valindex(sim, obs)

  nQ <- length(vi) # nQ = length(sim) = length(obs)
     
  if (nQ > 0) {
	 
    obs <- as.numeric(obs[vi])
    sim <- as.numeric(sim[vi])

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ...)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end

    # Mean values
    mean.sim <- mean(sim, na.rm=na.rm)
    mean.obs <- mean(obs, na.rm=na.rm)

    # Normalized flow duration curves
    fdc.sim <- sort(sim, decreasing=FALSE) / (mean.sim * nQ)
    fdc.obs <- sort(obs, decreasing=FALSE) / (mean.obs * nQ)
         
    # Spearman's rank correlation coefficient
    rS    <- cor(sim, obs, method="spearman", use="pairwise.complete.obs")

    # Alpha is a non-parametric form of the variability, based on the FDC (See Ref)
    Alpha <- 1 - 0.5 * sum(abs(fdc.sim - fdc.obs))

    # Beta is the ratio between the mean of the simulated values to the mean of observations
    Beta <- mean.sim / mean.obs

    # KGEnp Computation
    if ( mean.obs != 0 ) {
        KGEnp <- 1 - sqrt( (Beta-1)^2 + (Alpha-1)^2 + (rS-1)^2 )
    } else {
        if ( mean.obs != 0)  warning("Warning: 'mean(obs)==0'. Beta = Inf")
        KGEnp <- NA
      } # ELSE end  
            
  } else {
      r     <- NA
      Beta  <- NA
      Alpha <- NA
      KGEnp <- NA
      warning("There are no pairs of 'sim' and 'obs' without missing values !")
    } # ELSE end

  if (out.type=="single") {
        out <- KGEnp
  } else {
      out <- list(KGEnp.value=KGEnp, KGEnp.elements=c(r, Beta, Alpha))
      names(out[[2]]) <- c("rSpearman", "Beta", "Alpha")
    } # ELSE end    
 
  return(out)
     
} # 'KGEnp.default' end


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 13-Jan-2023                                                         #
# Updates: 16-Jan-2023                                                         #
################################################################################
KGEnp.matrix <- function(sim, obs, na.rm=TRUE, 
                         out.type=c("single", "full"), 
                         fun=NULL, ...,
                         epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                         epsilon.value=NA) { 

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
     stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
           paste(dim(sim), collapse=" "), "] != [", 
           paste(dim(obs), collapse=" "), "] )", sep="") )
           

  out.type <- match.arg(out.type) 


  KGEnp              <- rep(NA, ncol(obs))       
  elements           <- matrix(NA, nrow=3, ncol=ncol(obs))
  rownames(elements) <- c("rSpearman", "Beta", "Alpha")
  colnames(elements) <- colnames(obs)
          
  if (out.type=="single") {
    out <- sapply(1:ncol(obs), function(i,x,y) { 
                   KGEnp[i] <- KGEnp.default( x[,i], y[,i], na.rm=na.rm, 
                                              out.type=out.type, 
                                              fun=fun, ..., 
                                              epsilon.type=epsilon.type,  
                                              epsilon.value=epsilon.value)
                 }, x=sim, y=obs )  
    names(out) <- colnames(obs) 
  } else { out <- lapply(1:ncol(obs), function(i,x,y) { 
                         KGEnp.default( x[,i], y[,i], na.rm=na.rm, 
                                        out.type=out.type, 
                                        fun=fun, ..., 
                                        epsilon.type=epsilon.type,  
                                        epsilon.value=epsilon.value 
                                      )
                       }, x=sim, y=obs ) 
            for (i in 1:length(out) ) {
               KGEnp[i] <- out[[i]][[1]]
               elements[,i] <- as.numeric(out[[i]][[2]])
            } # FOR end 
            out <- list(KGEnp.value=KGEnp, KGEnp.elements=elements)
          } # ELSE end                     
  
  return(out)
     
} # 'KGEnp.matrix' end


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 13-Jan-2023                                                         #
# Updates: 16-Jan-2023                                                         #
################################################################################
KGEnp.data.frame <- function(sim, obs, na.rm=TRUE, 
                             out.type=c("single", "full"), 
                             fun=NULL, ...,
                             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                             epsilon.value=NA) { 
 
  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
  
  method   <- match.arg(method)
  out.type <- match.arg(out.type) 
   
  KGEnp.matrix(sim, obs, na.rm=na.rm, out.type=out.type, 
               fun=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'KGEnp.data.frame' end


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 13-Jan-2023                                                         #
# Updates:                                                                     #
################################################################################
KGEnp.zoo <- function(sim, obs, na.rm=TRUE, 
                      out.type=c("single", "full"), 
                      fun=NULL, ...,
                      epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                      epsilon.value=NA) { 
    
  sim <- zoo::coredata(sim)
  if (is.zoo(obs)) obs <- zoo::coredata(obs)
   
  if (is.matrix(sim) | is.data.frame(sim)) {
     KGEnp.matrix(sim, obs, na.rm=na.rm, out.type=out.type,
                  fun=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value)
  } else NextMethod(sim, obs, na.rm=na.rm, out.type=out.type,
                    fun=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
  } # 'KGEnp.zoo' end

# File LME.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2026-2026 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# Liu-Mean Efficiency (LME)                                                    #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 28-Abr-2026                                                         #
################################################################################
# Reference:                                                                   #
#  Liu, D. (2020). A rational performance criterion for hydrological model.    #
#  Journal of Hydrology, 590, 125488.                                          #
#  https://doi.org/10.1016/j.jhydrol.2020.125488                               #
################################################################################
# This goodness-of-fit measure was proposed by Liu et al. (2020) as an 
# alternative to the Nash-Sutcliffe efficiency (NSE), designed to provide a 
# more balanced assessment of model performance by normalising the mean squared 
# error using the mean of the observed values instead of their variance.
################################################################################
# The Liu-Mean Efficiency emphasises proportional error relative to the mean 
# magnitude of the observed variable, making it particularly useful in 
# hydrological applications where the mean value is a meaningful scale for 
# evaluating prediction accuracy.
################################################################################
# The Liu-Mean Efficiency (LME) is a goodness-of-fit metric designed to 
# evaluate hydrological model performance by jointly assessing two fundamental 
# aspects of agreement between simulated and observed time series: 
# - the combined representation of correlation and variability, through the 
#   product ( r\alpha ) (reflecting how well the model reproduces the temporal 
#   dynamics and dispersion of flows), and 
# - the bias ratio ( \beta ) (reflecting systematic over- or underestimation 
#   of mean magnitude). 
################################################################################
# The metric has a theoretical range from -Inf to 1, where:
# - a value of 1 indicates perfect agreement in both dynamic behavior and mean 
#   flow conditions, meaning the simulation reproduces the observed variability 
#   structure and central tendency exactly; 
# - values near 0 indicate substantial discrepancies in timing, variability, 
#   or bias, such that the simulation departs meaningfully from observed 
#   behavior; and 
# - negative values indicate progressively poorer performance, typically 
#   arising when variability is poorly represented, correlation is weak, or 
#   mean bias is large. 

# Consequently, in hydrological model calibration and evaluation, values closer 
# to 1 denote higher overall fidelity of the simulated hydrological regime, 
# while increasingly negative values signal structural deficiencies in the 
# model's representation of flow dynamics or water balance.
################################################################################


# 'obs'   : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim'   : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 'Result': Liu-Mean Efficiency between 'sim' and 'obs'

LME <- function(sim, obs, ...) UseMethod("LME")

###############################################################################
# Default method
###############################################################################

LME.default <- function(sim, obs, na.rm=TRUE,
                        out.type=c("single","full"),
                        fun=NULL, ...,
                        epsilon.type=c("none",
                                       "Pushpalatha2012",
                                       "otherFactor",
                                       "otherValue"),
                        epsilon.value=NA) {

  if (missing(sim)) stop("Argument 'sim' is missing")
  if (missing(obs)) stop("Argument 'obs' is missing")

  if (!is.numeric(sim)) stop("'sim' must be numeric")
  if (!is.numeric(obs)) stop("'obs' must be numeric")

  if (length(sim) != length(obs))
    stop("'sim' and 'obs' must have the same length")

  out.type     <- match.arg(out.type)
  epsilon.type <- match.arg(epsilon.type)

  #############################################################################
  # Remove NA pairs
  #############################################################################

  if (na.rm) {
    valid <- !(is.na(sim) | is.na(obs))
    sim <- sim[valid]
    obs <- obs[valid]
  }

  if (length(sim) == 0)
    return(NA_real_)

  #############################################################################
  # Epsilon handling
  #############################################################################

  if (epsilon.type != "none") {

    if (epsilon.type == "Pushpalatha2012") {

      eps <- mean(obs, na.rm=TRUE) / 100

    } else if (epsilon.type == "otherFactor") {

      if (is.na(epsilon.value))
        stop("'epsilon.value' must be provided")

      eps <- epsilon.value * mean(obs, na.rm=TRUE)

    } else if (epsilon.type == "otherValue") {

      if (is.na(epsilon.value))
        stop("'epsilon.value' must be provided")

      eps <- epsilon.value
    }

    sim <- sim + eps
    obs <- obs + eps
  }

  #############################################################################
  # Transformation
  #############################################################################

  if (!is.null(fun)) {

    if (!is.function(fun))
      stop("'fun' must be a function")

    sim <- fun(sim, ...)
    obs <- fun(obs, ...)
  }

  #############################################################################
  # Core statistics
  #############################################################################

  mean.sim <- mean(sim)
  mean.obs <- mean(obs)

  sd.sim <- stats::sd(sim)
  sd.obs <- stats::sd(obs)

  if (sd.obs == 0)
    return(NA_real_)

  r <- stats::cor(sim, obs)

  Alpha <- sd.sim / sd.obs
  Beta  <- mean.sim / mean.obs

  #############################################################################
  # Liu Mean Efficiency
  #############################################################################

  LME.value <- 1 - sqrt((r * Alpha - 1)^2 +
                        (Beta - 1)^2)

  if (out.type == "single") {

    return(LME.value)

  } else {

    elements <- c(r, Alpha, Beta)

    names(elements) <- c("r", "Alpha", "Beta")

    return(list(LME.value    = LME.value,
                LME.elements = elements))
  }

} # 'LME.default' end


################################################################################
# Matrix method                                                                #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 28-Apr-2026                                                         #
################################################################################
LME.matrix <- function(sim, obs, na.rm=TRUE,
                       out.type=c("single","full"),
                       fun=NULL, ...,
                       epsilon.type=c("none",
                                      "Pushpalatha2012",
                                      "otherFactor",
                                      "otherValue"),
                       epsilon.value=NA) {

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
     stop( paste("Invalid argument: dim(sim) != dim(obs) ( [",
           paste(dim(sim), collapse=" "), "] != [",
           paste(dim(obs), collapse=" "), "] )", sep="") )

  out.type     <- match.arg(out.type)
  epsilon.type <- match.arg(epsilon.type)

  LME                <- rep(NA, ncol(obs))
  elements           <- matrix(NA, nrow=2, ncol=ncol(obs))
  rownames(elements) <- c("MSE", "MeanObs")
  colnames(elements) <- colnames(obs)

  if (out.type=="single") {

    out <- sapply(1:ncol(obs), function(i, x, y) {

                   LME[i] <- LME.default(
                                 sim=x[, i],
                                 obs=y[, i],
                                 na.rm=na.rm,
                                 out.type=out.type,
                                 fun=fun, ...,
                                 epsilon.type=epsilon.type,
                                 epsilon.value=epsilon.value)

                 }, x=sim, y=obs)

    names(out) <- colnames(obs)

  } else {

    out <- lapply(1:ncol(obs), function(i, x, y) {

                    LME.default(
                        sim=x[, i],
                        obs=y[, i],
                        na.rm=na.rm,
                        out.type=out.type,
                        fun=fun, ...,
                        epsilon.type=epsilon.type,
                        epsilon.value=epsilon.value)

                  }, x=sim, y=obs)

    for (i in 1:length(out)) {
       LME[i]        <- out[[i]][[1]]
       elements[, i] <- as.numeric(out[[i]][[2]])
    }

    out <- list(LME.value= LME,
                LME.elements= elements)
  }

  return(out)

} # 'LME.matrix' end

###############################################################################
# data.frame method
###############################################################################
LME.data.frame <- function(sim, obs, na.rm=TRUE,
                           out.type=c("single","full"),
                           fun=NULL, ...,
                           epsilon.type=c("none",
                                          "Pushpalatha2012",
                                          "otherFactor",
                                          "otherValue"),
                           epsilon.value=NA) {

  sim <- as.matrix(sim)
  obs <- as.matrix(obs)

  out.type     <- match.arg(out.type)
  epsilon.type <- match.arg(epsilon.type)

  LME.matrix(sim=sim, obs=obs,
             na.rm=na.rm,
             out.type=out.type,
             fun=fun, ...,
             epsilon.type=epsilon.type,
             epsilon.value=epsilon.value)

} # 'LME.data.frame' end

###############################################################################
# zoo method
###############################################################################
LME.zoo <- function(sim, obs, na.rm=TRUE,
                    out.type=c("single","full"),
                    fun=NULL, ...,
                    epsilon.type=c("none",
                                   "Pushpalatha2012",
                                   "otherFactor",
                                   "otherValue"),
                    epsilon.value=NA) {

  sim <- zoo::coredata(sim)
  if (is.zoo(obs))
     obs <- zoo::coredata(obs)

  out.type     <- match.arg(out.type)
  epsilon.type <- match.arg(epsilon.type)


  if (is.matrix(sim) | is.data.frame(sim)) {

     LME.matrix(sim, obs,
                na.rm=na.rm,
                out.type=out.type,
                fun=fun, ...,
                epsilon.type=epsilon.type,
                epsilon.value=epsilon.value)

  } else {

     NextMethod(sim, obs,
                na.rm=na.rm,
                out.type=out.type,
                fun=fun, ...,
                epsilon.type=epsilon.type,
                epsilon.value=epsilon.value)

  }

} # 'LME.zoo' end

# File cp.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2008-2024 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'cp': Coefficient of Persistence                                             #
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 18-Dec-2008;                                                        #
# Updates: 06-Sep-2009;                                                        #
#          16-Jan-2023                                                         #
#          20-Jan-2024                                                         #
################################################################################

# Persistence Index (Kitadinis and Bras, 1980; Corradini et al., 1986) 
# is used to compare the model  performance agains a simple model using 
# the observed value of the previous day as the prediction for the current day.

#Kitanidis, P.K., and Bras, R.L. 1980. Real-time forecasting with a conceptual
#hydrologic model. 2. Applications and results. Water Resources Research,
#Vol. 16, No. 6, pp. 1034:1044.

# The coefficient of persistencec omparest he predictions of the model 
# with the predictions obtained by assuming that the process is a Wiener
# process(variance increasing linearly with time), in which case,
# the best estimate for the future is given by the latest measurement 
# (Kitadinis and Bras, 1980) 

# Persistence model efficiency (PME) is a normalized model evaluation statistic
# that quantifies the relative magnitude of the residual variance (noise)
# to the variance of the errors obtained by the use of a simple persistence 
# model 
# ("Ref: Moriasi, D.N., Arnold, J.G., Van Liew, M.W., Bingner, R.L., Harmel, 
#   R.D., Veith, T.L. 2007. Model evaluation guidelines for systematic 
#   quantification of accuracy in watershed simulations. 
#   Transactions of the ASABE. 50(3):885-900.. 

# PME ranges from 0 to 1, with PME = 1 being the optimal value. 
# PME values should be larger than 0.0 to indicate a minimally acceptable
# model performance (Gupta et al., 1999

# 'obs'   : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim'   : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 'Result': Persistence Index Efficiency between 'sim' and 'obs'

cp <-function(sim, obs, ...) UseMethod("cp")

cp.default <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                       epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                       epsilon.value=NA){ 

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo"))) |
       is.na(match(class(obs), c("integer", "numeric", "ts", "zoo")))
  ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo')")

  # the next two lines are required for avoiding an strange behaviour 
  # of the difference function when sim and obs are time series.
  if ( !is.na(match(class(sim), c("ts", "zoo"))) ) sim <- as.numeric(sim)
  if ( !is.na(match(class(obs), c("ts", "zoo"))) ) obs <- as.numeric(obs)

  # Checking 'epsilon.type'
  epsilon.type <- match.arg(epsilon.type)  

  # index of those elements that are present both in 'sim' and 'obs' (NON- NA values)
  vi <- valindex(sim, obs)
   
  if (length(vi) > 0) {	 
    # Filtering 'obs' and 'sim', selecting only those pairs of elements 
    # that are present both in 'x' and 'y' (NON- NA values)
    obs <- obs[vi]
    sim <- sim[vi]

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end     
     
     # lenght of the data sets that will be ocnsidered for the ocmputations
     n <- length(obs)
      
     denominator <- sum( ( obs[2:n] - obs[1:(n-1)] )^2 )
     
    if ( (denominator != 0) & (!is.na(denominator)) ) {      
       cp <- ( 1 - ( sum( (obs[2:n] - sim[2:n])^2 ) / denominator ) )     
     } else {
         cp <- NA
         warning("'sum((obs[2:n]-obs[1:(n-1))^2)=0' -> it is not possible to compute 'cp' !")  
       }
   } else {
         cp <- NA
         warning("There are no pairs of 'sim' and 'obs' without missing values !")
     } # ELSE end
     
   return(cp)
     
} # 'cp.default' end


################################################################################
# 'cp': Coefficient of Persistence                                             #
################################################################################
# Started: 18-Dec-2008;                                                        #
# Updates: 06-Sep-2009;                                                        #
#          16-Jan-2023                                                         #
################################################################################
cp.matrix <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                      epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                      epsilon.value=NA){ 

  # Checking 'epsilon.type'
  epsilon.type <- match.arg(epsilon.type)  

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
    stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
          paste(dim(sim), collapse=" "), "] != [", 
          paste(dim(obs), collapse=" "), "] )", sep="") )

  cp <- rep(NA, ncol(obs))       
          
  cp <- sapply(1:ncol(obs), function(i,x,y) { 
                 cp[i] <- cp.default( x[,i], y[,i], na.rm=na.rm, fun=fun, ..., 
                                      epsilon.type=epsilon.type,  
                                      epsilon.value=epsilon.value)
                 }, x=sim, y=obs )    
                     
   names(cp) <- colnames(obs)
     
   return(cp)
     
} # 'cp.matrix' end


################################################################################
# 'cp': Coefficient of Persistence                                             #
################################################################################
# Started: 18-Dec-2008;                                                        #
# Updates: 06-Sep-2009;                                                        #
#          16-Jan-2023                                                         #
################################################################################
cp.data.frame <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                          epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                          epsilon.value=NA){ 
 
  # Checking 'epsilon.type'
  epsilon.type <- match.arg(epsilon.type)  

  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
   
  cp.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
            epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'cp.data.frame' end


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 16-Jan-2023                                                         #
################################################################################
cp.zoo <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                   epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                   epsilon.value=NA){
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       cp.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
                 epsilon.type=epsilon.type, epsilon.value=epsilon.value)
    } else NextMethod(sim, obs, na.rm=na.rm, fun=fun, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
  } # 'cp.zoo' end

# File dr.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/
# Copyright 2008-2024 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

########################################
# 'dr': Refined Index of Agreement     #
########################################
# December 18th, 2008;  06-Sep-09      #
# 28-Feb-2016                          #
# Updates: 20-Jul-2022 ; 29-Jul-2022   #
########################################
# 1) Willmott, C.J., Robeson, S.M. and Matsuura, K. (2012). A refined index of model performance. International Journal of climatology, 32(13), pp.2088-2094. doi:10.1002/joc.2419.
# 2) Willmott, C.J., Robeson, S.M., Matsuura, K. and Ficklin, D.L. (2015). Assessment of three dimensionless measures of model performance. Environmental Modelling & Software, 73, pp.167-174. doi:10.1016/j.envsoft.2015.08.012
# 3) Willmott, C.J. 1981. On the validation of models. Physical Geography, 2, 184-194
# 4) Willmott, C. J. (1984). "On the evaluation of model performance in physical geography." Spatial Statistics and Models, G. L. Gaile and C. J. Willmott, eds., 443-460.
# 5) Legates, D. R., and G. J. McCabe Jr. (1999), Evaluating the Use of "Goodness-of-Fit" Measures in Hydrologic and Hydroclimatic Model Validation, Water Resour. Res., 35(1), 233-241. 


# In contrast to the Index of Agreement (Willmott et al., 1984), which ranges from 0 to 1.0,
# the Refined Index of Agreement is bounded by -1.0 and 1.0. The closer to 1 the better 
# the performance of the model.
# In geneeral, dr is  "more rationally related to model accuracy than are other existing
# indices" (MSE, NSE, d, rd) (Willmott et a., 2012; Willmott et al., 2015)

# 'obs'   : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim'   : numeric 'data.frame', 'matrix' or 'vector' with simulated values

# 'Result': Index of Agreement between 'sim' and 'obs'

dr <-function(sim, obs, ...) UseMethod("dr")

################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 20-Jul-2022                                                         #
# Updates: 29-Jul-2022                                                         #
################################################################################
dr.default <- function(sim, obs, na.rm=TRUE,
                      fun=NULL, ...,
                      epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                      epsilon.value=NA){ 

     if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo"))) |
          is.na(match(class(obs), c("integer", "numeric", "ts", "zoo")))
     ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo')")

     epsilon.type <- match.arg(epsilon.type)

     # index of those elements that are present both in 'x' and 'y' (NON- NA values)
     vi <- valindex(sim, obs)
     
     if (length(vi) > 0) {	 
       # Filtering 'obs' and 'sim', selecting only those pairs of elements 
       # that are present both in 'x' and 'y' (NON- NA values)
       obs <- obs[vi]
       sim <- sim[vi]

       if (!is.null(fun)) {
         fun1 <- match.fun(fun)
         new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                         epsilon.type=epsilon.type, epsilon.value=epsilon.value)
         sim  <- new[["sim"]]
         obs  <- new[["obs"]]
       } # IF end
     
       # the next two lines are required for avoiding an strange behaviour 
       # of the difference function when sim and obs are time series.
       if ( !is.na(match(class(sim), c("ts", "zoo"))) ) sim <- as.numeric(sim)
       if ( !is.na(match(class(obs), c("ts", "zoo"))) ) obs <- as.numeric(obs)
     
       # Mean of the observed values
       Om <- mean(obs, na.rm=na.rm)

       # Constant 'c' value
       c <- 2

       # Components of the denominator
       A <- sum( abs(sim - obs) )
       B <- c*sum( abs(obs - Om) )
     
       if (A <= B) {      
         dr <- 1 - A / B     
       } else dr <- 1 - B / A 
     } else {
         dr <- NA
         warning("There are no pairs of 'sim' and 'obs' without missing values !")
       } # ELSE end
     
     return(dr) 
     
} # 'dr.default' end


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 20-Jul-2022                                                         #
# Updates: 29-Jul-2022                                                         #
################################################################################
dr.matrix <- function(sim, obs, na.rm=TRUE,
                     fun=NULL, ...,
                     epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                     epsilon.value=NA){ 
 
 # Checking that 'sim' and 'obs' have the same dimensions
 if ( all.equal(dim(sim), dim(obs)) != TRUE )
    stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
          paste(dim(sim), collapse=" "), "] != [", 
          paste(dim(obs), collapse=" "), "] )", sep="") )

 dr <- rep(NA, ncol(obs))       
          
 dr <- sapply(1:ncol(obs), function(i,x,y) { 
             dr[i] <- dr.default( x[,i], y[,i], na.rm=na.rm, ... )
             }, x=sim, y=obs, na.rm=na.rm, fun=fun, ..., 
             epsilon.type=epsilon.type, epsilon.value=epsilon.value)    
                     
  names(dr) <- colnames(obs)
  return(dr)
     
} # 'dr.matrix' end


dr.data.frame <- function(sim, obs, na.rm=TRUE,
                         fun=NULL, ...,
                         epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                         epsilon.value=NA){  
 
  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
   
  dr.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
            epsilon.type=epsilon.type, epsilon.value=epsilon.value)    
     
} # 'dr.data.frame' end


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 20-Jul-2022                                                         #
# Updates: 29-Jul-2022                                                         #
################################################################################
dr.zoo <- function(sim, obs, na.rm=TRUE,
                  fun=NULL, ...,
                  epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                  epsilon.value=NA){ 
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       dr.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
                epsilon.type=epsilon.type, epsilon.value=epsilon.value)    
    } else NextMethod(sim, obs, na.rm=na.rm, fun=fun, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)    
     
  } # 'dr.zoo' end

# File wsNSE.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2008-2023 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'wsNSE': weighted seasonal Nash-Sutcliffe Efficiency                         #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 04-May-2024                                                         #
# Updates: 05-May-2024                                                         #
################################################################################

# Following the traditional Nash-Sutcliffe efficiency, the weighted seasonal 
# Nash-Sutcliffe Efficiency (wsNSE) ranges from -Inf to 1, with an optimal value 
# of 1. Higher values of wsNSE indicate lower differences between \code{sim} and 
# \code{obs}. Essentially, the closer to 1, the more similar\code{sim} and 
# \code{obs} are. 

# This function is designed to identify differences in high or low values, 
# depending on the user-defined value given to the \code{lambda} argument.

# The weighted seasonal Nash-Sutcliffe Efficiency was proposed by 
# Zambrano-Bigiarini and Bellin (2012), inspired by the well-known Nash-Sutcliffe 
# efficiency (NSE, Nash and Sutcliffe, 1970), and the  commentaries made by 
# Schaefli and Gupta (2007) and Criss and Winston (2008).
# 
# This function gives different weights to the high/low values in the 
# (obs_i - sim_i) terms used in the Nash-Sutcliffe formula, using high weights 
# for high or low flows, depending on how close the user-defined 'lambda' value 
# is to 1 or zero, respectively. Between  high and low values there is a linear 
# transition from \code{lambda} to \code{1-lambda}, respectively.

# Refs:
# 1) Zambrano-Bigiarini, M.; Bellin, A. (2012). Comparing goodness-of-fit 
#    measures for calibration of models focused on extreme events. 
#    EGU General Assembly 2012, Vienna, Austria, 22-27 Apr 2012, EGU2012-11549-1.
# 2) Nash, J.E.; J.V. Sutcliffe. (1970). River flow forecasting through 
#    conceptual models. Part 1: a discussion of principles, Journal of Hydrology
#    10, pp. 282-290. doi:10.1016/0022-1694(70)90255-6
# 3) Schaefli, B.; Gupta, H. (2007). Do Nash values have value?. 
#    Hydrological Processes 21, 2075-2080. doi:10.1002/hyp.6825
# 4) Criss, R. E.; Winston, W. E. (2008), Do Nash values have value? 
#    Discussion and alternate proposals. Hydrological Processes, 22: 2723-2725. 
#    doi:10.1002/hyp.7072
# 5) Yilmaz, K. K.; Gupta, H. V.; Wagener, T. (2008), A process-based
#    diagnostic approach to model evaluation: Application to the NWS
#    distributed hydrologic model, Water Resources Research, 44, W09417,
#    doi:10.1029/2007WR006716.
# 6) Krause, P.; Boyle, D. P.; Base, F. (2005). Comparison of different 
#    efficiency criteria for hydrological model assessment. 
#    Adv. Geosci., 5, 89-97. doi:10.5194/adgeo-5-89-2005.
# 7) Legates, D. R.; G. J. McCabe Jr. (1999), Evaluating the Use of 
#    "Goodness-of-Fit" Measures in Hydrologic and Hydroclimatic Model Validation, 
#    Water Resources Research, 35(1), 233--241. doi:10.1029/1998WR900018.




# 'obs'   : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'j'     : numeric, representing an arbitrary value used to power the 
#           differences between observations and simulations. By default j=2,
#           which mimics the traditional Nash-Sutcliffe function, mainly focused 
#           on thr representation of high flows. For low flows, suggested values 
#           for 'j' are 1, 1/2 or 1/3. See Legates and McCabe, (1999) and 
#           Krausse et al. (2005) for a discussion of suggested values of 'j'.
# 'lambda': numeric in [0, 1] representing the weight given to the high observed 
#           values. The closer the \code{lambda=1} value is to 1, the higher the 
#           weight given to high values. On the contrary, the closer the 
#           \code{lambda=1} value is to 0, the higher the weight given to low 
#           values.
#           Low values get a weight equal to \code{1-lambda}. Between high and 
#           low values there is a linear transition from \code{lambda} to 
#           \code{1-lambda}, respectively.
# 'lQ.thr': numeric, representing the exceedence probability used to identify 
#           low-flows in the flow duration curve. See Yilmaz et al., (2008).
#           All the values to the right of it are deemed as low flows. 
#           Default value is 0.7.
# 'hQ.thr': numeric, representing the exceedence probability used to identify 
#           high-flows in the flow duration curve. See Yilmaz et al., (2008).
#           All the values to the left of it are deemed as high flows. 
#           Default value is 0.2.
# 'sim'   : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 'Result': weighted seasonal Nash-sutcliffe Efficiency between 'sim' and 'obs'

wsNSE <-function(sim, obs, ...) UseMethod("wsNSE")

wsNSE.default <- function(sim, obs, na.rm=TRUE, 
                          j=2, lambda=0.95, lQ.thr=0.6, hQ.thr=0.1, fun=NULL, ..., 
                          epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                          epsilon.value=NA){ 



  lweight <- function(x, llambda, llQ, lhQ, lna.rm=TRUE) {

    w <- ifelse(x >= lhQ, lambda, 
                ifelse(x  <= llQ, 1 - llambda, 
                (1 - llambda) + (2*llambda - 1) * (x - llQ) / (lhQ - llQ) ) 
                )
        
    return(w)
  } #'lweight' END


  # Checking 'epsilon.type'
  epsilon.type <- match.arg(epsilon.type) 

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo", "xts"))) |
       is.na(match(class(obs), c("integer", "numeric", "ts", "zoo", "xts")))
  ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo', 'xts')")      

  # index of those elements that are present both in 'sim' and 'obs' (NON- NA values)
  vi <- valindex(sim, obs)
   
  if (length(vi) > 0) {	 
    # Filtering 'obs' and 'sim', selecting only those pairs of elements 
    # that are present both in 'x' and 'y' (NON- NA values)
    obs <- obs[vi]
    sim <- sim[vi]

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end    

    # Number of observations
    n <- length(obs) 

    # Low and high-flow threshold values
    hQ <- stats::quantile(obs, probs=1-hQ.thr, na.rm=na.rm)
    lQ <- stats::quantile(obs, probs=1-lQ.thr, na.rm=na.rm)

    # Computing annual hfb values
    w <-  lweight(x=obs, llambda=lambda, llQ=lQ, lhQ=hQ, lna.rm=na.rm)
     
    denominator <- sum( abs(w*(obs - mean(obs)))^j )
     
    if ( (denominator != 0) & (!is.na(denominator)) ) {      
      wsNSE <- 1 - ( sum( abs(w*(obs - sim))^j ) / denominator )     
    } else {
        wsNSE <- NA
        warning("'sum( abs( w*(obs - mean(obs)) )^j ) = 0' => it is not possible to compute 'wsNSE'")  
      } 
  } else {
       wsNSE <- NA
       warning("There are no pairs of 'sim' and 'obs' without missing values !")
    } # ELSE end
     
  return(wsNSE)
     
} # 'wsNSE' end



################################################################################
# 'wsNSE': weighted seasonal Nash-Sutcliffe Efficiency                         #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 04-May-2024                                                         #
# Updates: 05-May-2024                                                         #
################################################################################
wsNSE.matrix <- function(sim, obs, na.rm=TRUE, 
                         j=2, lambda=0.95, lQ.thr=0.6, hQ.thr=0.1, fun=NULL, ..., 
                         epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                         epsilon.value=NA){ 

  # Checking 'epsilon.type'
  epsilon.type <- match.arg(epsilon.type)  

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
    stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
          paste(dim(sim), collapse=" "), "] != [", 
          paste(dim(obs), collapse=" "), "] )", sep="") )
 
  wNSE <- rep(NA, ncol(obs))       
          
  wNSE <- sapply(1:ncol(obs), function(i,x,y) { 
                 wNSE[i] <- wsNSE.default( x[,i], y[,i], na.rm=na.rm, 
                                           j=j, lambda=lambda, lQ.thr=lQ.thr, 
                                           hQ.thr=hQ.thr, fun=fun, ..., 
                                           epsilon.type=epsilon.type, epsilon.value=epsilon.value)
               }, x=sim, y=obs )    
                     
  names(wNSE) <- colnames(obs)
  
  return(wNSE)
     
} # 'wsNSE.matrix' end



################################################################################
# 'wsNSE': weighted seasonal Nash-Sutcliffe Efficiency                         #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 04-May-2024                                                         #
# Updates: 05-May-2024                                                         #
################################################################################
wsNSE.data.frame <- function(sim, obs, na.rm=TRUE, 
                             j=2, lambda=0.95, lQ.thr=0.6, hQ.thr=0.1, fun=NULL, ..., 
                             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                             epsilon.value=NA){ 
 
  # Checking 'epsilon.type'
  epsilon.type <- match.arg(epsilon.type)  

  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
   
  wsNSE.matrix(sim, obs, na.rm=na.rm, j=j, lambda=lambda, lQ.thr=lQ.thr, 
               hQ.thr=hQ.thr, fun=fun, ..., 
               epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'wsNSE.data.frame' end



################################################################################
# 'wsNSE': weighted seasonal Nash-Sutcliffe Efficiency                         #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 04-May-2024                                                         #
# Updates: 05-May-2024                                                         #
################################################################################
wsNSE.zoo <- function(sim, obs, na.rm=TRUE, 
                      j=2, lambda=0.95, lQ.thr=0.6, hQ.thr=0.1, fun=NULL, ..., 
                      epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                      epsilon.value=NA){ 
    
    # Checking 'epsilon.type'
    epsilon.type <- match.arg(epsilon.type) 

    #sim <- zoo::coredata(sim)
    #if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       wsNSE.matrix(sim, obs, na.rm=na.rm, j=j, lambda=lambda, lQ.thr=lQ.thr, 
                    hQ.thr=hQ.thr, fun=fun, ..., 
                    epsilon.type=epsilon.type, epsilon.value=epsilon.value)
    } else NextMethod(sim, obs, na.rm=na.rm, j=j, lambda=lambda, lQ.thr=lQ.thr, 
                      hQ.thr=hQ.thr, fun=fun, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
  } # 'wsNSE.zoo' end

# File rPearson.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2009-2023 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

# Before Oct 27th 2009, this function was included in 'gof' function
# Up to 17-Jul2016, this function was a hidden function 

# The 'r.Pearson' coefficient ranges from -1 to 1. 
# A value of 1 shows that a linear equation describes the relationship 
# perfectly and positively, with all data points lying on the same line 
# and with Y increasing with X. 
# A score of -1 shows that all data points lie on a single line but 
# that Y increases as X decreases. 
# A value of 0 shows that a linear model is not needed, i.e., that there 
# is no linear relationship between the variables.

# References:
# 1) \url{https://en.wikipedia.org/wiki/Pearson_correlation_coefficient}

# 2) Pearson, K. (1920). Notes on the history of correlation. 
#    Biometrika, 13(1), 25-45. doi:10.2307/2331722

# 3) Schober, P., Boer, C., Schwarte, L. A. (2018). Correlation coefficients: appropriate 
#   use and interpretation. Anesthesia & analgesia, 126(5), 1763-1768. 
#   doi:10.1213/ANE.0000000000002864

################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 27-Oct-2009                                                         #
# Updates: 17-Jul-2016                                                         #
#          16-Jan-2023                                                         #
################################################################################
rPearson <-function(sim, obs, ...) UseMethod("rPearson")

rPearson.default <- function(sim, obs, fun=NULL, ..., 
                             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                             epsilon.value=NA) {

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo"))) |
          is.na(match(class(obs), c("integer", "numeric", "ts", "zoo")))
     ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo')")

  vi <- valindex(sim, obs)
     
  if (length(vi) > 0) {
	 
    obs <- as.numeric(obs[vi])
    sim <- as.numeric(sim[vi])

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end
  
    rPearson <- cor(sim, obs, method="pearson", use="pairwise.complete.obs")      
    # if 'sim' and 'obs' were matrixs or data.frame, then the correlation
    # between observed and simulated values for each variable is given by the diagonal of 'r.Pearson' 
  
    #if ( is.matrix(r.Pearson) | is.data.frame(r.Pearson) ) {
    #r.Pearson        <- diag(r.Pearson)
    #}

  } else {
           rPearson <- NA
           warning("There are no pairs of 'sim' and 'obs' without missing values !")
         } # ELSE end
  
  return(rPearson)
  
} # 'rPearson.default' end



################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 27-Oct-2009                                                         #
# Updates: 17-Jul-2016                                                         #
#          16-Jan-2023                                                         #
################################################################################
rPearson.matrix <- function(sim, obs, na.rm=TRUE, fun=NULL, ..., 
                            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                            epsilon.value=NA){

    rPearson <- rep(NA, ncol(obs))       
          
    rPearson <- sapply(1:ncol(obs), function(i,x,y) { 
                 rPearson[i] <- rPearson.default( x[,i], y[,i], na.rm=na.rm, fun=fun, ..., 
                                                  epsilon.type=epsilon.type, epsilon.value=epsilon.value)
            }, x=sim, y=obs )            
           
    return(rPearson)
     
} # 'rPearson.matrix' END
  

################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 27-Oct-2009                                                         #
# Updates: 17-Jul-2016                                                         #
#          16-Jan-2023                                                         #
################################################################################  
rPearson.data.frame <- function(sim, obs, na.rm=TRUE, fun=NULL, ..., 
                                epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                                epsilon.value=NA){

    sim <- as.matrix(sim)
    obs <- as.matrix(obs)
	
    rPearson.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
                    epsilon.type=epsilon.type, epsilon.value=epsilon.value)        
     
  } # 'rPearson.data.frame' END
  
 
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 17-Jul-2016                                                         #
#          16-Jan-2023                                                         #
################################################################################
rPearson.zoo <- function(sim, obs, na.rm=TRUE, fun=NULL, ..., 
                         epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                         epsilon.value=NA){
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       rPearson.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
                       epsilon.type=epsilon.type, epsilon.value=epsilon.value)
    } else NextMethod(sim, obs, na.rm=na.rm, fun=fun, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
  } # 'rPearson.zoo' end


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 17-Jul-2016                                                         #
# Updates:                                                                     #
################################################################################
.rPearson <-function(sim, obs, ...) UseMethod("rPearson")

root <- normalizePath(file.path("..", ".."), mustWork = TRUE)

if (!exists("valindex", mode = "function")) {
  source(file.path(root, "R", "valindex.R"))
}

if (!exists("preproc", mode = "function")) {
  source(file.path(root, "R", "preproc.R"))
}

if (!exists("JDKGE", mode = "function")) {
  source(file.path(root, "R", "JDKGE.R"))
}

if (!exists("PMR", mode = "function")) {
  source(file.path(root, "R", "PMR.R"))
}

if (!exists("plot2", mode = "function")) {
  source(file.path(root, "R", "plot2.R"))
}

if (!exists("ggof", mode = "function")) {
  source(file.path(root, "R", "ggof.R"))
}

# File rmse.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2011-2024 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'rmse': Root Mean Square Error                                               #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 15-Dic-2008                                                         #
# Updates: 06-Sep-2009                                                         #
#          18-Jan-2024                                                         #
################################################################################
# 'obs'   : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim'   : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 'Result': Root Mean Square Error between 'sim' and 'obs', in the same units of 'sim' and 'obs'

rmse <-function(sim, obs, ...) UseMethod("rmse")

rmse.default <- function(sim, obs, na.rm=TRUE, 
                         fun=NULL, ...,
                         epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                         epsilon.value=NA) {

  # Checking 'epsilon.type'
  epsilon.type <- match.arg(epsilon.type) 

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo"))) |
          is.na(match(class(obs), c("integer", "numeric", "ts", "zoo")))
     ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo')")    
      
  if ( length(obs) != length(sim) ) 
	 stop("Invalid argument: 'sim' & 'obs' doesn't have the same length !")   

  # index of those elements that are present both in 'sim' and 'obs' (NON- NA values)
  vi <- valindex(sim, obs)
   
  if (length(vi) > 0) {	 
    # Filtering 'obs' and 'sim', selecting only those pairs of elements 
    # that are present both in 'x' and 'y' (NON- NA values)
    obs <- obs[vi]
    sim <- sim[vi]

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end     
	 
    rmse <- sqrt( mean( (sim - obs)^2, na.rm = na.rm) )
  
  } else {
       rmse <- NA
       warning("There are no pairs of 'sim' and 'obs' without missing values !")
    } # ELSE end
           
  return(rmse)
     
} # 'rmse.default' end
  

rmse.matrix <- function(sim, obs, na.rm=TRUE, 
                        fun=NULL, ...,
                        epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                        epsilon.value=NA) {

   # Checking 'epsilon.type'
   epsilon.type <- match.arg(epsilon.type) 

   # Checking that 'sim' and 'obs' have the same dimensions
   if ( all.equal(dim(sim), dim(obs)) != TRUE )
    stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
          paste(dim(sim), collapse=" "), "] != [", 
          paste(dim(obs), collapse=" "), "] )", sep="") )

   rmse <- rep(NA, ncol(obs))       
          
   rmse <- sapply(1:ncol(obs), function(i,x,y) { 
                  rmse[i] <- rmse.default( x[,i], y[,i], na.rm=na.rm, fun=fun, ..., 
                                       epsilon.type=epsilon.type, epsilon.value=epsilon.value)
                 }, x=sim, y=obs )    
                     
   names(rmse) <- colnames(obs)
            
   return(rmse)
     
} # 'rmse.matrix' end


rmse.data.frame <- function(sim, obs, na.rm=TRUE, 
                            fun=NULL, ...,
                            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                            epsilon.value=NA) {

  # Checking 'epsilon.type'
  epsilon.type <- match.arg(epsilon.type)  

  sim <- as.matrix(sim)
  obs <- as.matrix(obs)

  rmse.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
              epsilon.type=epsilon.type, epsilon.value=epsilon.value)        
           
  return(rmse)
     
} # 'rmse.data.frame' end


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 18-Jan-2024                                                         #
################################################################################
rmse.zoo <- function(sim, obs, na.rm=TRUE, 
                     fun=NULL, ...,
                     epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                     epsilon.value=NA){
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       rmse.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., epsilon.type=epsilon.type, 
                   epsilon.value=epsilon.value)
    } else NextMethod(sim, obs, na.rm=na.rm, fun=fun, ..., epsilon.type=epsilon.type, 
                      epsilon.value=epsilon.value)
     
  } # 'rmse.zoo' end

# File plotbandsonly.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/
# Copyright 2013-2024 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# plotbandsonly: Plots a polygon representing uncertainty bounds               #
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: Date: 24-Nov-2010                                                   #
################################################################################
# Updates: 15-Apr-2013                                                         #
#          28-Dec-2022                                                         #
################################################################################
      
plotbandsonly <- function(lband, uband,
                      
                          dates,
                          date.fmt="%Y-%m-%d", 
                        
                          bands.col="lightblue",
                          border= NA,               
                      
                          ...) {
                    
    # Checking  the class of 'x', 'lband', 'uband, and 'sim' (if provided)
    valid.class <- c("xts", "zoo", "numeric", "integer")
    if ( length(which((class(lband) %in% valid.class) == TRUE)) == 0) 
      stop("Invalid argument: 'class(lband)' must be in c('xts', 'zoo', 'numeric', 'integer')")
    if ( length(which((class(uband) %in% valid.class) == TRUE)) == 0) 
      stop("Invalid argument: 'class(uband)' must be in c('xts', 'zoo', 'numeric', 'integer')")         

    # Checking that the lenghts of 'lband' and 'uband' are equal 
    if ( length(lband) != length(uband) )
      stop("Invalid argument: 'length(lband)' is different from 'length(uband)'")    
    
    # For easier reading
    x <- lband
    
    # If the user didn't provided the dates, but 'x' is a zoo object
    # dates are taken from 'x'
    if ( missing(dates) ) {
    
      if ( zoo::is.zoo(x) | xts::is.xts(x) ) {
        # class(time(x))== "Date" for 'daily' and 'monthly' time series
        # class(time(x))== "character" for 'annual' time series
        if ( inherits(time(x), "Date") ) { dates <- time(x) 
        } else if ( inherits(time(x), "character") ) {  
             dates <- as.Date(time(x), format="%Y") 
          }  
      } else # If there is no way to obtain the dates
          message("[Note: You didn't provide dates, so only a numeric index will be used in the time axis.]")  
          
      # Checking that the dates of 'x', 'lband', 'uband' and 'sim' are equal ,
      # when they are zoo objects    
      if ( zoo::is.zoo(lband) & zoo::is.zoo(uband) ) 
        if  ( !all.equal( time(lband), time(uband) ) )
         stop("Invalid argument: time(lband) is different from time(uband)")       
          
    } # IF end
    
    # If the user provided 'dates', 
    # its length is checked against 'length(x)', and
    # the values of 'dates' are set to 'x', 'lband', 'uband' and 'sim' 
    # when they are zoo objects 
    if ( !missing(dates) )  { 
  
      # Checking that 'dates' have the same length than 'lband' ( and 'uband')      
      if ( length(dates) != length(lband) )  
         stop("Invalid argument: 'dates' and 'lband' must have the same length")
  
      # Checking that 'dates' have the right class
      if (is.na(match(class(dates), c("character", "factor", "Date")))) 
        stop("Invalid argument: 'class(dates)' must be in c('character', 'factor', 'Date')")
        
      # If 'dates' is a factor or character , it have to be converted into 'Date' class, 
      # using the date format  specified by 'date.fmt'
      if ( !is.na( match(class(dates), c("factor", "character") ) ) ) 
        dates <- as.Date(dates, format= date.fmt)   
    
      # If 'lband', 'uband'  (when provided) are 'zoo' 
      # and the user provides 'dates' (probably new dates), 
      # the dates of the objects are changed to the new date
      if ( zoo::is.zoo(lband) ) { time(lband) <- dates } 
      if ( zoo::is.zoo(uband) ) { time(uband) <- dates }  
        
      # If the class of 'x' 'lband', 'uband' and 'sim' (when provided) 
      # are not 'zoo' and the user provides the dates, 
      # then we turn them into a zoo objects
      if ( !zoo::is.zoo(lband) )  lband <- vector2zoo(x=lband, dates=dates, date.fmt=date.fmt) # hydroTSM::vector2zoo
      if ( !zoo::is.zoo(uband) )  uband <- vector2zoo(x=uband, dates=dates, date.fmt=date.fmt) # hydroTSM::vector2zoo 
    
    }  # IF end       

    # Getting the position of the possible NA's
    na.index <- which(is.na(x))

    # Avoiding plotting the uncertainty bounds for the Na's
    if (length(na.index) > 0) {
      uband[na.index] <- uband[na.index-1]
      lband[na.index] <- lband[na.index+1]
    } # IF end

    #uband[na.index] <- .5*( uband[na.index+1] + uband[na.index-1] )
    #lband[na.index] <- .5*( lband[na.index+1] + lband[na.index-1] )

    if ( length(which((class(lband) %in% c("xts")) == TRUE)) > 0) {
      lband.coords <- xy.coords(xts::.index(lband), lband[, 1])
      uband.coords <- xy.coords(xts::.index(uband), uband[, 1])

      t     <- c( lband.coords$x, rev(lband.coords$x) )
      bands <- c( uband.coords$y, rev(lband.coords$y) )              
    } else {
       # Length of the observed values and all the vectors provided
       L <- length(lband) 
    
       # Creating the 'x' values of the polygons of the bands
       if ( zoo::is.zoo(x) ) {
         t <- c( time(lband), rev(time(uband)) )
       } else t <- c( 1:L, L:1)
         # Creating the 'y' values of the polygons of the bands
         bands <- c(as.numeric(lband), rev(as.numeric(uband)) )             
      } # ELSE end    
    
    # Plotting the polygons between the lower and upper bands
    polygon(t, bands, col=bands.col, border=border)

} # 'plotbandsonly' END

# File PMR.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2026-2026 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'PMR': Proxy for Model Robustness                                            #
#        Normalized mean absolute deviation of moving-window bias              #
#        from the global bias                                                  #
################################################################################
# Reference:                                                                   #
# Royer-Gaspard, P., Andreassian, V., and Thirel, G. (2021).                   #
# Technical note: PMR - a proxy metric to assess hydrological model robustness #
# in a changing climate, Hydrology and Earth System Sciences, 25, 5703--5716,  #
# https://doi.org/10.5194/hess-25-5703-2021.                                   #
################################################################################
# Started: 27-Apr-2026 ; 28-Apr-2026 ; 29-Apr-2026                             #
################################################################################
# The proxy for model robustness (PMR) is a dimensionless performance metric 
# that quantifies the temporal stability of model bias by measuring how much 
# the bias computed over moving sub-periods deviates, on average, from the 
# overall bias of the simulation relative to observations. 
# In practical terms, it evaluates whether a model maintains consistent 
# performance across different climatic or hydrological conditions rather 
# than performing well only during specific periods. 
################################################################################
# The PMR ranges from 0 to +Inf: 
#
# - a value of 0 indicates perfect robustness, meaning that the model bias is 
#   identical across all sub-periods and therefore fully stable over time;  
# - values close to 0 indicate high robustness with only minor temporal 
#   variability in bias; and progressively 
# - larger values indicate decreasing robustness, reflecting increasing 
#   variability in model bias between periods; and very large values 
#   suggest substantial non-stationarity in model errors, implying that the 
#   model performance is highly sensitive to changes in hydrological  
#   conditions or calibration/validation periods.

# 'obs'   : 'zoo' object with observed values
# 'sim'   : 'zoo' object with simulated values
# 'Result': Proxy for Model Robustness between 'sim' and 'obs'


PMR <- function(sim, obs, ...) UseMethod("PMR")

PMR.default <- function(sim, obs, na.rm=TRUE, 
                        k=NULL, min.years=5,
                        days.per.year=365,
                        fun=NULL, ...,
                        epsilon.type=c("none",
                                       "Pushpalatha2012",
                                       "otherFactor",
                                       "otherValue"),
                        epsilon.value=NA) {

  #' Compute default window length corresponding to 5 years of data
  get_default_value_for_k <- function(x, years = 5, days.per.year = 365) {

    #'
    #' @param x A zoo time series
    #' @param years Number of years to use for the adaptive window (default: 5)
    #' @param days.per.year Use 365.25 instead of 365 if long climatological series are expected.
    #'
    #' @return Integer value for k (number of observations)
    #' @importFrom hydroTSM sfreq
    #' @importFrom zoo index

    if (!inherits(x, "zoo"))
      stop("'x' must be a 'zoo' time series")

    freq <- hydroTSM::sfreq(x)

    # Map frequency to observations per year
    obs_per_year <- switch(freq,
      hourly  = days.per.year * 24,
      daily   = days.per.year,
      weekly  = 52,
      monthly = 12,
      annual  = 1,
      stop("Unsupported or unknown temporal frequency returned by 'sfreq' !")
    )

    k <- years * obs_per_year

    # Basic safeguard: ensure at least two windows can be formed
    if (length(x) < 2 * k) 
      warning("'x' is short relative to 'k' (", k, "). Please specify 'k' explicitly.") 

    return(as.integer(k))

  } # 'get_default_value_for_k' END


  epsilon.type <- match.arg(epsilon.type)

  if ( !inherits(sim, "zoo") | !inherits(obs, "zoo"))
    stop("Invalid argument: 'sim' and 'obs' must be 'zoo' objects !")

  if (is.null(k)) 
    k <- get_default_value_for_k(obs, years = min.years,
                                 days.per.year = days.per.year)

  if (NCOL(sim) > 1 | NCOL(obs) > 1)
    stop("Invalid argument: 'sim' and 'obs' must be univariate 'zoo' objects !")

  if (!is.null(fun)) {
    fun1 <- match.fun(fun)

    dots <- list(...)

    if (length(dots) > 0) {
      new <- do.call(preproc,
                     c(list(sim=sim, obs=obs, fun=fun1),
                       dots,
                       list(epsilon.type=epsilon.type,
                            epsilon.value=epsilon.value)))
    } else new <- preproc(sim=sim, obs=obs, fun=fun1,
                          epsilon.type=epsilon.type,
                          epsilon.value=epsilon.value)

    sim <- new[["sim"]]
    obs <- new[["obs"]]
  } # IF end

  n <- length(obs)

  if (n < k) {
    PMRval <- NA
    warning("Length of series smaller than window length 'k'")
    return(PMRval)
  } # IF end

  vi <- valindex(sim, obs)

  if (length(vi) > 0) {

    obs.valid <- obs[vi]
    sim.valid <- sim[vi]

    Qobs_mean <- mean(obs.valid)

    if ( (Qobs_mean == 0) | is.na(Qobs_mean) ) {
      PMRval <- NA
      warning("'mean(obs)=0' => not possible to compute 'PMR'")
      return(PMRval)
    } # IF end

    mean_bias <- mean(sim.valid) - mean(obs.valid)

    N <- n - k + 1

    moving_bias <- rep(NA, N)

    for (i in seq_len(N)) {

      idx <- i:(i + k - 1)

      sim.window <- sim[idx]
      obs.window <- obs[idx]
      vi.window  <- valindex(sim.window, obs.window)

      if (length(vi.window) > 0) {
        moving_bias[i] <-
          mean(sim.window[vi.window]) - mean(obs.window[vi.window])
      } # IF end
    } # FOR end

    deviations <- abs(moving_bias - mean_bias)

    PMRval     <- 2 * mean(deviations, na.rm=na.rm) / Qobs_mean

  } else {

      PMRval <- NA

      warning("There are no pairs of 'sim' and 'obs' without missing values !")
    } # ELSE end

  return(PMRval)

} # 'PMR.default' END



PMR.matrix <- function(sim, obs, na.rm=TRUE, 
                       k=NULL, min.years=5,
                       days.per.year=365,
                       fun=NULL, ...,
                       epsilon.type=c("none",
                                      "Pushpalatha2012",
                                      "otherFactor",
                                      "otherValue"),
                       epsilon.value=NA) {

  epsilon.type <- match.arg(epsilon.type)

  if (!inherits(sim, "zoo") | !inherits(obs, "zoo"))
    stop("Invalid argument: 'sim' and 'obs' must be 'zoo' objects !")

  if ( all.equal(dim(sim), dim(obs)) != TRUE )
    stop(paste("Invalid argument: dim(sim) != dim(obs) ( [",
               paste(dim(sim), collapse=" "),
               "] != [",
               paste(dim(obs), collapse=" "),
               "] )",
               sep=""))

  PMRval <- rep(NA, ncol(obs))

  PMRval <- sapply(
    1:ncol(obs),
    function(i, x, y) {

      PMR.default( x[, i], y[, i], na.rm=na.rm, 
                   k=k, min.years=min.years,
                   days.per.year=days.per.year,
                   fun=fun, ...,
                   epsilon.type=epsilon.type,
                   epsilon.value=epsilon.value
                  )

    },
    x=sim,
    y=obs
  ) # sapply END

  names(PMRval) <- colnames(obs)

  return(PMRval)

} # 'PMR.matriz' END


PMR.data.frame <- function(sim, obs, na.rm=TRUE, 
                           k=NULL, min.years=5,
                           days.per.year=365,
                           fun=NULL, ...,
                           epsilon.type=c("none",
                                          "Pushpalatha2012",
                                          "otherFactor",
                                          "otherValue"),
                           epsilon.value=NA) {

  epsilon.type <- match.arg(epsilon.type)

  if (!inherits(sim, "zoo") | !inherits(obs, "zoo"))
    stop("Invalid argument: 'sim' and 'obs' must be 'zoo' objects !")

  sim <- as.matrix(sim)
  obs <- as.matrix(obs)

  PMR.matrix( sim, obs, na.rm=na.rm, 
              k=k, min.years=min.years,
              days.per.year=days.per.year,
              fun=fun, ...,
              epsilon.type=epsilon.type,
              epsilon.value=epsilon.value
            )

} # 'PMR.data.frame' END


PMR.zoo <- function(sim, obs, na.rm=TRUE, 
                    k=NULL, min.years=5,
                    days.per.year=365,
                    fun=NULL, ...,
                    epsilon.type=c("none",
                                   "Pushpalatha2012",
                                   "otherFactor",
                                   "otherValue"),
                    epsilon.value=NA) {

  epsilon.type <- match.arg(epsilon.type)

  if (NCOL(sim) > 1 | NCOL(obs) > 1) {

    if (NCOL(sim) != NCOL(obs))
      stop("Invalid argument: ncol(sim) != ncol(obs) !")

    PMRval <- sapply(
                seq_len(NCOL(obs)),
                function(i, x, y) {

                  PMR.default(x[, i], y[, i], na.rm=na.rm, 
                              k=k, min.years=min.years,
                              days.per.year=days.per.year,
                              fun=fun, ...,
                              epsilon.type=epsilon.type,
                              epsilon.value=epsilon.value)

                },
                x=sim,
                y=obs
              )

    names(PMRval) <- colnames(obs)

    return(PMRval)

  } else {

      dots <- list(...)

      args <- list(sim=sim, obs=obs,
                   na.rm=na.rm,
                   k=k,
                   min.years=min.years,
                   days.per.year=days.per.year,
                   fun=fun,
                   epsilon.type=epsilon.type,
                   epsilon.value=epsilon.value)

      if (length(dots) > 0)
        args <- c(args, dots)

      do.call(PMR.default, args)

    }

} # 'PMR.zoo' end

test_that("gof includes JDKGE, LME, and LCE rows", {
  obs <- 1:10
  sim <- obs

  out <- gof(sim, obs)

  expect_true(all(c("JDKGE", "LME", "LCE") %in% rownames(out)))
  expect_false("PMR" %in% rownames(out))
  expect_equal(unname(out["JDKGE", 1]), 1)
  expect_equal(unname(out["LME", 1]), 1)
  expect_equal(unname(out["LCE", 1]), 1)
})

test_that("gof computes PMR for zoo inputs", {
  dates <- seq.Date(as.Date("2000-01-01"), by = "day", length.out = 20)
  obs <- zoo::zoo(seq_len(20), dates)
  sim <- obs
  sim[1:10] <- sim[1:10] + 2

  out <- gof(sim, obs, do.pmr = TRUE, k = 5)

  expect_equal(unname(out["PMR", 1]), unname(round(PMR(sim, obs, k = 5), 2)))
})

test_that("gof handles optional rows for matrix inputs", {
  obs <- matrix(1:40, ncol = 2)
  sim <- obs

  out <- gof(sim, obs, do.spearman = TRUE)

  expect_true("rSpearman" %in% rownames(out))
  expect_equal(ncol(out), 2)
  expect_equal(unname(out["rSpearman", ]), c(1, 1))
})

test_that("gof handles multicolumn zoo inputs column-wise", {
  dates <- seq.Date(as.Date("2000-01-01"), by = "day", length.out = 20)
  obs <- zoo::zoo(matrix(1:40, ncol = 2), dates)
  sim <- obs

  out <- gof(sim, obs, do.pmr = TRUE, k = 5)

  expect_equal(ncol(out), 2)
  expect_true("PMR" %in% rownames(out))
  expect_equal(unname(out["PMR", ]), c(0, 0))
})

test_that("gof handles zoo series with integer indexes", {
  obs <- zoo::zoo(1:10, 1:10)
  sim <- obs

  out <- gof(sim, obs, do.pmr = TRUE)

  expect_true("KGE" %in% rownames(out))
  expect_true(is.na(out["PMR", 1]))
})

test_that("PMR requires zoo inputs", {
  obs <- matrix(1:20, ncol = 2)
  sim <- obs

  expect_error(PMR(sim, obs, k = 3), "must be 'zoo' objects")
  expect_error(PMR(as.data.frame(sim), as.data.frame(obs), k = 3),
               "must be 'zoo' objects")
})

test_that("PMR handles multicolumn zoo objects column-wise", {
  dates <- seq.Date(as.Date("2000-01-01"), by = "day", length.out = 10)
  obs <- zoo::zoo(matrix(1:20, ncol = 2), dates)
  sim <- obs
  sim[1:5, 1] <- sim[1:5, 1] + 2
  sim[6:10, 2] <- sim[6:10, 2] - 2

  out <- PMR(sim, obs, k = 3)
  expected <- c(PMR(sim[, 1], obs[, 1], k = 3),
                PMR(sim[, 2], obs[, 2], k = 3))

  expect_equal(out, expected)
})

test_that("PMR selects fixed windows before removing invalid pairs", {
  dates <- seq.Date(as.Date("2000-01-01"), by = "day", length.out = 6)
  obs <- zoo::zoo(c(1, 2, NA, 4, 5, 6), dates)
  sim <- zoo::zoo(c(1, 4, 10, 8, NA, 6), dates)
  k <- 3

  valid <- !is.na(sim) & !is.na(obs)
  mean_bias <- mean(sim[valid]) - mean(obs[valid])
  qobs_mean <- mean(obs[valid])
  moving_bias <- sapply(seq_len(length(obs) - k + 1), function(i) {
    idx <- i:(i + k - 1)
    valid_window <- !is.na(sim[idx]) & !is.na(obs[idx])
    mean(sim[idx][valid_window]) - mean(obs[idx][valid_window])
  })
  expected <- 2 * mean(abs(moving_bias - mean_bias)) / qobs_mean

  expect_equal(PMR(sim, obs, k = k), expected)
})

# File HFB.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/
# Copyright 2024-2025 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'HFB': median annual High Flow Bias                                          #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 04-May-2024                                                         #
# Updates: 05-May-2024                                                         #
#          01-Nov-2025 ; 20-Nov-2025                                           #
#          28-Apr-2026                                                         #
################################################################################

# The high flow bias (HFB) ranges from 0 to Inf, with an optimal value of 0.
# Higher values of HFB indicate stronger differences between the high values
# of \code{sim} and \code{obs}. Essentially, the closer to 0, the more similar
# the high values of \code{sim} and \code{obs} are.

# The median annual high-flows bias (HFB) is designed to drive the calibration of 
# hydrological models focused in the reproduction of high-flow events.

# It is inspired in the annual peak-flow bias (APFB) objective function 
# proposed by Mizukami et al. (2019). However, it has four important diferences:
# 1) instead of considering only the observed annual peak flow in each year,
#    it considers all the high flows in each year, where "high flows" are all 
#    the values above a user-defined probability of exceedence of the observed 
#    values, by default 0.1 (\code{hQ.thr=0.1}).
# 2) insted of considering only the simulated high flows for each 
#    year, which might occur in a date/time different from the date in which  
#    occurs the observed annual peak flow, it considers as many high simulated 
#    flows as the number of high observed flows for each year, each one in the 
#    exact same date/time in which the corresponding observed high flow occurred.
# 3) for each year, instead of using a single bias value (i.e., the bias in the 
#    annual peak flow), it uses the median of all the bias in the user-defined 
#    high flows 
# 4) when computing the final value of this metric, instead o using the mean of 
#    the annual values, it uses the median, in order to take a stronger 
#    representation of the bias when its distribution is not symetric.

# 'hQ.thr'     : numeric, representing the exceedence probabiliy used to identify 
#                high flows in \code{obs}. All values in \code{obs} that are equal or 
#                higher than \code{quantile(obs, hQ.thrs=hQ.thr)} are considered as 
#                high flows.\cr
#                On the other hand, the high values in \code{sim} are those located at 
#                the same i-th position than the i-th value of \code{obs} deemed as 
#                high flows. 
# 'start.month': [OPTIONAL]. Only used when the (hydrological) year of interest is 
#                different from the calendar year.
#                numeric in [1:12] indicating the starting month of the (hydrological) 
#                year. Numeric values in [1, 12] represent months in [January, December]. 
#                By default \code{start.month=1}.
# 'out.PerYear': logical, indicating whether the output of this function has to include 
#                the median annual high-flows bias obtained for the individual years in 
#                \code{sim} and \code{obs} or not.

# Ref:
# Mizukami, N., Rakovec, O., Newman, A. J., Clark, M. P., Wood, A. W., 
# Gupta, H. V., and Kumar, R.: (2019). On the choice of calibration metrics for 
# "high-flow" estimation using hydrologic models, Hydrology Earth System 
# Sciences 23, 2601-2614, doi:10.5194/hess-23-2601-2019.

HFB <- function(sim, obs, ...) UseMethod("HFB")

# epsilon: By default it is set at one hundredth of the mean flow. See Pushpalatha et al. (2012)
HFB.default <- function(sim, obs, na.rm=TRUE, 
                        hQ.thr=0.1,
                        start.month=1, out.PerYear=FALSE,
                        fun=NULL,
                        ...,
                        epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                        epsilon.value=NA
                        ) { 

  # Function to compute the high flow bias in a single year
  lHFB.year <- function(i,          # index corresponding to the position of the unique year being analised (i in [1, nyears])
                        lsim,       # list where each element has all the individual simulated values during year 'i'
                        lobs,       # list where each element has all the individual observed values during year 'i'
                        lhQ.val,    # numeric, representing the streamflow value (in m3/s) used to identify high flows in \code{obs}
                        lna.rm=TRUE
                        ) {

    # Selecting all the individual simulated and observed values during year 'i'
    llsim          <- lsim[[i]]
    llobs          <- lobs[[i]]

    # Selecting only high values in 'obs'
    llobs.high.pos <- which(llobs >= lhQ.val)
    llobs.high     <- llobs[llobs.high.pos]

    # Selecting values in 'sim' that have the same temporal location than the high values in 'obs'
    llsim.high     <- llsim[llobs.high.pos]

    # Annual high-flow bias as the absolute relative difference between the
    # annual median simulated and observed high flows.
    lHFB  <- sqrt((stats::median(llsim.high, na.rm=na.rm) /
                    stats::median(llobs.high, na.rm=na.rm) - 1)^2)

    return(lHFB)
  } #'lHFB.year' END
   

  if ( !inherits(sim, "zoo") | !inherits(obs, "zoo"))
    stop("Invalid argument: 'sim' and 'obs' must be 'zoo' objects !")

  if ( (hQ.thr < 0) | (hQ.thr > 1) | 
       (length(hQ.thr) > 1) | (length(hQ.thr) == 0) ) {
    hQ.val <- NA
    stop("Invalid argument: 'hQ.thr' must be a single number in [0, 1] !")
  } # IF end 

  
  # Selecting only valid paris of values
  vi <- valindex(sim, obs)    
 
  if (length(vi) > 0) {	 
    obs <- obs[vi]
    sim <- sim[vi]

    # Applying 'fun' to each value in 'obs' and 'sim'
    if (!is.null(fun)) {
      fun <- match.fun(fun)
      new <- preproc(sim=sim, obs=obs, fun=fun, ..., 
                     epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim <- new[["sim"]]
      obs <- new[["obs"]]
    } # IF end
 

    hQ.val <- stats::quantile(obs, probs=(1-hQ.thr)) # To use 'lhQ.thr' as pbb of exceedence instead of as a quantile  
    #message("hQ.val= ", round(hQ.val,3) )

    # Checking that time of sim' and 'obs' are the same
    sim.ltime <- time(sim)
    obs.ltime <- time(obs)
    if ( !all.equal(sim.ltime, obs.ltime ) ) 
      stop("Invalid argument: 'sim' and 'obs' must have the same time attribute !")


    # Getting annual values of 'sim' and 'obs'
    years  <- format(obs.ltime, "%Y") # or 'ltimes <- sim.ltime', because 'sim.ltime' is the same as 'obs.ltime'

    # Shifting backwards the year each element in 'x', 
    # only when start.month != 1
    ltimes <- obs.ltime # or 'ltimes <- sim.ltime', because 'sim.ltime' is the same as 'obs.ltime'
    if ( start.month != 1 )
      years <- hydroTSM::shiftyears(ltime=ltimes, lstart.month=start.month)

    # Getting a numeric vector with the unique years in 'sim' and 'obs'
    years.unique <- unique(years)

    # Getting the number of years in 'sim' and 'obs'
    nyears <- length(years.unique)

    # Getting a list of 'sim' and 'obs' values for each year
    sim.PerYear <- split(coredata(sim), years)
    obs.PerYear <- split(coredata(obs), years) # years.sim == years.obs

    # Computing annual HFB values
    HFB.yr        <- sapply(1:nyears, FUN=lHFB.year, lsim=sim.PerYear, lobs=obs.PerYear, 
                            lhQ.val=hQ.val, lna.rm= na.rm)
    names(HFB.yr) <- years.unique

    HFB <- stats::median(HFB.yr, na.rm=na.rm)

  } else {
      HFB    <- NA
      HFB.yr <- NA
    } # ELSE end

  if (out.PerYear) {
    out <- list(HFB.value=HFB, HFB.PerYear=HFB.yr)
  } else out <- HFB
    
  return(out)
} # 'HFB.default' END
#HFB.default(sim,sim, hQ.thr=0.1)
#HFB.default(sim,obs, hQ.thr=0.20)
#HFB.default(sim,obs, hQ.thr=0.10)
#HFB.default(sim,obs, hQ.thr=0.05)
#HFB.default(sim,obs, hQ.thr=0.01)


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 04-May-2024                                                         #
# Updates:                                                                     #
################################################################################

HFB.matrix <- function(sim, obs, na.rm=TRUE, 
                       hQ.thr=0.1,
                       start.month=1, out.PerYear=FALSE, 
                       fun=NULL,
                       ...,
                       epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                       epsilon.value=NA) { 

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
     stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
           paste(dim(sim), collapse=" "), "] != [", 
           paste(dim(obs), collapse=" "), "] )", sep="") )
           

  # Annual index for 'sim' and 'obs'
  dates.sim  <- time(sim)
  dates.obs  <- time(obs)
  years.sim  <- format( dates.sim, "%Y")
  years.obs  <- format( dates.obs, "%Y")
  if (!all.equal(years.sim, years.obs)) {
    stop("Invalid argument: 'sim' and 'obs' must have the same dates !")
  } 
  nyears <- length(unique(years.obs))


  HFB                <- rep(NA, ncol(obs))       
  elements           <- matrix(NA, nrow=nyears, ncol=ncol(obs))
  rownames(elements) <- unique(years.obs)
  colnames(elements) <- colnames(obs)


  out.single <- sapply(1:ncol(obs), function(i,x,y) { 
                  HFB[i] <- HFB.default( x[,i], y[,i], na.rm=na.rm, 
                                         hQ.thr=hQ.thr,  
                                         start.month=start.month, 
                                         out.PerYear=out.PerYear, 
                                         fun=fun, 
                                         epsilon.type=epsilon.type, 
                                         epsilon.value=epsilon.value )[[1]]
                 }, x=sim, y=obs ) 
  names(out.single) <- names(obs)


  if (out.PerYear) {        
    out.yr <- sapply(1:ncol(obs), function(i,x,y) { 
                    elements[,i] <- HFB.default( x[,i], y[,i], na.rm=na.rm, 
                                                 hQ.thr=hQ.thr,  
                                                 start.month=start.month, 
                                                 out.PerYear=out.PerYear, 
                                                 fun=fun, 
                                                 epsilon.type=epsilon.type, 
                                                 epsilon.value=epsilon.value )[[2]]
                   }, x=sim, y=obs ) 
 
    colnames(out.yr) <- names(obs)                     
  } # IF end

  if (out.PerYear) {
    out <- list(HFB.value=out.single, HFB.PerYear=out.yr)
  } else out <- out.single
  
  return(out)
     
} # 'HFB.matrix' end


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 04-May-2024                                                         #
# Updates: 05-May-2024                                                         #
################################################################################
HFB.data.frame <- function(sim, obs, na.rm=TRUE, 
                           hQ.thr=0.1,
                           start.month=1, out.PerYear=FALSE, 
                           fun=NULL,
                           ...,
                           epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                           epsilon.value=NA) { 
 
  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
  
   
  HFB.matrix(sim, obs, na.rm=na.rm, hQ.thr=hQ.thr, 
             start.month=start.month, out.PerYear=out.PerYear, fun=fun, ...,  
             epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'HFB.data.frame' end


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 04-May-2024                                                         #
# Updates:                                                                     #
################################################################################
HFB.zoo <- function(sim, obs, na.rm=TRUE, 
                    hQ.thr=0.1,
                    start.month=1, out.PerYear=FALSE, 
                    fun=NULL,
                    ...,
                    epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                    epsilon.value=NA) { 

  #sim <- zoo::coredata(sim)
  #if (is.zoo(obs)) obs <- zoo::coredata(obs)    

  if (is.matrix(sim) | is.data.frame(sim)) {
    HFB.matrix(sim, obs, na.rm=na.rm, hQ.thr=hQ.thr, 
                 start.month=start.month, out.PerYear=out.PerYear, fun=fun, ...,  
                 epsilon.type=epsilon.type, epsilon.value=epsilon.value)
  } else NextMethod(sim, obs, na.rm=na.rm, hQ.thr=hQ.thr, 
                    start.month=start.month, out.PerYear=out.PerYear, fun=fun, ...,  
                    epsilon.type=epsilon.type, epsilon.value=epsilon.value)  
     
} # 'HFB.zoo' end

# File valindex.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/
# Copyright 2009-2024 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'valindex': index of the elements that belongs to both vectors               #
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 19-Jan-2009                                                         #
# Updates: 08-May-2012                                                         #
#          22-Mar-2013 ; 15-Apr-2013                                           #
################################################################################
# 'x'     : vector (numeric, xts, zoo)
# 'y'     : vector (numeric, xts, zoo)
# 'Result': index containing the position in 'x' and 'y' where both vectors 
#           have valid elements (NON- NA)

valindex <- function(sim, obs, ...) UseMethod("valindex")

valindex.default <- function(sim, obs, ...) {  

   if ( length(obs) != length(sim) ) {
	  stop( "Invalid argument: 'length(sim) != length(obs)' !! (", length(sim), "!=", length(obs), ") !!" )
   } else { 
       index <- which(!is.na(sim) & !is.na(obs))
       if (length(index)==0) warning("'sim' and 'obs' are empty or they do not have any common pair of elements with data !!")
       return( index  )
     } # ELSE end
     
} # 'valindex' END


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 25-Jul-2011                                                         #
# Updates: 08-May-2012                                                         #
################################################################################
valindex.matrix <- function(sim, obs, ...) { 

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE ) {
    stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
          paste(dim(sim), collapse=" "), "] != [", 
          paste(dim(obs), collapse=" "), "] )", sep="") )
   } else  
       return ( !is.na( sim) & !is.na(obs) )
 
} # 'valindex.matrix' END

# File mNSE.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/
# Copyright 2011-2024 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

##################################################
# 'mNSE': Modified Nash-sutcliffe Efficiency     #
##################################################
# Started: July 28th, 2009;  06-Sep-09           #
# Updates: 01-Jun-2011                           #
#          29-Jul-2022                           #
##################################################
# Ref:
# Krause, P., Boyle, D. P., and Base, F. (2005). Comparison of different efficiency criteria for hydrological model assessment, Adv. Geosci., 5, 89-97
# Legates and McCabe, 1999. Evaluating the use of "goodness-of-fit" measures 
#                           in hydrologic and hydroclimatic model validation. 
#                           Water Resources Research. v35 i1. 233-241.

# Nash-Sutcliffe efficiency not "inflated" by squared values
# Essentially, the closer the model efficiency is to 1, the more accurate the model is.  

# 'obs' : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim' : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 'j'   : numeric, with the exponent to be used in the computation of the modified Nash-Sutcliffe effciency. The default value is j=1

# 'Result': Modified Nash-sutcliffe Efficiency between 'sim' and 'obs'

mNSE <-function(sim, obs, ...) UseMethod("mNSE")

mNSE.default <- function(sim, obs, j=1, na.rm=TRUE,
                         fun=NULL, ...,
                         epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                         epsilon.value=NA){ 

	 if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo", "xts"))) |
          is.na(match(class(obs), c("integer", "numeric", "ts", "zoo", "xts")))
     ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo', 'xts')")   

     epsilon.type <- match.arg(epsilon.type)
     
     # Checking that the provided exponent is positive
     if (j < 0 ) stop("Invalid argument: 'j' must be positive")           
   
     vi <- valindex(sim, obs)

     if (length(vi) > 0) {	 
       # Filtering 'obs' and 'sim', selecting only those pairs of elements 
       # that are present both in 'x' and 'y' (NON- NA values)
       obs <- obs[vi]
       sim <- sim[vi]

       if (!is.null(fun)) {
         fun1 <- match.fun(fun)
         new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                         epsilon.type=epsilon.type, epsilon.value=epsilon.value)
         sim  <- new[["sim"]]
         obs  <- new[["obs"]]
       } # IF end
	  
	     denominator <- sum( abs(obs - mean(obs, na.rm=na.rm))^j )
	 
       if ( (denominator != 0) & (!is.na(denominator)) ) {      
	       NS1 <- 1 - ( sum( abs(obs - sim)^j ) / denominator )	 
	     } else {
	         NS1 <- NA
	         warning("'sum(abs(obs - mean(obs))^j)=0', it is not possible to compute 'mNSE'")  
	       } # ELSE end

     } else {
         NS1 <- NA
         warning("There are no pairs of 'sim' and 'obs' without missing values !")
       } # ELSE end
	 
	return(NS1)
     
} # 'mNSE.default' end


mNSE.matrix <- function (sim, obs, j=1, na.rm=TRUE,
                         fun=NULL, ...,
                         epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                         epsilon.value=NA){ 

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
    stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
          paste(dim(sim), collapse=" "), "] != [", 
          paste(dim(obs), collapse=" "), "] )", sep="") )

  NS1 <- rep(NA, ncol(obs))       
          
  NS1 <- sapply(1:ncol(obs), function(i,x,y) { 
                 NS1[i] <- mNSE.default( x[,i], y[,i], j=j, na.rm=na.rm, fun=fun, ..., 
                                         epsilon.type=epsilon.type, epsilon.value=epsilon.value)
               }, x=sim, y=obs)    
                     
  names(NS1) <- colnames(obs)
  return(NS1)
     
} # 'mNSE.matrix' end


mNSE.data.frame <- function(sim, obs, j=1, na.rm=TRUE,
                            fun=NULL, ...,
                            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                            epsilon.value=NA){  
 
  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
   
  mNSE.matrix(sim, obs, j, na.rm=na.rm, fun=fun, ..., 
              epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'mNSE.data.frame' end


mNSeff <-function(sim, obs, ...) UseMethod("mNSE")


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 29-Jul-2022                                                         #
################################################################################
mNSE.zoo <- function(sim, obs, j=1, na.rm=TRUE, 
                     fun=NULL, ...,
                     epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                     epsilon.value=NA){ 
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       mNSE.matrix(sim, obs, j=j, na.rm=na.rm, ...)
    } else NextMethod(sim, obs, j=j, na.rm=na.rm, fun=fun, ..., 
             epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
  } # 'mNSE.zoo' end

# File NSE.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2008-2023 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'NSE': Nash-Sutcliffe Efficiency                                             #
################################################################################
# 15-Dic-2008   ; 06-Sep-09                                                    #
# 29-Jun-2017                                                                  #
# 11-Jul-2022 ; 12-Jul-2022 ; 13-Jul-2022                                      #
# 20-Jan-2024                                                                  #
################################################################################
# Nash-Sutcliffe efficiencies (Nash and Sutcliffe, 1970) range from -Inf to 1. 
# An efficiency of 1 (NSE = 1) corresponds to a perfect match of modeled to the observed data. 
# An efficiency of 0 (NSE = 0) indicates that the model predictions are as accurate
# as the mean of the observed data, whereas 
# an efficiency less than zero (-Inf < NSE < 0) occurs when the observed mean is a better predictor than the model.
# Essentially, the closer the model efficiency is to 1, the more accurate the model is.  

# 'obs'   : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim'   : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 'Result': Nash-sutcliffe Efficiency between 'sim' and 'obs'

NSE <-function(sim, obs, ...) UseMethod("NSE")

NSE.default <- function (sim, obs, na.rm=TRUE, fun=NULL, ..., 
                         epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                         epsilon.value=NA){ 

  # Checking 'epsilon.type'
  epsilon.type <- match.arg(epsilon.type) 

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo", "xts"))) |
       is.na(match(class(obs), c("integer", "numeric", "ts", "zoo", "xts")))
  ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo', 'xts')")      

  # index of those elements that are present both in 'sim' and 'obs' (NON- NA values)
  vi <- valindex(sim, obs)
   
  if (length(vi) > 0) {	 
    # Filtering 'obs' and 'sim', selecting only those pairs of elements 
    # that are present both in 'x' and 'y' (NON- NA values)
    obs <- obs[vi]
    sim <- sim[vi]

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end     
     
    denominator <- sum( (obs - mean(obs))^2 )
     
    if ( (denominator != 0) & (!is.na(denominator)) ) {      
      NS <- 1 - ( sum( (obs - sim)^2 ) / denominator )     
    } else {
        NS <- NA
        warning("'sum((obs - mean(obs))^2)=0' => it is not possible to compute 'NSE'")  
      } 
  } else {
       NS <- NA
       warning("There are no pairs of 'sim' and 'obs' without missing values !")
    } # ELSE end
     
  return(NS)
     
} # 'NSE' end


NSE.matrix <- function(sim, obs, na.rm=TRUE, fun=NULL, ..., 
                       epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                       epsilon.value=NA){ 

  # Checking 'epsilon.type'
  epsilon.type <- match.arg(epsilon.type)  

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
    stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
          paste(dim(sim), collapse=" "), "] != [", 
          paste(dim(obs), collapse=" "), "] )", sep="") )
 
  NS <- rep(NA, ncol(obs))       
          
  NS <- sapply(1:ncol(obs), function(i,x,y) { 
                 NS[i] <- NSE.default( x[,i], y[,i], na.rm=na.rm, fun=fun, ..., 
                                       epsilon.type=epsilon.type, epsilon.value=epsilon.value)
               }, x=sim, y=obs )    
                     
  names(NS) <- colnames(obs)
  
  return(NS)
     
} # 'NSE.matrix' end


NSE.data.frame <- function(sim, obs, na.rm=TRUE, fun=NULL, ..., 
                           epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                           epsilon.value=NA){ 
 
  # Checking 'epsilon.type'
  epsilon.type <- match.arg(epsilon.type)  

  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
   
  NSE.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
             epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'NSE.data.frame' end


NSeff <-function(sim, obs, ...) UseMethod("NSE")


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 12-Jul-2022 ; 13-Jul-2022                                           #
#          18-Jan-2024 ; 19-Jan-2024                                           #
################################################################################
NSE.zoo <- function(sim, obs, na.rm=TRUE, fun=NULL, ..., 
                    epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                    epsilon.value=NA){ 
    
    # Checking 'epsilon.type'
    epsilon.type <- match.arg(epsilon.type) 

    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       NSE.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., epsilon.type=epsilon.type, 
                  epsilon.value=epsilon.value)
    } else NextMethod(sim, obs, na.rm=na.rm, fun=fun, ..., epsilon.type=epsilon.type, 
                      epsilon.value=epsilon.value)
     
  } # 'NSE.zoo' end

# File rSpearman.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2024-2024 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

# From https://en.wikipedia.org/wiki/Spearman%27s_rank_correlation_coefficient:
# In statistics, Spearman's rank correlation coefficient or Spearman's rho, named after 
# Charles Spearman[1] and often denoted by the Greek letter \rho  (rho) or as r_{s}, 
# is a nonparametric measure of rank correlation (statistical dependence between the 
# rankings of two variables). It assesses how well the relationship between two variables
# can be described using a monotonic function.

# The Spearman correlation between two variables is equal to the Pearson correlation between 
# the rank values of those two variables; while Pearson's correlation assesses linear 
# relationships, Spearman's correlation assesses monotonic relationships (whether linear 
# or not). 

# If there are no repeated data values, a perfect Spearman correlation of +1 or -1 occurs 
# when each of the variables is a perfect monotone function of the other.

# Intuitively, the Spearman correlation between two variables will be high when observations
# have a similar (or identical for a correlation of 1) rank (i.e. relative position label 
# of the observations within the variable: 1st, 2nd, 3rd, etc.) between the two variables, 
# and low when observations have a dissimilar (or fully opposed for a correlation of -1) 
# rank between the two variables.

################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 20-Jan-2024                                                         #
# Updates:                                                                     #
################################################################################
rSpearman <-function(sim, obs, ...) UseMethod("rSpearman")

rSpearman.default <- function(sim, obs, fun=NULL, ..., 
                             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                             epsilon.value=NA) {

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo"))) |
          is.na(match(class(obs), c("integer", "numeric", "ts", "zoo")))
     ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo')")

  vi <- valindex(sim, obs)
     
  if (length(vi) > 0) {
	 
    obs <- as.numeric(obs[vi])
    sim <- as.numeric(sim[vi])

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end
  
    rSpearman <- cor(sim, obs, method="spearman", use="pairwise.complete.obs") 
    # if 'sim' and 'obs' were matrixs or data.frame, then the correlation
    # between observed and simulated values for each variable is given by the diagonal of 'rSpearman' 
 

  } else {
           rSpearman <- NA
           warning("There are no pairs of 'sim' and 'obs' without missing values !")
         } # ELSE end
  
  return(rSpearman)
  
} # 'rSpearman.default' end



################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 20-Jan-2024                                                         #
# Updates:                                                                     #
################################################################################
rSpearman.matrix <- function(sim, obs, na.rm=TRUE, fun=NULL, ..., 
                             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                             epsilon.value=NA){

    rSpearman <- rep(NA, ncol(obs))       
          
    rSpearman <- sapply(1:ncol(obs), function(i,x,y) { 
                        rSpearman[i] <- rSpearman.default( x[,i], y[,i], na.rm=na.rm, fun=fun, ..., 
                                                  epsilon.type=epsilon.type, epsilon.value=epsilon.value)
                 }, x=sim, y=obs )            
           
    return(rSpearman)
     
} # 'rSpearman.matrix' END
  

################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 20-Jan-2024                                                         #
# Updates:                                                                     #
################################################################################  
rSpearman.data.frame <- function(sim, obs, na.rm=TRUE, fun=NULL, ..., 
                                 epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                                 epsilon.value=NA){

    sim <- as.matrix(sim)
    obs <- as.matrix(obs)
	
    rSpearman.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
                     epsilon.type=epsilon.type, epsilon.value=epsilon.value)        
     
} # 'rSpearman.data.frame' END
  
 
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 20-Jan-2024                                                         #
# Updates:                                                                     #
################################################################################
rSpearman.zoo <- function(sim, obs, na.rm=TRUE, fun=NULL, ..., 
                          epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                          epsilon.value=NA){
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       rSpearman.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
                       epsilon.type=epsilon.type, epsilon.value=epsilon.value)
    } else NextMethod(sim, obs, na.rm=na.rm, fun=fun, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'rSpearman.zoo' end

# File md.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/
# Copyright 2010-2024 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

########################################
# 'md': Modified Index of Agreement    #
########################################
# Started: 07-Apr-2010                 #
# Updates: 14-Jan-2023                 #
#          20-Jan-2024                 #
########################################
# Ref
# 1) Krause, P., Boyle, D. P., and Base, F.: Comparison of different efficiency criteria for hydrological model assessment, Adv. Geosci., 5, 89-97, 2005 

# Index of Agreement (Willmott et al., 1984) range from 0.0 to 1.0 
# and the closer to 1 the better the performance of the model 

# 'obs' : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim' : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 'j'   : numeric, with the exponent to be used in the computation of the modified index  of agreement. The default value is j=1

# 'Result': Modified Index of Agreement between 'sim' and 'obs'

md <-function(sim, obs, ...) UseMethod("md")

md.default <- function(sim, obs, j=1, na.rm=TRUE,
                       fun=NULL, ...,
                       epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                       epsilon.value=NA){ 

     if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo"))) |
          is.na(match(class(obs), c("integer", "numeric", "ts", "zoo")))
     ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo')")

     epsilon.type <- match.arg(epsilon.type)

     # the next two lines are required for avoiding an strange behaviour 
     # of the difference function when sim and obs are time series.
     if ( !is.na(match(class(sim), c("ts", "zoo"))) ) sim <- as.numeric(sim)
     if ( !is.na(match(class(obs), c("ts", "zoo"))) ) obs <- as.numeric(obs)

     # Checking that the provided exponent is positive
     if (j < 0 ) stop("Invalid argument: 'j' must be positive")   

     # index of those elements that are present both in 'x' and 'y' (NON- NA values)
     vi <- valindex(sim, obs)
     
     if (length(vi) > 0) {
	 
       # Filtering 'obs' and 'sim', selecting only those pairs of elements 
       # that are present both in 'x' and 'y' (NON- NA values)
       obs <- obs[vi]
       sim <- sim[vi]

       if (!is.null(fun)) {
         fun1 <- match.fun(fun)
         new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                         epsilon.type=epsilon.type, epsilon.value=epsilon.value)
         sim  <- new[["sim"]]
         obs  <- new[["obs"]]
       } # IF end
     
       # Mean of the observed values
       Om <- mean(obs)
      
       denominator <- sum( ( abs(sim - Om) + abs(obs - Om)  )^j )
     
       if ( (denominator != 0) & (!is.na(denominator)) ) {      
         d1 <- 1 - ( sum( ( abs(obs - sim) )^j ) / denominator )
       } else {
           d1 <- NA
           warning("'sum((abs(sim-Om)+abs(obs-Om))^j)=0', it is not possible to compute 'md'")  
         } # ELSE end

     } else {
         d1 <- NA
         warning("There are no pairs of 'sim' and 'obs' without missing values !")
       } # ELSE end
     
     return(d1) 
     
} # 'md.default' end


md.matrix <- function(sim, obs, j=1, na.rm=TRUE,
                      fun=NULL, ...,
                      epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                      epsilon.value=NA){ 

 # Checking that 'sim' and 'obs' have the same dimensions
 if ( all.equal(dim(sim), dim(obs)) != TRUE )
    stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
          paste(dim(sim), collapse=" "), "] != [", 
          paste(dim(obs), collapse=" "), "] )", sep="") )

 d1 <- rep(NA, ncol(obs))       
          
 d1 <- sapply(1:ncol(obs), function(i,x,y) { 
                 d1[i] <- md.default( x[,i], y[,i], j, na.rm=na.rm, fun=fun, ..., 
                                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
                 }, x=sim, y=obs )    
                     
  names(d1) <- colnames(obs)
  return(d1)
     
} # 'md.matrix' end


md.data.frame <- function(sim, obs, j=1, na.rm=TRUE,
                          fun=NULL, ...,
                          epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                          epsilon.value=NA){ 
 
  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
   
  md.matrix(sim=sim, obs=obs, j=j, na.rm=na.rm, ...)
     
} # 'md.data.frame' end


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 14-Jan-2023                                                         #
################################################################################
md.zoo <- function(sim, obs, j=1, na.rm=TRUE,
                   fun=NULL, ...,
                   epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                   epsilon.value=NA){
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       md.matrix(sim, obs, j=j, na.rm=na.rm, ...)
    } else NextMethod(sim, obs, j=j, na.rm=na.rm, ...)
     
  } # 'md.zoo' end

# File JDKGE.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2026-2026 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'JDKGE': Joint Divergence Kling-Gupta Efficiency (JDKGE)                     #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
# Started: 28-Abr-2026 ; 29-Apr-2026                                           #
################################################################################
# Reference:                                                                   #
#  Ficchi, A.; Bavera, D.; Grimaldi, S.; Moschini, F.; Pistocchi, A.;          #
#  Russo, C.; Salamon, P.; Toreti, A. (2026). Improving low and high flow      #
#  simulations at once: An enhanced metric for hydrological model calibrations.#
#  EGUsphere [preprint], https://doi.org/10.5194/egusphere-2026-43.            #
################################################################################
# The Joint Divergence Kling-Gupta Efficiency (JDKGE) is a composite 
# performance metric designed to evaluate hydrological model simulations by 
# simultaneously assessing four complementary attributes of agreement between 
# simulated and observed time series: 
# - linear correlation (timing and co-variability), 
# - relative variability (dispersion), 
# - bias (systematic over- or underestimation), and 
# - similarity of the full flow distributions through a divergence measure 
#  (typically the Jensen-Shannon divergence applied to log-transformed flows).
################################################################################
# Its theoretical range of JDKGE extends from -Inf to 1, where:
# - a value of 1 indicates perfect agreement across all four components, 
#   meaning that simulated values reproduce the observed timing, variability, 
#   mean magnitude, and distributional behavior exactly; 
# - a value of 0 indicates that the combined discrepancies in these attributes
#    are of the same overall magnitude as the reference deviations embedded 
#    in the metric formulation; and
# - negative values indicate progressively poorer performance, reflecting 
#   increasing mismatch in one or more components, such that the simulation 
#   deviates substantially from the observed statistical and distributional 
#   characteristics. 
################################################################################
# In practical hydrological model evaluation, therefore, values closer to 1 
# denote higher overall fidelity of the simulation across both 
# **central tendencies and extremes**, while increasingly negative values 
# signal structural deficiencies in the model representation of the 
# hydrological regime.
################################################################################
# Results by Ficchi et al. (2026) show that calibrations using JDKGE 
# significantly improve low-flow simulations compared to KGE, NSE and other 
# competitors, while maintaining comparable or improved performance in other 
# regimes, including high flows.
################################################################################
# 'obs'   : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim'   : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 'Result': Joint Divergence Kling-Gupta Efficiency between 'sim' and 'obs'



################################################################################
# 'JDKGE': Joint Divergence Kling-Gupta Efficiency                             #
################################################################################

JDKGE <- function(sim, obs, ...) UseMethod("JDKGE")


.JDKGE_check_s <- function(s) {

  if (!identical(s, c(1, 1, 1, 1))) {
    if (length(s) != 4)
      stop("Invalid argument: length(s) must be equal to 4 !")
    if (sum(s) != 1)
      stop("Invalid argument: sum(s) must be equal to 1.0 !")
  }

} # '.JDKGE_check_s' end


.JDKGE_timestep_seconds <- function(x) {

  timestep <- 86400

  if (inherits(x, "zoo")) {

    idx <- time(x)

    if (length(idx) > 1) {
      if (inherits(idx, "POSIXt")) {
        dt <- median(diff(as.numeric(idx)), na.rm=TRUE)
      } else if (inherits(idx, "Date")) {
        dt <- median(diff(as.numeric(idx)), na.rm=TRUE) * 86400
      } else {
        dt <- NA_real_
      }

      if (is.finite(dt) && (dt > 0))
        timestep <- dt
    }

  } else if (inherits(x, "ts")) {

    freq <- stats::frequency(x)

    if (is.finite(freq) && (freq > 0))
      timestep <- (365.25 * 86400) / freq
  }

  return( timestep )

} # '.JDKGE_timestep_seconds' end


.JDKGE_resolve_epsilon <- function(sim, obs, na.rm=TRUE,
                                   epsilon.type=c("otherValue", "none", "Pushpalatha2012",
                                                  "otherFactor"),
                                   epsilon.value=NA) {

  epsilon.type <- match.arg(epsilon.type)

  if (epsilon.type == "otherFactor") {
    if (is.na(epsilon.value))
      stop("Missing argument: you need to provide 'epsilon.value' !")
    if (!is.numeric(epsilon.value))
      stop("Invalid argument: 'epsilon.value' must be numeric !")
  } # IF end

  if (epsilon.type == "Pushpalatha2012") {
      epsilon <- mean(obs, na.rm=na.rm) / 100
    } else if (epsilon.type == "otherFactor") {
        epsilon <- epsilon.value * mean(obs, na.rm=na.rm)
      } else if (epsilon.type == "otherValue") {
          if (is.na(epsilon.value)) {
            positive <- c(sim[sim > 0], obs[obs > 0])
            if (length(positive) <= 0)
              return(NA_real_)
            epsilon <- min(1e-6, 0.1 * min(positive))
          } else {
              if (!is.numeric(epsilon.value))
                stop("Invalid argument: 'epsilon.value' must be numeric !")
              epsilon <- epsilon.value
            } # ELSE end
        } else epsilon <- 0

  return( epsilon )

} # '.JDKGE_resolve_epsilon' end


.JDKGE_prepare_logflows <- function(sim, obs, na.rm=TRUE,
                                    epsilon.type=c("otherValue", "none", "Pushpalatha2012",
                                                   "otherFactor"),
                                    epsilon.value=NA) {

  if (length(sim) != length(obs))
    stop("Invalid argument: length(sim) != length(obs)")

  if (any(!is.finite(sim)) || any(!is.finite(obs)))
    stop("Invalid argument: 'sim' and 'obs' must be finite")

  if (any(sim < 0) || any(obs < 0))
    stop("Invalid argument: negative values are not allowed in JDKGE")

  epsilon <- .JDKGE_resolve_epsilon(sim=sim, obs=obs, na.rm=na.rm,
                                    epsilon.type=epsilon.type,
                                    epsilon.value=epsilon.value)

  if (is.na(epsilon)) {
    return(list(log.sim=NA_real_, log.obs=NA_real_, epsilon=NA_real_))
  }

  if ((epsilon <= 0) && (any(sim == 0) || any(obs == 0))) {
    warning("Zero flows detected: choose a positive 'epsilon.type' or 'epsilon.value' to compute JDKGE", call.=FALSE)
    return(list(log.sim=NA_real_, log.obs=NA_real_, epsilon=epsilon))
  } # IF end

  sim.log <- log(ifelse(sim == 0, epsilon, sim))
  obs.log <- log(ifelse(obs == 0, epsilon, obs))

  return( list(log.sim=sim.log, log.obs=obs.log, epsilon=epsilon) )

} # '.JDKGE_prepare_logflows' end


.JDKGE_jsd_hist <- function(sim, obs, timestep=86400, na.rm=TRUE,
                            epsilon.type=c("otherValue", "none", "Pushpalatha2012",
                                           "otherFactor"),
                            epsilon.value=NA) {

  prep <- .JDKGE_prepare_logflows(sim=sim, obs=obs, na.rm=na.rm,
                                  epsilon.type=epsilon.type,
                                  epsilon.value=epsilon.value)

  if (length(prep$log.sim) == 1 && is.na(prep$log.sim))
    return(list(jsd=NA_real_, epsilon=prep$epsilon, nbins=NA_integer_, alpha=NA_real_))

  sim.log <- prep$log.sim
  obs.log <- prep$log.obs
  epsilon <- prep$epsilon

  if (identical(sim.log, obs.log)) {
    return(list(jsd=0, epsilon=epsilon, nbins=25L, alpha=epsilon))
  }

  xmin <- min(c(sim.log, obs.log))
  xmax <- max(c(sim.log, obs.log))

  iqr.obs <- stats::IQR(obs.log, na.rm=TRUE, type=7)
  h.min   <- min(1e2 * epsilon, 1e-1)

  if (is.finite(iqr.obs) && (iqr.obs > 0)) {
    h.fd <- 2 * iqr.obs * (length(obs.log)^(-1/3))
  } else h.fd <- 0

  h <- max(h.fd, h.min)

  tsf <- timestep / 86400
  if (!is.finite(tsf) || (tsf <= 0))
    tsf <- 1

  span <- xmax - xmin
  if (!is.finite(span) || (span <= 0))
    span <- h

  n.raw  <- ceiling((tsf^(1/3)) * span / h)
  nbins  <- max(min(n.raw, 100), 25)
  breaks <- seq(xmin, xmax, length.out=nbins + 1)

  h.sim <- graphics::hist(sim.log, breaks=breaks, plot=FALSE,
                          include.lowest=TRUE, right=TRUE)
  h.obs <- graphics::hist(obs.log, breaks=breaks, plot=FALSE,
                          include.lowest=TRUE, right=TRUE)

  width <- diff(h.sim$breaks)[1]

  d.sim <- h.sim$counts / (length(sim.log) * width)
  d.obs <- h.obs$counts / (length(obs.log) * width)

  alpha <- epsilon

  p.tilde <- d.sim + alpha
  q.tilde <- d.obs + alpha

  p <- p.tilde / sum(p.tilde)
  q <- q.tilde / sum(q.tilde)
  m <- 0.5 * (p + q)

  idx.p <- (p > 0) & (m > 0)
  idx.q <- (q > 0) & (m > 0)

  jsd <- 0.5 * sum(p[idx.p] * log2(p[idx.p] / m[idx.p])) +
         0.5 * sum(q[idx.q] * log2(q[idx.q] / m[idx.q]))

  return( list(jsd=jsd, epsilon=epsilon, nbins=nbins, alpha=alpha) )

} # '.JDKGE_jsd_hist' end


.JDKGE_jsd_kde <- function(sim, obs, na.rm=TRUE,
                           epsilon.type=c("otherValue", "none", "Pushpalatha2012",
                                          "otherFactor"),
                           epsilon.value=NA,
                           n.grid=512,
                           ...) {

  prep <- .JDKGE_prepare_logflows(sim=sim, obs=obs, na.rm=na.rm,
                                  epsilon.type=epsilon.type,
                                  epsilon.value=epsilon.value)

  if (length(prep$log.sim) == 1 && is.na(prep$log.sim))
    return(list(jsd=NA_real_, epsilon=prep$epsilon, n.grid=NA_integer_, alpha=NA_real_))

  sim.log <- prep$log.sim
  obs.log <- prep$log.obs
  epsilon <- prep$epsilon

  if (identical(sim.log, obs.log))
    return(list(jsd=0, epsilon=epsilon, n.grid=as.integer(n.grid), alpha=epsilon))

  grid.range <- range(c(sim.log, obs.log))
  pooled <- c(sim.log, obs.log)
  bw <- stats::bw.nrd0(pooled)

  if (!is.finite(bw) || bw <= 0)
    bw <- max(stats::IQR(pooled, type=7) / 1.349, 1e-6)

  d.sim <- stats::density(sim.log, bw=bw, from=grid.range[1], to=grid.range[2],
                          n=n.grid, ...)
  d.obs <- stats::density(obs.log, bw=bw, from=grid.range[1], to=grid.range[2],
                          n=n.grid, ...)

  dx <- d.sim$x[2] - d.sim$x[1]
  p.tilde <- d.sim$y * dx + epsilon
  q.tilde <- d.obs$y * dx + epsilon

  p <- p.tilde / sum(p.tilde)
  q <- q.tilde / sum(q.tilde)
  m <- 0.5 * (p + q)

  idx.p <- (p > 0) & (m > 0)
  idx.q <- (q > 0) & (m > 0)

  jsd <- 0.5 * sum(p[idx.p] * log2(p[idx.p] / m[idx.p])) +
         0.5 * sum(q[idx.q] * log2(q[idx.q] / m[idx.q]))

  return( list(jsd=jsd, epsilon=epsilon, n.grid=as.integer(n.grid), alpha=epsilon, bandwidth=bw) )

} # '.JDKGE_jsd_kde' end


.JDKGE_wasserstein <- function(sim, obs, na.rm=TRUE,
                               epsilon.type=c("otherValue", "none", "Pushpalatha2012",
                                              "otherFactor"),
                               epsilon.value=NA,
                               n.quantiles=512) {

  prep <- .JDKGE_prepare_logflows(sim=sim, obs=obs, na.rm=na.rm,
                                  epsilon.type=epsilon.type,
                                  epsilon.value=epsilon.value)

  if (length(prep$log.sim) == 1 && is.na(prep$log.sim))
    return(list(distance=NA_real_, similarity=NA_real_, epsilon=prep$epsilon, scale=NA_real_))

  sim.log <- prep$log.sim
  obs.log <- prep$log.obs
  epsilon <- prep$epsilon

  if (identical(sim.log, obs.log))
    return(list(distance=0, similarity=1, epsilon=epsilon, scale=1))

  probs <- seq(0, 1, length.out=n.quantiles)
  q.sim <- stats::quantile(sim.log, probs=probs, names=FALSE, type=8)
  q.obs <- stats::quantile(obs.log, probs=probs, names=FALSE, type=8)

  w1 <- mean(abs(q.sim - q.obs))
  pooled <- c(sim.log, obs.log)
  scale <- stats::IQR(pooled, na.rm=TRUE, type=7)

  if (!is.finite(scale) || scale <= 0)
    scale <- stats::sd(pooled, na.rm=TRUE)

  if (!is.finite(scale) || scale <= 0)
    scale <- 1

  similarity <- exp(-w1 / scale)

  return( list(distance=w1, similarity=similarity, epsilon=epsilon, scale=scale) )

} # '.JDKGE_wasserstein' end


JDKGE.default <- function(sim, obs, na.rm=TRUE,
                          s=c(1, 1, 1, 1),
                          method=c("2012", "2009", "2021"),
                          out.type=c("single", "full"),
                          density.method=c("hist", "kde", "wasserstein"),
                          nbins="paper",
                          timestep=86400,
                          kde.n.grid=512,
                          wasserstein.n.quantiles=512,
                          fun=NULL, ...,
                          epsilon.type=c("otherValue", "none", "Pushpalatha2012",
                                         "otherFactor"),
                          epsilon.value=NA) {

  #####################################
  # Checkings
  #####################################
  .JDKGE_check_s(s)

  method       <- match.arg(method)
  out.type     <- match.arg(out.type)
  epsilon.type <- match.arg(epsilon.type)
  density.method <- match.arg(density.method)

  if ((density.method != "hist") && !identical(nbins, "paper"))
    warning("'nbins' is only used when density.method='hist'; ignoring supplied value", call.=FALSE)

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo"))) |
       is.na(match(class(obs), c("integer", "numeric", "ts", "zoo"))) ) {
    stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo')")
  }

  vi <- valindex(sim, obs)

  if (length(vi) <= 0) {
    warning("There are no pairs of 'sim' and 'obs' without missing values !")
    JDK <- NA_real_
    elements <- c(r=NA_real_, Beta=NA_real_, Gamma=NA_real_, Delta=NA_real_)
    if (out.type == "single") return(JDK)
    return(list(JDKGE.value=JDK, JDKGE.elements=elements))
  } # IF end

  obs <- as.numeric(obs[vi])
  sim <- as.numeric(sim[vi])

  if (!is.null(fun)) {
    preproc.epsilon.type  <- epsilon.type
    preproc.epsilon.value <- epsilon.value

    if ((epsilon.type == "otherValue") && is.na(epsilon.value)) {
      preproc.epsilon.value <- .JDKGE_resolve_epsilon(sim=sim, obs=obs, na.rm=na.rm,
                                                      epsilon.type="otherValue",
                                                      epsilon.value=NA)
      preproc.epsilon.type <- if (is.na(preproc.epsilon.value)) "none" else "otherValue"
    }

    fun1 <- match.fun(fun)
    new <- preproc(sim=sim, obs=obs,
                   fun=fun1, ...,
                   epsilon.type=preproc.epsilon.type,
                   epsilon.value=preproc.epsilon.value)
    sim <- new[["sim"]]
    obs <- new[["obs"]]
  } # IF end

  keep <- is.finite(sim) & is.finite(obs)
  sim  <- sim[keep]
  obs  <- obs[keep]

  if (length(sim) <= 0) {
    warning("There are no finite pairs of 'sim' and 'obs' after preprocessing !")
    JDK <- NA_real_
    elements <- c(r=NA_real_, Beta=NA_real_, Gamma=NA_real_, Delta=NA_real_)
    if (out.type == "single") return(JDK)
    return(list(JDKGE.value=JDK, JDKGE.elements=elements))
  } # IF end

  if (any(sim < 0) || any(obs < 0)) {
    warning("Negative values detected: JDKGE is defined for non-negative flows only", call.=FALSE)
    JDK <- NA_real_
    elements <- c(r=NA_real_, Beta=NA_real_, Gamma=NA_real_, Delta=NA_real_)
    if (out.type == "single") return(JDK)
    return(list(JDKGE.value=JDK, JDKGE.elements=elements))
  } # IF end

  #####################################
  # Starting computations of the JDKGE
  #####################################

  r <- stats::cor(sim, obs)

  mean.sim  <- mean(sim, na.rm=na.rm)
  mean.obs  <- mean(obs, na.rm=na.rm)
  sigma.sim <- stats::sd(sim, na.rm=na.rm)
  sigma.obs <- stats::sd(obs, na.rm=na.rm)

  Beta  <- NA_real_
  Gamma <- NA_real_
  Alpha <- NA_real_
  Delta <- NA_real_
  JDK   <- NA_real_

  if (method %in% c("2009", "2012")) {
    if (mean.obs == 0) {
      warning("Warning: 'mean(obs)==0'. Beta is undefined", call.=FALSE)
    } else Beta <- mean.sim / mean.obs
  } else {
      if (sigma.obs == 0) {
        warning("Warning: 'sd(obs)==0'. Beta.2021 is undefined", call.=FALSE)
      } else Beta <- (mean.sim - mean.obs) / sigma.obs
    } # ELSE end

  if (method == "2012") {
    if (mean.sim == 0 || mean.obs == 0 || sigma.obs == 0) {
      if (mean.sim == 0)
        warning("Warning: 'mean(sim)==0'. Gamma is undefined", call.=FALSE)
      if (mean.obs == 0)
        warning("Warning: 'mean(obs)==0'. Gamma is undefined", call.=FALSE)
      if (sigma.obs == 0)
        warning("Warning: 'sd(obs)==0'. Gamma is undefined", call.=FALSE)
    } else Gamma <- (sigma.sim / mean.sim) / (sigma.obs / mean.obs)
  } else {
      if (sigma.obs == 0) {
        warning("Warning: 'sd(obs)==0'. Alpha is undefined", call.=FALSE)
      } else Alpha <- sigma.sim / sigma.obs
      Gamma <- Alpha
    } # ELSE end


  if (density.method == "hist") {
    jsd.info <- .JDKGE_jsd_hist(sim=sim, obs=obs, timestep=timestep, na.rm=na.rm,
                                epsilon.type=epsilon.type,
                                epsilon.value=epsilon.value)
    if (!is.na(jsd.info$jsd))
      Delta <- 1 - jsd.info$jsd
  } else if (density.method == "kde") {
      jsd.info <- .JDKGE_jsd_kde(sim=sim, obs=obs, na.rm=na.rm,
                                 epsilon.type=epsilon.type,
                                 epsilon.value=epsilon.value,
                                 n.grid=kde.n.grid,
                                 ...)
      if (!is.na(jsd.info$jsd))
        Delta <- 1 - jsd.info$jsd
    } else {
        w.info <- .JDKGE_wasserstein(sim=sim, obs=obs, na.rm=na.rm,
                                     epsilon.type=epsilon.type,
                                     epsilon.value=epsilon.value,
                                     n.quantiles=wasserstein.n.quantiles)
        if (!is.na(w.info$similarity))
          Delta <- w.info$similarity
      } # ELSE end

  vr     <- if (method == "2012") Gamma else Alpha
  br.stg <- if (method == "2021") "Beta.2021" else "Beta"
  vr.stg <- if (method == "2012") "Gamma" else "Alpha"

  if (is.finite(r) && is.finite(Beta) && is.finite(vr) && is.finite(Delta)) {
    JDK <- 1 - sqrt((s[1] * (r - 1))^2 +
                    (s[2] * (vr - 1))^2 +
                    (s[3] * (Beta - 1))^2 +
                    (s[4] * (Delta - 1))^2)
  } # IF end

  elements        <- c(r=r, Beta=Beta, vr, Delta=Delta)
  names(elements) <- c("r", br.stg, vr.stg, "Delta")

  if (out.type == "single") {
    out <- JDK
  } else out <- list(JDKGE.value=JDK, JDKGE.elements=elements)

  return( out )
} # 'JDKGE.default' end


JDKGE.matrix <- function(sim, obs, na.rm=TRUE,
                         s=c(1, 1, 1, 1),
                         method=c("2012", "2009", "2021"),
                         out.type=c("single", "full"),
                         density.method=c("hist", "kde", "wasserstein"),
                         nbins="paper",
                         timestep=86400,
                         kde.n.grid=512,
                         wasserstein.n.quantiles=512,
                         fun=NULL, ...,
                         epsilon.type=c("otherValue", "none", "Pushpalatha2012",
                                        "otherFactor"),
                         epsilon.value=NA) {

  if (all.equal(dim(sim), dim(obs)) != TRUE)
    stop("Invalid argument: dim(sim) != dim(obs)")

  .JDKGE_check_s(s)

  method       <- match.arg(method)
  out.type     <- match.arg(out.type)
  epsilon.type <- match.arg(epsilon.type)

  JDK <- rep(NA_real_, ncol(obs))
  elements <- matrix(NA_real_, nrow=4, ncol=ncol(obs))
  if (method == "2012") {
    rownames(elements) <- c("r", "Beta", "Gamma", "Delta")
  } else if (method == "2009") {
      rownames(elements) <- c("r", "Beta", "Alpha", "Delta")
    } else rownames(elements) <- c("r", "Beta.2021", "Alpha", "Delta")

  colnames(elements) <- colnames(obs)

  if (out.type == "single") {
    out <- sapply(seq_len(ncol(obs)), function(i, x, y) {
      JDKGE.default(x[, i], y[, i],
                    na.rm=na.rm, s=s, method=method, out.type="single", 
                    density.method=density.method,
                    nbins=nbins, timestep=timestep,
                    kde.n.grid=kde.n.grid,
                    wasserstein.n.quantiles=wasserstein.n.quantiles,
                    fun=fun, ..., epsilon.type=epsilon.type,
                    epsilon.value=epsilon.value)
    }, x=sim, y=obs)
    names(out) <- colnames(obs)
    return(out)
  } # IF end

  tmp <- lapply(seq_len(ncol(obs)), function(i, x, y) {
    JDKGE.default(x[, i], y[, i],
                  na.rm=na.rm, s=s, method=method, out.type="full",
                  density.method=density.method,
                  nbins=nbins, timestep=timestep,
                  kde.n.grid=kde.n.grid,
                  wasserstein.n.quantiles=wasserstein.n.quantiles,
                  fun=fun, ..., epsilon.type=epsilon.type,
                  epsilon.value=epsilon.value)
  }, x=sim, y=obs)

  for (i in seq_along(tmp)) {
    JDK[i] <- tmp[[i]][[1]]
    elements[, i] <- as.numeric(tmp[[i]][[2]])
  } # FOR end

  return ( list(JDKGE.value=JDK, JDKGE.elements=elements) )

} # 'JDKGE.matrix' end


JDKGE.data.frame <- function(sim, obs, na.rm=TRUE,
                             s=c(1, 1, 1, 1),
                             method=c("2012", "2009", "2021"),
                             out.type=c("single", "full"),
                             density.method=c("hist", "kde", "wasserstein"),
                             nbins="paper",
                             timestep=86400,
                             kde.n.grid=512,
                             wasserstein.n.quantiles=512,
                             fun=NULL, ...,
                             epsilon.type=c("otherValue", "none", "Pushpalatha2012",
                                            "otherFactor"),
                             epsilon.value=NA) {

  sim <- as.matrix(sim)
  obs <- as.matrix(obs)

  JDKGE.matrix(sim, obs,
               na.rm=na.rm, s=s, method=method, out.type=out.type, 
               density.method=density.method,
               nbins=nbins, timestep=timestep,
               kde.n.grid=kde.n.grid,
               wasserstein.n.quantiles=wasserstein.n.quantiles,
               fun=fun, ..., epsilon.type=epsilon.type,
               epsilon.value=epsilon.value)

} # 'JDKGE.data.frame' end


JDKGE.zoo <- function(sim, obs, na.rm=TRUE,
                      s=c(1, 1, 1, 1),
                      method=c("2012", "2009", "2021"),
                      out.type=c("single", "full"),
                      density.method=c("hist", "kde", "wasserstein"),
                      nbins="paper",
                      timestep=86400,
                      kde.n.grid=512,
                      wasserstein.n.quantiles=512,
                      fun=NULL, ...,
                      epsilon.type=c("otherValue", "none", "Pushpalatha2012",
                                     "otherFactor"),
                      epsilon.value=NA) {

  if (is.na(timestep))
    timestep <- .JDKGE_timestep_seconds(sim)

  sim <- zoo::coredata(sim)

  if (zoo::is.zoo(obs))
    obs <- zoo::coredata(obs)

  if (is.matrix(sim) || is.data.frame(sim)) {
    JDKGE.matrix(sim, obs, na.rm=na.rm, 
                 s=s, method=method, out.type=out.type, 
                 density.method=density.method,
                 nbins=nbins, timestep=timestep,
                 kde.n.grid=kde.n.grid,
                 wasserstein.n.quantiles=wasserstein.n.quantiles,
                 fun=fun, ..., epsilon.type=epsilon.type,
                 epsilon.value=epsilon.value)
  } else JDKGE.default(sim, obs, na.rm=na.rm, 
                       s=s, method=method, out.type=out.type, 
                       density.method=density.method,
                       nbins=nbins, timestep=timestep,
                       kde.n.grid=kde.n.grid,
                       wasserstein.n.quantiles=wasserstein.n.quantiles,
                       fun=fun, ..., epsilon.type=epsilon.type,
                       epsilon.value=epsilon.value)

} # 'JDKGE.zoo' end

test_that("JDKGE perfect agreement returns one across divergence backends", {
  obs <- c(0, 1, 2, 4, 8, 16)
  sim <- obs

  out_hist <- JDKGE(sim, obs, density.method = "hist", out.type = "full")
  out_kde <- JDKGE(sim, obs, density.method = "kde", out.type = "full")
  out_w1 <- JDKGE(sim, obs, density.method = "wasserstein", out.type = "full")

  expect_equal(out_hist$JDKGE.value, 1)
  expect_equal(out_kde$JDKGE.value, 1)
  expect_equal(out_w1$JDKGE.value, 1)
  expect_equal(out_kde$JDKGE.elements[["Delta"]], 1)
  expect_equal(out_w1$JDKGE.elements[["Delta"]], 1)
})

test_that("JDKGE supports backend tuning arguments", {
  obs <- c(0, 0.2, 0.5, 1, 2, 4, 8, 16)
  sim <- c(0, 0.1, 0.4, 1.2, 1.7, 3.8, 7, 20)

  out_kde_1 <- JDKGE(sim, obs, density.method = "kde", kde.n.grid = 128, out.type = "full")
  out_kde_2 <- JDKGE(sim, obs, density.method = "kde", kde.n.grid = 1024, out.type = "full")
  out_w1_1 <- JDKGE(sim, obs, density.method = "wasserstein", wasserstein.n.quantiles = 64, out.type = "full")
  out_w1_2 <- JDKGE(sim, obs, density.method = "wasserstein", wasserstein.n.quantiles = 2048, out.type = "full")

  expect_true(is.finite(out_kde_1$JDKGE.value))
  expect_true(is.finite(out_kde_2$JDKGE.value))
  expect_true(is.finite(out_w1_1$JDKGE.value))
  expect_true(is.finite(out_w1_2$JDKGE.value))
  expect_false(isTRUE(all.equal(out_kde_1$JDKGE.elements[["Delta"]], out_kde_2$JDKGE.elements[["Delta"]])))
  expect_false(isTRUE(all.equal(out_w1_1$JDKGE.elements[["Delta"]], out_w1_2$JDKGE.elements[["Delta"]])))
})

test_that("JDKGE default epsilon is the article epsilon through otherValue", {
  obs <- c(0, 0, 1, 2, 3, 5)
  sim <- c(0, 1, 1, 2, 4, 5)
  eps <- min(1e-6, 0.1 * min(c(sim[sim > 0], obs[obs > 0])))

  out_default <- JDKGE(sim, obs, out.type = "full")
  out_explicit <- JDKGE(sim, obs, epsilon.type = "otherValue", epsilon.value = eps, out.type = "full")

  expect_equal(out_default$JDKGE.value, out_explicit$JDKGE.value)
  expect_error(JDKGE(sim, obs, epsilon.type = "paper"), "should be one of")
})

test_that("JDKGE method variants expose the expected component names", {
  obs <- c(0, 0.2, 0.5, 1, 2, 4, 8, 16)
  sim <- c(0, 0.1, 0.4, 1.2, 1.7, 3.8, 7, 20)

  out_2012 <- JDKGE(sim, obs, method = "2012", out.type = "full")
  out_2009 <- JDKGE(sim, obs, method = "2009", out.type = "full")
  out_2021 <- JDKGE(sim, obs, method = "2021", out.type = "full")

  expect_identical(names(out_2012$JDKGE.elements), c("r", "Beta", "Gamma", "Delta"))
  expect_identical(names(out_2009$JDKGE.elements), c("r", "Beta", "Alpha", "Delta"))
  expect_identical(names(out_2021$JDKGE.elements), c("r", "Beta.2021", "Alpha", "Delta"))
})

# File LCE.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2026-2026 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# Lee and Choi Efficiency (LCE)                                                #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 29-Abr-2026                                                         #
################################################################################
# Reference:                                                                   #
#  Lee, J. S. and Choi, H. I. (2022). A rebalanced performance criterion for   #
#  hydrological model calibration. Journal of Hydrology, 606, 127372.          #
#  https://doi.org/10.1016/j.jhydrol.2021.127372                               #
################################################################################
# This goodness-of-fit measure was proposed by Lee and Choi (2022) as an       #
# alternative to the Liu-Mean Efficiency (LME), designed to provide a          #
# multi-dimensional and diagnostically balanced evaluation of model            #
# performance, whereas LME is fundamentally a single-error-based metric.       #
################################################################################
# LME evaluates performance through a normalized mean squared error, so it 
# measures overall accuracy relative to the mean magnitude of observations,  
# but it does not distinguish between different sources of error (e.g., timing, 
# variability, or bias). As a result, two simulations with very different 
# hydrological behaviors (e.g., correct mean but wrong dynamics, or correct 
# variability but biased magnitude) can yield similar LME values.
# In contrast, LCE explicitly decomposes model performance into three 
# interacting components: correlation (r), variability ratio (alpha), and 
# bias (Beta) and, crucially, introduces the terms r*Alpha and r/Alpha to  
# enforce consistency between timing and variability
################################################################################
# The Lee and Choi Efficiency (LCE) is a goodness-of-fit metric that evaluates 
# how well simulated values reproduce observed data by jointly assessing 
# correlation, variability, and bias, while explicitly penalizing imbalances
# between correlation and variability through two complementary terms 
# (r*Alpha and r/Alpha).
################################################################################
# LCE values range from -Inf to 1, where:
# - LCE = 1 indicates perfect agreement (i.e., identical timing, dispersion, 
#   and magnitude between simulated and observed series), 
# - values close to 1 indicate high overall consistency across these attributes, 
# - values around 0 indicate that discrepancies in correlation-variability 
#   balance and bias are substantial relative to the ideal conditions, and 
# - negative values reflect progressively poorer performance, typically 
#   arising when the simulation fails to reproduce either the temporal dynamics 
#   (low r), the relative variability (Alpha), or the mean magnitude (Beta), or 
#   when these components are inconsistently balanced. 
################################################################################
# By construction, LCE is particularly sensitive to mismatches in the interaction 
# between correlation and variability, making it a more stringent and 
# diagnostically informative criterion than traditional efficiency metrics in 
# hydrological model evaluation.
################################################################################

# 'obs'   : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim'   : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 'Result': Lee and Choi Efficiency between 'sim' and 'obs'

LCE <- function(sim, obs, ...) UseMethod("LCE")

LCE.default <- function(sim, obs, na.rm=TRUE,
                        out.type=c("single", "full"),
                        fun=NULL, ...,
                        epsilon.type=c("none", "Pushpalatha2012",
                                       "otherFactor", "otherValue"),
                        epsilon.value=NA) {

  out.type     <- match.arg(out.type)
  epsilon.type <- match.arg(epsilon.type)

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo"))) |
       is.na(match(class(obs), c("integer", "numeric", "ts", "zoo"))) )
    stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo')")

  vi <- valindex(sim, obs)

  if (length(vi) > 0) {

    obs <- as.numeric(obs[vi])
    sim <- as.numeric(sim[vi])

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ...,
                      epsilon.type=epsilon.type,
                      epsilon.value=epsilon.value)
      sim <- new[["sim"]]
      obs <- new[["obs"]]
    }

    mean.sim  <- mean(sim, na.rm=na.rm)
    mean.obs  <- mean(obs, na.rm=na.rm)
    sigma.sim <- stats::sd(sim, na.rm=na.rm)
    sigma.obs <- stats::sd(obs, na.rm=na.rm)

    r     <- rPearson(sim, obs)
    Alpha <- sigma.sim / sigma.obs
    Beta  <- mean.sim / mean.obs

    rAlpha <- r * Alpha
    rAlpha.inv <- r / Alpha

    if ( (mean.obs != 0) & (sigma.obs != 0) & (Alpha != 0) ) {

      LCE <- 1 - sqrt( (rAlpha - 1)^2 +
                       (rAlpha.inv - 1)^2 +
                       (Beta - 1)^2 )

    } else {

      LCE <- NA

      if (mean.obs == 0)
        warning("Warning: 'mean(obs)==0'. Beta = Inf")

      if (sigma.obs == 0)
        warning("Warning: 'sd(obs)==0'. Alpha = Inf")

      if (Alpha == 0)
        warning("Warning: 'Alpha==0'. r/Alpha is undefined")
    }

  } else {

    r <- Alpha <- Beta <- rAlpha <- rAlpha.inv <- NA
    LCE <- NA

    warning("There are no pairs of 'sim' and 'obs' without missing values !")
  }

  if (out.type=="single") {

    out <- LCE

  } else {

    out <- list(LCE.value=LCE,
                LCE.elements=c(r, Alpha, Beta, rAlpha, rAlpha.inv))

    names(out[[2]]) <- c("r", "Alpha", "Beta", "rAlpha", "rOverAlpha")
  }

  return(out)

} # 'LCE.default' end


LCE.matrix <- function(sim, obs, na.rm=TRUE,
                       out.type=c("single", "full"),
                       fun=NULL, ...,
                       epsilon.type=c("none", "Pushpalatha2012",
                                      "otherFactor", "otherValue"),
                       epsilon.value=NA) {

  if ( all.equal(dim(sim), dim(obs)) != TRUE )
    stop( paste("Invalid argument: dim(sim) != dim(obs) ( [",
          paste(dim(sim), collapse=" "), "] != [",
          paste(dim(obs), collapse=" "), "] )", sep="") )

  out.type <- match.arg(out.type)

  LCE                <- rep(NA, ncol(obs))
  elements           <- matrix(NA, nrow=5, ncol=ncol(obs))
  rownames(elements) <- c("r", "Alpha", "Beta", "rAlpha", "rOverAlpha")
  colnames(elements) <- colnames(obs)

  if (out.type=="single") {

    out <- sapply(1:ncol(obs), function(i, x, y) {
      LCE[i] <- LCE.default(x[, i], y[, i],
                            na.rm=na.rm,
                            out.type=out.type,
                            fun=fun, ...,
                            epsilon.type=epsilon.type,
                            epsilon.value=epsilon.value)
    }, x=sim, y=obs)

    names(out) <- colnames(obs)

  } else {

    out <- lapply(1:ncol(obs), function(i, x, y) {
      LCE.default(x[, i], y[, i],
                  na.rm=na.rm,
                  out.type=out.type,
                  fun=fun, ...,
                  epsilon.type=epsilon.type,
                  epsilon.value=epsilon.value)
    }, x=sim, y=obs)

    for (i in 1:length(out)) {
      LCE[i]         <- out[[i]][[1]]
      elements[, i] <- as.numeric(out[[i]][[2]])
    }

    out <- list(LCE.value=LCE, LCE.elements=elements)
  }

  return(out)

} # 'LCE.matrix' end


LCE.data.frame <- function(sim, obs, na.rm=TRUE,
                           out.type=c("single", "full"),
                           fun=NULL, ...,
                           epsilon.type=c("none", "Pushpalatha2012",
                                          "otherFactor", "otherValue"),
                           epsilon.value=NA) {

  sim <- as.matrix(sim)
  obs <- as.matrix(obs)

  out.type <- match.arg(out.type)

  LCE.matrix(sim, obs,
             na.rm=na.rm,
             out.type=out.type,
             fun=fun, ...,
             epsilon.type=epsilon.type,
             epsilon.value=epsilon.value)

} # 'LCE.data.frame' end


LCE.zoo <- function(sim, obs, na.rm=TRUE,
                    out.type=c("single", "full"),
                    fun=NULL, ...,
                    epsilon.type=c("none", "Pushpalatha2012",
                                   "otherFactor", "otherValue"),
                    epsilon.value=NA) {

  sim <- zoo::coredata(sim)

  if (is.zoo(obs))
    obs <- zoo::coredata(obs)

  out.type <- match.arg(out.type)

  if (is.matrix(sim) | is.data.frame(sim)) {

    LCE.matrix(sim, obs,
               na.rm=na.rm,
               out.type=out.type,
               fun=fun, ...,
               epsilon.type=epsilon.type,
               epsilon.value=epsilon.value)

  } else {

    NextMethod(sim, obs,
               na.rm=na.rm,
               out.type=out.type,
               fun=fun, ...,
               epsilon.type=epsilon.type,
               epsilon.value=epsilon.value)
  }

} # 'LCE.zoo' end

test_that("LCE returns one for perfect agreement", {
  obs <- 1:10
  sim <- obs

  expect_equal(LCE(sim, obs), 1)
})

test_that("LCE matches the published component formula", {
  obs <- c(1, 2, 4, 8, 16)
  sim <- c(1.1, 1.8, 5, 7, 18)

  r <- stats::cor(sim, obs)
  alpha <- stats::sd(sim) / stats::sd(obs)
  beta <- mean(sim) / mean(obs)
  expected <- 1 - sqrt((r * alpha - 1)^2 +
                       (r / alpha - 1)^2 +
                       (beta - 1)^2)

  expect_equal(LCE(sim, obs), expected)
})

test_that("LCE handles matrix inputs column-wise", {
  obs <- matrix(1:20, ncol = 2)
  sim <- obs
  sim[, 2] <- sim[, 2] * 1.1

  out <- LCE(sim, obs)
  expected <- c(LCE(sim[, 1], obs[, 1]),
                LCE(sim[, 2], obs[, 2]))

  expect_equal(out, expected)
})

# File gof.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2008-2025 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 15-Dic-2008 -> 03 Feb 2009;                                         #
# Updates: 06-Sep-09                                                           #
#          2010                                                                #
#          21-Jan-2011                                                         #
#          08-May-2012                                                         #
#          14-Jan-2023 ; 15-Jan-2023 ; 16-Jan-2023                             #
#          19-Jan-2024 ; 20-Jan-2024 ; 23-Mar-2024 ; 08-May-2024               #
#          03-May-2025 ; 01-Nov-2025                                           #
#          29-Apr-2026                                                         #
################################################################################

# It computes:

#  1) 'me'        : Mean Error
#  2) 'mae'       : Mean Absolute Error
#  3) 'mse'       : Mean Square Error
#  4) 'rmse'      : Root Mean Square Error
#  5) 'ubRMSE     : unbiased Root Mean Square Error
#  6) 'nrms'      : Normalized Root Mean Square Error
#  7) 'PBIAS'     : Percent Bias ( -1 <= PBIAS <= 1 )
#  8) 'RSR'       : Ratio of the RMSE to the standard deviation of the observations
#  9) 'rSD'       : Ratio of Standard Deviations, rSD = SD(sim) / SD(obs)
# 10) 'NSE'       : Nash-Sutcliffe Efficiency ( -Inf <= NSE <= 1 )
# 11) 'mNSE'      : Modified Nash-Sutcliffe Efficiency
# 12) 'rNSE'      : Relative Nash-Sutcliffe Efficiency
# 13) 'wNSE'      : Weighted Nash-Sutcliffe Efficiency
# 14) 'wsNSE'     : Weighted Seasonal Nash-Sutcliffe Efficiency ( -Inf <= wsNSE <= 1 )
# 15) 'd'         : Index of Agreement( 0 <= d <= 1 )
# 16) 'dr'        : Refined Index of Agreement( -1 <= dr <= 1 )
# 17) 'md'        : Modified Index of Agreement( 0 <= md <= 1 )
# 18) 'rd'        : Relative Index of Agreement( 0 <= rd <= 1 )
# 29) 'cp'        : Coefficient of Persistence ( 0 <= cp <= 1 ) 
# 20) 'r'         : Pearson Correlation coefficient ( -1 <= r <= 1 )
# 21) 'R2'        : Coefficient of Determination ( 0 <= R2 <= 1 )
# 22) 'bR2'       : Weighted coefficient of determination
# 23) 'VE'        : Volumetric efficiency
# 24) 'KGE'       : Kling-Gupta efficiency (-Inf < KGE <= 1)
# 25) 'KGElf'     : Kling-Gupta efficiency with focus on low values (-Inf < KGElf <= 1)
# 26) 'KGEnp'     : Non-parametric Kling-Gupta efficiency (-Inf < KGEnp <= 1)
# 27) 'KGEkm'     : Knowable Moments Kling-Gupta efficiency (-Inf < KGEkm <= 1) 
# 28) 'JDKGE'     : Joint Divergence Kling-Gupta Efficiency (-Inf < JDKGE <= 1) 
# 29) 'LME'       : Liu-Mean Efficiency (-Inf < LME <= 1) 
# 30) 'LCE'       : Lee and Choi Efficiency  Efficiency (-Inf < LCE <= 1) 


# 31) 'APFB'      : Annual Peak Flow Bias ( 0 <= APFB <= Inf )
# 32) 'HFB'       : High Flow Bias ( 0 <= HFB <= Inf )
# 33) 'sKGE'      : Split Kling-Gupta efficiency (-Inf < sKGE <= 1)
# 34) 'rSpearman' : Spearman correlation coefficient ( -1 <= r <= 1 ) 
# 35) 'pbiasFDC'  : PBIAS in the slope of the midsegment of the Flow Duration Curve  ( 0 <= pbiasFDC ) 
# 36) 'PMR'       : Proxy for Model Robustness ( 0 <= PMR <= +Inf ) 

gof <-function(sim, obs, ...) UseMethod("gof")

gof.default <- function(sim, obs, na.rm=TRUE, do.spearman=FALSE, do.pbfdc=FALSE, do.pmr=FALSE,
                        j=1, lambda=0.95, norm="sd", 
                        s=c(1,1,1,1),                                   # The 4th element is only used for JDKGE 
                        method=c("2009", "2012", "2021"), lQ.thr=0.6, hQ.thr=0.1, 
                        start.month=1, 
                        k=NULL,            # PMR only
                        min.years=5,       # PMR only
                        days.per.year=365, # PMR only
                        density.method=c("hist", "kde", "wasserstein"), # JDKGE only
                        nbins="paper",                                  # JDKGE only
                        timestep=86400,                                 # JDKGE only
                        kde.n.grid=512,                                 # JDKGE only
                        wasserstein.n.quantiles=512,                    # JDKGE only
                        digits=2, 
                        fun=NULL, ...,
                        epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                        epsilon.value=NA){

     method         <- match.arg(method)
     epsilon.type   <- match.arg(epsilon.type)
     density.method <- match.arg(density.method)

     # Only JDKGE requires 4 elements for 's'; the other KGE-like functions use 3 elements.
     s0 <- s
     s  <- s0[1:3]

     # Checking the sampling frequency of 'x' and 'y'
     sim.sfreq <- NULL
     obs.sfreq <- NULL
     if ( ( zoo::is.zoo(sim) & zoo::is.zoo(obs) ) ) {
       if (  !is.numeric( time(sim) ) & !is.numeric( time(obs) ) ) {
         sim.sfreq <- hydroTSM::sfreq(sim)
         obs.sfreq <- hydroTSM::sfreq(obs)
         if ( sim.sfreq != obs.sfreq)
           stop("Invalid arguments: sampling frequency of 'sim' and 'obs' is not the same ! (", 
             sim.sfreq, " != ", obs.sfreq, ")")
       } # IF end
     } # IF end
     
     ME     <- me(sim, obs, na.rm=na.rm, fun=fun, ..., 
                  epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     MAE    <- mae(sim, obs, na.rm=na.rm, fun=fun, ..., 
                   epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     MSE    <- mse(sim, obs, na.rm=na.rm, fun=fun, ..., 
                   epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     RMSE   <- rmse(sim, obs, na.rm=na.rm, fun=fun, ..., 
                   epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     ubRMSE <- ubRMSE(sim, obs, na.rm=na.rm, fun=fun, ..., 
                   epsilon.type=epsilon.type, epsilon.value=epsilon.value) 
     NRMSE  <- nrmse(sim, obs, na.rm=na.rm, norm=norm, fun=fun, ..., 
                   epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     RSR    <- rsr(sim, obs, na.rm=na.rm, fun=fun, ..., 
                   epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     rSD    <- rSD(sim, obs, na.rm=na.rm, fun=fun, ..., 
                   epsilon.type=epsilon.type, epsilon.value=epsilon.value)     
     PBIAS  <- pbias(sim, obs, na.rm=na.rm, fun=fun, ..., 
                   epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     NSE    <- NSE(sim, obs, na.rm=na.rm, fun=fun, ..., 
                   epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     mNSE   <- mNSE(sim, obs, na.rm=na.rm, j=j, fun=fun, ..., 
                    epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     rNSE   <- rNSE(sim, obs, na.rm=na.rm, fun=fun, ..., 
                    epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     wNSE   <- wNSE(sim, obs, na.rm=na.rm, fun=fun, ..., 
                    epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     wsNSE  <- wsNSE(sim, obs, na.rm=na.rm, j=j, lambda=lambda, 
                     lQ.thr=lQ.thr, hQ.thr=hQ.thr, fun=fun, ..., 
                     epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     d      <- d(sim, obs, na.rm=na.rm, fun=fun, ..., 
                 epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     dr     <- dr(sim, obs, na.rm=na.rm, fun=fun, ..., 
                  epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     md     <- md(sim, obs, na.rm=na.rm, fun=fun, ..., 
                  epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     rd     <- rd(sim, obs, na.rm=na.rm, fun=fun, ..., 
                  epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     cp     <- cp(sim, obs, na.rm=na.rm, fun=fun, ..., 
                  epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     r      <- .rPearson(sim, obs, fun=fun, ..., 
                         epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     R2     <- R2(sim, obs, na.rm=na.rm, fun=fun, ..., 
                  epsilon.type=epsilon.type, epsilon.value=epsilon.value) 
     bR2    <- br2(sim, obs, na.rm=na.rm, fun=fun, ..., 
                   epsilon.type=epsilon.type, epsilon.value=epsilon.value)     
     VE     <- VE(sim, obs, na.rm=na.rm, fun=fun, ..., 
                  epsilon.type=epsilon.type, epsilon.value=epsilon.value)     
     KGE    <- KGE(sim, obs, na.rm=na.rm, s=s, method=method, out.type="single", 
                    fun=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value) 
     KGElf  <- KGElf(sim, obs, na.rm=na.rm, s=s, method=method, 
                     epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     KGEnp  <- KGEnp(sim, obs, na.rm=na.rm, out.type="single", fun=fun, ..., 
                     epsilon.type=epsilon.type, epsilon.value=epsilon.value) 
     KGEkm  <- KGEkm(sim, obs, na.rm=na.rm, s=s, method=method, out.type="single", 
                     fun=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     JDKGE  <- JDKGE(sim, obs, na.rm=na.rm, s=s0, method=method, out.type="single",
                    fun=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value,
                    density.method=density.method, nbins=nbins, timestep=timestep,
                    kde.n.grid=kde.n.grid, wasserstein.n.quantiles=wasserstein.n.quantiles)
     LME    <- LME(sim, obs, na.rm=na.rm, out.type="single", fun=fun, ..., 
                   epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     LCE    <- LCE(sim, obs, na.rm=na.rm, out.type="single", fun=fun, ..., 
                   epsilon.type=epsilon.type, epsilon.value=epsilon.value)

     do.sKGE <- FALSE ; sKGE <- NA
     do.HFB  <- FALSE ; HFB  <- NA
     do.APFB <- FALSE ; APFB <- NA
     do.PMR  <- FALSE ; PMR  <- NA

     if ( ( zoo::is.zoo(sim) & zoo::is.zoo(obs) ) & ( !is.null(sim.sfreq)  ) ) {
       if (sim.sfreq != "annual") {
         do.sKGE <- TRUE
         sKGE    <- sKGE(sim, obs, s=s, na.rm=na.rm, method=method, 
                         start.month=start.month, out.PerYear=FALSE, fun=fun, ..., 
                         epsilon.type=epsilon.type, epsilon.value=epsilon.value) 

         do.HFB <- TRUE
         HFB    <- HFB(sim, obs, na.rm=na.rm, hQ.thr=hQ.thr, start.month=start.month, 
                       out.PerYear=FALSE, fun=fun, ..., 
                       epsilon.type=epsilon.type, epsilon.value=epsilon.value)

         do.APFB <- TRUE
         APFB    <- APFB(sim, obs, na.rm=na.rm, start.month=start.month, 
                         fun=fun, ..., 
                         epsilon.type=epsilon.type, epsilon.value=epsilon.value) 

         do.PMR <- isTRUE(do.pmr)
         if (do.PMR & ( !is.numeric(time(sim)) | !is.null(k) ) ) {
           PMR <- PMR(sim, obs, na.rm=na.rm, k=k, min.years=min.years,
                      days.per.year=days.per.year, fun=fun, ...,
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
         } # IF end
       } # IF end
     } # IF end

     if (isTRUE(do.pmr) & zoo::is.zoo(sim) & zoo::is.zoo(obs)) {
       do.PMR <- TRUE
       if (is.na(PMR) & ( !is.numeric(time(sim)) | !is.null(k) ) ) {
         PMR <- PMR(sim, obs, na.rm=na.rm, k=k, min.years=min.years,
                    days.per.year=days.per.year, fun=fun, ...,
                    epsilon.type=epsilon.type, epsilon.value=epsilon.value)
       } # IF end
     } # IF end
       
     # Creating the basic output object
     gof <- rbind(    ME,   MAE,   MSE,  RMSE, ubRMSE,  
                   NRMSE, PBIAS,   RSR,   rSD,    NSE,   
                    mNSE,  rNSE,  wNSE, wsNSE,      d,
                      dr,    md,    rd,    cp,      r,    
                      R2,   bR2,    VE,   KGE,  KGElf, 
                   KGEnp, KGEkm, JDKGE,   LME, LCE)   
     
     # Changing names to NRMSE and PBIAS
     rownames(gof)[6] <- "NRMSE %"
     rownames(gof)[7] <- "PBIAS %"   
     
     # Adding Split KGE
     if (do.sKGE) { # 'sKGE' is presented after 'KGEkm'
       gof <- rbind(gof, sKGE) 
       rownames(gof)[length(rownames(gof))] <- "sKGE"
     } # IF end

     # Adding APFB
     if (do.APFB) { # 'APFB' is presented after 'sKGE'
       gof <- rbind(gof, APFB) 
       rownames(gof)[length(rownames(gof))] <- "APFB"
     } # IF end

     # Adding HFB
     if (do.HFB) { # 'HFB' is presented after 'APFB'
       gof <- rbind(gof, HFB) 
       rownames(gof)[length(rownames(gof))] <- "HFB"
     } # IF end

     # Adding r.Spearman
     if (do.spearman) {
       r.Spearman <- rSpearman(sim, obs, na.rm=na.rm, fun=fun, ..., 
                               epsilon.type=epsilon.type, epsilon.value=epsilon.value) 
       gof <- rbind(gof, r.Spearman) 
       rownames(gof)[length(rownames(gof))] <- "rSpearman"
     } # IF end
     
     # Adding pbiasfdc
     if (do.pbfdc) { 
       pbfdc  <- pbiasfdc(sim, obs, na.rm=na.rm, lQ.thr=lQ.thr, hQ.thr=hQ.thr, plot=FALSE, 
                          fun=fun, ..., epsilon.type=epsilon.type, epsilon.value=epsilon.value)
                          
       gof <- rbind(gof, pbfdc) 
       rownames(gof)[length(rownames(gof))] <- "pbiasFDC %"
     } # IF end

     # Adding PMR
     if (do.PMR) {
       gof <- rbind(gof, PMR)
       rownames(gof)[length(rownames(gof))] <- "PMR"
     } # IF end
     
     # Rounding the final results, for avoiding scientific notation
     gof <- round(gof, digits)
     
     return(gof)
     
} # 'gof.default' end


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 15-Dic-2008 -> 03 Feb 2009;                                         #
# Updates: 06-Sep-09                                                           #
#          2010                                                                #
#          21-Jan-2011                                                         #
#          08-May-2012                                                         #
#          15-Jan-2023                                                         #
#          19-Jan-2024 ; 08-May-2024                                           #
#          29-Apr-2026                                                         #
################################################################################
gof.matrix <- function(sim, obs, na.rm=TRUE, do.spearman=FALSE, do.pbfdc=FALSE, do.pmr=FALSE, 
                       j=1, lambda=0.95, norm="sd", 
                       s=c(1,1,1,1),                                   # The 4th element is only used for JDKGE 
                       method=c("2009", "2012", "2021"), lQ.thr=0.6, hQ.thr=0.1, 
                       start.month=1, 
                       k=NULL,            # PMR only
                       min.years=5,       # PMR only
                       days.per.year=365, # PMR only,
                       density.method=c("hist", "kde", "wasserstein"), # JDKGE only
                       nbins="paper",                                  # JDKGE only
                       timestep=86400,                                 # JDKGE only
                       kde.n.grid=512,                                 # JDKGE only
                       wasserstein.n.quantiles=512,                    # JDKGE only
                       digits=2, 
                       fun=NULL, ...,
                       epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                       epsilon.value=NA
                      ){
    
    if ( all.equal(dim(sim), dim(obs)) != TRUE )
      stop( paste("Invalid argument: dim(sim) != dim(obs) ( [",
            paste(dim(sim), collapse=" "), "] != [",
            paste(dim(obs), collapse=" "), "] )", sep="") )

    first <- gof.default( sim[,1], obs[,1], na.rm=na.rm,
                          do.spearman=do.spearman, do.pbfdc=do.pbfdc, do.pmr=do.pmr,
                          j=j, lambda=lambda, norm=norm, s=s,
                          method=method, lQ.thr=lQ.thr, hQ.thr=hQ.thr,
                          start.month=start.month,
                          k=k, min.years=min.years, days.per.year=days.per.year,
                          digits=digits, fun=fun, ...,
                          epsilon.type=epsilon.type,
                          epsilon.value=epsilon.value,
                          density.method=density.method, nbins=nbins, timestep=timestep,
                          kde.n.grid=kde.n.grid, wasserstein.n.quantiles=wasserstein.n.quantiles)

    gof <- matrix(NA, nrow=nrow(first), ncol=ncol(obs))
    rownames(gof) <- rownames(first)
    colnames(gof) <- colnames(sim)
    gof[, 1] <- first[, 1]

    if (ncol(obs) > 1) {
      for (i in 2:ncol(obs)) {
        gof[, i] <- gof.default( sim[,i], obs[,i], na.rm=na.rm,
                                 do.spearman=do.spearman, do.pbfdc=do.pbfdc, do.pmr=do.pmr,
                                 j=j, lambda=lambda, norm=norm, s=s,
                                 method=method, lQ.thr=lQ.thr, hQ.thr=hQ.thr,
                                 start.month=start.month,
                                 k=k, min.years=min.years, days.per.year=days.per.year,
                                 digits=digits, fun=fun, ...,
                                 epsilon.type=epsilon.type,
                                 epsilon.value=epsilon.value,
                                 density.method=density.method, nbins=nbins, timestep=timestep,
                                 kde.n.grid=kde.n.grid, wasserstein.n.quantiles=wasserstein.n.quantiles)[, 1]
      } # FOR end
    } # IF end
           
    return(gof)  
     
  } # 'gof.matrix' end
  

################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 15-Dic-2008 -> 03 Feb 2009;                                         #
# Updates: 06-Sep-09                                                           #
#          2010                                                                #
#          21-Jan-2011                                                         #
#          08-May-2012 ;                                                       #
#          15-Jan-2023                                                         #
#          19-Jan-2024 ; 08-May-2024                                           #
#          29-Apr-2026                                                         #
################################################################################
gof.data.frame <- function(sim, obs, na.rm=TRUE, do.spearman=FALSE, do.pbfdc=FALSE, do.pmr=FALSE, 
                           j=1, lambda=0.95, norm="sd", 
                           s=c(1,1,1,1),                                   # The 4th element is only used for JDKGE 
                           method=c("2009", "2012", "2021"), lQ.thr=0.6, hQ.thr=0.1, 
                           start.month=1, 
                           k=NULL,            # PMR only
                           min.years=5,       # PMR only
                           days.per.year=365, # PMR only
                           density.method=c("hist", "kde", "wasserstein"), # JDKGE only
                           nbins="paper",                                  # JDKGE only
                           timestep=86400,                                 # JDKGE only
                           kde.n.grid=512,                                 # JDKGE only
                           wasserstein.n.quantiles=512,                    # JDKGE only
                           digits=2, 
                           fun=NULL, ...,
                           epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                           epsilon.value=NA
                          ){ 
 
  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
   
  gof.matrix(sim, obs, na.rm=na.rm, do.spearman=do.spearman, do.pbfdc=do.pbfdc, do.pmr=do.pmr,
             j=j, lambda=lambda, norm=norm, s=s, 
             method=method, lQ.thr=lQ.thr, hQ.thr=hQ.thr, 
             start.month=start.month, 
             k=k, min.years=min.years, days.per.year=days.per.year,
             digits=digits, fun=fun, ...,  
             epsilon.type=epsilon.type, epsilon.value=epsilon.value,
             density.method=density.method, nbins=nbins, timestep=timestep,
             kde.n.grid=kde.n.grid, wasserstein.n.quantiles=wasserstein.n.quantiles)
     
} # 'gof.data.frame' end 


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 05-Nov-2012                                                         #
# Updates: 22-Mar-2013                                                         #
#          15-Jan-2023                                                         #
#          19-Jan-2024 ; 08-May-2024                                           #
#          29-Apr-2026                                                         #
################################################################################
gof.zoo <- function(sim, obs, na.rm=TRUE, do.spearman=FALSE, do.pbfdc=FALSE, do.pmr=FALSE, 
                    j=1, lambda=0.95, norm="sd", 
                    s=c(1,1,1,1),                                   # The 4th element is only used for JDKGE 
                    method=c("2009", "2012", "2021"), lQ.thr=0.6, hQ.thr=0.1, 
                    start.month=1, 
                    k=NULL,            # PMR only
                    min.years=5,       # PMR only
                    days.per.year=365, # PMR only
                    density.method=c("hist", "kde", "wasserstein"), # JDKGE only
                    nbins="paper",                                  # JDKGE only
                    timestep=86400,                                 # JDKGE only
                    kde.n.grid=512,                                 # JDKGE only
                    wasserstein.n.quantiles=512,                    # JDKGE only
                    digits=2, 
                    fun=NULL, ...,
                    epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                    epsilon.value=NA){
    
    if (NCOL(sim) > 1 | NCOL(obs) > 1) {

       if (NCOL(sim) != NCOL(obs))
         stop("Invalid argument: ncol(sim) != ncol(obs) !")

       first <- gof.default( sim[,1], obs[,1], na.rm=na.rm,
                             do.spearman=do.spearman, do.pbfdc=do.pbfdc, do.pmr=do.pmr,
                             j=j, lambda=lambda, norm=norm, s=s,
                             method=method, lQ.thr=lQ.thr, hQ.thr=hQ.thr,
                             start.month=start.month,
                             k=k, min.years=min.years, days.per.year=days.per.year,
                             digits=digits, fun=fun, ...,
                             epsilon.type=epsilon.type,
                             epsilon.value=epsilon.value,
                             density.method=density.method, nbins=nbins, timestep=timestep,
                             kde.n.grid=kde.n.grid, wasserstein.n.quantiles=wasserstein.n.quantiles)

       gof <- matrix(NA, nrow=nrow(first), ncol=NCOL(obs))
       rownames(gof) <- rownames(first)
       colnames(gof) <- colnames(sim)
       gof[, 1] <- first[, 1]

       if (NCOL(obs) > 1) {
         for (i in 2:NCOL(obs)) {
           gof[, i] <- gof.default( sim[,i], obs[,i], na.rm=na.rm,
                                    do.spearman=do.spearman, do.pbfdc=do.pbfdc, do.pmr=do.pmr,
                                    j=j, lambda=lambda, norm=norm, s=s,
                                    method=method, lQ.thr=lQ.thr, hQ.thr=hQ.thr,
                                    start.month=start.month,
                                    k=k, min.years=min.years, days.per.year=days.per.year,
                                    digits=digits, fun=fun, ...,
                                    epsilon.type=epsilon.type,
                                    epsilon.value=epsilon.value,
                                    density.method=density.method, nbins=nbins, timestep=timestep,
                                    kde.n.grid=kde.n.grid, wasserstein.n.quantiles=wasserstein.n.quantiles)[, 1]
         } # FOR end
       } # IF end

       return(gof)

    } else
        NextMethod(sim, obs, na.rm=na.rm, 
                   do.spearman=do.spearman, do.pbfdc=do.pbfdc, do.pmr=do.pmr,
                   j=j, lambda=lambda, norm=norm, s=s, 
                   method=method, lQ.thr=lQ.thr, hQ.thr=hQ.thr, 
                   start.month=start.month,
                   k=k, min.years=min.years, days.per.year=days.per.year,
                   digits=digits, fun=fun, ...,  
                   epsilon.type=epsilon.type, epsilon.value=epsilon.value,
                   density.method=density.method, nbins=nbins, timestep=timestep,
                   kde.n.grid=kde.n.grid, wasserstein.n.quantiles=wasserstein.n.quantiles)
     
} # 'gof.zoo' end
  

# File plotbands.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/
# Copyright 2009-2024 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# plotbands: Plot a ts with simulated values and two confidence bands          #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
# Started: 13-Oct-2009                                                         #
# Updates: 30-Jun-2010; 28-Oct-2010; 28-Nov-2010 ;                             # 
#          15-Apr-2011 ; 17-May-2011                                           #
#          15-Apr-2013                                                         #
#          06-Aug-2017                                                         #
#          28-Dec-2022                                                         #
#          20-Jan-2024                                                         #
################################################################################
plotbands <- function(x, lband, uband, sim,
                      
                      dates,
                      date.fmt="%Y-%m-%d", 

                      gof.leg= TRUE, 
                      gof.digits=2,    
                      
                      legend=c("Obs", "Sim", "95PPU"),
                      leg.cex=1,
                      
                      bands.col="lightblue",
                      border= NA,

                      tick.tstep= "auto", 
                      lab.tstep= "auto",
                      lab.fmt=NULL,
                      
                      cal.ini=NA, 
                      val.ini=NA, 
                      
                      main="Confidence Bounds for 'x'",
                      xlab="Time",
                      ylab="Q, [m3/s]",

                      ylim,
                      
                      col= c("black", "blue"),
                      type= c("lines", "lines"),

                      cex= c(0.5, 0.5),
                      cex.axis=1.2,
                      cex.lab=1.2,
                      
                      lwd=c(0.6, 1),
                      lty=c(3, 4),    
                      pch=c(1, 9),   
                      
                      ...) {
                    
    # Checking  the class of 'x', 'lband', 'uband, and 'sim' (if provided)
    valid.class <- c("xts", "zoo", "numeric", "integer")
    if ( is.na( match(class(x), valid.class ) ) )
      stop("Invalid argument: 'class(x)' must be in c('xts', 'zoo', 'numeric', 'integer')")
    if ( is.na( match(class(lband), valid.class ) ) )
      stop("Invalid argument: 'class(lband)' must be in c('xts', 'zoo', 'numeric', 'integer')")
    if ( is.na( match(class(uband), valid.class ) ) )
      stop("Invalid argument: 'class(uband)' must be in c('xts', 'zoo', 'numeric', 'integer')")      
    if ( !missing(sim) ) {
      if ( is.na( match(class(sim), valid.class ) ) )
        stop("Invalid argument: 'class(sim)' must be in c('xts', 'zoo', 'numeric', 'integer')")
    } # IF end    

    # Checking that the lenghts of 'lband' and 'uband' are equal between 
    # them, an equal to the lenght of 'x' and 'sim' (if provided)
    if ( length(lband) != length(uband) )
      stop("Invalid argument: 'length(lband)' is different from 'length(uband)'")
    if ( length(x) != length(uband) )
      stop("Invalid argument: 'length(x)' is different from the lengths of the bands")      
    if ( !missing(sim) ) {
      if ( length(x) != length(sim) )
      stop("Invalid argument: 'length(sim)' is different from 'length(x)'")
    } # IF end 
    
    # Length of the observed values and all the vectors provided
    L <- length(x)      
      
    # Checking 'type'
    if ( length( which( !is.na( match((type), c("lines", "points") ) ) ) ) < 2)
      stop("Invalid argument: 'type' elements must be in c('lines', 'points')")
      
    # If the user provided a value for 'legend' here we verify that it has 3 elements
    if ( !missing(legend) & (length(legend) > 1) )
        if ( length(legend) != 3 ) stop("Invalid argument: 'legend' must have 3 elements. e.g, c('obs', 'sim', 'PPU')")

    # If the user provided a value for 'cal.ini', it is transformed into a Date class
    if ( !missing(cal.ini) ) cal.ini <- as.Date(cal.ini, format=date.fmt)
    
    # If the user provided a value for 'val.ini', it is transformed into a Date class
    if ( !missing(val.ini) ) val.ini <- as.Date(val.ini, format=date.fmt)      
     
    # If the user didn't provided the dates, but 'x' is a zoo object
    # dates are taken from 'x'
    if ( missing(dates) ) {
    
      if ( zoo::is.zoo(x) ) {
        # class(time(x))== "Date" for 'daily' and 'monthly' time series
        # class(time(x))== "character" for 'annual' time series
        if ( inherits(time(x), "Date") ) { dates <- time(x) 
        } else if ( inherits(time(x), "character") ) {  
             dates <- as.Date(time(x), format="%Y") 
          }  
      } else # If there is no way to obtain the dates
          message("[Note: You didn't provide dates, so only a numeric index will be used in the time axis.]")  
          
      # Checking that the dates of 'x', 'lband', 'uband' and 'sim' are equal ,
      # when they are zoo objects    
      if ( zoo::is.zoo(lband) & zoo::is.zoo(uband) ) 
        if  ( !all.equal( time(lband), time(uband) ) )
         stop("Invalid argument: time(lband) is different from time(uband)")       
      if ( zoo::is.zoo(x) & zoo::is.zoo(uband) ) 
        if  ( !all.equal( time(x), time(uband) ) )
          stop("Invalid argument: time(x) is different from the time of the bands")      
      if ( !missing(sim) ) {
        if ( zoo::is.zoo(x) & zoo::is.zoo(sim) ) 
          if  ( !all.equal( time(x), time(sim) ) )
            stop("Invalid argument: time(x) is different from the time of 'sim'")    
      } # IF end
          
    } # IF end
    
    # If the user provided 'dates', 
    # its length is checked against 'length(x)', and
    # the values of 'dates' are aplyied to 'x', 'lband', 'uband' and 'sim' 
    # when they are zoo objects 
    if ( !missing(dates) )  { 
  
      # Checking that 'dates' have the same length than 'sim' ( and 'obs')      
      if ( length(dates) != length(x) )  
         stop("Invalid argument: 'dates' and 'x' must have the same length")
  
      # Checking that 'dates' have the right class
      if (is.na(match(class(dates), c("character", "factor", "Date")))) 
        stop("Invalid argument: 'class(dates)' must be in c('character', 'factor', 'Date')")
        
      # If 'dates' is a factor or character , it have to be converted into 'Date' class, 
      # using the date format  specified by 'date.fmt'
      if ( !is.na( match(class(dates), c("factor", "character") ) ) ) 
        dates <- as.Date(dates, format= date.fmt)   
    
      # If 'x', 'lband', 'uband' and 'sim' (when provided) are 'zoo' 
      # and the user provides 'dates' (probably new dates), 
      # the dates of the objects are changed to the new date
      if ( zoo::is.zoo(x) )     { time(x)     <- dates }  
      if ( zoo::is.zoo(lband) ) { time(lband) <- dates } 
      if ( zoo::is.zoo(uband) ) { time(uband) <- dates }  
      if ( !missing(sim) ) 
        if ( is.zoo(sim) ) { time(sim)   <- dates }  
        
      # If the class of 'x' 'lband', 'uband' and 'sim' (when provided) 
      # are not 'zoo' and the user provides the dates, 
      # then we turn them into a zoo objects
      if ( !zoo::is.zoo(x) )      x     <- vector2zoo(x=x, dates=dates, date.fmt=date.fmt)     # hydroTSM::vector2zoo
      if ( !zoo::is.zoo(lband) )  lband <- vector2zoo(x=lband, dates=dates, date.fmt=date.fmt) # hydroTSM::vector2zoo
      if ( !zoo::is.zoo(uband) )  uband <- vector2zoo(x=uband, dates=dates, date.fmt=date.fmt) # hydroTSM::vector2zoo
      if ( !missing(sim) ) {
        if ( !zoo::is.zoo(sim) )  {
           sim <- vector2zoo(x=sim, dates=dates, date.fmt=date.fmt) # hydroTSM::vector2zoo
	   message("[Note: 'sim'  was transformed into a zoo object, with 'time(sim)' equal to 'time(obs)']") 
	} # IF end
      }  # IF end 
    }  # IF end       

    # Getting the position of the possible NA's
    na.index <- which(is.na(x))

    # Avoiding plotting the uncertainty bands for the Na's
    uband[na.index] <- uband[na.index-1]
    lband[na.index] <- lband[na.index+1]

    #uband[na.index] <- .5*( uband[na.index+1] + uband[na.index-1] )
    #lband[na.index] <- .5*( lband[na.index+1] + lband[na.index-1] )
    
    # Computing 'ylim', if it was not provided
    if ( missing(ylim) ) {
      if ( missing(sim) ) {
        ylim <- range(lband, uband, x, na.rm=TRUE)
      } else ylim <- range(lband, uband, x, sim, na.rm=TRUE)
    } # IF end
    
    # Creating the plot, but without anything on it, for allowign the call to polygon
    if ( zoo::is.zoo(x) ) {
      #if ( !xts::is.xts(x) ) x <- xts::as.xts(x)   
      # Creating the plot, but without anything on it, for allowign the call to polygon
      zoo::plot.zoo(x, xaxt = "n", yaxt = "n", type="n", main=main, 
                    xlab=xlab, ylab=ylab, ylim=ylim, 
                    cex.axis=cex.axis, cex.lab=cex.lab, ...) 
      axis(2, cex.axis=cex.axis, cex.lab=cex.lab)  
    } else plot(x, type="n", xaxt = "n", main=main, xlab=xlab, ylab=ylab, ylim=ylim, 
                cex.axis=cex.axis, cex.lab=cex.lab, ...)

    #if ( zoo::is.zoo(lband) & !xts::is.xts(lband) )  lband <- xts::as.xts(lband)
    #if ( zoo::is.zoo(uband) & !xts::is.xts(uband) )  uband <- xts::as.xts(uband)
    
    # Plotting the uncertainty bounds (polygon)
    plotbandsonly(lband=lband, uband=uband, dates=dates, date.fmt=date.fmt, 
                  bands.col=bands.col, border= border, ...)

    # Draws custom ticks and labels on the X axis
    if ( zoo::is.zoo(x) | xts::is.xts(x) ) {
      hydroTSM::drawTimeAxis(x, tick.tstep=tick.tstep, lab.tstep=lab.tstep, lab.fmt=lab.fmt, cex.axis=cex.axis) # hydroTSM::drawTimeAxis
    } else axis(side = 1, labels = TRUE)

    # Plotting the OBSERVED time series, over the polygons
    if (type[1] == "lines") {
      lines(x, cex= cex[1], col=col[1], lty=lty[1], lwd=lwd[1], pch=pch[1], ... )
    } else if (type[1] == "points") {
      points(x, cex= cex[1], col=col[1], lty=lty[1], lwd=lwd[1], pch=pch[1], ... )
      } # IF end
      
    # Plotting the SIMULATED time series, over the polygons
    if ( !missing(sim) ) {
        if ( (zoo::is.zoo(x)) & (!is.zoo(sim)) ) sim <- zoo::as.zoo(sim)
        # Plotting the SIMULATED time series, over the polygons
        if (type[2] == "lines") {
          lines(sim, cex= cex[2], col=col[2], lty=lty[2], lwd=lwd[2], pch=pch[2], ... )
        } else if (type[2] == "points") {
          points(sim, cex= cex[2], col=col[2], lty=lty[2], lwd=lwd[2], pch=pch[2], ... )
          } # IF end
    } # IF end

    # If the user provided a value for 'cal.ini', a vertical line is drawn
    if ( !missing(cal.ini) ) abline(v=cal.ini, col="red", lty=3, lwd=2)
    # If the user provided a value for 'val.ini', a vertical line is drawn
    if ( !missing(val.ini) ) abline(v=val.ini, col="red", lty=3, lwd=2)

    # Legend with 'Obs', 'Sim'  & 95PPU is drawn, when 'legend' is not FALSE
    if ( !identical(legend, FALSE) ) {                        
      if ( missing(sim) ) {
        #legend <- c("Obs", "95PPU")
        legend <- c( legend[1], legend[3] ) 
        legend("topright", legend,  inset=0.03,
               bty="n", cex =0.9, col=c(col[1], bands.col), lwd=c(lwd[1], 0), lty=c(lty[1],0), pch=c(NA,15), pt.cex=3)
      } else {
        #legend <- c("Obs", "Sim", "95PPU") 
        legend("topright", legend, inset=0.03,
               bty="n", cex =0.9, col=c(col, bands.col), lwd=c(lwd, 0), lty=c(lty, 0), pch=c(NA,NA,15), pt.cex=3)
        } # ELSE end
    } # IF end
    
    # Legend with the p-factor and r-factor
    if (gof.leg) {
        legend("topleft",  y.intersp=1.2, cex =leg.cex, bty="n", #inset=0.01,
              c( paste( "p-factor =", round(pfactor(x, lband=lband, uband=uband), gof.digits), sep=" "),
                 paste( "r-factor =", round(rfactor(x, lband=lband, uband=uband), gof.digits), sep=" ") )
               )
    } # IF end

} # 'plotbands' END

# File KGElf.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/
# Copyright 2017-2024 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'KGElf': Kling-Gupta Efficiency with focus on low flows                      #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 2017                                                                #
# Updates: 07-Jul-2022 ; 11-Jul-2022 ;12-Jul-2022                              #
# Updates: 15-Jan-2023 ; 16-Jan-2023                                           #  
#          08-May-2024                                                         #
################################################################################
# The optimal value of KGElf is 1

# Ref1:
# Garcia, F., Folton, N. and Oudin, L. (2017). 
# Which objective function to calibrate rainfall-runoff models for low-flow index simulations?. 
# Hydrological sciences journal, 62(7), pp.1149-1166. doi:10.1080/02626667.2017.1308511

# Ref2:
# Pushpalatha, R., Perrin, C., Le Moine, N. and Andreassian, V. (2012). 
# A review of efficiency criteria suitable for evaluating low-flow simulations. 
# Journal of Hydrology, 420, pp.171-182. doi: 10.1016/j.jhydrol.2011.11.055

KGElf <- function(sim, obs, ...) UseMethod("KGElf")

# epsilon: By default it is set at one hundredth of the mean flow. See Pushpalatha et al. (2012)
KGElf.default <- function(sim, obs, s=c(1,1,1), na.rm=TRUE, 
                          method=c("2009", "2012", "2021"), 
                          epsilon.type=c("Pushpalatha2012", "otherFactor", "otherValue", "none"), 
                          epsilon.value=NA, ...) { 
  
  # Checking 'method' and 'epsilon''
  method       <- match.arg(method)
  epsilon.type <- match.arg(epsilon.type)

  # 1) KGE(Q): KGE (2009 or 2012)
  kge <- KGE(sim=sim, obs=obs, s=s, na.rm=na.rm, method=method, out.type="single")
  
  # 2) KGE(1/Q): KGE based on Garcia et al. (2017), with epsilon based on Pushpalatha et al. (2012)
  new <- preproc(sim=sim, obs=obs, fun=function(x) 1/x, 
                 epsilon.type=epsilon.type, epsilon.value=epsilon.value)
  sim.lf <- new[["sim"]]
  obs.lf <- new[["obs"]]
  kge.lf <- KGE(sim=sim.lf, obs=obs.lf, s=s, na.rm=na.rm, method=method, out.type="single")
  
  # 3) [KGE(Q) + KGE(1/Q)] / 2 : comprehensive goodness-of-fit value
  out <- (kge + kge.lf) / 2
    
  return(out)
  
} # 'KGElf.default' END


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 12-Jul-2022                                                         #
# Updates: 15-Jan-2023 ; 16-Jan-2023                                           #
#          08-May-2024                                                         #
################################################################################
KGElf.matrix <- function(sim, obs, s=c(1,1,1), na.rm=TRUE, 
                         method=c("2009", "2012", "2021"), 
                         epsilon.type=c("Pushpalatha2012", "otherFactor", "otherValue", "none"), 
                         epsilon.value=NA, ...) { 

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
     stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
           paste(dim(sim), collapse=" "), "] != [", 
           paste(dim(obs), collapse=" "), "] )", sep="") )
           
  # If the user provided a value for 's'
  if (!all.equal(s, c(1,1,1)) )  {
     if ( length(s) != 3 ) stop("Invalid argument: lenght(s) must be equal to 3 !")
     if ( sum(s) != 1 )    stop("Invalid argument: sum(s) must be equal to 1.0 !")
  } # IF end
           
  method       <- match.arg(method)
  epsilon.type <- match.arg(epsilon.type)

  ifelse(method=="2012", vr.stg <- "Gamma", vr.stg <- "Alpha")

  KGElf              <- rep(NA, ncol(obs))       
  elements           <- matrix(NA, nrow=3, ncol=ncol(obs))
  rownames(elements) <- c("r", "Beta", vr.stg)
  colnames(elements) <- colnames(obs)
          
  out <- sapply(1:ncol(obs), function(i,x,y) { 
                   KGElf[i] <- KGElf.default( x[,i], y[,i], s=s, na.rm=na.rm, 
                                              method=method,
                                              epsilon.type=epsilon.type, 
                                              epsilon.value=epsilon.value, ... )
                 }, x=sim, y=obs )  
  names(out) <- colnames(obs)                     
  
  return(out)
     
} # 'KGElf.matrix' end


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 12-Jul-2022                                                         #
# Updates: 15-Jan-2023 ; 16-Jan-2023                                           # 
#          08-May-2024                                                         #
################################################################################
KGElf.data.frame <- function(sim, obs, s=c(1,1,1), na.rm=TRUE, 
                             method=c("2009", "2012", "2021"), 
                             epsilon.type=c("Pushpalatha2012", "otherFactor", "otherValue", "none"), 
                             epsilon.value=NA, ...) { 
 
  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
  
  method       <- match.arg(method)
  epsilon.type <- match.arg(epsilon.type) 
   
  KGElf.matrix(sim, obs, s=s, na.rm=na.rm, method=method,
               epsilon.type=epsilon.type, epsilon.value=epsilon.value, ...)
     
} # 'KGElf.data.frame' end


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 12-Jul-2022                                                         #
# Updates: 15-Jan-2023 ; 16-Jan-2023                                           # 
#          08-May-2024                                                         #
################################################################################
KGElf.zoo <- function(sim, obs, s=c(1,1,1), na.rm=TRUE, 
                      method=c("2009", "2012", "2021"), 
                      epsilon.type=c("Pushpalatha2012", "otherFactor", "otherValue", "none"), 
                      epsilon.value=NA, ...) { 
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       KGElf.matrix(sim, obs, s=s, na.rm=na.rm, method=method, 
                    epsilon.type=epsilon.type, epsilon.value=epsilon.value, ...)
    } else NextMethod(sim, obs, s=s, na.rm=na.rm, method=method, 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value, ...)
     
  } # 'KGElf.zoo' end

# File br2.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2009-2024 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'br2': Weighted R2                                                           #
# Coef. of  determination multiplied by the coef. of the regression line       #
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 27-Oct-2009                                                         #
# Updates: 11-Mar-2020                                                         #
#          16-Jan-2023 ; 29-Nov-2023                                           #
#          20-Jan-2024                                                         #
################################################################################

# This index allows accounting for the discrepancy in the magnitude of two signals
# under or overpredictions, (depicted by 'b') as well as their dynamics (depicted by R2).

# Krause, P., Boyle, D. P., and Base, F.: Comparison of different efficiency 
# criteria for hydrological model assessment, Adv. Geosci., 5, 89-97, 2005

# Krstic, G., Krstic, N. S., Zambrano-Bigiarini, M. (2016). 
# The br2-weighting Method for Estimating the Effects of Air Pollution on 
# Population Health. Journal of Modern Applied Statistical Methods, 15(2), 42. 
# doi:10.22237/jmasm/1478004000}

br2 <-function(sim, obs, ...) UseMethod("br2")
 
# 'obs'   : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim'   : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 'Result': weighted R2 between 'sim' and 'obs'

br2.default <- function(sim, obs, na.rm=TRUE, use.abs=FALSE, fun=NULL, ...,
                        epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                        epsilon.value=NA){

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo"))) |
       is.na(match(class(obs), c("integer", "numeric", "ts", "zoo")))
     ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo')")

  # the next two lines are required for avoiding an strange behaviour 
  # of the difference function when sim and obs are time series.
  if ( !is.na(match(class(sim), c("ts", "zoo"))) ) sim <- as.numeric(sim)
  if ( !is.na(match(class(obs), c("ts", "zoo"))) ) obs <- as.numeric(obs)

  # Checking 'epsilon.type'
  epsilon.type <- match.arg(epsilon.type)  

  # index of those elements that are present both in 'sim' and 'obs' (NON- NA values)
  vi <- valindex(sim, obs)
   
  if (length(vi) > 0) {	 
    # Filtering 'obs' and 'sim', selecting only those pairs of elements 
    # that are present both in 'x' and 'y' (NON- NA values)
    obs <- obs[vi]
    sim <- sim[vi]

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end     
     
    # Computing the linear regression between 'sim' and 'obs', 
    # forcing a zero intercept.
    x.lm <- lm(sim ~ obs - 1)
     
    # Getting the slope of the previous linear regression
    b <- as.numeric( coefficients(x.lm)["obs"]   )
     
    # computing the r2
    #r2 <- (.rPearson(sim, obs))^2 # this works only for linear models. 
    # https://github.com/hzambran/hydroGOF/issues/16#issue-1736556320
    r2 <- R2(sim=sim, obs=obs)

    if (!(use.abs)) {
      br2 <- ifelse(b <= 1, r2*abs(b), r2/abs(b))
    } else br2 <- ifelse(abs(b) <= 1, r2*abs(b), r2/abs(b))
   
  } else {
      br2 <- NA
      warning("There are no pairs of 'sim' and 'obs' without missing values !")
    } # ELSE end  
  
  return(br2)
     
} # 'br2' END
  

################################################################################
# 'br2': Weighted R2                                                           #
# Coef. of  determination multiplied by the coef. of the regression line       #
################################################################################
# Started: 27-Oct-2009                                                         #
# Updates: 11-Mar-2020                                                         #
#          16-Jan-2023                                                         #
################################################################################
br2.matrix <- function(sim, obs, na.rm=TRUE, use.abs=FALSE, fun=NULL, ...,
                       epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                       epsilon.value=NA){

    # Checking that 'sim' and 'obs' have the same dimensions
    if ( all.equal(dim(sim), dim(obs)) != TRUE )
      stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
            paste(dim(sim), collapse=" "), "] != [", 
            paste(dim(obs), collapse=" "), "] )", sep="") )

    br2 <- rep(NA, ncol(obs))       
          
    br2 <- sapply(1:ncol(obs), function(i,x,y) { 
              br2[i] <- br2.default( x[,i], y[,i], na.rm=na.rm, use.abs=use.abs, 
                                     fun=fun, ..., 
                                     epsilon.type=epsilon.type,  
                                     epsilon.value=epsilon.value)
            }, x=sim, y=obs )            
           
    return(br2)
     
} # 'br2.matrix' END
  


################################################################################
# 'br2': Weighted R2                                                           #
# Coef. of  determination multiplied by the coef. of the regression line       #
################################################################################
# Started: 27-Oct-2009                                                         #
# Updates: 11-Mar-2020                                                         #
#          16-Jan-2023                                                         #
################################################################################  
br2.data.frame <- function(sim, obs, na.rm=TRUE, use.abs=FALSE, fun=NULL, ...,
                           epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                           epsilon.value=NA){

    sim <- as.matrix(sim)
    obs <- as.matrix(obs)

    br2.matrix(sim, obs, na.rm=na.rm, use.abs=use.abs, fun=fun, ..., 
               epsilon.type=epsilon.type, epsilon.value=epsilon.value)        
     
} # 'br2.data.frame' END
  
  
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 11-Mar-2020                                                         #
################################################################################
br2.zoo <- function(sim, obs, na.rm=TRUE, use.abs=FALSE, fun=NULL, ...,
                    epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                    epsilon.value=NA){
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       br2.matrix(sim, obs, na.rm=na.rm, use.abs=use.abs, fun=fun, ..., 
                  epsilon.type=epsilon.type, epsilon.value=epsilon.value)
    } else NextMethod(sim, obs, na.rm=na.rm, use.abs=use.abs, fun=fun, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'br2.zoo' end

# File rd.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/
# Copyright 2010-2024 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

########################################
# 'rd': Relative Index of Agreement    #
########################################
# Started: April 15th, 2010            #
# Updates: 01-Jun-2011                 #
#          20-Jul-2022 ; 29-Jul-2022   #
#          20-Jan-2024                 #
########################################
# Ref
# 1) Krause, P., Boyle, D. P., and Base, F.: 
#    Comparison of different efficiency criteria for hydrological model assessment, Adv. Geosci., 5, 89-97, 2005 

# Relative Index of Agreement (Willmott et al., 1984) range from 0.0 to 1.0 
# and the closer to 1 the better the performance of the model 

# 'obs' : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim' : numeric 'data.frame', 'matrix' or 'vector' with simulated values

# 'Result': Modified Index of Agreement between 'sim' and 'obs'

# This index was developed to  be sensitive to systematic over- or 
# under-prediction, in particular during low flow conditions.

# This index quantify the difference between simulated and observed values 
# in a relative way, in order to significatively reduce the influence of 
# the absolute differences of high flows and to give more weight to 
# over- or under-prediction of low flows. At the same time, differences in
# low flows become more important, because they are looked in a relative way.

rd <-function(sim, obs, ...) UseMethod("rd")

rd.default <- function (sim, obs, na.rm=TRUE,
                        fun=NULL, ...,
                        epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                        epsilon.value=NA){ 

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo"))) |
       is.na(match(class(obs), c("integer", "numeric", "ts", "zoo")))
  ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo')")

  epsilon.type <- match.arg(epsilon.type)

  # index of those elements that are present both in 'x' and 'y' (NON- NA values)
  vi <- valindex(sim, obs)

  if (length(vi) > 0) {
	 
    # Filtering 'obs' and 'sim', selecting only those pairs of elements 
    # that are present both in 'x' and 'y' (NON- NA values)
    obs <- obs[vi]
    sim <- sim[vi]

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end
     
    # Testing for zero values in obs, which leads to -Inf as result
    zero.index <- which(obs==0)
    if (length(zero.index > 0) ) 
      warning("'rd' can not be computed: some elements in 'obs' are zero !", call.=FALSE)
     
    # the next two lines are required for avoiding an strange behaviour 
    # of the difference function when sim and obs are time series.
    if ( !is.na(match(class(sim), c("ts", "zoo"))) ) sim <- as.numeric(sim)
    if ( !is.na(match(class(obs), c("ts", "zoo"))) ) obs <- as.numeric(obs)
     
    # Mean of the observed values
    Om <- mean(obs, na.rm=na.rm)
     
    denominator <- sum( ( ( abs(sim - Om) + abs(obs - Om) ) / Om )^2 )
     
    if ( (denominator != 0) & (!is.na(denominator)) ) {      
      rd <- 1 - ( sum( ( (obs - sim) / obs)^2 ) / denominator )     
    } else {
        rd <- NA
        warning("'sum( ( ( abs(sim-Om) + abs(obs-Om) ) / Om )^2 ) = 0', it is not possible to compute 'rd'")  
      } # ELSE end

  } else {
      rd <- NA
      warning("There are no pairs of 'sim' and 'obs' without missing values !")
    } # ELSE end
     
  return(rd) 
} # 'rd.default' end


rd.matrix <- function (sim, obs, na.rm=TRUE,
                       fun=NULL, ...,
                       epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                       epsilon.value=NA){ 

 # Checking that 'sim' and 'obs' have the same dimensions
 if ( all.equal(dim(sim), dim(obs)) != TRUE )
    stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
          paste(dim(sim), collapse=" "), "] != [", 
          paste(dim(obs), collapse=" "), "] )", sep="") )

 rd <- rep(NA, ncol(obs))       
          
 rd <- sapply(1:ncol(obs), function(i,x,y) { 
                 rd[i] <- rd.default( x[,i], y[,i], na.rm=na.rm, fun=fun, ..., 
                                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
                 }, x=sim, y=obs )    
                     
  names(rd) <- colnames(obs)
  return(rd)
     
} # 'rd.matrix' end


rd.data.frame <- function (sim, obs, na.rm=TRUE,
                           fun=NULL, ...,
                           epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                           epsilon.value=NA){ 
 
  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
   
  rd.matrix(sim=sim, obs=obs, na.rm=na.rm, fun=fun, ..., 
            epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'rd.data.frame' end


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 20-Jul-2022 ; 29-Jul-2022                                           #
################################################################################
rd.zoo <- function(sim, obs, na.rm=TRUE,
                   fun=NULL, ...,
                   epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                   epsilon.value=NA){ 
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       rd.matrix(sim, obs, na.rm=na.rm, fun=fun, ..., 
                 epsilon.type=epsilon.type, epsilon.value=epsilon.value)
    } else NextMethod(sim, obs, na.rm=na.rm, fun=fun, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
  } # 'rd.zoo' end

# File mse.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/ ;
# Copyright 2009-2024 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# 'mse': Mean Squared Error                                                    #
################################################################################
# Started:  03-Feb-2009;  06-Sep-09                                            #
# Updates:  16-Jan-2023                                                        #
################################################################################ 

# 'obs'   : numeric 'data.frame', 'matrix' or 'vector' with observed values
# 'sim'   : numeric 'data.frame', 'matrix' or 'vector' with simulated values
# 'Result': Mean Squared Error between 'sim' and 'obs'
# Ref: Yapo P. O., Gupta H. V., Sorooshian S., 1996. 
#      Automatic calibration of conceptual rainfall-runoff models: 
#      sensitivity to calibration data. Journal of Hydrology. v181 i1-4. 23-48.

mse <-function(sim, obs, ...) UseMethod("mse")

mse.default <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                        epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                        epsilon.value=NA){

  if ( is.na(match(class(sim), c("integer", "numeric", "ts", "zoo"))) |
       is.na(match(class(obs), c("integer", "numeric", "ts", "zoo")))
     ) stop("Invalid argument type: 'sim' & 'obs' have to be of class: c('integer', 'numeric', 'ts', 'zoo')")

  epsilon.type <- match.arg(epsilon.type)  

  # index of those elements that are present both in 'sim' and 'obs' (NON- NA values)
  vi <- valindex(sim, obs)
   
  if (length(vi) > 0) {	 
    # Filtering 'obs' and 'sim', selecting only those pairs of elements 
    # that are present both in 'x' and 'y' (NON- NA values)
    obs <- obs[vi]
    sim <- sim[vi]

    if (!is.null(fun)) {
      fun1 <- match.fun(fun)
      new  <- preproc(sim=sim, obs=obs, fun=fun1, ..., 
                      epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim  <- new[["sim"]]
      obs  <- new[["obs"]]
    } # IF end     
      
   mse <- mean( (sim - obs)^2, na.rm = na.rm)

  } else {
      mse <- NA
      warning("There are no pairs of 'sim' and 'obs' without missing values !")
    } # ELSE end 
     
  return( mse )
     
} # 'mse.default' end
  

################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started:  03-Feb-2009;  06-Sep-09                                            #
# Updates:  16-Jan-2023                                                        #
################################################################################  
mse.matrix <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                       epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                       epsilon.value=NA){

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
    stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
          paste(dim(sim), collapse=" "), "] != [", 
          paste(dim(obs), collapse=" "), "] )", sep="") )

  #mse <- colMeans( (sim - obs)^2, na.rm= na.rm)

  mse <- rep(NA, ncol(obs))       
          
  mse <- sapply(1:ncol(obs), function(i,x,y) { 
                 mse[i] <- mse.default( x[,i], y[,i], na.rm=na.rm, norm=norm, 
                                        fun=fun, ..., 
                                        epsilon.type=epsilon.type,  
                                        epsilon.value=epsilon.value)
               }, x=sim, y=obs )         
                    
  return(mse)
     
} # 'mse.matrix' end
  

################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started:  03-Feb-2009;  06-Sep-09                                            #
# Updates:  16-Jan-2023                                                        #
################################################################################
mse.data.frame <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                           epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                           epsilon.value=NA){ 
 
  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
   
  mse.matrix(sim, obs, na.rm=na.rm, , fun=fun, ..., 
             epsilon.type=epsilon.type, epsilon.value=epsilon.value)
     
} # 'mse.data.frame' end  


################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Started: 22-Mar-2013                                                         #
# Updates: 16-Jan-2023                                                         #
################################################################################
mse.zoo <- function(sim, obs, na.rm=TRUE, fun=NULL, ...,
                    epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                    epsilon.value=NA){
    
    sim <- zoo::coredata(sim)
    if (is.zoo(obs)) obs <- zoo::coredata(obs)
    
    if (is.matrix(sim) | is.data.frame(sim)) {
       mse.matrix(sim, obs, na.rm=na.rm, ...)
    } else NextMethod(sim, obs, na.rm=na.rm, ...)
     
} # 'mse.zoo' end

# File preproc.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/
# Copyright 2017-2022 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'preproc': It applies a user-defined function to simulated and observed      #
#            values before computing any goodness-of-fit function, probably    #
#            adding a user-defined (and small) 'epsilon' value in order to     #
#            allow the use of logarithm and other similar functions that do    #
#            not work with zero values                                         #
################################################################################
# Author: Mauricio Zambrano-Bigiarini                                          #
################################################################################
# Reference: Pushpalatha, R., Perrin, C., Le Moine, N., & Andreassian, V.      #
#            (2012). A review of efficiency criteria suitable for evaluating   #
#            low-flow simulations. Journal of Hydrology, 420, 171-182.         #
#            DOI: 10.1016/j.jhydrol.2011.11.055                                #
################################################################################
# Started: 29-Jun-2017                                                         #
# Updates: 11-Jul-2022 ; 12-Jul-2022 ; 13-Jul-2022                             #
################################################################################
# 'sim'     : numeric, with simulated values
# 'obs'     : numeric, with observed values
# 'fun'     : function to be applied to 'sim' and 'obs' in order to obtain 
#             transformed values thereof before applying any goodness-of-fit 
#             function included in the hydroGOF package
# '...'     : additional argument to be passed to fun
# 'epsilon.type' : argument used to define a numeric value to be added to both 'sim' 
#                  and 'obs' before applying fun. It is was  designed to allow the 
#                  use of logarithm and other similar functions that do not work with 
#                  zero values. It must be one of the following three possible values:
#             -) "Pushpalatha2012": one hundredth of the mean observed values is 
#                                   added to both 'sim' and 'obs', as described  
#                                   in Pushpalatha et al., (2012). 
#             -) "otherFactor"    : the numeric value defined in the \code{epsilon.value} 
#                                   argument is used to multiply the the mean 
#                                   observed values, instead of the 
#                                   one hundredth (1/100) described in Pushpalatha et al. (2012). 
#                                   The resulting value is then added to both 
#                                   \code{sim} and \code{obs}.
#             -) "otherValue"     : the numeric value defined in the 'epsilon.value'
#                                   argument is directly added to both 'sim' and 'obs'

# 'epsilon.value': numeric value to be added to both 'sim' and 'obs' when 
#                  'epsilon="other"'

# 'Output': a list with two numeric vectors:
#           1) 'sim': simulated values after adding 'epsilon.value' and 
#                     applying 'fun' 
#           2) 'obs': observed values after adding 'epsilon.value' and 
#                     applying 'fun' 
preproc <- function (sim, obs, na.rm=TRUE, fun,  ..., 
                     epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                     epsilon.value=0) { 

   # fun ?
   fun.exists <- FALSE
   if (!missing(fun)) {
     fun.exists <- TRUE
     fun        <- match.fun(fun)
   } # IF end

   # epsilon.type ?
   epsilon.type <- match.arg(epsilon.type)

   if (epsilon.type %in% c("otherFactor", "otherValue") )  {
     if (is.na(epsilon.value))
       stop("Missing argument: you need to provide 'epsilon.value' !")

     if ( !is.numeric(epsilon.value) )
       stop("Invalid argument: 'epsilon.value' must be numeric !")
   } # IF end

   # epsilon.value 
   if (epsilon.type != "none") {
     if (epsilon.type=="Pushpalatha2012") {    
       epsilon.value <- (1/100)*mean(obs, na.rm=na.rm)
     } else if (epsilon.type=="otherFactor") {
         epsilon.value <- epsilon.value*mean(obs, na.rm=na.rm)
       } # ELSE (epsilon="otherValue"): epsilon.value=epsilon.value
   } else epsilon.value <- 0

   # Adding epsilon, before applying fun
   obs <- obs + epsilon.value
   sim <- sim + epsilon.value

   # using fun (and 'epsilon.value')
   if (fun.exists) {
     obs.bak <- obs
     sim.bak <- sim

     obs <- fun( obs, ...)     
     sim <- fun( sim, ...)

     if (length(obs) != length(obs.bak))
        stop("Invalid argument: 'fun' returns an object with a length different from 'obs' or 'sim' !")
   } # IF 'fun.exists' end
     
   out <- list(sim=sim, obs=obs)
     
   return(out)

} # 'preproc' END

# File APFB.R
# Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
#                                 https://cran.r-project.org/package=hydroGOF
#                                 http://www.rforge.net/hydroGOF/
# Copyright 2024-2026 Mauricio Zambrano-Bigiarini
# Distributed under GPL 2 or later

################################################################################
# 'APFB': Annual peak-flows bias                                               #
################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 04-May-2024                                                         #
# Updates: 05-May-2024                                                         #
#          02-May-2025 (EGU 2025) ; 03-May-2025                                #
#          28-Apr-2026                                                         #
################################################################################
# The optimal value of APFB is 0

# The annual peak-flow bias (APFB) objective function was proposed by 
# Mizukami et al. (2019) to drive the calibration of hydrological models focused
# in the reproduction of high-flow events.

# Ref:
# Mizukami, N., Rakovec, O., Newman, A. J., Clark, M. P., Wood, A. W., 
# Gupta, H. V., and Kumar, R.: (2019). On the choice of calibration metrics for 
# "high-flow" estimation using hydrologic models, Hydrology Earth System 
# Sciences 23, 2601-2614, doi:10.5194/hess-23-2601-2019.

APFB <- function(sim, obs, ...) UseMethod("APFB")

# epsilon: By default it is set at one hundredth of the mean flow. See Pushpalatha et al. (2012)
APFB.default <- function(sim, obs, na.rm=TRUE, 
                         start.month=1,
                         out.PerYear=FALSE,
                         fun=NULL,
                         ...,
                         epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                         epsilon.value=NA
                         ) { 

  if ( !inherits(sim, "zoo") | !inherits(obs, "zoo"))
    stop("Invalid argument: 'sim' and 'obs' must be 'zoo' objects !")

  # Selecting only valid pairs of values
  vi <- valindex(sim, obs)    

  if (length(vi) > 0) {  
    obs <- obs[vi]
    sim <- sim[vi]

    # Applying 'fun' to each value in 'obs' and 'sim'
    if (!is.null(fun)) {
      fun <- match.fun(fun)
      new <- preproc(sim=sim, obs=obs, fun=fun, ..., 
                     epsilon.type=epsilon.type, epsilon.value=epsilon.value)
      sim <- new[["sim"]]
      obs <- new[["obs"]]
    } # IF end
  } else stop("There are no points with simultaneous values of 'sim' and 'obs' !!")


  # Getting the observed and simulated annual maximum for each year
  obs.annual.max <- hydroTSM::daily2annual(obs, FUN=max, na.rm=na.rm, start.month=start.month)
  sim.annual.max <- hydroTSM::daily2annual(sim, FUN=max, na.rm=na.rm, start.month=start.month)

  # Getting the mean of the observed annual maximum and simulated annual maximum, respectively 
  mu.obs.annual.max <- mean(obs.annual.max, na.rm=na.rm)
  mu.sim.annual.max <- mean(sim.annual.max, na.rm=na.rm)

  # Overall APFB
  APFB.value <- sqrt(( mu.obs.annual.max / mu.sim.annual.max - 1)^2 )

  if (!out.PerYear) {

    return(APFB.value)

  } else {

      # Per-year APFB
      APFB.PerYear <- sqrt( ( coredata(obs.annual.max) / coredata(sim.annual.max) - 1)^2 )

      names(APFB.PerYear) <- format( time(obs.annual.max), "%Y" )

      return( list( APFB.value=APFB.value, APFB.PerYear = APFB.PerYear ) )

    } # ELSE end

} # 'APFB.default' END



################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 04-May-2024                                                         #
# Updates: 03-May-2025                                                         #
#          28-Apr-2026                                                         #
################################################################################

APFB.matrix <- function(sim, obs, na.rm=TRUE, 
                        start.month=1, 
                        out.PerYear=FALSE,
                        fun=NULL,
                        ...,
                        epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                        epsilon.value=NA) { 

  # Checking that 'sim' and 'obs' have the same dimensions
  if ( all.equal(dim(sim), dim(obs)) != TRUE )
     stop( paste("Invalid argument: dim(sim) != dim(obs) ( [", 
           paste(dim(sim), collapse=" "), "] != [", 
           paste(dim(obs), collapse=" "), "] )", sep="") )
           

  # Annual index for 'sim' and 'obs'
  dates.sim  <- time(sim)
  dates.obs  <- time(obs)
  years.sim  <- format( dates.sim, "%Y")
  years.obs  <- format( dates.obs, "%Y")
  if (!all.equal(years.sim, years.obs)) 
    stop("Invalid argument: 'sim' and 'obs' must have the same dates !")
  
  nyears <- length(unique(years.obs))


  APFB.value <- rep(NA, ncol(obs))

  APFB.PerYear <- matrix(NA, nrow=nyears, ncol=ncol(obs) )

  rownames(APFB.PerYear) <- unique(years.obs)
  colnames(APFB.PerYear) <- colnames(obs)


  for (i in 1:ncol(obs)) {

    res <- APFB.default( sim[, i], obs[, i],  na.rm=na.rm, start.month=start.month, 
                         out.PerYear=out.PerYear, fun=fun, epsilon.type=epsilon.type, 
                         epsilon.value=epsilon.value )

    if (!out.PerYear) {
      APFB.value[i] <- res
    } else {
        APFB.value[i]   <- res$APFB.value
        APFB.PerYear[,i] <- res$APFB.PerYear
      } # ELSE end

  } # FOR end


  if (!out.PerYear) {
    names(APFB.value) <- colnames(obs)
    return(APFB.value)
  } else {
      colnames(APFB.PerYear) <- colnames(obs)
      return( list( APFB.value   = APFB.value, APFB.PerYear = APFB.PerYear ) )
    } # ELSE end
     
} # 'APFB.matrix' end


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 04-May-2024                                                         #
# Updates: 05-May-2024                                                         #
#          03-May-2025                                                         #
#          28-Apr-2028                                                         #
################################################################################
APFB.data.frame <- function(sim, obs, na.rm=TRUE, 
                           start.month=1,
                           out.PerYear=FALSE,
                           fun=NULL,
                           ...,
                           epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                           epsilon.value=NA) { 
 
  sim <- as.matrix(sim)
  obs <- as.matrix(obs)
  
  APFB.matrix(
    sim,
    obs,
    na.rm=na.rm,
    start.month=start.month,
    out.PerYear=out.PerYear,
    fun=fun,
    ...,
    epsilon.type=epsilon.type,
    epsilon.value=epsilon.value
  )

} # 'APFB.data.frame' end


################################################################################
# Author : Mauricio Zambrano-Bigiarini                                         #
################################################################################
# Started: 04-May-2024                                                         #
# Updates: 03-May-2025                                                         #
################################################################################
APFB.zoo <- function(sim, obs, na.rm=TRUE, 
                    start.month=1,
                    out.PerYear=FALSE,
                    fun=NULL,
                    ...,
                    epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
                    epsilon.value=NA) { 

  if (is.matrix(sim) | is.data.frame(sim)) {

    APFB.matrix( sim, obs, na.rm=na.rm, start.month=start.month,
      out.PerYear=out.PerYear, fun=fun, ...,
      epsilon.type=epsilon.type, epsilon.value=epsilon.value )

  } else {

      NextMethod( sim, obs, na.rm=na.rm, start.month=start.month,
        out.PerYear=out.PerYear, fun=fun, ...,
        epsilon.type=epsilon.type, epsilon.value=epsilon.value )

    } # 'ELSE' end

} # 'APFB.zoo' end

---
title: Goodness-of-fit measures to compare observed and simulated time series with hydroGOF
author:
- Mauricio Zambrano-Bigiarini^[mauricio.zambrano@ufrontera.cl]
date: "version 0.4, 30-Apr-2026"
output: 
  pdf_document:
    number_sections: yes
  rmarkdown::
    html_vignette
vignette: |
  %\VignetteIndexEntry{Goodness-of-fit measures to compare observed and simulated time series with hydroGOF}
  %\VignetteKeyword{hydrology}
  %\VignetteKeyword{hydrological modelling}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

# Citation

If you use *[hydroGOF](https://cran.r-project.org/package=hydroGOF)*, please cite it as Zambrano-Bigiarini (2026):

Zambrano-Bigiarini, M. (2026) hydroGOF: Goodness-of-fit functions for comparison of simulated and observed hydrological time series R package version 0.7-0. URL: https://cran.r-project.org/package=hydroGOF. doi:10.32614/CRAN.package.hydroGOF.


# Installation

Installing the latest stable version (from [CRAN](https://cran.r-project.org/package=hydroGOF)):
```{r installation1, eval=FALSE}
install.packages("hydroGOF")
```


\noindent Alternatively, you can also try the under-development version (from  [Github](https://github.com/hzambran/hydroGOF)):
```{r installation2, eval=FALSE}
if (!require(devtools)) install.packages("devtools")
library(devtools)
install_github("hzambran/hydroGOF")
```


# Setting up the environment

Loading the *hydroGOF* package, which contains data and functions used in this analysis:

```{r LoadingPkg}
library(hydroGOF)
```

# Example using NSE

The following examples use the well-known Nash-Sutcliffe efficiency (NSE), but you can repeat the computations using any of the goodness-of-fit measures included in the *hydroGOF* package (e.g., KGE, ubRMSE, dr).


## Ex 1: ideal integer values

Basic ideal case with a numeric sequence of integers:

```{r Example1}
obs <- 1:10
sim <- 1:10
NSE(sim, obs)

obs <- 1:10
sim <- 2:11
NSE(sim, obs)
```

## Ex 2: ideal real values

Basic ideal case with a numeric sequence of integers:

```{r Example2}
obs <- 1:10 + 0.1
sim <- 1:10 +0.1
NSE(sim, obs)

obs <- 1:10 + 0.1
sim <- 2:11 + 0.1
NSE(sim, obs)
```

## Ex 3: ideal daily ts

From this example onwards, a streamflow time series will be used.

First, we load the daily streamflows of the Ega River (Spain), from 1961 to 1970:

```{r Example3-Loading}
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts
```


Generating a simulated daily time series, initially equal to the observed series:
```{r Example3-1}
sim <- obs 
```

Visualising the observed and simulated time series:

```{r Example3-2, fig.width=8, fig.height=5}
ggof(sim, obs)
```

Computing the 'NSE' for the "best" (unattainable) case
```{r Example3-3}
NSE(sim=sim, obs=obs)
```


## Ex 4: random noise in the first half of the simulated values

NSE for simulated values equal to observations plus random noise on the first half of the observed values. 

This random noise has more relative importance for low flows than for medium and high flows.
  
Randomly changing the first 1826 elements of 'sim', by using a normal distribution with mean 10 and standard deviation equal to 1 (default of 'rnorm').

```{r Example4-1, fig.width=8, fig.height=5}
sim[1:1826] <- obs[1:1826] + rnorm(1826, mean=10)
ggof(sim, obs)

NSE(sim=sim, obs=obs)
```

Let's have a look at other goodness-of-fit measures:

```{r Example4-2, fig.width=8, fig.height=5}
mNSE(sim=sim, obs=obs)                 # Modified NSE
rNSE(sim=sim, obs=obs)                 # Relative NSE
wNSE(sim=sim, obs=obs)                 # Weighted NSE
wsNSE(sim=sim, obs=obs)                # Weighted Seasonal NSE

KGE(sim=sim, obs=obs)                  # Kling-Gupta efficiency (KGE), 2009
KGE(sim=sim, obs=obs, method="2012")   # Kling-Gupta efficiency (KGE), 2012
KGE(sim=sim, obs=obs, method="2021")   # Kling-Gupta efficiency (KGE), 2021
KGElf(sim=sim, obs=obs)                # KGE for low flows
KGEnp(sim=sim, obs=obs)                # Non-parametric KGE
sKGE(sim=sim, obs=obs)                 # Split KGE
KGEkm(sim=sim, obs=obs)                # Knowable Moments KGE
JDKGE(sim=sim, obs=obs)                # Joint Divergence KGE

d(sim=sim, obs=obs)                    # Index of Agreement
dr(sim=sim, obs=obs)                   # Refined Index of Agreement
md(sim=sim, obs=obs)                   # Modified Index of Agreement
rd(sim=sim, obs=obs)                   # Relative Index of Agreement

VE(sim=sim, obs=obs)                   # Volumetric Efficiency
cp(sim=sim, obs=obs)                   # Coefficient of Persistence
APFB(sim=sim, obs=obs)                 # Annual Peak Flow Bias
HFB(sim=sim, obs=obs)                  # High Flow Bias
LME(sim=sim, obs=obs)                  # Liu-Mean Efficiency
LCE(sim=sim, obs=obs)                  # Lee and Choi Efficiency
PMR(sim=sim, obs=obs)                  # Proxy for Model Robustness

pbias(sim=sim, obs=obs)                # Percent bias (PBIAS)
pbiasfdc(sim=sim, obs=obs)             # PBIAS in the slope of the midsegment of the FDC

me(sim=sim, obs=obs)                   # Mean Error
mae(sim=sim, obs=obs)                  # Mean Absolute Error
mse(sim=sim, obs=obs)                  # Mean Squared Error 
rmse(sim=sim, obs=obs)                 # Root Mean Square Error (RMSE)
ubRMSE(sim=sim, obs=obs)               # Unbiased RMSE
nrmse(sim=sim, obs=obs, norm="sd")     # Normalised Root Mean Square Error
nrmse(sim=sim, obs=obs, norm="maxmin") # Normalised Root Mean Square Error
nrmse(sim=sim, obs=obs, norm="mean")   # Normalised Root Mean Square Error
nrmse(sim=sim, obs=obs, norm="IQR")    # Normalised Root Mean Square Error

rPearson(sim=sim, obs=obs)             # Pearson correlation coefficient
rSpearman(sim=sim, obs=obs)            # Spearman rank correlation coefficient
R2(sim=sim, obs=obs)                   # Coefficient of determination (R2)
br2(sim=sim, obs=obs)                  # R2 multiplied by the slope of the regression line
```

## Ex 5: random noise and logarithmic transformation

NSE for simulated values equal to observations plus random noise on the first half of the observed values and applying (natural) logarithm to *obs* against *sim* during computations.

```{r Example5-1}
NSE(sim=sim, obs=obs, fun=log)
```

Verifying the previous value:

```{r Example5-2}
lsim <- log(sim)
lobs <- log(obs)
NSE(sim=lsim, obs=lobs)
```

Let's have a look at other goodness-of-fit measures:

```{r Example5-3, fig.width=8, fig.height=5}
mNSE(sim=sim, obs=obs)                 # Modified NSE
rNSE(sim=sim, obs=obs)                 # Relative NSE
wNSE(sim=sim, obs=obs)                 # Weighted NSE
wsNSE(sim=sim, obs=obs)                # Weighted Seasonal NSE

KGE(sim=sim, obs=obs)                  # Kling-Gupta efficiency (KGE), 2009
KGE(sim=sim, obs=obs, method="2012")   # Kling-Gupta efficiency (KGE), 2012
KGE(sim=sim, obs=obs, method="2021")   # Kling-Gupta efficiency (KGE), 2021
KGElf(sim=sim, obs=obs)                # KGE for low flows
KGEnp(sim=sim, obs=obs)                # Non-parametric KGE
sKGE(sim=sim, obs=obs)                 # Split KGE
KGEkm(sim=sim, obs=obs)                # Knowable Moments KGE
JDKGE(sim=sim, obs=obs)                # Joint Divergence KGE

d(sim=sim, obs=obs)                    # Index of Agreement
dr(sim=sim, obs=obs)                   # Refined Index of Agreement
md(sim=sim, obs=obs)                   # Modified Index of Agreement
rd(sim=sim, obs=obs)                   # Relative Index of Agreement

VE(sim=sim, obs=obs)                   # Volumetric Efficiency
cp(sim=sim, obs=obs)                   # Coefficient of Persistence
APFB(sim=sim, obs=obs)                 # Annual Peak Flow Bias
HFB(sim=sim, obs=obs)                  # High Flow Bias
LME(sim=sim, obs=obs)                  # Liu-Mean Efficiency
LCE(sim=sim, obs=obs)                  # Lee and Choi Efficiency
PMR(sim=sim, obs=obs)                  # Proxy for Model Robustness

pbias(sim=sim, obs=obs)                # Percent bias (PBIAS)
pbiasfdc(sim=sim, obs=obs)             # PBIAS in the slope of the midsegment of the FDC

me(sim=sim, obs=obs)                   # Mean Error
mae(sim=sim, obs=obs)                  # Mean Absolute Error
mse(sim=sim, obs=obs)                  # Mean Squared Error 
rmse(sim=sim, obs=obs)                 # Root Mean Square Error (RMSE)
ubRMSE(sim=sim, obs=obs)               # Unbiased RMSE
nrmse(sim=sim, obs=obs, norm="sd")     # Normalised Root Mean Square Error
nrmse(sim=sim, obs=obs, norm="maxmin") # Normalised Root Mean Square Error
nrmse(sim=sim, obs=obs, norm="mean")   # Normalised Root Mean Square Error
nrmse(sim=sim, obs=obs, norm="IQR")    # Normalised Root Mean Square Error

rPearson(sim=sim, obs=obs)             # Pearson correlation coefficient
rSpearman(sim=sim, obs=obs)            # Spearman rank correlation coefficient
R2(sim=sim, obs=obs)                   # Coefficient of determination (R2)
br2(sim=sim, obs=obs)                  # R2 multiplied by the slope of the regression line
```

## Ex 6: random noise, logarithmic transformation and Pushpalatha2012 constant 

NSE for simulated values equal to observations plus random noise on the first half of the observed values and applying (natural) logarithm to *obs* against *sim* and adding the Pushpalatha2012 constant during computations.

```{r Example6-1}
NSE(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012")
```

Verifying the previous value, with the epsilon value following Pushpalatha2012:

```{r Example6-2}
eps  <- mean(obs, na.rm=TRUE)/100
lsim <- log(sim+eps)
lobs <- log(obs+eps)
NSE(sim=lsim, obs=lobs)
```

Let's have a look at other goodness-of-fit measures:

```{r Example6-3}
gof(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012", do.spearman=TRUE, do.pbfdc=TRUE, do.pmr=TRUE)
```

## Ex 7: random noise, logarithmic transformation and user-defined constant 

NSE for simulated values equal to observations plus random noise on the first half of the observed values and applying (natural) logarithm to *obs* against *sim* and adding a user-defined constant during computations

```{r Example7-1}
eps <- 0.01
NSE(sim=sim, obs=obs, fun=log, epsilon.type="otherValue", epsilon.value=eps)
```

Verifying the previous value:

```{r Example7-2}
lsim <- log(sim+eps)
lobs <- log(obs+eps)
NSE(sim=lsim, obs=lobs)
```

Let's have a look at other goodness-of-fit measures:

```{r Example7-3}
gof(sim=sim, obs=obs, fun=log, epsilon.type="otherValue", epsilon.value=eps, do.spearman=TRUE, do.pbfdc=TRUE, do.pmr=TRUE)
```

## Ex 8: random noise, logarithmic transformation and user-defined factor 

NSE for simulated values equal to observations plus random noise on the first half of the observed values and applying (natural) logarithm to *obs* against *sim* and using a user-defined factor to multiply the mean of the observed values to obtain the constant to be added to *obs* against *sim* during computations

```{r Example8-1}
fact <- 1/50
NSE(sim=sim, obs=obs, fun=log, epsilon.type="otherFactor", epsilon.value=fact)
```

Verifying the previous value:

```{r Example8-2}
fact <- 1/50
eps  <- fact*mean(obs, na.rm=TRUE)
lsim <- log(sim+eps)
lobs <- log(obs+eps)
NSE(sim=lsim, obs=lobs)
```

Let's have a look at other goodness-of-fit measures:

```{r Example8-3}
gof(sim=sim, obs=obs, fun=log, epsilon.type="otherFactor", epsilon.value=fact, do.spearman=TRUE, do.pbfdc=TRUE, do.pmr=TRUE)
```

## Ex 9: random noise, user-defined transformation 

NSE for simulated values equal to observations plus random noise on the first half of the observed values and applying a user-defined function to *obs* against *sim* during computations:

```{r Example9-1}
fun1 <- function(x) {sqrt(x+1)}
NSE(sim=sim, obs=obs, fun=fun1)
```

Verifying the previous value, with the epsilon value following Pushpalatha2012:

```{r Example9-2}
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
NSE(sim=sim1, obs=obs1)
```

```{r Example9-3}
gof(sim=sim, obs=obs, fun=fun1, do.spearman=TRUE, do.pbfdc=TRUE, do.pmr=TRUE)
```


# A short example from hydrological modelling

Loading observed streamflows of the Ega River (Spain), with daily data from 1961-Jan-01 up to 1970-Dec-31

```{r LoadingEgaEnEstellaQts}
require(zoo)
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts
```

Generating a simulated daily time series, initially equal to the observed values (simulated values are usually read from the output files of the hydrological model)

```{r SettingSim}
sim <- obs 
```

Plotting the graphical comparison of *obs* against *sim*, along with the **default goodness-of-fit measures**:

```{r ggof-default1, fig.width=8, fig.height=5}
ggof(sim, obs)
```

Plotting the graphical comparison of *obs* against *sim*, along with **user-defined goodness-of-fit measures**:

```{r ggof-userdefined1, fig.width=8, fig.height=5}
ggof(sim, obs, 
     gofs=c( "PBIAS", "dr", "R2",  "NSE", "KGE",  "LCE", "JDKGE", "APFB", "HFB"))
```

Computing the numeric goodness-of-fit measures for the *best* (unattainable) case, including the following three measures that -due to slightly high computation time- are not computed by default: i) the Spearman's Rank Correlation Coefficient (rSpearman), ii) the percent bias in the Slope of the Midsegment of the Flow Duration Curve (pbiasFDC), and iii) the Proxy for Model Robustness (PMR).

```{r ComputingGOFs}
gof(sim=sim, obs=obs, do.spearman=TRUE, do.pbfdc=TRUE, do.pmr=TRUE)
```

-  Randomly changing the first 1826 elements of 'sim' (half of the ts), by using a normal distribution with mean 10 and standard deviation equal to 1 (default of 'rnorm').

```{r AddingNoiseToSim}
sim[1:1826] <- obs[1:1826] + rnorm(1826, mean=10)
```

Plotting the graphical comparison of *obs* against *sim*, along with the **default goodness-of-fit measures** for the daily and monthly time series:

```{r ggof-default2, fig=TRUE, pdf=TRUE, eps=FALSE, fig.width=10, fig.height=7}
ggof(sim=sim, obs=obs, ftype="dm", FUN=mean)
```

Plotting the graphical comparison of *obs* against *sim*, along with **user-defined goodness-of-fit measures** for the daily and monthly time series:

```{r ggof-userdefined2, fig.width=8, fig.height=5}
ggof(sim=sim, obs=obs, ftype="dm", FUN=mean,
     gofs=c( "PBIAS", "dr", "R2",  "NSE", "KGE",  "LCE", "JDKGE", "APFB", "HFB"))
```




## Removing warm-up period

Using the first two years (1961-1962) as warm-up period, and removing the corresponding observed and simulated values from the computation of the goodness-of-fit measures:
```{r ggof2, fig=TRUE, pdf=TRUE, eps=FALSE, fig.width=10, fig.height=7}
ggof(sim=sim, obs=obs, ftype="dm", FUN=mean, cal.ini="1963-01-01")
```


Verification of the goodness-of-fit measures for the daily values after removing the warm-up period:
```{r ComputingGOF}
sim <- window(sim, start="1963-01-01")
obs <- window(obs, start="1963-01-01")

gof(sim, obs)
```

## Plotting uncertainty bands

Generating fictitious lower and upper uncertainty bounds:

```{r ubands1, fig.width=8, fig.height=5}
lband <- obs - 5
uband <- obs + 5
```

Plotting the previously generated uncertainty bands:

```{r ubands2, fig.width=8, fig.height=5}
plotbands(obs, lband, uband)
```

Randomly generating a simulated time series:

```{r ubands3}
sim <- obs + rnorm(length(obs), mean=3)
```

Plotting the previously generated simulated time series along the observations and the uncertainty bounds:

```{r ubands4, fig.width=8, fig.height=5}
plotbands(obs, lband, uband, sim)
```

## Computing P-factor

The **P-factor** quantifies the percentage of observed values that fall within the prediction uncertainty band defined by the lower and upper bounds. It is a measure of the coverage of the uncertainty interval.

The **P-factor** ranges from 0 to 1. A value of 1 indicates that all observations are bracketed by the uncertainty bounds, whereas a value of 0 indicates that none of the observations fall within the bounds.

Computing the P-factor:

```{r P-Factor, fig.width=8, fig.height=5}
( pfactor(x=obs, lband=lband, uband=uband) )
```

## Computing R-factor

The **R-factor** quantifies the average width of the prediction uncertainty band relative to the variability of the observed data. It is a measure of the magnitude of predictive uncertainty associated with a model simulation.

The **R-factor** ranges from 0 to infinity, with an optimal value of 0 indicating perfect agreement between simulated and observed values (i.e., zero prediction uncertainty). In practical applications, the **R-factor** represents the width of the uncertainty interval and should be as small as possible. Values close to or smaller than 1 are commonly considered indicative of an acceptable level of predictive uncertainty, although acceptable thresholds depend on the quality of observations and the modelling context.

Computing the R-factor:

```{r R-Factor, fig.width=8, fig.height=5}
( rfactor(x=obs, lband=lband, uband=uband) )
```

**Important note**:

> Because a larger fraction of observations can often be bracketed by widening the uncertainty bounds, the **R-factor** is typically interpreted jointly with the **P-factor**. A balance between a high **P-factor** (good coverage) and a low **R-factor** (narrow uncertainty bounds) is therefore sought during model calibration and uncertainty analysis.

## Analysis of the residuals


Computing the daily residuals (even if this is a dummy example, it is enough for illustrating the capability)

```{r Computing_r1}
r <- sim-obs
```

Summarizing and plotting the residuals (it requires the hydroTSM package):

```{r Computing_r2}
library(hydroTSM)
smry(r) 
```

```{r hydroplot2, fig=TRUE, pdf=TRUE, fig.width=10, fig.height=12}
# daily, monthly and annual plots, boxplots and histograms
hydroplot(r, FUN=mean)
```


Seasonal plots and boxplots
```{r hydroplo3, fig=TRUE, eval=TRUE, pdf=TRUE, eps=FALSE, fig.width=8, fig.height=8}
# daily, monthly and annual plots, boxplots and histograms
hydroplot(r, FUN=mean, pfreq="seasonal")
```








# Software details
This tutorial was built under: 

```{r echo=FALSE}
sessionInfo()$platform
sessionInfo()$R.version$version.string 
paste("hydroGOF", sessionInfo()$otherPkgs$hydroGOF$Version)
```

# Version history of this vignette

* v0.4: 30-Apr-2026
* v0.3: 21-Jan-2024
* v0.2: Mar-2020
* v0.1: Aug 2011

%% File rd.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2008-2024 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later


\name{rd}
\Rdversion{1.1}
\alias{rd}
\alias{rd.default}
\alias{rd.matrix}
\alias{rd.data.frame}
\alias{rd.zoo}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Relative Index of Agreement
}
\description{
This function computes the Relative Index of Agreement (d) between \code{sim} and \code{obs}, with treatment of missing values. \cr
If \code{x} is a matrix or a data frame, a vector of the relative index of agreement among the columns is returned.
}
\usage{
rd(sim, obs, ...)

\method{rd}{default}(sim, obs, na.rm=TRUE, fun=NULL, ...,
            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
            epsilon.value=NA)

\method{rd}{data.frame}(sim, obs, na.rm=TRUE, fun=NULL, ...,
            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
            epsilon.value=NA)

\method{rd}{matrix}(sim, obs, na.rm=TRUE, fun=NULL, ...,
            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
            epsilon.value=NA)

\method{rd}{zoo}(sim, obs, na.rm=TRUE, fun=NULL, ...,
            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
            epsilon.value=NA)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sim}{
numeric, zoo, matrix or data.frame with simulated values
}
  \item{obs}{
numeric, zoo, matrix or data.frame with observed values
}
  \item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
When an 'NA' value is found at the i-th position in \code{obs} \bold{OR} \code{sim}, the i-th value of \code{obs} \bold{AND} \code{sim} are removed before the computation.
}
  \item{fun}{
function to be applied to \code{sim} and \code{obs} in order to obtain transformed values thereof before computing the Nash-Sutcliffe efficiency.

The first argument MUST BE a numeric vector with any name (e.g., \code{x}), and additional arguments are passed using \code{\dots}.
}
  \item{\dots}{
arguments passed to \code{fun}, in addition to the mandatory first numeric vector.
}
  \item{epsilon.type}{
argument used to define a numeric value to be added to both \code{sim} and \code{obs} before applying \code{FUN}. 

It is was  designed to allow the use of logarithm and other similar functions that do not work with zero values.

Valid values of \code{epsilon.type} are:

1) \kbd{"none"}: \code{sim} and \code{obs} are used by \code{FUN} without the addition of any nummeric value.

2) \kbd{"Pushpalatha2012"}: one hundredth (1/100) of the mean observed values is added to both \code{sim} and \code{obs} before applying \code{FUN}, as described in Pushpalatha et al. (2012). 

3) \kbd{"otherFactor"}: the numeric value defined in the \code{epsilon.value} argument is used to multiply the the mean observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs}, before applying \code{FUN}.

4) \kbd{"otherValue"}: the numeric value defined in the \code{epsilon.value} argument is directly added to both \code{sim} and \code{obs}, before applying \code{FUN}.
}
  \item{epsilon.value}{
 -) when \code{epsilon.type="otherValue"} it represents the numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. \cr
 -) when \code{epsilon.type="otherFactor"} it represents the numeric factor used to multiply the mean of the observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs} before applying \code{fun}.
}
}
\details{
\deqn{rd = 1 - \frac{ \sum_{i=1}^N { \left( \frac{O_i - S_i}{O_i} \right) ^2} } { \sum_{i=1}^N {  \left( \frac{ \left| S_i -  \bar{O} \right| + \left| O_i -  \bar{O}  \right|}{\bar{O}} \right)^2 } } }{%
rd = 1 - [ sum( ( (obs - sim) / obs )^2  ] /  sum( ( (abs(sim - mean(obs) ) + abs(obs - mean(obs) ) ) / mean(obs)  )^2 ) } 

%% This index was developed to  be sensitive to systematic over- or under-prediction, in particular during low flow conditions. \cr

%% This index quantify the difference between simulated and observed values in a relative way, in order to significatively reduce the influence of the absolute differences of high flows and to give more weight to over- or under-prediction of low flows. At the same time, differences in low flows become more important, because they are looked in a relative way. \cr

It varies between 0 and 1. A value of 1 indicates a perfect match, and 0 indicates no agreement at all.
}
\value{
Relative index of agreement between \code{sim} and \code{obs}. \cr

If \code{sim} and \code{obs} are matrixes, the returned value is a vector, with the relative index of agreement between each column of \code{sim} and \code{obs}.
}
\references{
\cite{Krause, P.; Boyle, D.P.; Base, F. (2005). Comparison of different efficiency criteria for hydrological model assessment, Advances in Geosciences, 5, 89-97. doi:10.5194/adgeo-5-89-2005.}

\cite{Willmott, C.J. (1981). On the validation of models. Physical Geography, 2, 184--194. doi:10.1080/02723646.1981.10642213.}

\cite{Willmott, C.J. (1984). On the evaluation of model performance in physical geography. Spatial Statistics and Models, G. L. Gaile and C. J. Willmott, eds., 443-460. doi:10.1007/978-94-017-3048-8_23.}

\cite{Willmott, C.J.; Ackleson, S.G. Davis, R.E.; Feddema, J.J.; Klink, K.M.; Legates, D.R.; O'Donnell, J.; Rowe, C.M. (1985), Statistics for the Evaluation and Comparison of Models, J. Geophys. Res., 90(C5), 8995-9005. doi:10.1029/JC090iC05p08995.}

\cite{Legates, D.R.; McCabe, G. J. Jr. (1999), Evaluating the Use of "Goodness-of-Fit" Measures in Hydrologic and Hydroclimatic Model Validation, Water Resour. Res., 35(1), 233-241. doi:10.1029/1998WR900018.} 
}

\author{
Mauricio Zambrano Bigiarini <mzb.devel@gmail.com>
}
\note{
\code{obs} and \code{sim} has to have the same length/dimension \cr

The missing values in \code{obs} and \code{sim} are removed before the computation proceeds, and only those positions with non-missing values in \code{obs} and \code{sim} are considered in the computation. \cr

If some of the observed values are equal to zero (at least one of them), this index can not be computed.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{d}}, \code{\link{md}}, \code{\link{dr}}, \code{\link{gof}}, \code{\link{ggof}}
}
\examples{
##################
# Example 1: basic ideal case
obs <- 1:10
sim <- 1:10
rd(sim, obs)

obs <- 1:10
sim <- 2:11
rd(sim, obs)

##################
# Example 2: 
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Generating a simulated daily time series, initially equal to the observed series
sim <- obs 

# Computing the 'rd' for the "best" (unattainable) case
rd(sim=sim, obs=obs)

##################
# Example 3: rd for simulated values equal to observations plus random noise 
#            on the first half of the observed values. 
#            This random noise has more relative importance for ow flows than 
#            for medium and high flows.
  
# Randomly changing the first 1826 elements of 'sim', by using a normal distribution 
# with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim[1:1826] <- obs[1:1826] + rnorm(1826, mean=10)
ggof(sim, obs)

rd(sim=sim, obs=obs)

##################
# Example 4: rd for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' during computations.

rd(sim=sim, obs=obs, fun=log)

# Verifying the previous value:
lsim <- log(sim)
lobs <- log(obs)
rd(sim=lsim, obs=lobs)

##################
# Example 5: rd for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding the Pushpalatha2012 constant
#            during computations

rd(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012")

# Verifying the previous value, with the epsilon value following Pushpalatha2012
eps  <- mean(obs, na.rm=TRUE)/100
lsim <- log(sim+eps)
lobs <- log(obs+eps)
rd(sim=lsim, obs=lobs)

##################
# Example 6: rd for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding a user-defined constant
#            during computations

eps <- 0.01
rd(sim=sim, obs=obs, fun=log, epsilon.type="otherValue", epsilon.value=eps)

# Verifying the previous value:
lsim <- log(sim+eps)
lobs <- log(obs+eps)
rd(sim=lsim, obs=lobs)

##################
# Example 7: rd for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and using a user-defined factor
#            to multiply the mean of the observed values to obtain the constant
#            to be added to 'sim' and 'obs' during computations

fact <- 1/50
rd(sim=sim, obs=obs, fun=log, epsilon.type="otherFactor", epsilon.value=fact)

# Verifying the previous value:
eps  <- fact*mean(obs, na.rm=TRUE)
lsim <- log(sim+eps)
lobs <- log(obs+eps)
rd(sim=lsim, obs=lobs)

##################
# Example 8: rd for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying a 
#            user-defined function to 'sim' and 'obs' during computations

fun1 <- function(x) {sqrt(x+1)}

rd(sim=sim, obs=obs, fun=fun1)

# Verifying the previous value, with the epsilon value following Pushpalatha2012
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
rd(sim=sim1, obs=obs1)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

%% File KGEkm.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2026-2026 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

%% File LME.Rd
%% Part of the hydroGOF R package
%% Copyright 2024
%% Distributed under GPL 2 or later

\name{LME}
\Rdversion{1.1}
\alias{LME}
\alias{LME.default}
\alias{LME.matrix}
\alias{LME.data.frame}
\alias{LME.zoo}

\title{
Liu-Mean Efficiency
}

\description{
Liu-Mean Efficiency between \code{sim} and \code{obs}, with treatment of missing values.

This goodness-of-fit measure was proposed by Liu et al. (2020) as an alternative to the Nash-Sutcliffe efficiency (NSE), designed to provide a more balanced assessment of model performance by normalising the mean squared error using the mean of the observed values instead of their variance.

The Liu-Mean Efficiency evaluates how large the error is compared to the average level of the observations, making it particularly useful in hydrological applications where the mean value is a meaningful scale for evaluating prediction accuracy.

The normalisation makes that this performance measure behave like a dimensionless relative error, scaled by the characteristic magnitude of the variable. As a result, the same absolute error will be judged differently depending on whether the mean flow is small or large.

For a short description of the metric and the numeric range of values, please see Details.
}

\usage{
LME(sim, obs, ...)

\method{LME}{default}(sim, obs, na.rm=TRUE, out.type=c("single","full"), fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"),
             epsilon.value=NA)

\method{LME}{data.frame}(sim, obs, na.rm=TRUE, out.type=c("single","full"), fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"),
             epsilon.value=NA)

\method{LME}{matrix}(sim, obs, na.rm=TRUE, out.type=c("single","full"), fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"),
             epsilon.value=NA)

\method{LME}{zoo}(sim, obs, na.rm=TRUE, out.type=c("single","full"), fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"),
             epsilon.value=NA)
}

\arguments{

\item{sim}{
numeric, zoo, matrix or data.frame with simulated values.
}

\item{obs}{
numeric, zoo, matrix or data.frame with observed values.
}

\item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
When an 'NA' value is found at the i-th position in \code{obs} \bold{OR} \code{sim}, the i-th value of \code{obs} \bold{AND} \code{sim} are removed before the computation.
}
\item{out.type}{
character, indicating whether the output of the function has to include only the Liu-Mean Efficiency or also the intermediate quantities used in its computation. Valid values are:

-) \kbd{single}: the output is a numeric with the Liu-Mean Efficiency only.

-) \kbd{full}: the output is a list of two elements: the first one with the Liu-Mean Efficiency, and the second is a numeric with 2 elements: the mean squared error (\sQuote{MSE}) between \code{sim} and \code{obs}, and the mean of the observed values (\sQuote{MeanObs}) used as the normalization term in the computation of the Liu-Mean Efficiency.
}
\item{fun}{
function to be applied to \code{sim} and \code{obs} in order to obtain transformed values thereof before computing the Liu-Mean Efficiency.

The first argument MUST BE a numeric vector with any name (e.g., \code{x}), and additional arguments are passed using \code{\dots}.
}

\item{\dots}{
arguments passed to \code{fun}, in addition to the mandatory first numeric vector.
}

\item{epsilon.type}{
argument used to define a numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}.

It is designed to allow the use of logarithm and other similar functions that do not work with zero values.

Valid values of \code{epsilon.type} are:

1) \kbd{"none"}: \code{sim} and \code{obs} are used by \code{fun} without the addition of any numeric value.

2) \kbd{"Pushpalatha2012"}: one hundredth (1/100) of the mean observed values is added to both \code{sim} and \code{obs} before applying \code{fun}, as described in Pushpalatha et al. (2012).

3) \kbd{"otherFactor"}: the numeric value defined in the \code{epsilon.value} argument is used to multiply the mean observed values. The resulting value is then added to both \code{sim} and \code{obs}, before applying \code{fun}.

4) \kbd{"otherValue"}: the numeric value defined in the \code{epsilon.value} argument is directly added to both \code{sim} and \code{obs}, before applying \code{fun}.
}

\item{epsilon.value}{
-) when \code{epsilon.type="otherValue"} it represents the numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. \cr
-) when \code{epsilon.type="otherFactor"} it represents the numeric factor used to multiply the mean of the observed values. The resulting value is then added to both \code{sim} and \code{obs} before applying \code{fun}.
}

}

\details{

The Liu-Mean Efficiency (LME) is based on the mean squared error (MSE) normalized by the squared mean of the observed values.

Its formulation is conceptually similar to the Nash-Sutcliffe efficiency, but uses the mean of observations as the reference scaling factor instead of the variance. This modification reduces the sensitivity of the metric to high variability and makes the performance evaluation more directly interpretable in terms of proportional error relative to the mean magnitude of the observed variable.

The Liu-Mean Efficiency ranges from -Inf to 1.

A value of:

- \kbd{LME = 1} indicates perfect agreement between \code{sim} and \code{obs}.
- \kbd{LME = 0} indicates that the mean squared error equals the squared mean of the observed values.
- \kbd{LME < 0} indicates that the model predictions are worse than the squared mean of the observed values.

Essentially, the closer the LME value is to 1, the more similar \code{sim} and \code{obs} are.

\deqn{LME = 1 - \frac{MSE}{\mu_o^2}}

\deqn{MSE = \frac{1}{n} \sum_{i=1}^{n} (sim_i - obs_i)^2}

\deqn{\mu_o = \frac{1}{n} \sum_{i=1}^{n} obs_i}

where:

\itemize{

\item \kbd{n} is the number of paired observations

\item \kbd{sim_i} is the simulated value at time step i

\item \kbd{obs_i} is the observed value at time step i

\item \kbd{\mu_o} is the mean of the observed values

}

}

\value{

If \code{out.type=single}: numeric with the Liu-Mean Efficiency between \code{sim} and \code{obs}. If \code{sim} and \code{obs} are matrices, the output value is a vector, with the Liu-Mean Efficiency between each column of \code{sim} and \code{obs}

If \code{out.type=full}: a list of two elements:

\item{LME.value}{
numeric with the Liu-Mean Efficiency. If \code{sim} and \code{obs} are matrices, the output value is a vector, with the Liu-Mean Efficiency between each column of \code{sim} and \code{obs}
}

\item{LME.elements}{
numeric with 2 elements: the mean squared error (\sQuote{MSE}) between \code{sim} and \code{obs}, and the mean of the observed values (\sQuote{MeanObs}). If \code{sim} and \code{obs} are matrices, the output value is a matrix, with the previous two elements computed for each column of \code{sim} and \code{obs}\cr
}
}

\references{

\cite{Liu, D.; Chen, X.; Lian, Y.; Lou, Z. (2020). A new performance measure for hydrologic models. Journal of Hydrology, 590, 125488. doi:10.1016/j.jhydrol.2020.125488.}

\cite{Nash, J.E.; Sutcliffe, J.V. (1970). River flow forecasting through conceptual models part I - A discussion of principles. Journal of Hydrology, 10(3), 282-290.}

\cite{Pushpalatha, R.; Perrin, C.; Le Moine, N.; Andreassian, V. (2012). A review of efficiency criteria suitable for evaluating low-flow simulations. Journal of Hydrology, 420-421, 171-182.}

}

\author{
Mauricio Zambrano-Bigiarini <mzb.devel@gmail.com>
}

\note{

\code{obs} and \code{sim} have to have the same length/dimension \cr

The missing values in \code{obs} and \code{sim} are removed before the computation proceeds, and only those positions with non-missing values in \code{obs} and \code{sim} are considered in the computation

}

\seealso{
\code{\link{LCE}}, \code{\link{me}}, \code{\link{pbias}},\code{\link{NSE}}, \code{\link{KGE}}, \code{\link{gof}}, \code{\link{ggof}}
}

\examples{

# Example 0: basic ideal case
obs <- 1:10
sim <- 1:10
LME(sim, obs)

obs <- 1:10
sim <- 2:11
LME(sim, obs)

##################
# Example 1: Looking at the difference between LME and KGE, both with 'method=2009' 
#            and 'method=2012'

# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Simulated daily time series, initially equal to twice the observed values
sim <- 2*obs 

# KGE 2009
KGE(sim=sim, obs=obs, method="2009", out.type="full")

# KGE 2012
KGE(sim=sim, obs=obs, method="2012", out.type="full")

# LME (Liu et al., 2020):
LME(sim=sim, obs=obs, method="2012")

##################
# Example 2: 
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Generating a simulated daily time series, initially equal to the observed series
sim <- obs 

# Computing the 'LME' for the "best" (unattainable) case
LME(sim=sim, obs=obs)

##################
# Example 3: LME for simulated values equal to observations plus random noise 
#            on the first half of the observed values. 
#            This random noise has more relative importance for ow flows than 
#            for medium and high flows.
  
# Randomly changing the first 1826 elements of 'sim', by using a normal distribution 
# with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim[1:1826] <- obs[1:1826] + rnorm(1826, mean=10)
ggof(sim, obs)

LME(sim=sim, obs=obs)

##################
# Example 4: LME for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' during computations.

LME(sim=sim, obs=obs, fun=log)

# Verifying the previous value:
lsim <- log(sim)
lobs <- log(obs)
LME(sim=lsim, obs=lobs)

##################
# Example 5: LME for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding the Pushpalatha2012 constant
#            during computations

LME(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012")

# Verifying the previous value, with the epsilon value following Pushpalatha2012
eps  <- mean(obs, na.rm=TRUE)/100
lsim <- log(sim+eps)
lobs <- log(obs+eps)
LME(sim=lsim, obs=lobs)

##################
# Example 6: LME for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding a user-defined constant
#            during computations

eps <- 0.01
LME(sim=sim, obs=obs, fun=log, epsilon.type="otherValue", epsilon.value=eps)

# Verifying the previous value:
lsim <- log(sim+eps)
lobs <- log(obs+eps)
LME(sim=lsim, obs=lobs)

##################
# Example 7: LME for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and using a user-defined factor
#            to multiply the mean of the observed values to obtain the constant
#            to be added to 'sim' and 'obs' during computations

fact <- 1/50
LME(sim=sim, obs=obs, fun=log, epsilon.type="otherFactor", epsilon.value=fact)

# Verifying the previous value:
eps  <- fact*mean(obs, na.rm=TRUE)
lsim <- log(sim+eps)
lobs <- log(obs+eps)
LME(sim=lsim, obs=lobs)

##################
# Example 8: LME for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying a 
#            user-defined function to 'sim' and 'obs' during computations

fun1 <- function(x) {sqrt(x+1)}

LME(sim=sim, obs=obs, fun=fun1)

# Verifying the previous value, with the epsilon value following Pushpalatha2012
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
LME(sim=sim1, obs=obs1)

##################
# Example 9: LME for a two-column data frame where simulated values are equal to 
#            observations plus random noise on the first half of the observed values 

SIM <- cbind(sim, sim)
OBS <- cbind(obs, obs)

LME(sim=SIM, obs=OBS)

##################
# Example 10: LME for each year, where simulated values are given in a two-column data 
#             frame equal to the observations plus random noise on the first half of the 
#             observed values 
SIM <- cbind(sim, sim)
OBS <- cbind(obs, obs)
LME(sim=SIM, obs=OBS, out.PerYear=TRUE)

}

\keyword{ math }

%% File KGE.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2011-2024 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{KGE}
\Rdversion{1.1}
\alias{KGE}
\alias{KGE.default}
\alias{KGE.matrix}
\alias{KGE.data.frame}
\alias{KGE.zoo}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Kling-Gupta Efficiency
}
\description{
Kling-Gupta efficiency between \code{sim} and \code{obs}, with treatment of missing values.

This goodness-of-fit measure was developed by Gupta et al. (2009) to provide a diagnostically interesting decomposition of the Nash-Sutcliffe efficiency (and hence MSE), which facilitates the analysis of the relative importance of its different components (correlation, bias and variability) in the context of hydrological modelling. 

Kling et al. (2012) proposed a revised version of this index (KGE') to ensure that the bias and variability ratios are not cross-correlated.

Tang et al. (2021) proposed a revised version of this index (KGE'') to avoid the anomalously negative KGE' or KGE values when the mean value is close to zero.

For a short description of its three components and the numeric range of varios, pleae see Details.
}
\usage{
KGE(sim, obs, ...)

\method{KGE}{default}(sim, obs, s=c(1,1,1), na.rm=TRUE, method=c("2009", "2012", "2021"), 
             out.type=c("single", "full"), fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)

\method{KGE}{data.frame}(sim, obs, s=c(1,1,1), na.rm=TRUE, method=c("2009", "2012", "2021"), 
             out.type=c("single", "full"), fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)

\method{KGE}{matrix}(sim, obs, s=c(1,1,1), na.rm=TRUE, method=c("2009", "2012", "2021"), 
             out.type=c("single", "full"), fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)
             
\method{KGE}{zoo}(sim, obs, s=c(1,1,1), na.rm=TRUE, method=c("2009", "2012", "2021"), 
             out.type=c("single", "full"), fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sim}{
numeric, zoo, matrix or data.frame with simulated values
}
  \item{obs}{
numeric, zoo, matrix or data.frame with observed values
}
  \item{s}{
numeric of length 3, representing the scaling factors to be used for re-scaling the criteria space before computing the Euclidean distance from the ideal point c(1,1,1), i.e., \code{s} elements are used for adjusting the emphasis on different components.
The first elements is used for rescaling the Pearson product-moment correlation coefficient (\code{r}), the second element is used for rescaling \code{Alpha} and the third element is used for re-scaling \code{Beta}
}
  \item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
When an 'NA' value is found at the i-th position in \code{obs} \bold{OR} \code{sim}, the i-th value of \code{obs} \bold{AND} \code{sim} are removed before the computation.
}
  \item{method}{
character, indicating the formula used to compute the variability ratio in the Kling-Gupta efficiency. Valid values are:

-) \kbd{2009}: the variability is defined as \sQuote{Alpha}, the ratio of the standard deviation of \code{sim} values to the standard deviation of \code{obs}. This is the default option. See Gupta et al. (2009).

-) \kbd{2012}: the variability is defined as \sQuote{Gamma}, the ratio of the coefficient of variation of \code{sim} values to the coefficient of variation of \code{obs}. See Kling et al. (2012). 

-) \kbd{2021}: the bias is defined as \sQuote{Beta}, the ratio of \code{mean(sim)} minus \code{mean(obs)} to the standard deviation of \code{obs}. The variability is defined as \sQuote{Alpha}, the ratio of the standard deviation of \code{sim} values to the standard deviation of \code{obs}. See Tang et al. (2021). 
}
  \item{out.type}{
character, indicating the whether the output of the function has to include each one of the three terms used in the computation of the Kling-Gupta efficiency or not. Valid values are:

-) \kbd{single}: the output is a numeric with the Kling-Gupta efficiency only.

-) \kbd{full}: the output is a list of two elements: the first one with the Kling-Gupta efficiency, and the second is a numeric with 3 elements: the Pearson product-moment correlation coefficient (\sQuote{r}), the ratio between the mean of the simulated values to the mean of observations (\sQuote{Beta}), and the variability measure (\sQuote{Gamma} or \sQuote{Alpha}, depending on the value of \code{method}).
}
  \item{fun}{
function to be applied to \code{sim} and \code{obs} in order to obtain transformed values thereof before computing the Kling-Gupta efficiency.

The first argument MUST BE a numeric vector with any name (e.g., \code{x}), and additional arguments are passed using \code{\dots}.
}
  \item{\dots}{
arguments passed to \code{fun}, in addition to the mandatory first numeric vector.
}
  \item{epsilon.type}{
argument used to define a numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. 

It is was  designed to allow the use of logarithm and other similar functions that do not work with zero values.

Valid values of \code{epsilon.type} are:

1) \kbd{"none"}: \code{sim} and \code{obs} are used by \code{fun} without the addition of any nummeric value.

2) \kbd{"Pushpalatha2012"}: one hundredth (1/100) of the mean observed values is added to both \code{sim} and \code{obs} before applying \code{fun}, as described in Pushpalatha et al. (2012). 

3) \kbd{"otherFactor"}: the numeric value defined in the \code{epsilon.value} argument is used to multiply the the mean observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs}, before applying \code{fun}.

4) \kbd{"otherValue"}: the numeric value defined in the \code{epsilon.value} argument is directly added to both \code{sim} and \code{obs}, before applying \code{fun}.
}
  \item{epsilon.value}{
 -) when \code{epsilon.type="otherValue"} it represents the numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. \cr
 -) when \code{epsilon.type="otherFactor"} it represents the numeric factor used to multiply the mean of the observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs} before applying \code{fun}.
}
}
\details{
In the computation of this index, there are three main components involved: 

1) \kbd{r}    : the Pearson product-moment correlation coefficient. Ideal value is r=1.

2) \kbd{Beta} : the ratio between the mean of the simulated values and the mean of the observed ones. Ideal value is Beta=1.

3) \kbd{vr}   : variability ratio, which could be computed using the standard deviation (\kbd{Alpha}) or the coefficient of variation (\kbd{Gamma}) of \code{sim} and \code{obs}, depending on the value of \code{method}:


  3.1) \kbd{Alpha}: the ratio between the standard deviation of the simulated values and the standard deviation of the observed ones. Its ideal value is \kbd{Alpha=1}.

  3.2) \kbd{Gamma}: the ratio between the coefficient of variation (\kbd{CV}) of the simulated values to the coefficient of variation of the observed ones. Its ideal value is \kbd{Gamma=1}.

For a full discussion of the Kling-Gupta index, and its advantages over the Nash-Sutcliffe efficiency (\code{\link{NSE}}) see Gupta et al. (2009).


Kling-Gupta efficiencies range from -Inf to 1. Essentially, the closer to 1, the more similar \code{sim} and \code{obs} are. 

Knoben et al. (2019) showed that KGE values greater than -0.41 indicate that a model improves upon the mean flow benchmark, even if the model's KGE value is negative.

\deqn{KGE = 1 - ED}
\deqn{ ED =  \sqrt{ (s[1]*(r-1))^2 +(s[2]*(vr-1))^2 + (s[3]*(\beta-1))^2 } }{%
KGE = 1 - sqrt[ (s[1]*(r-1))^2 + (s[2]*(vr-1))^2 + (s[3]*(Beta-1))^2] 

r     = Pearson product-moment correlation coefficient 
beta  = mu_s/mu_o ; 
alpha = sigma_s/sigma_o
gamma = CV_s/CV_o; 

method="2009": vr=alfa
method="2012": vr=gamma }
\deqn{r=Pearson product-moment correlation coefficient}
\deqn{vr=  \left\{
  \begin{array}{cc}
    \alpha & , \: method=2009 \\
    \gamma & , \: method=2012
  \end{array}
\right.}
\deqn{\beta=\mu_s/\mu_o}
\deqn{\alpha=\sigma_s/\sigma_o}
\deqn{\gamma=\frac{CV_s}{CV_o} = \frac{\sigma_s/\mu_s}{\sigma_o/\mu_o}}
}
\value{
If \code{out.type=single}: numeric with the Kling-Gupta efficiency between \code{sim} and \code{obs}. If \code{sim} and \code{obs} are matrices, the output value is a vector, with the Kling-Gupta efficiency between each column of \code{sim} and \code{obs}

If \code{out.type=full}: a list of two elements:
\item{KGE.value}{
numeric with the Kling-Gupta efficiency. If \code{sim} and \code{obs} are matrices, the output value is a vector, with the Kling-Gupta efficiency between each column of \code{sim} and \code{obs}
}
\item{KGE.elements}{
numeric with 3 elements: the Pearson product-moment correlation coefficient (\sQuote{r}), the ratio between the mean of the simulated values to the mean of observations (\sQuote{Beta}), and the variability measure (\sQuote{Gamma} or \sQuote{Alpha}, depending on the value of \code{method}). If \code{sim} and \code{obs} are matrices, the output value is a matrix, with the previous three elements computed for each column of \code{sim} and \code{obs}\cr  
}
}
\references{
\cite{Gupta, H.V.; Kling, H.; Yilmaz, K.K.; Martinez, G.F. (2009). Decomposition of the mean squared error and NSE performance criteria: Implications for improving hydrological modelling. Journal of hydrology, 377(1-2), 80-91. doi:10.1016/j.jhydrol.2009.08.003. ISSN 0022-1694.}

\cite{Kling, H.; Fuchs, M.; Paulin, M. (2012). Runoff conditions in the upper Danube basin under an ensemble of climate change scenarios. Journal of Hydrology, 424, 264-277, doi:10.1016/j.jhydrol.2012.01.011.}

\cite{Tang, G.; Clark, M.P.; Papalexiou, S.M. (2021). SC-earth: a station-based serially complete earth dataset from 1950 to 2019. Journal of Climate, 34(16), 6493-6511. doi:10.1175/JCLI-D-21-0067.1.}

\cite{Santos, L.; Thirel, G.; Perrin, C. (2018). Pitfalls in using log-transformed flows within the KGE criterion. doi:10.5194/hess-22-4583-2018.}

\cite{Knoben, W.J.; Freer, J.E.; Woods, R.A. (2019). Inherent benchmark or not? Comparing Nash-Sutcliffe and Kling-Gupta efficiency scores. Hydrology and Earth System Sciences, 23(10), 4323-4331. doi:10.5194/hess-23-4323-2019.}

\cite{Mizukami, N.; Rakovec, O.; Newman, A.J.; Clark, M.P.; Wood, A.W.; Gupta, H.V.; Kumar, R. (2019). On the choice of calibration metrics for "high-flow" estimation using hydrologic models. doi:10.5194/hess-23-2601-2019.}

\cite{Cinkus, G.; Mazzilli, N.; Jourde, H.; Wunsch, A.; Liesch, T.; Ravbar, N.; Chen, Z.; and Goldscheider, N. (2023). When best is the enemy of good - critical evaluation of performance criteria in hydrological models. Hydrology and Earth System Sciences 27, 2397-2411, doi:10.5194/hess-27-2397-2023.}
}

\author{
Mauricio Zambrano-Bigiarini <mzb.devel@gmail.com>
}
\note{
\code{obs} and \code{sim} has to have the same length/dimension \cr

The missing values in \code{obs} and \code{sim} are removed before the computation proceeds, and only those positions with non-missing values in \code{obs} and \code{sim} are considered in the computation
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{KGElf}}, \code{\link{sKGE}}, \code{\link{KGEnp}}, \code{\link{gof}}, \code{\link{ggof}}
}
\examples{
# Example1: basic ideal case
obs <- 1:10
sim <- 1:10
KGE(sim, obs)

obs <- 1:10
sim <- 2:11
KGE(sim, obs)

##################
# Example2: Looking at the difference between 'method=2009' and 'method=2012'
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Simulated daily time series, initially equal to twice the observed values
sim <- 2*obs 

# Traditional Kling-Gupta eficiency (Gupta and Kling, 2009)
KGE(sim=sim, obs=obs, method="2009", out.type="full")

# KGE': Kling-Gupta eficiency 2012 (Kling et al.,2012) 
KGE(sim=sim, obs=obs, method="2012", out.type="full")

# KGE'': Kling-Gupta eficiency 2021 (Tang et al.,2021) 
KGE(sim=sim, obs=obs, method="2021", out.type="full")

##################
# Example3: KGE for simulated values equal to observations plus random noise 
#           on the first half of the observed values
# Randomly changing the first 1826 elements of 'sim', by using a normal distribution 
# with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim <- obs 
sim[1:1826] <- obs[1:1826] + rnorm(1826, mean=10)

# Computing the new 'KGE'
KGE(sim=sim, obs=obs)

# Randomly changing the first 2000 elements of 'sim', by using a normal distribution 
# with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim[1:2000] <- obs[1:2000] + rnorm(2000, mean=10)

# Traditional Kling-Gupta eficiency (Gupta and Kling, 2009)
KGE(sim=sim, obs=obs, method="2009", out.type="full")

# KGE': Kling-Gupta eficiency 2012 (Kling et al.,2012) 
KGE(sim=sim, obs=obs, method="2012", out.type="full")

# KGE'': Kling-Gupta eficiency 2021 (Tang et al.,2021) 
KGE(sim=sim, obs=obs, method="2021", out.type="full")

##################
# Example 4: KGE for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' during computations.

KGE(sim=sim, obs=obs, fun=log)

# Verifying the previous value:
lsim <- log(sim)
lobs <- log(obs)
KGE(sim=lsim, obs=lobs)

##################
# Example 5: KGE for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding the Pushpalatha2012 constant
#            during computations

KGE(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012")

# Verifying the previous value, with the epsilon value following Pushpalatha2012
eps  <- mean(obs, na.rm=TRUE)/100
lsim <- log(sim+eps)
lobs <- log(obs+eps)
KGE(sim=lsim, obs=lobs)

##################
# Example 6: KGE for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding a user-defined constant
#            during computations

eps <- 0.01
KGE(sim=sim, obs=obs, fun=log, epsilon.type="otherValue", epsilon.value=eps)

# Verifying the previous value:
lsim <- log(sim+eps)
lobs <- log(obs+eps)
KGE(sim=lsim, obs=lobs)

##################
# Example 7: KGE for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and using a user-defined factor
#            to multiply the mean of the observed values to obtain the constant
#            to be added to 'sim' and 'obs' during computations

fact <- 1/50
KGE(sim=sim, obs=obs, fun=log, epsilon.type="otherFactor", epsilon.value=fact)

# Verifying the previous value:
eps  <- fact*mean(obs, na.rm=TRUE)
lsim <- log(sim+eps)
lobs <- log(obs+eps)
KGE(sim=lsim, obs=lobs)

##################
# Example 8: KGE for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying a 
#            user-defined function to 'sim' and 'obs' during computations

fun1 <- function(x) {sqrt(x+1)}

KGE(sim=sim, obs=obs, fun=fun1)

# Verifying the previous value, with the epsilon value following Pushpalatha2012
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
KGE(sim=sim1, obs=obs1)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

%% File hydroGOF-internal.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2008-2024 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{hydroGOF-internal}
\title{Internal hydroGOF objects}
\alias{.intersect}
\alias{preproc}
\description{Internal hydroGOF objects.}
\details{These are not to be called by the user.}
\keyword{internal}

%% File KGEkm.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2011-2024 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{KGEkm}
\Rdversion{1.1}
\alias{KGEkm}
\alias{KGEkm.default}
\alias{KGEkm.matrix}
\alias{KGEkm.data.frame}
\alias{KGEkm.zoo}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Kling-Gupta Efficiency with knowable-moments
}
\description{
Kling-Gupta efficiency between \code{sim} and \code{obs}, with use of knowable moments and treatment of missing values.

This goodness-of-fit measure was developed by Pizarro and Jorquera (2024), as a modification to the original Kling-Gupta efficiency (KGE) proposed by Gupta et al. (2009). See Details.
}
\usage{
KGEkm(sim, obs, ...)

\method{KGEkm}{default}(sim, obs, s=c(1,1,1), na.rm=TRUE, method=c("2012", "2009", "2021"), 
             out.type=c("single", "full"), fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)

\method{KGEkm}{data.frame}(sim, obs, s=c(1,1,1), na.rm=TRUE, method=c("2012", "2009", "2021"), 
             out.type=c("single", "full"), fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)

\method{KGEkm}{matrix}(sim, obs, s=c(1,1,1), na.rm=TRUE, method=c("2012", "2009", "2021"), 
             out.type=c("single", "full"), fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)
             
\method{KGEkm}{zoo}(sim, obs, s=c(1,1,1), na.rm=TRUE, method=c("2012", "2009", "2021"), 
             out.type=c("single", "full"), fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sim}{
numeric, zoo, matrix or data.frame with simulated values
}
  \item{obs}{
numeric, zoo, matrix or data.frame with observed values
}
  \item{s}{
numeric of length 3, representing the scaling factors to be used for re-scaling the criteria space before computing the Euclidean distance from the ideal point c(1,1,1), i.e., \code{s} elements are used for adjusting the emphasis on different components.
The first elements is used for rescaling the Pearson product-moment correlation coefficient (\code{r}), the second element is used for rescaling \code{Alpha} and the third element is used for re-scaling \code{Beta}
}
  \item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
When an 'NA' value is found at the i-th position in \code{obs} \bold{OR} \code{sim}, the i-th value of \code{obs} \bold{AND} \code{sim} are removed before the computation.
}
  \item{method}{
character, indicating the formula used to compute the variability ratio in the Kling-Gupta efficiency. Valid values are:

-) \kbd{2012}: the variability is defined as \sQuote{Gamma}, the ratio of the coefficient of variation of \code{sim} values to the coefficient of variation of \code{obs}. See Pizarro and Jorquera (2024) and Kling et al. (2012). 

-) \kbd{2009}: the variability is defined as \sQuote{Alpha}, the ratio of the standard deviation of \code{sim} values to the standard deviation of \code{obs}. This is the default option. See Gupta et al. (2009).

-) \kbd{2021}: the bias is defined as \sQuote{Beta}, the ratio of \code{mean(sim)} minus \code{mean(obs)} to the standard deviation of \code{obs}. The variability is defined as \sQuote{Alpha}, the ratio of the standard deviation of \code{sim} values to the standard deviation of \code{obs}. See Tang et al. (2021). 
}
  \item{out.type}{
character, indicating the whether the output of the function has to include each one of the three terms used in the computation of the Kling-Gupta efficiency or not. Valid values are:

-) \kbd{single}: the output is a numeric with the Kling-Gupta efficiency only.

-) \kbd{full}: the output is a list of two elements: the first one with the Kling-Gupta efficiency, and the second is a numeric with 3 elements: the Pearson product-moment correlation coefficient (\sQuote{r}), the ratio between the mean of the simulated values to the mean of observations (\sQuote{Beta}), and the variability measure (\sQuote{Gamma} or \sQuote{Alpha}, depending on the value of \code{method}).
}
  \item{fun}{
function to be applied to \code{sim} and \code{obs} in order to obtain transformed values thereof before computing the Kling-Gupta efficiency.

The first argument MUST BE a numeric vector with any name (e.g., \code{x}), and additional arguments are passed using \code{\dots}.
}
  \item{\dots}{
arguments passed to \code{fun}, in addition to the mandatory first numeric vector.
}
  \item{epsilon.type}{
argument used to define a numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. 

It is was  designed to allow the use of logarithm and other similar functions that do not work with zero values.

Valid values of \code{epsilon.type} are:

1) \kbd{"none"}: \code{sim} and \code{obs} are used by \code{fun} without the addition of any nummeric value.

2) \kbd{"Pushpalatha2012"}: one hundredth (1/100) of the mean observed values is added to both \code{sim} and \code{obs} before applying \code{fun}, as described in Pushpalatha et al. (2012). 

3) \kbd{"otherFactor"}: the numeric value defined in the \code{epsilon.value} argument is used to multiply the the mean observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs}, before applying \code{fun}.

4) \kbd{"otherValue"}: the numeric value defined in the \code{epsilon.value} argument is directly added to both \code{sim} and \code{obs}, before applying \code{fun}.
}
  \item{epsilon.value}{
 -) when \code{epsilon.type="otherValue"} it represents the numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. \cr
 -) when \code{epsilon.type="otherFactor"} it represents the numeric factor used to multiply the mean of the observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs} before applying \code{fun}.
}
}
\details{
Traditional objective functions, such as Nash-Sutcliffe Efficiency (NSE) and Kling-Gupta Efficiency (KGE), often make assumptions about data distribution and are sensitive to outliers. The Kling-Gupta Efficiency with knowable-moments (KGEkm) goodness-of-fit measure was developed by Pizarro and Jorquera (2024) to provide a reliable estimation and effective description of high-order statistics from typical hydrological samples and, therefore, reducing uncertainty in their estimation and computation of the KGE. 

In the \eqn{KGE_{km}}, the dispersion is quantified using knowable moments (computed over ordered values of the samples in ascending order) instead of the standard deviation, while retaining the decomposition into correlation, variability, and bias components.

The general formulation of Kling--Gupta Efficiency with knowable moments (\eqn{KGE_{km}}) is:

\deqn{
KGE_{km} = 1 - \sqrt{ \left[ s_1 (r - 1) \right]^2 + \left[ s_2 (vr - 1) \right]^2 + \left[ s_3 (br - 1) \right]^2 }
}

where \eqn{r} is the Pearson product--moment correlation coefficient between simulated (\eqn{Q^{sim}_t}) and observed (\eqn{Q^{obs}_t}) values, \eqn{vr} is the variability ratio, \eqn{br} is the bias ratio, and \eqn{s = (s_1, s_2, s_3)} is a vector of non-negative scaling factors that control the relative importance of each component.

Dispersion is computed from the second knowable moment. For a sample \eqn{x_1, x_2, \ldots, x_n}, the second knowable moment is defined as:

\deqn{
K_2 = \frac{1}{n(n-1)} \sum_{i=1}^{n} 2 (i-1) x_{(i)}
}

where \eqn{x_{(i)}} denotes the \bold{ordered values of the sample in ascending order}. The corresponding dispersion measure is:

\deqn{
\sigma_{km} = \sqrt{ 2 K_2 }
}

The variability ratio depends on the selected \code{method}:

\itemize{

\item For \code{method = "2009"}, variability is defined as the ratio of 
knowable-moment dispersions:

\deqn{
vr = \alpha = \frac{\sigma^{sim}_{km}}{\sigma^{obs}_{km}}
}

\item For \code{method = "2012"}, variability is defined as the ratio of 
coefficients of variation:

\deqn{
vr = \gamma = \frac{
\sigma^{sim}_{km} / \mu^{sim}
}{
\sigma^{obs}_{km} / \mu^{obs}
}
}

\item For \code{method = "2021"}, variability is defined as in the 2009 
formulation:

\deqn{
vr = \alpha = \frac{\sigma^{sim}_{km}}{\sigma^{obs}_{km}}
}

}

The bias component also depends on the selected \code{method}:

\itemize{

\item For \code{method = "2009"} and \code{method = "2012"}:

\deqn{
br = \beta = \frac{\mu^{sim}}{\mu^{obs}}
}

\item For \code{method = "2021"}:

\deqn{
br = \beta_{2021} = \frac{ \mu^{sim} - \mu^{obs}
}{
\sigma^{obs}_{km}
}
}

}

In the same line that the traditional Kling-Gupta efficiency, the (\eqn{KGE_{km}}) ranges from -Inf to 1. Essentially, the closer to 1, the more similar \code{sim} and \code{obs} are. 

As with other KGE-type metrics, the statistic integrates information about correlation, variability, and bias into a single performance measure while allowing explicit control over the relative contribution of each component through the scaling factors \eqn{s}.
}

\value{
If \code{out.type=single}: numeric with the Kling-Gupta efficiency between \code{sim} and \code{obs}. If \code{sim} and \code{obs} are matrices, the output value is a vector, with the Kling-Gupta efficiency between each column of \code{sim} and \code{obs}

If \code{out.type=full}: a list of two elements:
\item{KGEkm.value}{
numeric with the Kling-Gupta efficiency. If \code{sim} and \code{obs} are matrices, the output value is a vector, with the Kling-Gupta efficiency between each column of \code{sim} and \code{obs}
}
\item{KGEkm.elements}{
numeric with 3 elements: the Pearson product-moment correlation coefficient (\sQuote{r}), the ratio between the mean of the simulated values to the mean of observations (\sQuote{Beta}), and the variability measure (\sQuote{Gamma} or \sQuote{Alpha}, depending on the value of \code{method}). If \code{sim} and \code{obs} are matrices, the output value is a matrix, with the previous three elements computed for each column of \code{sim} and \code{obs}\cr  
}
}
\references{
\cite{Pizarro, A.; Jorquera, J. (2024). Advancing objective functions in hydrological modelling: Integrating knowable moments for improved simulation accuracy. Journal of Hydrology, 634, 131071. doi:10.1016/j.jhydrol.2024.131071.}

\cite{Kling, H.; Fuchs, M.; Paulin, M. (2012). Runoff conditions in the upper Danube basin under an ensemble of climate change scenarios. Journal of Hydrology, 424, 264-277, doi:10.1016/j.jhydrol.2012.01.011.}

\cite{Gupta, H. V.; Kling, H.; Yilmaz, K. K.; Martinez, G. F. (2009). Decomposition of the mean squared error and NSE performance criteria: Implications for improving hydrological modelling. Journal of hydrology, 377(1-2), 80-91. doi:10.1016/j.jhydrol.2009.08.003. ISSN 0022-1694.}

\cite{Tang, G.; Clark, M. P.; Papalexiou, S. M. (2021). SC-earth: a station-based serially complete earth dataset from 1950 to 2019. Journal of Climate, 34(16), 6493-6511. doi:10.1175/JCLI-D-21-0067.1.}

\cite{Santos, L.; Thirel, G.; Perrin, C. (2018). Pitfalls in using log-transformed flows within the KGEkm criterion. doi:10.5194/hess-22-4583-2018.}

\cite{Knoben, W.J.; Freer, J.E.; Woods, R.A. (2019). Inherent benchmark or not? Comparing Nash-Sutcliffe and Kling-Gupta efficiency scores. Hydrology and Earth System Sciences, 23(10), 4323-4331. doi:10.5194/hess-23-4323-2019.}

\cite{Cinkus, G., Mazzilli, N., Jourde, H., Wunsch, A., Liesch, T., Ravbar, N., Chen, Z., and Goldscheider, N. (2023). When best is the enemy of good - critical evaluation of performance criteria in hydrological models. Hydrology and Earth System Sciences 27, 2397-2411, doi:10.5194/hess-27-2397-2023}
}

\author{
Mauricio Zambrano-Bigiarini <mzb.devel@gmail.com>
}
\note{
\code{obs} and \code{sim} has to have the same length/dimension \cr

The missing values in \code{obs} and \code{sim} are removed before the computation proceeds, and only those positions with non-missing values in \code{obs} and \code{sim} are considered in the computation
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{KGE}}, \code{\link{KGElf}}, \code{\link{sKGE}}, \code{\link{KGEnp}}, \code{\link{gof}}, \code{\link{ggof}}
}
\examples{
# Example1: basic ideal case
obs <- 1:10
sim <- 1:10
KGEkm(sim, obs)

obs <- 1:10
sim <- 2:11
KGEkm(sim, obs)

##################
# Example2: Looking at the difference between 'method=2009' and 'method=2012'

# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Simulated daily time series, initially equal to twice the observed values
sim <- 2*obs 

# KGEkm 2012 (method="2012" is the default option for KGEkm)
KGEkm(sim=sim, obs=obs, method="2012", out.type="full")

# KGEkm 2009
KGEkm(sim=sim, obs=obs, method="2009", out.type="full")


##################
# Example 2: Looking at the difference between 'KGEkm', KGE', 'NSE', 'wNSE', 
#            'wsNSE' and 'APFB' for detecting differences in high flows

# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Simulated daily time series, created equal to the observed values and then 
# random noise is added only to high flows, i.e., those equal or higher than 
# the quantile 0.9 of the observed values.
sim      <- obs
hQ.thr   <- quantile(obs, probs=0.9, na.rm=TRUE)
hQ.index <- which(obs >= hQ.thr)
hQ.n     <- length(hQ.index)
sim[hQ.index] <- sim[hQ.index] + rnorm(hQ.n, mean=mean(sim[hQ.index], na.rm=TRUE))

# KGEkm (Pizarro and Jorquera, 2024; method='2012')
KGEkm(sim=sim, obs=obs)

# KGE': Kling-Gupta eficiency 2012 (Kling et al.,2012) 
KGE(sim=sim, obs=obs, method="2012")

# Traditional Kling-Gupta eficiency (Gupta and Kling, 2009)
KGE(sim=sim, obs=obs)

# KGE'': Kling-Gupta eficiency 2021 (Tang et al.,2021) 
KGE(sim=sim, obs=obs, method="2021")

# Traditional Nash-Sutcliffe eficiency (Nash and Sutcliffe, 1970)
NSE(sim=sim, obs=obs)

# Weighted Nash-Sutcliffe efficiency (Hundecha and Bardossy, 2004)
wNSE(sim=sim, obs=obs)

# wsNSE (Zambrano-Bigiarini and Bellin, 2012):
wsNSE(sim=sim, obs=obs)

# APFB (Mizukami et al., 2019):
APFB(sim=sim, obs=obs)


##################
# Example 4: Looking at the difference between 'KGE', 'NSE', 'wsNSE',
#            'dr', 'rd', 'md', and 'KGElf' for detecting 
#            differences in low flows

# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Simulated daily time series, created equal to the observed values and then 
# random noise is added only to low flows, i.e., those equal or lower than 
# the quantile 0.4 of the observed values.
sim      <- obs
lQ.thr   <- quantile(obs, probs=0.4, na.rm=TRUE)
lQ.index <- which(obs <= lQ.thr)
lQ.n     <- length(lQ.index)
sim[lQ.index] <- sim[lQ.index] + rnorm(lQ.n, mean=mean(sim[lQ.index], na.rm=TRUE))

# KGEkm (Pizarro and Jorquera, 2024; method='2012')
KGEkm(sim=sim, obs=obs)

# KGE': Kling-Gupta eficiency 2012 (Kling et al.,2012) 
KGE(sim=sim, obs=obs, method="2012")

# Traditional Kling-Gupta eficiency (Gupta and Kling, 2009)
KGE(sim=sim, obs=obs)

# KGE'': Kling-Gupta eficiency 2021 (Tang et al.,2021) 
KGE(sim=sim, obs=obs, method="2021")

# Traditional Nash-Sutcliffe eficiency (Nash and Sutcliffe, 1970)
NSE(sim=sim, obs=obs)

# Weighted seasonal Nash-Sutcliffe efficiency (Zambrano-Bigiarini and Bellin, 2012):
wsNSE(sim=sim, obs=obs, lambda=0.05, j=1/2)

# Refined Index of Agreement (Willmott et al., 2012):
dr(sim=sim, obs=obs)

# Relative Index of Agreement (Krause et al., 2005):
rd(sim=sim, obs=obs)

# Modified Index of Agreement (Krause et al., 2005):
md(sim=sim, obs=obs)

# KGElf (Garcia et al., 2017):
KGElf(sim=sim, obs=obs)


##################
# Example 5: KGEkm for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' during computations.

KGEkm(sim=sim, obs=obs, fun=log)

# Verifying the previous value:
lsim <- log(sim)
lobs <- log(obs)
KGEkm(sim=lsim, obs=lobs)

##################
# Example 6: KGEkm for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding the Pushpalatha2012 constant
#            during computations

KGEkm(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012")

# Verifying the previous value, with the epsilon value following Pushpalatha2012
eps  <- mean(obs, na.rm=TRUE)/100
lsim <- log(sim+eps)
lobs <- log(obs+eps)
KGEkm(sim=lsim, obs=lobs)

##################
# Example 7: KGEkm for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding a user-defined constant
#            during computations

eps <- 0.01
KGEkm(sim=sim, obs=obs, fun=log, epsilon.type="otherValue", epsilon.value=eps)

# Verifying the previous value:
lsim <- log(sim+eps)
lobs <- log(obs+eps)
KGEkm(sim=lsim, obs=lobs)

##################
# Example 8: KGEkm for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and using a user-defined factor
#            to multiply the mean of the observed values to obtain the constant
#            to be added to 'sim' and 'obs' during computations

fact <- 1/50
KGEkm(sim=sim, obs=obs, fun=log, epsilon.type="otherFactor", epsilon.value=fact)

# Verifying the previous value:
eps  <- fact*mean(obs, na.rm=TRUE)
lsim <- log(sim+eps)
lobs <- log(obs+eps)
KGEkm(sim=lsim, obs=lobs)

##################
# Example 9: KGEkm for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying a 
#            user-defined function to 'sim' and 'obs' during computations

fun1 <- function(x) {sqrt(x+1)}

KGEkm(sim=sim, obs=obs, fun=fun1)

# Verifying the previous value, with the epsilon value following Pushpalatha2012
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
KGEkm(sim=sim1, obs=obs1)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

%% File KGEnp.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2017-2024 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or late

\name{KGEnp}
\Rdversion{1.1}
\alias{KGEnp}
\alias{KGEnp.default}
\alias{KGEnp.matrix}
\alias{KGEnp.data.frame}
\alias{KGEnp.zoo}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Non-parametric version of the Kling-Gupta Efficiency
}
\description{
Non-parametric Kling-Gupta efficiency between \code{sim} and \code{obs}, with treatment of missing values. \cr

This goodness-of-fit measure was developed by Pool et al. (2018), as a non-parametric alternative to the original Kling-Gupta efficiency (KGE) proposed by Gupta et al. (2009). See Details.
}
\usage{
KGEnp(sim, obs, ...)

\method{KGEnp}{default}(sim, obs, na.rm=TRUE, out.type=c("single", "full"), fun=NULL, ..., 
               epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
               epsilon.value=NA)

\method{KGEnp}{data.frame}(sim, obs, na.rm=TRUE, out.type=c("single", "full"), fun=NULL, ..., 
               epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
               epsilon.value=NA)

\method{KGEnp}{matrix}(sim, obs, na.rm=TRUE, out.type=c("single", "full"), fun=NULL, ..., 
               epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
               epsilon.value=NA)
             
\method{KGEnp}{zoo}(sim, obs, na.rm=TRUE, out.type=c("single", "full"), fun=NULL, ..., 
               epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
               epsilon.value=NA)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sim}{
numeric, zoo, matrix or data.frame with simulated values
}
  \item{obs}{
numeric, zoo, matrix or data.frame with observed values
}
  \item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
When an 'NA' value is found at the i-th position in \code{obs} \bold{OR} \code{sim}, the i-th value of \code{obs} \bold{AND} \code{sim} are removed before the computation.
}
  \item{out.type}{
character, indicating the whether the output of the function has to include each one of the three terms used in the computation of the Kling-Gupta efficiency or not. Valid values are:

-) \kbd{single}: the output is a numeric with the Kling-Gupta efficiency only.

-) \kbd{full}: the output is a list of two elements: the first one with the Kling-Gupta efficiency, and the second is a numeric with 3 elements: the Spearman rank correlation coefficient (\sQuote{rSpearman}), the ratio between the mean of the simulated values to the mean of observations (\sQuote{Beta}), and the variability measure (\sQuote{Alpha}).
}
  \item{fun}{
function to be applied to \code{sim} and \code{obs} in order to obtain transformed values thereof before computing this goodness-of-fit index.

The first argument MUST BE a numeric vector with any name (e.g., \code{x}), and additional arguments are passed using \code{\dots}.
}
  \item{\dots}{
arguments passed to \code{fun}, in addition to the mandatory first numeric vector.
}
  \item{epsilon.type}{
argument used to define a numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. 

It is was  designed to allow the use of logarithm and other similar functions that do not work with zero values.

Valid values of \code{epsilon.type} are:

1) \kbd{"none"}: \code{sim} and \code{obs} are used by \code{fun} without the addition of any numeric value. This is the default option.

2) \kbd{"Pushpalatha2012"}: one hundredth (1/100) of the mean observed values is added to both \code{sim} and \code{obs} before applying \code{fun}, as described in Pushpalatha et al. (2012). 

3) \kbd{"otherFactor"}: the numeric value defined in the \code{epsilon.value} argument is used to multiply the the mean observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs}, before applying \code{fun}.

4) \kbd{"otherValue"}: the numeric value defined in the \code{epsilon.value} argument is directly added to both \code{sim} and \code{obs}, before applying \code{fun}.
}
  \item{epsilon.value}{
 -) when \code{epsilon.type="otherValue"} it represents the numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. \cr
 -) when \code{epsilon.type="otherFactor"} it represents the numeric factor used to multiply the mean of the observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs} before applying \code{fun}.
}
}
\details{

This non-paramettric verison of the Kling-Gupta efficiency keeps the bias term Alpha (mean(sim) / mean(obs)), but for correlation uses the Spearman rank coefficient instead of the Pearson product-moment coefficient; and for variability it uses the normalized flow-duration curve instead of the standard deviation (or coefficient of variation).

The proposed non-parametric based multi-objective function can be seen as a useful alternative to existing performance measures when aiming at acceptable simulations of multiple hydrograph aspects (Pool et al., 2018).

\deqn{KGE_{np} = 1 - ED}
\deqn{ ED =  \sqrt{ ((\rho-1)^2 + (\alpha-1)^2 + (\beta-1)^2 } }
\deqn{\rho = \textrm{Spearman rank correlation coefficient}}
\deqn{\alpha = 1 - 0.5*sum( sim(I(k)) / (n*\mu_s) - obs(J(k)) / (n*\mu_o) )}
\deqn{\beta = \mu_s/\mu_o}{%

KGEnp = 1 - sqrt[ ((rS-1)^2 + (Alpha-1)^2 + (Beta-1)^2] ; rS=Spearman rank correlation coefficient ; alpha=1-0.5*sum(abs(fdc.sim - fdc.obs)) ; beta=mu_s/mu_o }

Traditional Kling-Gupta efficiencies (Gupta et al., 2009; Kling et al., 2012) range from -Inf to 1, and therefore KGEnp should do so. Essentially, the closer to 1, the more similar \code{sim} and \code{obs} are. \cr

Knoben et al. (2019) showed that traditional Kling-Gupta (Gupta et al., 2009; Kling et al., 2012) values greater than -0.41 indicate that a model improves upon the mean flow benchmark, even if the model's KGE value is negative.
}
\value{
numeric with the non-parametric Kling-Gupta efficiency between \code{sim} and \code{obs}. \cr
If \code{sim} and \code{obs} are matrices, the output value is a vector, with the non-parametric Kling-Gupta efficiency between each column of \code{sim} and \code{obs}
}
\references{
\cite{Pool, S.; Vis, M.; Seibert, J. (2018). Evaluating model performance: towards a non-parametric variant of the Kling-Gupta efficiency. Hydrological Sciences Journal, 63(13-14), pp.1941-1953. doi:/10.1080/02626667.2018.1552002.}

\cite{Garcia, F.; Folton, N.; Oudin, L. (2017). Which objective function to calibrate rainfall-runoff models for low-flow index simulations?. Hydrological sciences journal, 62(7), 1149-1166. doi:10.1080/02626667.2017.1308511.}

\cite{Gupta, H. V.; Kling, H.; Yilmaz, K. K.; Martinez, G. F. (2009). Decomposition of the mean squared error and NSE performance criteria: Implications for improving hydrological modelling. Journal of hydrology, 377(1-2), 80-91. doi:10.1016/j.jhydrol.2009.08.003. ISSN 0022-1694.}

\cite{Kling, H.; Fuchs, M.; Paulin, M. (2012). Runoff conditions in the upper Danube basin under an ensemble of climate change scenarios. Journal of Hydrology, 424, 264-277, doi:10.1016/j.jhydrol.2012.01.011.}

\cite{Santos, L.; Thirel, G.; Perrin, C. (2018). Pitfalls in using log-transformed flows within the KGE criterion. doi:10.5194/hess-22-4583-2018.}

\cite{Knoben, W.J.; Freer, J.E.; Woods, R.A. (2019). Inherent benchmark or not? Comparing Nash-Sutcliffe and Kling-Gupta efficiency scores. Hydrology and Earth System Sciences, 23(10), 4323-4331. doi:10.5194/hess-23-4323-2019.}
}
\author{
Mauricio Zambrano-Bigiarini <mzb.devel@gmail.com>
}
\note{
\code{obs} and \code{sim} has to have the same length/dimension \cr

The missing values in \code{obs} and \code{sim} are removed before the computation proceeds, and only those positions with non-missing values in \code{obs} and \code{sim} are considered in the computation
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{KGE}}, \code{\link{KGElf}}, \code{\link{sKGE}}, \code{\link{gof}}, \code{\link{ggof}}
}
\examples{
# Example1: basic ideal case
obs <- 1:10
sim <- 1:10
KGEnp(sim, obs)

obs <- 1:10
sim <- 2:11
KGEnp(sim, obs)

##################
# Example2: Looking at the difference between 'method=2009' and 'method=2012'
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Simulated daily time series, initially equal to twice the observed values
sim <- 2*obs 

# KGE 2009
KGE(sim=sim, obs=obs, method="2009", out.type="full")

# KGE 2012
KGE(sim=sim, obs=obs, method="2012", out.type="full")

# KGEnp (Pool et al., 2018):
KGEnp(sim=sim, obs=obs)

##################
# Example3: KGEnp for simulated values equal to observations plus random noise 
#           on the first half of the observed values
# Randomly changing the first 1826 elements of 'sim', by using a normal distribution 
# with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim <- obs 
sim[1:1826] <- obs[1:1826] + rnorm(1826, mean=10)

# Computing the new 'KGEnp'
KGEnp(sim=sim, obs=obs)

# Randomly changing the first 2000 elements of 'sim', by using a normal distribution 
# with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim[1:2000] <- obs[1:2000] + rnorm(2000, mean=10)

# Computing the new 'KGEnp'
KGEnp(sim=sim, obs=obs)

##################
# Example 4: KGEnp for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' during computations.

KGEnp(sim=sim, obs=obs, fun=log)

# Verifying the previous value:
lsim <- log(sim)
lobs <- log(obs)
KGEnp(sim=lsim, obs=lobs)

##################
# Example 5: KGEnp for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding the Pushpalatha2012 constant
#            during computations

KGEnp(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012")

# Verifying the previous value, with the epsilon value following Pushpalatha2012
eps  <- mean(obs, na.rm=TRUE)/100
lsim <- log(sim+eps)
lobs <- log(obs+eps)
KGEnp(sim=lsim, obs=lobs)

##################
# Example 6: KGEnp for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding a user-defined constant
#            during computations

eps <- 0.01
KGEnp(sim=sim, obs=obs, fun=log, epsilon.type="otherValue", epsilon.value=eps)

# Verifying the previous value:
lsim <- log(sim+eps)
lobs <- log(obs+eps)
KGEnp(sim=lsim, obs=lobs)

##################
# Example 7: KGEnp for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and using a user-defined factor
#            to multiply the mean of the observed values to obtain the constant
#            to be added to 'sim' and 'obs' during computations

fact <- 1/50
KGEnp(sim=sim, obs=obs, fun=log, epsilon.type="otherFactor", epsilon.value=fact)

# Verifying the previous value:
eps  <- fact*mean(obs, na.rm=TRUE)
lsim <- log(sim+eps)
lobs <- log(obs+eps)
KGEnp(sim=lsim, obs=lobs)

##################
# Example 8: KGEnp for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying a 
#            user-defined function to 'sim' and 'obs' during computations

fun1 <- function(x) {sqrt(x+1)}

KGEnp(sim=sim, obs=obs, fun=fun1)

# Verifying the previous value, with the epsilon value following Pushpalatha2012
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
KGEnp(sim=sim1, obs=obs1)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

%% File wsNSE.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2024-2026 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or late

\name{wsNSE}
\Rdversion{1.1}
\alias{wsNSE}
\alias{wsNSE.default}
\alias{wsNSE.matrix}
\alias{wsNSE.data.frame}
\alias{wsNSE.zoo}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Weighted seasonal Nash-Sutcliffe Efficiency
}
\description{
Weighted seasonal Nash-Sutcliffe Efficiency between \code{sim} and \code{obs}, with treatment of missing values.  

This function is designed to identify differences in high or low values, depending on the user-defined value given to the \code{lambda} argument. See Usage and Details.
}
\usage{
wsNSE(sim, obs, ...)

\method{wsNSE}{default}(sim, obs, na.rm=TRUE, 
              j=2, lambda=0.95, lQ.thr=0.6, hQ.thr=0.1, fun=NULL, ..., 
              epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
              epsilon.value=NA)

\method{wsNSE}{data.frame}(sim, obs, na.rm=TRUE, 
              j=2, lambda=0.95, lQ.thr=0.6, hQ.thr=0.1, fun=NULL, ..., 
              epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
              epsilon.value=NA)

\method{wsNSE}{matrix}(sim, obs, na.rm=TRUE, 
              j=2, lambda=0.95, lQ.thr=0.6, hQ.thr=0.1, fun=NULL, ..., 
              epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
              epsilon.value=NA)
             
\method{wsNSE}{zoo}(sim, obs, na.rm=TRUE, 
              j=2, lambda=0.95, lQ.thr=0.6, hQ.thr=0.1, fun=NULL, ..., 
              epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
              epsilon.value=NA)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sim}{
numeric, zoo, matrix or data.frame with simulated values
}
  \item{obs}{
numeric, zoo, matrix or data.frame with observed values
}
  \item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
When an 'NA' value is found at the i-th position in \code{obs} \bold{OR} \code{sim}, the i-th value of \code{obs} \bold{AND} \code{sim} are removed before the computation.
}
  \item{j}{
numeric, representing an arbitrary value used to power the differences between observations and simulations. By default \code{j=2}, which mimics the traditional Nash-Sutcliffe function, mainly focused on thr representation of high values. For low flows, suggested values for \code{j} are 1, 1/2 or 1/3. See Legates and McCabe, (1999) and Krausse et al. (2005) for a discussion of suggested values of \code{j}. 
}
  \item{lambda}{
numeric in [0, 1] representing the weight given to the high observed values. The closer the \code{lambda=1} value is to 1, the higher the weight given to high values. On the contrary, the closer the \code{lambda=1} value is to 0, the higher the weight given to low values.

Low values get a weight equal to \code{1-lambda}. Between high and low values there is a linear transition from \code{lambda} to \code{1-lambda}, respectively.

Suggested values for lambda are \code{lambda=0.95} when focusing in high (streamflow) values and \code{lambda=0.05} when focusing in low (streamflow) values.
}
  \item{lQ.thr}{
numeric, representing the non-exceedence probabiliy used to identify low flows in \code{obs}. All values in \code{obs} that are equal or lower than \code{quantile(obs, probs=(1-lQ.thr))} are considered as low values. By default \code{lQ.thr=0.6}. 

On the other hand, the low values in \code{sim} are those located at the same i-th position than the i-th value of the \code{obs} deemed as low flows.  
}
  \item{hQ.thr}{
numeric, representing the non-exceedence probabiliy used to identify high flows in \code{obs}. All values in \code{obs} that are equal or higher than \code{quantile(obs, probs=(1-hQ.thr))} are considered as high flows. By default \code{hQ.thr=0.1}. 

On the other hand, the high values in \code{sim} are those located at the same i-th position than the i-th value of the \code{obs} deemed as high flows.  
}
  \item{fun}{
function to be applied to \code{sim} and \code{obs} in order to obtain transformed values thereof before computing this goodness-of-fit index.

The first argument MUST BE a numeric vector with any name (e.g., \code{x}), and additional arguments are passed using \code{\dots}.
}
  \item{\dots}{
arguments passed to \code{fun}, in addition to the mandatory first numeric vector.
}
  \item{epsilon.type}{
argument used to define a numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. 

It is was  designed to allow the use of logarithm and other similar functions that do not work with zero values.

Valid values of \code{epsilon.type} are:

1) \kbd{"none"}: \code{sim} and \code{obs} are used by \code{fun} without the addition of any numeric value. This is the default option.

2) \kbd{"Pushpalatha2012"}: one hundredth (1/100) of the mean observed values is added to both \code{sim} and \code{obs} before applying \code{fun}, as described in Pushpalatha et al. (2012). 

3) \kbd{"otherFactor"}: the numeric value defined in the \code{epsilon.value} argument is used to multiply the the mean observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs}, before applying \code{fun}.

4) \kbd{"otherValue"}: the numeric value defined in the \code{epsilon.value} argument is directly added to both \code{sim} and \code{obs}, before applying \code{fun}.
}
  \item{epsilon.value}{
 -) when \code{epsilon.type="otherValue"} it represents the numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. \cr
 -) when \code{epsilon.type="otherFactor"} it represents the numeric factor used to multiply the mean of the observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs} before applying \code{fun}.
}
}
\details{
The weighted seasonal Nash-Sutcliffe Efficiency was proposed by Zambrano-Bigiarini and Bellin (2012), inspired by the classical Nash-Sutcliffe efficiency (NSE, Nash and Sutcliffe, 1970), but designed to give more emphasis to either high or low observed values.

In the implemented formulation, the low- and high-flow thresholds are obtained from the observed series as:

\deqn{lQ = Q_{obs}(1-lQ.thr)}
\deqn{hQ = Q_{obs}(1-hQ.thr)}

where \eqn{Q_{obs}(p)} is the empirical quantile of \code{obs} at probability \eqn{p}. A weight \eqn{w_i} is then assigned to each observed value \eqn{obs_i} according to the following piecewise-linear function:

\deqn{
w_i =
\left\{
\begin{array}{ll}
\lambda, & obs_i \ge hQ \cr
1-\lambda, & obs_i \le lQ \cr
(1-\lambda) + (2\lambda - 1)\frac{obs_i - lQ}{hQ - lQ}, & lQ < obs_i < hQ
\end{array}
\right.
}

Hence, \code{lambda} controls the emphasis of the metric:
\itemize{
\item when \code{lambda > 0.5}, high observed values receive larger weights than low values;
\item when \code{lambda < 0.5}, low observed values receive larger weights than high values;
\item when \code{lambda = 0.5}, all values receive the same weight and the weighting becomes uniform.
}

Using these weights, \code{wsNSE} is computed as:

\deqn{
wsNSE = 1 - \frac{\sum_{i=1}^{n} \left| w_i (obs_i - sim_i) \right|^j}
                 {\sum_{i=1}^{n} \left| w_i (obs_i - \overline{obs}) \right|^j}
}

where \eqn{\overline{obs}} is the arithmetic mean of the observed series after removing missing pairs, and \eqn{j} is the user-defined exponent. Therefore, the numerator is a weighted error term and the denominator is the corresponding weighted dispersion of \code{obs} around its mean. This is the exact mathematical formulation implemented in \code{wsNSE.R}.

Following the traditional NSE, \code{wsNSE} ranges from \eqn{-\infty} to 1, with an optimal value of 1. Larger values indicate smaller weighted discrepancies between \code{sim} and \code{obs}.
}
\value{
numeric with the the weighted seasonal Nash-Sutcliffe Efficiency (wsNSE) between \code{sim} and \code{obs}. If \code{sim} and \code{obs} are matrices, the output value is a vector, with the the weighted seasonal Nash-Sutcliffe Efficiency (wsNSE) between each column of \code{sim} and \code{obs}.
}
\references{
\cite{Zambrano-Bigiarini, M.; Bellin, A. (2012). Comparing goodness-of-fit measures for calibration of models focused on extreme events. EGU General Assembly 2012, Vienna, Austria, 22-27 Apr 2012, EGU2012-11549-1.}

\cite{Nash, J.E.; J.V. Sutcliffe. (1970). River flow forecasting through conceptual models. Part 1: a discussion of principles, Journal of Hydrology 10, pp. 282-290. doi:10.1016/0022-1694(70)90255-6.}

\cite{Schaefli, B.; Gupta, H. (2007). Do Nash values have value?. Hydrological Processes 21, 2075-2080. doi:10.1002/hyp.6825.}

\cite{Criss, R. E.; Winston, W. E. (2008), Do Nash values have value?. Discussion and alternate proposals. Hydrological Processes, 22: 2723-2725. doi:10.1002/hyp.7072.}

\cite{Yilmaz, K. K.; Gupta, H. V.; Wagener, T. (2008), A process-based diagnostic approach to model evaluation: Application to the NWS distributed hydrologic model, Water Resources Research, 44, W09417, doi:10.1029/2007WR006716.}

\cite{Krause, P.; Boyle, D.P.; Base, F. (2005). Comparison of different efficiency criteria for hydrological model assessment, Advances in Geosciences, 5, 89-97. doi:10.5194/adgeo-5-89-2005.} \cr

\cite{Legates, D.R.; McCabe, G. J. Jr. (1999), Evaluating the Use of "Goodness-of-Fit" Measures in Hydrologic and Hydroclimatic Model Validation, Water Resour. Res., 35(1), 233-241. doi:10.1029/1998WR900018.} 
}
\author{
Mauricio Zambrano-Bigiarini <mzb.devel@gmail.com>
}
\note{
\code{obs} and \code{sim} has to have the same length/dimension \cr

The missing values in \code{obs} and \code{sim} are removed before the computation proceeds, and only those positions with non-missing values in \code{obs} and \code{sim} are considered in the computation
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{NSE}}, \code{\link{wNSE}}, \code{\link{wsNSE}}, \code{\link{APFB}}, \code{\link{KGElf}}, \code{\link{gof}}, \code{\link{ggof}}
}
\examples{
##################
# Example 1: Looking at the difference between 'KGE', 'NSE', 'wNSE', 'wsNSE',
# 'APFB' and 'KGElf' for detecting differences in high flows

# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Simulated daily time series, created equal to the observed values and then 
# random noise is added only to high flows, i.e., those equal or higher than 
# the quantile 0.9 of the observed values.
sim      <- obs
hQ.thr   <- quantile(obs, probs=0.9, na.rm=TRUE)
hQ.index <- which(obs >= hQ.thr)
hQ.n     <- length(hQ.index)
sim[hQ.index] <- sim[hQ.index] + rnorm(hQ.n, mean=mean(sim[hQ.index], na.rm=TRUE))

# Traditional Kling-Gupta eficiency (Gupta and Kling, 2009)
KGE(sim=sim, obs=obs)

# Traditional Nash-Sutcliffe eficiency (Nash and Sutcliffe, 1970)
NSE(sim=sim, obs=obs)

# Weighted Nash-Sutcliffe efficiency (Hundecha and Bardossy, 2004)
wNSE(sim=sim, obs=obs)

# wsNSE (Zambrano-Bigiarini and Bellin, 2012):
wsNSE(sim=sim, obs=obs)

# APFB (Mizukami et al., 2019):
APFB(sim=sim, obs=obs)


##################
# Example 2: Looking at the difference between 'KGE', 'NSE', 'wsNSE',
# 'dr', 'rd', 'md', 'APFB' and 'KGElf' for detecting differences in low flows

# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Simulated daily time series, created equal to the observed values and then 
# random noise is added only to low flows, i.e., those equal or lower than 
# the quantile 0.4 of the observed values.
sim      <- obs
lQ.thr   <- quantile(obs, probs=0.4, na.rm=TRUE)
lQ.index <- which(obs <= lQ.thr)
lQ.n     <- length(lQ.index)
sim[lQ.index] <- sim[lQ.index] + rnorm(lQ.n, mean=mean(sim[lQ.index], na.rm=TRUE))

# Traditional Kling-Gupta eficiency (Gupta and Kling, 2009)
KGE(sim=sim, obs=obs)

# Traditional Nash-Sutcliffe eficiency (Nash and Sutcliffe, 1970)
NSE(sim=sim, obs=obs)

# Weighted seasonal Nash-Sutcliffe efficiency (Zambrano-Bigiarini and Bellin, 2012):
wsNSE(sim=sim, obs=obs, lambda=0.05, j=1/2)

# Refined Index of Agreement (Willmott et al., 2012):
dr(sim=sim, obs=obs)

# Relative Index of Agreement (Krause et al., 2005):
rd(sim=sim, obs=obs)

# Modified Index of Agreement (Krause et al., 2005):
md(sim=sim, obs=obs)

# KGElf (Garcia et al., 2017):
KGElf(sim=sim, obs=obs)


##################
# Example 3: 
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Generating a simulated daily time series, initially equal to the observed series
sim <- obs 

# Computing the 'wsNSE' for the "best" (unattainable) case
wsNSE(sim=sim, obs=obs)


##################
# Example 4: wsNSE for simulated values created equal to the observed values and then 
#            random noise is added only to high flows, i.e., those equal or higher than 
#            the quantile 0.9 of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' during computations.

wsNSE(sim=sim, obs=obs, fun=log)

# Verifying the previous value:
lsim <- log(sim)
lobs <- log(obs)
wsNSE(sim=lsim, obs=lobs)


##################
# Example 5: wsNSE for simulated values created equal to the observed values and then 
#            random noise is added only to high flows, i.e., those equal or higher than 
#            the quantile 0.9 of the observed values and applying a 
#            user-defined function to 'sim' and 'obs' during computations

fun1 <- function(x) {sqrt(x+1)}

wsNSE(sim=sim, obs=obs, fun=fun1)

# Verifying the previous value, with the epsilon value following Pushpalatha2012
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
wsNSE(sim=sim1, obs=obs1)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

%% File R2.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2008-2024 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{R2}
\Rdversion{1.1}
\alias{R2}
\alias{R2.default}
\alias{R2.matrix}
\alias{R2.data.frame}
\alias{R2.zoo}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Coefficient of determination
}
\description{
coefficient of determination between \code{sim} and \code{obs}, with treatment of missing values.
}
\usage{
R2(sim, obs, ...)

\method{R2}{default}(sim, obs, fun=NULL, ..., 
            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
            epsilon.value=NA)

\method{R2}{matrix}(sim, obs, na.rm=TRUE, fun=NULL, ..., 
            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
            epsilon.value=NA)

\method{R2}{data.frame}(sim, obs, na.rm=TRUE, fun=NULL, ..., 
            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
            epsilon.value=NA)

\method{R2}{zoo}(sim, obs, na.rm=TRUE, fun=NULL, ..., 
            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
           epsilon.value=NA)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sim}{
numeric, zoo, matrix or data.frame with simulated values
}
  \item{obs}{
numeric, zoo, matrix or data.frame with observed values
}
  \item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
When an 'NA' value is found at the i-th position in \code{obs} \bold{OR} \code{sim}, the i-th value of \code{obs} \bold{AND} \code{sim} are removed before the computation.
}

  \item{fun}{
function to be applied to \code{sim} and \code{obs} in order to obtain transformed values thereof before computing this goodness-of-fit index.

The first argument MUST BE a numeric vector with any name (e.g., \code{x}), and additional arguments are passed using \code{\dots}.
}
  \item{\dots}{
arguments passed to \code{fun}, in addition to the mandatory first numeric vector.
}
  \item{epsilon.type}{
argument used to define a numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. 

It is was  designed to allow the use of logarithm and other similar functions that do not work with zero values.

Valid values of \code{epsilon.type} are:

1) \kbd{"none"}: \code{sim} and \code{obs} are used by \code{fun} without the addition of any numeric value. This is the default option.

2) \kbd{"Pushpalatha2012"}: one hundredth (1/100) of the mean observed values is added to both \code{sim} and \code{obs} before applying \code{fun}, as described in Pushpalatha et al. (2012). 

3) \kbd{"otherFactor"}: the numeric value defined in the \code{epsilon.value} argument is used to multiply the the mean observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs}, before applying \code{fun}.

4) \kbd{"otherValue"}: the numeric value defined in the \code{epsilon.value} argument is directly added to both \code{sim} and \code{obs}, before applying \code{fun}.
}
  \item{epsilon.value}{
numeric value to be added to both \code{sim} and \code{obs} when \code{epsilon.type="otherValue"}.
}
}
\details{
The coefficient of determination (R2) is the proportion of the variation in the dependent variable that is predictable from the independent variable(s).

It is a statistic used in the context of statistical models whose main purpose is either the prediction of future outcomes or the testing of hypotheses, on the basis of other related information. It provides a measure of how well observed outcomes are replicated by the model, based on the proportion of total variation of outcomes explained by the model.

The coefficient of determination is a statistical measure of how well the regression predictions approximate the real data points. An R2 of 1 indicates that the regression predictions perfectly fit the data.

Values of R2 outside the range 0 to 1 occur when the model fits the data worse than the worst possible least-squares predictor (equivalent to a horizontal hyperplane at a height equal to the mean of the observed data). This occurs when a wrong model was chosen, or nonsensical constraints were applied by mistake.
}
\value{
Coefficient of determination between \code{sim} and \code{obs}. \cr

If \code{sim} and \code{obs} are matrixes, the returned value is a vector, with the coefficient of determination between each column of \code{sim} and \code{obs}.
}
\references{
\url{https://en.wikipedia.org/wiki/Coefficient_of_determination}

\cite{Box, G.E. (1966). Use and abuse of regression. Technometrics, 8(4), 625-629. doi:10.1080/00401706.1966.10490407.}

\cite{Hahn, G.J. (1973). The coefficient of determination exposed. Chemtech, 3(10), 609-612. Aailable online at: \url{https://www2.hawaii.edu/~cbaajwe/Ph.D.Seminar/Hahn1973.pdf}.}

\cite{Barrett, J.P. (1974). The coefficient of determination-some limitations. The American Statistician, 28(1), 19-20. doi:10.1080/00031305.1974.10479056.}
}
\author{
Mauricio Zambrano Bigiarini <mzb.devel@gmail.com>
}
\note{
\code{obs} and \code{sim} has to have the same length/dimension \cr

The missing values in \code{obs} and \code{sim} are removed before the computation proceeds, and only those positions with non-missing values in \code{obs} and \code{sim} are considered in the computation \cr
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link[stats]{cor}}
}
\examples{
##################
# Example 1: basic ideal case
obs <- 1:10
sim <- 1:10
R2(sim, obs)

obs <- 1:10
sim <- 2:11
R2(sim, obs)

##################
# Example 2: 
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Generating a simulated daily time series, initially equal to the observed series
sim <- obs 

# Computing the 'R2' for the "best" (unattainable) case
R2(sim=sim, obs=obs)

##################
# Example 3: R2 for simulated values equal to observations plus random noise 
#            on the first half of the observed values. 
#            This random noise has more relative importance for ow flows than 
#            for medium and high flows.
  
# Randomly changing the first 1826 elements of 'sim', by using a normal distribution 
# with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim[1:1826] <- obs[1:1826] + rnorm(1826, mean=10)
ggof(sim, obs)

R2(sim=sim, obs=obs)

##################
# Example 4: R2 for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' during computations.

R2(sim=sim, obs=obs, fun=log)

# Verifying the previous value:
lsim <- log(sim)
lobs <- log(obs)
R2(sim=lsim, obs=lobs)

##################
# Example 5: R2 for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding the Pushpalatha2012 constant
#            during computations

R2(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012")

# Verifying the previous value, with the epsilon value following Pushpalatha2012
eps  <- mean(obs, na.rm=TRUE)/100
lsim <- log(sim+eps)
lobs <- log(obs+eps)
R2(sim=lsim, obs=lobs)

##################
# Example 6: R2 for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding a user-defined constant
#            during computations

eps <- 0.01
R2(sim=sim, obs=obs, fun=log, epsilon.type="otherValue", epsilon.value=eps)

# Verifying the previous value:
lsim <- log(sim+eps)
lobs <- log(obs+eps)
R2(sim=lsim, obs=lobs)

##################
# Example 7: R2 for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and using a user-defined factor
#            to multiply the mean of the observed values to obtain the constant
#            to be added to 'sim' and 'obs' during computations

fact <- 1/50
R2(sim=sim, obs=obs, fun=log, epsilon.type="otherFactor", epsilon.value=fact)

# Verifying the previous value:
eps  <- fact*mean(obs, na.rm=TRUE)
lsim <- log(sim+eps)
lobs <- log(obs+eps)
R2(sim=lsim, obs=lobs)

##################
# Example 8: R2 for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying a 
#            user-defined function to 'sim' and 'obs' during computations

fun1 <- function(x) {sqrt(x+1)}

R2(sim=sim, obs=obs, fun=fun1)

# Verifying the previous value, with the epsilon value following Pushpalatha2012
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
R2(sim=sim1, obs=obs1)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

%% File pfactor.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2008-2026 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{pfactor}
\Rdversion{1.1}
\alias{pfactor}
\alias{pfactor.default}
\alias{pfactor.matrix}
\alias{pfactor.data.frame}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
P-factor
}
\description{
\var{P-factor} is the percent of observations that are within the given uncertainty bounds. \cr

Ideally, i.e., with a combination of model structure and parameter values that perfectly represents the catchment under study, and in absence of measurement errors and other additional sources of uncertainty, all the simulated values should be in a perfect match with the observations, leading to a \var{P-factor} equal to 1, and an \var{R-factor} equal to zero. However, in real-world applications we aim at encompassing as much observations as possible within the given uncertainty bounds (\var{P-factor} close to 1) while keeping the width of the uncertainty bounds as small as possible (\var{R-factor} close to 0), in order to avoid obtaining a good bracketing of observations at expense of uncertainty bounds too wide to be informative for the decision-making process.
}
\usage{
pfactor(x, ...)

\method{pfactor}{default}(x, lband, uband, na.rm=TRUE, ...)

\method{pfactor}{data.frame}(x, lband, uband, na.rm=TRUE, ...)

\method{pfactor}{matrix}(x, lband, uband, na.rm=TRUE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
ts or zoo object with the observed values.
}
  \item{lband}{
numeric, ts or zoo object with the values of the lower uncertainty bound
}
  \item{uband}{
numeric, ts or zoo object with the values of the upper uncertainty bound
}
  \item{na.rm}{
a logical value indicating whether 'NA' values should be stripped before the computation proceeds.
}
  \item{\dots}{
further arguments passed to or from other methods.
}
}
\details{

The \var{P-factor} quantifies the percentage of observed values that fall within the prediction uncertainty band defined by the lower and upper bounds. It is a measure of the coverage of the uncertainty interval.

Mathematically, the P-factor is defined as:

\deqn{
  P\text{-factor} = \frac{1}{N} \sum_{i=1}^{N} I \left( lband_i \le x_i \le uband_i \right)
}

where \eqn{N} is the total number of observations, \eqn{x_i} is the observed value at time step \eqn{i}, and \eqn{lband_i} and \eqn{uband_i} are the lower and upper uncertainty bounds, respectively. The function \eqn{I(\cdot)} is an indicator function that takes the value 1 when the observed value lies within the uncertainty bounds and 0 otherwise.

The \var{P-factor} ranges from 0 to 1. A value of 1 indicates that all observations are bracketed by the uncertainty bounds, whereas a value of 0 indicates that none of the observations fall within the bounds.
}
\value{
Percent of the \code{x} observations that are within the given uncertainty bounds given by \code{lband} and \code{uband}. \cr

If \code{x}, \code{lband}, and \code{uband} are matrices, the returned value is a vector with the \var{P-factor} computed for each column.
}
\references{
\cite{Abbaspour, K.C.; Faramarzi, M.; Ghasemi, S.S.; Yang, H. (2009), Assessing the impact of climate change on water resources in Iran, Water Resources Research, 45(10), W10,434, doi:10.1029/2008WR007615.}

\cite{Abbaspour, K.C., Yang, J. ; Maximov, I.; Siber, R.; Bogner, K.; Mieleitner, J. ; Zobrist, J.; Srinivasan, R. (2007), Modelling hydrology and water quality in the pre-alpine/alpine Thur watershed using SWAT, Journal of Hydrology, 333(2-4), 413-430, doi:10.1016/j.jhydrol.2006.09.014.}

\cite{Schuol, J.; Abbaspour, K.C.; Srinivasan, R.; Yang, H. (2008b), Estimation of freshwater availability in the West African sub-continent using the SWAT hydrologic model, Journal of Hydrology, 352(1-2), 30, doi:10.1016/j.jhydrol.2007.12.025}

\cite{Abbaspour, K.C. (2007), User manual for SWAT-CUP, SWAT calibration and uncertainty analysis programs, 93pp, Eawag: Swiss Fed. Inst. of Aquat. Sci. and Technol. Dubendorf, Switzerland.}
}
\author{
Mauricio Zambrano Bigiarini <mzb.devel@gmail.com>
}
\note{
So far, the argument \code{na.rm} is not being taken into account.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{rfactor}}, \code{\link{plotbands}}
}
\examples{
x <- 1:10
lband <- x - 0.1
uband <- x + 0.1
pfactor(x, lband, uband)

lband <- x - rnorm(10)
uband <- x + rnorm(10)
pfactor(x, lband, uband)

#############
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Selecting only the daily values belonging to the year 1961
obs <- window(obs, end=as.Date("1961-12-31"))

# Generating the lower and upper uncertainty bounds, centred at the observations
lband <- obs - 5
uband <- obs + 5

pfactor(obs, lband, uband)

# Randomly generating the lower and upper uncertainty bounds
uband <- obs + rnorm(length(obs))
lband <- obs - rnorm(length(obs))

pfactor(obs, lband, uband)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

%% File plot2.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2008-2024 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{plot2}
\Rdversion{1.1}
\alias{plot2}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Plotting 2 Time Series
}
\description{
Plotting of 2 time series, in two different vertical windows or overlapped in the same window. \cr
It requires the \pkg{hydroTSM} package.
}
\usage{
plot2(x, y, plot.type = "multiple", 
      tick.tstep = "auto", lab.tstep = "auto", lab.fmt=NULL,
      main, xlab = "Time", ylab,
      cal.ini=NA, val.ini=NA, date.fmt="\%Y-\%m-\%d",
      gof.leg = FALSE, gof.digits=2, 
      gofs=c( "ME",  "MAE",  "RMSE", "NRMSE", "PBIAS", "NSE",   "d",    
             "dr",    "r",    "R2",   "KGE",  "LCE", "JDKGE", "VE"),
      legend, leg.cex = 1,
      col = c("black", "blue"),
      cex = c(0.5, 0.5), cex.axis=1.2, cex.lab=1.2, 
      lwd= c(1,1), lty=c(1,3), pch = c(1, 9), 
      pt.style = "ts", add = FALSE, 
      ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
time series that will be plotted. class(x) must be ts or zoo. If \code{leg.gof=TRUE}, then \code{x} is considered as \bold{simulated} (for some goodness-of-fit functions this is important)
}
  \item{y}{
time series that will be plotted. class(x) must be ts or zoo. If \code{leg.gof=TRUE}, then \code{y} is considered as \bold{observed} values (for some goodness-of-fit functions this is important)
}
  \item{plot.type}{
character, indicating if the 2 ts have to be plotted in the same window or in two different vertical ones. Valid values are: \cr
-) \kbd{single}  : (default) superimposes the 2 ts on a single plot \cr
-) \kbd{multiple}: plots the 2 series on 2 multiple vertical plots 
}
  \item{tick.tstep}{
character, indicating the time step that have to be used for putting the ticks on the time axis. Valid values are: \kbd{auto}, \kbd{years}, \kbd{months},\kbd{weeks}, \kbd{days}, \kbd{hours}, \kbd{minutes}, \kbd{seconds}.
}
  \item{lab.tstep}{
character, indicating the time step that have to be used for putting the labels on the time axis. Valid values are: \kbd{auto}, \kbd{years}, \kbd{months},\kbd{weeks}, \kbd{days}, \kbd{hours}, \kbd{minutes}, \kbd{seconds}.
}
  \item{lab.fmt}{
Character indicating the format to be used for the label of the axis. See \code{lab.fmt} in \code{\link[hydroTSM]{drawTimeAxis}}.
}
  \item{main}{
an overall title for the plot: see \code{\link[graphics]{title}}
}
  \item{xlab}{
label for the 'x' axis
}
  \item{ylab}{
label for the 'y' axis 
}
 \item{cal.ini}{
OPTIONAL. Character, indicating the date in which the calibration period started. \cr
When \code{cal.ini} is provided, all the values in \code{obs} and \code{sim} with dates previous to \code{cal.ini} are SKIPPED from the computation of the goodness-of-fit measures (when \code{gof.leg=TRUE}), but their values are still plotted, in order to examine if the warming up period was too short, acceptable or too long for the chosen calibration period.
In addition, a vertical red line in drawn at this date. 
}
  \item{val.ini}{
OPTIONAL. Character with the date in which the validation period started. \cr
ONLY used for drawing a vertical red line at this date. 
}
  \item{date.fmt}{
OPTIONAL. Character indicating the format in which the dates entered are stored in \code{cal.ini} and \code{val.ini}. Default value is \kbd{\%Y-\%m-\%d}. ONLY required when \code{cal.ini} or \code{val.ini} is provided.
}
  \item{gof.leg}{
logical, indicating if several numerical goodness-of-fit values have to be computed between \code{sim} and \code{obs}, and plotted as a legend on the graph. If \code{gof.leg=TRUE} (default value), then \code{x} is considered as observed and \code{y} as simulated values (for some gof functions this is important). This legend is ONLY plotted when \code{plot.type="single"}
}
  \item{gof.digits}{
OPTIONAL, only used when \code{gof.leg=TRUE}. Decimal places used for rounding the goodness-of-fit indexes.
}
  \item{gofs}{
character, with one or more strings indicating the goodness-of-fit measures to be shown in the legend of the plot when  \code{gof.leg=TRUE}. \cr
Possible values are in \code{c("ME", "MAE", "MSE", "RMSE", "NRMSE", "PBIAS", "RSR", "rSD", "NSE", "mNSE", "rNSE", "d", "md", "rd", "cp", "r", "R2", "bR2", "KGE", "VE")}.
}
  \item{legend}{
vector of length 2 to appear in the legend.  
}
  \item{leg.cex}{
numeric, indicating the character expansion factor *relative* to current 'par("cex")'. Used for text, and provides the default for 'pt.cex' and 'title.cex'. Default value = 1 \cr
So far, it controls the expansion factor of the 'GoF' legend and the legend referring to \code{x} and \code{y}
}
  \item{col}{
character, with the colors of \code{x} and \code{y}
}
  \item{cex}{
numeric, with the values controlling the size of text and symbols of \code{x} and \code{y} with respect to the default
}
  \item{cex.axis}{
numeric, with the magnification of axis annotation relative to 'cex'. See \code{\link[graphics]{par}}.
}
  \item{cex.lab}{
numeric, with the magnification to be used for x and y labels relative to the current setting of 'cex'. See \code{\link[graphics]{par}}.
}
  \item{lwd}{
vector with the line width of \code{x} and \code{y}
}
  \item{lty}{
vector with the line type of \code{x} and \code{y}
}
  \item{pch}{
vector with the type of symbol for \code{x} and \code{y}. (e.g.: 1: white circle; 9: white rhombus with a cross inside)
}
  \item{pt.style}{
Character, indicating if the 2 ts have to be plotted as lines or bars. Valid values are: \cr
-) \kbd{ts} : (default) each ts is plotted as a lines along the \code{x} axis \cr
-) \kbd{bar}: the 2 series are plotted as a barplot. 
}
  \item{add}{
logical indicating if other plots will be added in further calls to this function. \cr
-) \kbd{FALSE} => the plot and the legend are plotted on the same graph \cr
-) \kbd{TRUE}  => the legend is plotted in a new graph, usually when called from another function (e.g.: \code{\link{ggof}})
}
  \item{\dots}{
further arguments passed to \code{\link[zoo]{plot.zoo}} function for plotting \code{x}, or from other methods
}
}
%%\details{
%%  ~~ If necessary, more details than the description above ~~
%%}
%%\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
%%}
%%\references{
%% ~put references to the literature/web site here ~
%%}
\author{
Mauricio Zambrano Bigiarini <mzb.devel@gmail.com>
}
\note{
It requires the package \pkg{hydroTSM}.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{ggof}}, \code{\link[hydroTSM]{plot_pq}}
}
\examples{
sim <- 2:11
obs <- 1:10
\dontrun{
plot2(sim, obs)
}

##################
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Generating a simulated daily time series, initially equal to the observed series
sim <- obs 

# Randomly changing the first 2000 elements of 'sim', by using a normal distribution 
# with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim[1:2000] <- obs[1:2000] + rnorm(2000, mean=10)

# Plotting 'sim' and 'obs' in 2 separate panels
plot2(x=obs, y=sim)

# Plotting 'sim' and 'obs' in the same window
plot2(x=obs, y=sim, plot.type="single")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ dplot }

%% File sKGE.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2017-2022 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or late

\name{sKGE}
\Rdversion{1.1}
\alias{sKGE}
\alias{sKGE.default}
\alias{sKGE.matrix}
\alias{sKGE.data.frame}
\alias{sKGE.zoo}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Split Kling-Gupta Efficiency
}
\description{
Split Kling-Gupta efficiency between \code{sim} and \code{obs}.

This goodness-of-fit measure was developed by Fowler et al. (2018), as a modification to the original Kling-Gupta efficiency (KGE) proposed by Gupta et al. (2009). See Details.
}
\usage{
sKGE(sim, obs, ...)

\method{sKGE}{default}(sim, obs, s=c(1,1,1), na.rm=TRUE, method=c("2009", "2012", "2021"),
              start.month=1, out.PerYear=FALSE, fun=NULL, ...,
              epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
              epsilon.value=NA)

\method{sKGE}{data.frame}(sim, obs, s=c(1,1,1), na.rm=TRUE, method=c("2009", "2012", "2021"),
              start.month=1, out.PerYear=FALSE, fun=NULL, ...,
              epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
              epsilon.value=NA)

\method{sKGE}{matrix}(sim, obs, s=c(1,1,1), na.rm=TRUE, method=c("2009", "2012", "2021"),
              start.month=1, out.PerYear=FALSE, fun=NULL, ...,
              epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
              epsilon.value=NA)
             
\method{sKGE}{zoo}(sim, obs, s=c(1,1,1), na.rm=TRUE, method=c("2009", "2012", "2021"),
              start.month=1, out.PerYear=FALSE, fun=NULL, ...,
              epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
              epsilon.value=NA)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sim}{
numeric, zoo, matrix or data.frame with simulated values
}
  \item{obs}{
numeric, zoo, matrix or data.frame with observed values
}
  \item{s}{
numeric of length 3, representing the scaling factors to be used for re-scaling the criteria space before computing the Euclidean distance from the ideal point c(1,1,1), i.e., \code{s} elements are used for adjusting the emphasis on different components.
The first elements is used for rescaling the Pearson product-moment correlation coefficient (\code{r}), the second element is used for rescaling \code{Alpha} and the third element is used for re-scaling \code{Beta}
}
  \item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
When an 'NA' value is found at the i-th position in \code{obs} \bold{OR} \code{sim}, the i-th value of \code{obs} \bold{AND} \code{sim} are removed before the computation.
}
  \item{method}{
character, indicating the formula used to compute the variability ratio in the Kling-Gupta efficiency. Valid values are:

-) \kbd{2009}: the variability is defined as \sQuote{Alpha}, the ratio of the standard deviation of \code{sim} values to the standard deviation of \code{obs}. This is the default option. See Gupta et al. (2009).

-) \kbd{2012}: the variability is defined as \sQuote{Gamma}, the ratio of the coefficient of variation of \code{sim} values to the coefficient of variation of \code{obs}. See Kling et al. (2012). 

-) \kbd{2021}: the bias is defined as \sQuote{Beta}, the ratio of \code{mean(sim)} minus \code{mean(obs)} to the standard deviation of \code{obs}. The variability is defined as \sQuote{Alpha}, the ratio of the standard deviation of \code{sim} values to the standard deviation of \code{obs}. See Tang et al. (2021). 
}
  \item{start.month}{
[OPTIONAL]. Only used when the (hydrological) year of interest is different from the calendar year.

numeric in [1:12] indicating the starting month of the (hydrological) year. Numeric values in [1, 12] represent months in [January, December]. By default \code{start.month=1}.
}
  \item{out.PerYear}{
logical, indicating whether the output of this function has to include the Kling-Gupta efficiencies obtained for the individual years in \code{sim} and \code{obs} or not.
}
  \item{fun}{
function to be applied to \code{sim} and \code{obs} in order to obtain transformed values thereof before computing this goodness-of-fit index.

The first argument MUST BE a numeric vector with any name (e.g., \code{x}), and additional arguments are passed using \code{\dots}.
}
  \item{\dots}{
arguments passed to \code{fun}, in addition to the mandatory first numeric vector.
}
  \item{epsilon.type}{
argument used to define a numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. 

It is was  designed to allow the use of logarithm and other similar functions that do not work with zero values.

Valid values of \code{epsilon.type} are:

1) \kbd{"none"}: \code{sim} and \code{obs} are used by \code{fun} without the addition of any numeric value. This is the default option.

2) \kbd{"Pushpalatha2012"}: one hundredth (1/100) of the mean observed values is added to both \code{sim} and \code{obs} before applying \code{fun}, as described in Pushpalatha et al. (2012). 

3) \kbd{"otherFactor"}: the numeric value defined in the \code{epsilon.value} argument is used to multiply the the mean observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs}, before applying \code{fun}.

4) \kbd{"otherValue"}: the numeric value defined in the \code{epsilon.value} argument is directly added to both \code{sim} and \code{obs}, before applying \code{fun}.
}
  \item{epsilon.value}{
 -) when \code{epsilon.type="otherValue"} it represents the numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. \cr
 -) when \code{epsilon.type="otherFactor"} it represents the numeric factor used to multiply the mean of the observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs} before applying \code{fun}.
}
}
\details{

The Split Kling-Gupta Efficiency (sKGE) is computed by dividing the time series into individual years (or hydrological years when \code{start.month != 1}) and calculating the Kling-Gupta Efficiency (KGE) for each year separately. The final sKGE value is defined as the arithmetic mean of the annual KGE values:

\deqn{
sKGE = \frac{1}{N} \sum_{y=1}^{N} KGE_y
}

where \eqn{N} is the number of years in the evaluation period and \eqn{KGE_y} is the Kling-Gupta Efficiency computed using the simulated and observed values belonging to year \eqn{y}.

The Kling-Gupta Efficiency is defined as:

\deqn{
KGE = 1 - \sqrt{(r - 1)^2 + (V - 1)^2 + (B - 1)^2}
}

where \eqn{r} is the linear correlation coefficient between simulated and observed values, \eqn{V} represents the variability component, and \eqn{B} represents the bias component.

The definitions of the variability and bias components depend on the selected \code{method} argument:

\itemize{

\item \bold{method = "2009"} (Gupta et al., 2009)

\deqn{
\alpha = \frac{\sigma_{sim}}{\sigma_{obs}}
}

\deqn{
\beta = \frac{\mu_{sim}}{\mu_{obs}}
}

where the variability component is \eqn{V=\alpha} and the bias component is \eqn{B=\beta}.

\item \bold{method = "2012"} (Kling et al., 2012)

\deqn{
\gamma = \frac{CV_{sim}}{CV_{obs}}
}

\deqn{
\beta = \frac{\mu_{sim}}{\mu_{obs}}
}

where \eqn{CV = \sigma / \mu}, the variability component is \eqn{V=\gamma}, and the bias component is \eqn{B=\beta}.

\item \bold{method = "2021"} (Tang et al., 2021)

\deqn{
\alpha = \frac{\sigma_{sim}}{\sigma_{obs}}
}

\deqn{
\beta = \frac{\mu_{sim} - \mu_{obs}}{\sigma_{obs}}
}

where the variability component is \eqn{V=\alpha} and the bias component is a standardized bias term.

}

The splitting procedure allows model performance to be evaluated at the annual scale, providing a measure that summarizes inter-annual performance while reducing the influence of temporal aggregation over long periods.

When \code{out.PerYear=TRUE}, the individual annual KGE values are also returned.

The optimal value of sKGE is 1. Similar to the traditional Kling-Gupta efficiency, sKGE values can range from \eqn{-\infty} to 1, where values closer to 1 indicate better agreement between simulated and observed values.
}
\value{
If \code{out.PerYear=FALSE}: numeric with the Split Kling-Gupta efficiency between \code{sim} and \code{obs}. If \code{sim} and \code{obs} are matrices, the output value is a vector, with the Split Kling-Gupta efficiency between each column of \code{sim} and \code{obs}

If \code{out.PerYear=TRUE}: a list of two elements:
\item{sKGE.value}{
numeric with the Split Kling-Gupta efficiency. If \code{sim} and \code{obs} are matrices, the output value is a vector, with the Split Kling-Gupta efficiency between each column of \code{sim} and \code{obs}
}
\item{KGE.PerYear}{
numeric with the Kling-Gupta efficincies obtained for the individual years in \code{sim} and \code{obs}.
}
}
\references{
\cite{Fowler, K.; Coxon, G.; Freer, J.; Peel, M.; Wagener, T.; Western, A.; Woods, R.; Zhang, L. (2018). Simulating runoff under changing climatic conditions: A framework for model improvement. Water Resources Research, 54(12), 812-9832. doi:10.1029/2018WR023989.}

\cite{Gupta, H. V.; Kling, H.; Yilmaz, K. K.; Martinez, G. F. (2009). Decomposition of the mean squared error and NSE performance criteria: Implications for improving hydrological modelling. Journal of hydrology, 377(1-2), 80-91. doi:10.1016/j.jhydrol.2009.08.003.}

\cite{Kling, H.; Fuchs, M.; Paulin, M. (2012). Runoff conditions in the upper Danube basin under an ensemble of climate change scenarios. Journal of Hydrology, 424, 264-277, doi:10.1016/j.jhydrol.2012.01.011.}

\cite{Pushpalatha, R., Perrin, C., Le Moine, N. and Andreassian, V. (2012). A review of efficiency criteria suitable for evaluating low-flow simulations. Journal of Hydrology, 420, 171-182. doi:10.1016/j.jhydrol.2011.11.055.}

\cite{Pfannerstill, M.; Guse, B.; Fohrer, N. (2014). Smart low flow signature metrics for an improved overall performance evaluation of hydrological models. Journal of Hydrology, 510, 447-458. doi:10.1016/j.jhydrol.2013.12.044.} 

\cite{Santos, L.; Thirel, G.; Perrin, C. (2018). Pitfalls in using log-transformed flows within the sKGE criterion. doi:10.5194/hess-22-4583-2018}

\cite{Knoben, W.J.; Freer, J.E.; Woods, R.A. (2019). Inherent benchmark or not? Comparing Nash-Sutcliffe and Kling-Gupta efficiency scores. Hydrology and Earth System Sciences, 23(10), 4323-4331. doi:10.5194/hess-23-4323-2019.}
}
\author{
Mauricio Zambrano-Bigiarini <mzb.devel@gmail.com>
}
\note{
\code{obs} and \code{sim} has to have the same length/dimension \cr

The missing values in \code{obs} and \code{sim} are removed before the computation proceeds, and only those positions with non-missing values in \code{obs} and \code{sim} are considered in the computation
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{KGE}}, \code{\link{KGElf}}, \code{\link{KGEnp}}, \code{\link{gof}}, \code{\link{ggof}}
}
\examples{
##################
# Example 1: Looking at the difference between sKGE and KGE, both with 'method=2009' 
#            and 'method=2012'

# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Simulated daily time series, initially equal to twice the observed values
sim <- 2*obs 

# KGE 2009
KGE(sim=sim, obs=obs, method="2009", out.type="full")

# sKGE (Fowler et al., 2018):
sKGE(sim=sim, obs=obs, method="2009")

# KGE 2012
KGE(sim=sim, obs=obs, method="2012", out.type="full")

# sKGE (Fowler et al., 2018):
sKGE(sim=sim, obs=obs, method="2012")

##################
# Example 2: 
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Generating a simulated daily time series, initially equal to the observed series
sim <- obs 

# Computing the 'sKGE' for the "best" (unattainable) case
sKGE(sim=sim, obs=obs)

##################
# Example 3: sKGE for simulated values equal to observations plus random noise 
#            on the first half of the observed values. 
#            This random noise has more relative importance for low flows than 
#            for medium and high flows.
  
# Randomly changing the first 1826 elements of 'sim', by using a normal distribution 
# with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim[1:1826] <- obs[1:1826] + rnorm(1826, mean=10)
ggof(sim, obs)

sKGE(sim=sim, obs=obs)

##################
# Example 4: sKGE for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' during computations.

sKGE(sim=sim, obs=obs, fun=log)

# Verifying the previous value:
lsim <- log(sim)
lobs <- log(obs)
sKGE(sim=lsim, obs=lobs)

##################
# Example 5: sKGE for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding the Pushpalatha2012 constant
#            during computations

sKGE(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012")

# Verifying the previous value, with the epsilon value following Pushpalatha2012
eps  <- mean(obs, na.rm=TRUE)/100
lsim <- log(sim+eps)
lobs <- log(obs+eps)
sKGE(sim=lsim, obs=lobs)

##################
# Example 6: sKGE for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding a user-defined constant
#            during computations

eps <- 0.01
sKGE(sim=sim, obs=obs, fun=log, epsilon.type="otherValue", epsilon.value=eps)

# Verifying the previous value:
lsim <- log(sim+eps)
lobs <- log(obs+eps)
sKGE(sim=lsim, obs=lobs)

##################
# Example 7: sKGE for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and using a user-defined factor
#            to multiply the mean of the observed values to obtain the constant
#            to be added to 'sim' and 'obs' during computations

fact <- 1/50
sKGE(sim=sim, obs=obs, fun=log, epsilon.type="otherFactor", epsilon.value=fact)

# Verifying the previous value:
eps  <- fact*mean(obs, na.rm=TRUE)
lsim <- log(sim+eps)
lobs <- log(obs+eps)
sKGE(sim=lsim, obs=lobs)

##################
# Example 8: sKGE for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying a 
#            user-defined function to 'sim' and 'obs' during computations

fun1 <- function(x) {sqrt(x+1)}

sKGE(sim=sim, obs=obs, fun=fun1)

# Verifying the previous value
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
sKGE(sim=sim1, obs=obs1)

##################
# Example 9: sKGE for a two-column data frame where simulated values are equal to 
#            observations plus random noise on the first half of the observed values 

SIM <- cbind(sim, sim)
OBS <- cbind(obs, obs)

sKGE(sim=SIM, obs=OBS)

##################
# Example 10: sKGE for each year, where simulated values are given in a two-column data 
#             frame equal to the observations plus random noise on the first half of the 
#             observed values 
SIM <- cbind(sim, sim)
OBS <- cbind(obs, obs)
sKGE(sim=SIM, obs=OBS, out.PerYear=TRUE)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

%% File EgaEnEstellaQts.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2008-2024 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{EgaEnEstellaQts}
\docType{data}
\alias{EgaEnEstellaQts}
\title{
Ega in "Estella" (Q071), ts with daily streamflows.
}
\description{
Time series with daily streamflows of the Ega River (subcatchment of the Ebro River basin, Spain) measured at the gauging station "Estella" (Q071), for the period 01/Jan/1961 to 31/Dec/1970
}
\usage{
data(EgaEnEstellaQts)
}

%%\details{
%%
%%}
\format{
zoo object.
}
\source{
Downloaded from: \url{https://www.chebro.es}. Last accessed [March 2010]. \cr
These data are intended to be used for research purposes only, being distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
}

%%\references{
%% ~put references to the literature/web site here ~
%%}
\keyword{datasets}

%% File ggof.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2011-2026 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{ggof}
\Rdversion{1.1}
\alias{ggof}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Graphical Goodness of Fit
}
\description{
Graphical comparison between two vectors (numeric, ts or zoo), with several numerical goodness of fit printed as a legend. \cr
Missing values in observed and/or simulated values can removed before the computations. \cr
}
\usage{
ggof(sim, obs, na.rm = TRUE, dates, date.fmt = "\%Y-\%m-\%d", 
     pt.style = "ts", ftype = "o",  FUN, 
     stype="default", season.names=c("Winter", "Spring", "Summer", "Autumn"),
     gof.leg = TRUE,  digits=2, 
     gofs=c( "ME",  "MAE",  "RMSE", "NRMSE", "PBIAS", "NSE",   "d",    
             "dr",    "r",    "R2",   "KGE",  "LCE", "JDKGE", "VE"),
     legend, leg.cex=1,
     tick.tstep = "auto", lab.tstep = "auto", lab.fmt=NULL,
     cal.ini=NA, val.ini=NA,
     main, xlab = "Time", ylab=c("Q, [m3/s]"),  
     col = c("blue", "black"), 
     cex = c(0.5, 0.5), cex.axis=1.2, cex.lab=1.2,
     lwd = c(1, 1), lty = c(1, 3), pch = c(1, 9), ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
   \item{sim}{
numeric or zoo object with with simulated values
}
  \item{obs}{
numeric or zoo object with observed values
}
  \item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
When an 'NA' value is found at the i-th position in \code{obs} \bold{OR} \code{sim}, the i-th value of \code{obs} \bold{AND} \code{sim} are removed before the computation.
}
  \item{dates}{
character, factor, Date or POSIXct object indicating how to obtain the dates for the corresponding values in the \code{sim} and \code{obs} time series \cr
If \code{dates} is a character or factor, it is converted into Date/POSIXct class, using the date format specified by \code{date.fmt}
}
  \item{date.fmt}{
OPTIONAL. character indicating the format in which the dates are stored in \code{dates}, \code{cal.ini} and \code{val.ini}. See \code{format} in \code{\link[base]{as.Date}}. Default value is \kbd{\%Y-\%m-\%d} \cr
ONLY required when \code{class(dates)=="character"} or \code{class(dates)=="factor"} or when \code{cal.ini} and/or \code{val.ini} is provided.
}
  \item{pt.style}{
Character indicating if the 2 ts have to be plotted as lines or bars. When \code{ftype} is NOT \kbd{o}, it only applies to the annual values. Valid values are: \cr
-) \kbd{ts} : (default) each ts is plotted as a lines along the 'x' axis \cr
-) \kbd{bar}: both series are plotted as barplots. 
}
  \item{ftype}{
Character indicating how many plots are desired by the user. Valid values are: \cr
-) \kbd{o}       : only the original \code{sim} and \code{obs} time series are plotted \cr
-) \kbd{dm}      : it assumes that \code{sim} and \code{obs} are daily time series and Daily and Monthly values are plotted  \cr
-) \kbd{ma}      : it assumes that \code{sim} and \code{obs} are daily or monthly time series and Monthly and Annual values are plotted \cr
-) \kbd{dma}     : it assumes that \code{sim} and \code{obs} are daily time series and Daily, Monthly and Annual values are plotted \cr
-) \kbd{seasonal}: seasonal values are plotted. See \code{stype} and \code{season.names}
}
  \item{FUN}{
OPTIONAL, ONLY required when \code{ftype} is in \code{c('dm', 'ma', 'dma', 'seasonal')}. Function that have to be applied for transforming teh original ts into monthly, annual or seasonal time step (e.g., for precipitation FUN MUST be \code{sum}, for temperature and flow time series, FUN MUST be \code{mean})
}
  \item{stype}{
 OPTIONAL, only used when \code{ftype=seasonal}. \cr
character, indicating whath weather seasons will be used for computing the output. Possible values are: \cr
-) \kbd{default}          =>  "winter"= DJF  = Dec, Jan, Feb;      "spring"= MAM = Mar, Apr, May;  "summer"= JJA  = Jun, Jul, Aug;       "autumn"= SON = Sep, Oct, Nov  \cr
-) \kbd{FrenchPolynesia}  =>  "winter"= DJFM = Dec, Jan, Feb, Mar; "spring"= AM  = Apr, May;       "summer"= JJAS = Jun, Jul, Aug, Sep;  "autumn"= ON  = Oct, Nov 
}
  \item{season.names}{
 OPTIONAL, only used when \code{ftype=seasonal}. \cr
character of length 4 indicating the names of each one of the weather seasons defined by \code{stype}.These names are only used for plotting purposes
}
  \item{gof.leg}{
logical, indicating if several numerical goodness of fit have to be computed between \code{sim} and \code{obs}, and plotted as a legend on the graph. If \code{leg.gof=TRUE}, then \code{x} is considered as observed and \code{y} as simulated values (for some gof functions this is important).
}
  \item{digits}{
OPTIONAL, only used when \code{leg.gof=TRUE}. Numeric, representing the decimal places used for rounding the goodness-of-fit indexes.
}
  \item{gofs}{
character, with one or more strings indicating the goodness-of-fit measures to be shown in the legend of the plot when  \code{gof.leg=TRUE}. \cr
Possible values when \code{ftype!='seasonal'} are in \code{c("ME", "MAE", "MSE", "RMSE", "NRMSE", "PBIAS", "RSR", "rSD", "NSE", "mNSE", "rNSE", "d", "md", "rd", "cp", "r", "R2", "bR2", "KGE", "VE")} \cr
Possible values when \code{ftype='seasonal'} are in c("ME", "RMSE", "PBIAS", "RSR", "NSE", "d", "R2", "KGE", "VE")
}
  \item{legend}{
character of length 2 to appear in the legend.  
}
  \item{leg.cex}{
OPTIONAL. ONLY used when \code{leg.gof=TRUE}. Character expansion factor for drawing the legend, *relative*  to current 'par("cex")'. Used for text, and provides the default for 'pt.cex' and 'title.cex'. Default value = 1
}
  \item{tick.tstep}{
character, indicating the time step that have to be used for putting the ticks on the time axis. Valid values are: \kbd{auto}, \kbd{years}, \kbd{months},\kbd{weeks}, \kbd{days}, \kbd{hours}, \kbd{minutes}, \kbd{seconds}.
}
 \item{lab.tstep}{
character, indicating the time step that have to be used for putting the labels on the time axis. Valid values are: \kbd{auto}, \kbd{years}, \kbd{months},\kbd{weeks}, \kbd{days}, \kbd{hours}, \kbd{minutes}, \kbd{seconds}.
}
  \item{lab.fmt}{
Character indicating the format to be used for the label of the axis. See \code{lab.fmt} in \code{\link[hydroTSM]{drawTimeAxis}}.
}
  \item{cal.ini}{
OPTIONAL. Character, indicating the date in which the calibration period started. \cr
When \code{cal.ini} is provided, all the values in \code{obs} and \code{sim} with dates previous to \code{cal.ini} are SKIPPED from the computation of the goodness-of-fit measures (when \code{gof.leg=TRUE}), but their values are still plotted, in order to examine if the warming up period was too short, acceptable or too long for the chosen calibration period.
In addition, a vertical red line in drawn at this date. 
}
  \item{val.ini}{
OPTIONAL. Character, the date in which the validation period started. \cr
ONLY used for drawing a vertical red line at this date. 
}
   \item{main}{
character representing the main title of the plot.
}
  \item{xlab}{
label for the 'x' axis.
}
  \item{ylab}{
label for the 'y' axis.
}
  \item{col}{
character, representing the colors of \code{sim} and \code{obs}
}
  \item{cex}{
numeric, representing the values controlling the size of text and symbols of 'x' and 'y' with respect to the default
}
  \item{cex.axis}{
numeric, representing the magnification to be used for the axis annotation relative to 'cex'. See \code{\link[graphics]{par}}.
}
  \item{cex.lab}{
numeric, representing the magnification to be used for x and y labels relative to the current setting of 'cex'. See \code{\link[graphics]{par}}.
}
  \item{lwd}{
vector with the line width of \code{sim} and \code{obs}
}
  \item{lty}{
numeric with the line type of \code{sim} and \code{obs}
}
  \item{pch}{
numeric with the type of symbol for \code{x} and \code{y}. (e.g., 1: white circle; 9: white rhombus with a cross inside)
}
  \item{\dots}{
further arguments passed to or from other methods.
}
}
\details{
Plots observed and simulated values in the same graph.

If \code{gof.leg=TRUE}, it computes the numerical values of: \cr
'me', 'mae', 'rmse', 'nrmse', 'PBIAS',  'RSR, 'rSD', 'NSE', 'mNSE', 'rNSE', 'd', 'md, 'rd', 'cp', 'r', 'r.Spearman', 'R2', 'bR2', 'KGE', 'VE'
}
\value{
The output of the \code{gof} function is a matrix with one column only, and the following rows: 

\item{ME}{Mean Error}
\item{MAE}{Mean Absolute Error}
\item{MSE}{Mean Squared Error}
\item{RMSE}{Root Mean Square Error}
\item{ubRMSE}{Unbiased Root Mean Square Error}
\item{NRMSE}{Normalized Root Mean Square Error  ( -100\% <= NRMSE <= 100\% )}
\item{PBIAS}{Percent Bias ( -Inf <= PBIAS <= Inf [\%] )}
\item{RSR}{Ratio of RMSE to the Standard Deviation of the Observations, RSR = rms / sd(obs). ( 0 <= RSR <= +Inf )}
\item{rSD}{Ratio of Standard Deviations, rSD = sd(sim) / sd(obs)}
\item{NSE}{Nash-Sutcliffe Efficiency ( -Inf <= NSE <= 1 )}
\item{mNSE}{Modified Nash-Sutcliffe Efficiency ( -Inf <= mNSE <= 1 )}
\item{rNSE}{Relative Nash-Sutcliffe Efficiency ( -Inf <= rNSE <= 1 )}
\item{wNSE}{Weighted Nash-Sutcliffe Efficiency ( -Inf <= wNSE <= 1 )}
\item{wsNSE}{Weighted Seasonal Nash-Sutcliffe Efficiency ( -Inf <= wsNSE <= 1 )}
\item{d}{Index of Agreement ( 0 <= d <= 1 )}
\item{dr}{Refined Index of Agreement ( -1 <= dr <= 1 )}
\item{md}{Modified Index of Agreement ( 0 <= md <= 1 )}
\item{rd}{Relative Index of Agreement ( 0 <= rd <= 1 )}
\item{cp}{Persistence Index ( 0 <= cp <= 1 ) }
\item{r}{Pearson Correlation coefficient ( -1 <= r <= 1 )}
\item{R2}{Coefficient of Determination ( 0 <= R2 <= 1 )}
\item{bR2}{R2 multiplied by the coefficient of the regression line between \code{sim} and \code{obs} \cr ( 0 <= bR2 <= 1 )}
\item{VE}{Volumetric efficiency between \code{sim} and \code{obs} \cr ( -Inf <= VE <= 1)}
\item{KGE}{Kling-Gupta efficiency between \code{sim} and \code{obs} \cr ( -Inf <= KGE <= 1 )}
\item{KGElf}{Kling-Gupta Efficiency for low values between \code{sim} and \code{obs} \cr ( -Inf <= KGElf <= 1 )}
\item{KGEnp}{Non-parametric version of the Kling-Gupta Efficiency between \code{sim} and \code{obs} \cr ( -Inf <= KGEnp <= 1 )}
\item{KGEkm}{Knowable Moments Kling-Gupta Efficiency between \code{sim} and \code{obs} \cr ( -Inf <= KGEnp <= 1 )}

The following outputs are only produced when both \code{sim} and \code{obs} are zoo objects: 

\item{sKGE}{Split Kling-Gupta Efficiency between \code{sim} and \code{obs} \cr ( -Inf <= sKGE <= 1 ). Only computed when both \code{sim} and \code{obs} are zoo objects}
\item{APFB}{Annual Peak Flow Bias ( 0 <= APFB <= Inf )}
\item{HBF}{High Flow Bias ( 0 <= HFB <= Inf )}
\item{r.Spearman}{Spearman Correlation coefficient ( -1 <= r.Spearman <= 1 ). Only computed when \code{do.spearman=TRUE}}
\item{pbiasfdc}{PBIAS in the slope of the midsegment of the Flow Duration Curve}

%% ...
}
\references{
\cite{Abbaspour, K.C.; Faramarzi, M.; Ghasemi, S.S.; Yang, H. (2009), Assessing the impact of climate change on water resources in Iran, Water Resources Research, 45(10), W10,434, doi:10.1029/2008WR007615.}

\cite{Abbaspour, K.C., Yang, J. ; Maximov, I.; Siber, R.; Bogner, K.; Mieleitner, J. ; Zobrist, J.; Srinivasan, R. (2007), Modelling hydrology and water quality in the pre-alpine/alpine Thur watershed using SWAT, Journal of Hydrology, 333(2-4), 413-430, doi:10.1016/j.jhydrol.2006.09.014.}

\cite{Box, G.E. (1966). Use and abuse of regression. Technometrics, 8(4), 625-629. doi:10.1080/00401706.1966.10490407.}

\cite{Barrett, J.P. (1974). The coefficient of determination-some limitations. The American Statistician, 28(1), 19-20. doi:10.1080/00031305.1974.10479056.}

\cite{Chai, T.; Draxler, R.R. (2014). Root mean square error (RMSE) or mean absolute error (MAE)? - Arguments against avoiding RMSE in the literature, Geoscientific Model Development, 7, 1247-1250. doi:10.5194/gmd-7-1247-2014.}

\cite{Cinkus, G.; Mazzilli, N.; Jourde, H.; Wunsch, A.; Liesch, T.; Ravbar, N.; Chen, Z.; and Goldscheider, N. (2023). When best is the enemy of good - critical evaluation of performance criteria in hydrological models. Hydrology and Earth System Sciences 27, 2397-2411, doi:10.5194/hess-27-2397-2023.}

\cite{Criss, R. E.; Winston, W. E. (2008), Do Nash values have value? Discussion and alternate proposals. Hydrological Processes, 22: 2723-2725. doi:10.1002/hyp.7072.}

\cite{Entekhabi, D.; Reichle, R.H.; Koster, R.D.; Crow, W.T. (2010). Performance metrics for soil moisture retrievals and application requirements. Journal of Hydrometeorology, 11(3), 832-840. doi: 10.1175/2010JHM1223.1.}

\cite{Ficchi, A.; Bavera, D.; Grimaldi, S.; Moschini, F.; Pistocchi, A.; Russo, C.; Salamon, P.; Toreti, A. (2026). Improving low and high flow simulations at once: An enhanced metric for hydrological model calibrations. EGUsphere [preprint], https://doi.org/10.5194/egusphere-2026-43.}

\cite{Fowler, K.; Coxon, G.; Freer, J.; Peel, M.; Wagener, T.; Western, A.; Woods, R.; Zhang, L. (2018). Simulating runoff under changing climatic conditions: A framework for model improvement. Water Resources Research, 54(12), 812-9832. doi:10.1029/2018WR023989.}

\cite{Garcia, F.; Folton, N.; Oudin, L. (2017). Which objective function to calibrate rainfall-runoff models for low-flow index simulations?. Hydrological sciences journal, 62(7), 1149-1166. doi:10.1080/02626667.2017.1308511.}

\cite{Garrick, M.; Cunnane, C.; Nash, J.E. (1978). A criterion of efficiency for rainfall-runoff models. Journal of Hydrology 36, 375-381. doi:10.1016/0022-1694(78)90155-5.}

\cite{Gupta, H.V.; Kling, H.; Yilmaz, K.K.; Martinez, G.F. (2009). Decomposition of the mean squared error and NSE performance criteria: Implications for improving hydrological modelling. Journal of hydrology, 377(1-2), 80-91. doi:10.1016/j.jhydrol.2009.08.003. ISSN 0022-1694.}

\cite{Gupta, H.V.; Kling, H. (2011). On typical range, sensitivity, and normalization of Mean Squared Error and Nash-Sutcliffe Efficiency type metrics. Water Resources Research, 47(10). doi:10.1029/2011WR010962.}

\cite{Hahn, G.J. (1973). The coefficient of determination exposed. Chemtech, 3(10), 609-612. Aailable online at: \url{https://www2.hawaii.edu/~cbaajwe/Ph.D.Seminar/Hahn1973.pdf}.}

\cite{Hodson, T.O. (2022). Root-mean-square error (RMSE) or mean absolute error (MAE): when to use them or not, Geoscientific Model Development, 15, 5481-5487, doi:10.5194/gmd-15-5481-2022.}

\cite{Hundecha, Y., Bardossy, A. (2004). Modeling of the effect of land use changes on the runoff generation of a river basin through parameter regionalization of a watershed model. Journal of hydrology, 292(1-4), 281-295. doi:10.1016/j.jhydrol.2004.01.002.}

\cite{Kitanidis, P.K.; Bras, R.L. (1980). Real-time forecasting with a conceptual hydrologic model. 2. Applications and results. Water Resources Research, Vol. 16, No. 6, pp. 1034:1044. doi:10.1029/WR016i006p01034.} \cr

\cite{Kling, H.; Fuchs, M.; Paulin, M. (2012). Runoff conditions in the upper Danube basin under an ensemble of climate change scenarios. Journal of Hydrology, 424, 264-277, doi:10.1016/j.jhydrol.2012.01.011.}

\cite{Knoben, W.J.; Freer, J.E.; Woods, R.A. (2019). Inherent benchmark or not? Comparing Nash-Sutcliffe and Kling-Gupta efficiency scores. Hydrology and Earth System Sciences, 23(10), 4323-4331. doi:10.5194/hess-23-4323-2019.}

\cite{Krause, P.; Boyle, D.P.; Base, F. (2005). Comparison of different efficiency criteria for hydrological model assessment, Advances in Geosciences, 5, 89-97. doi:10.5194/adgeo-5-89-2005.} \cr

\cite{Krstic, G.; Krstic, N.S.; Zambrano-Bigiarini, M. (2016). The br2-weighting Method for Estimating the Effects of Air Pollution on Population Health. Journal of Modern Applied Statistical Methods, 15(2), 42. doi:10.22237/jmasm/1478004000}

\cite{Lee, J. S.; Choi, H. I. (2022). A rebalanced performance criterion for hydrological model calibration. Journal of Hydrology, 606, 127372. https://doi.org/10.1016/j.jhydrol.2021.127372}

\cite{Legates, D.R.; McCabe, G. J. Jr. (1999), Evaluating the Use of "Goodness-of-Fit" Measures in Hydrologic and Hydroclimatic Model Validation, Water Resour. Res., 35(1), 233-241. doi:10.1029/1998WR900018.} 

\cite{Ling, X.; Huang, Y.; Guo, W.; Wang, Y.; Chen, C.; Qiu, B.; Ge, J.; Qin, K.; Xue, Y.; Peng, J. (2021). Comprehensive evaluation of satellite-based and reanalysis soil moisture products using in situ observations over China. Hydrology and Earth System Sciences, 25(7), 4209-4229. doi:10.5194/hess-25-4209-2021.}

\cite{Liu, D.; Chen, X.; Lian, Y.; Lou, Z. (2020). A new performance measure for hydrologic models. Journal of Hydrology, 590, 125488. doi:10.1016/j.jhydrol.2020.125488.}

\cite{Mizukami, N.; Rakovec, O.; Newman, A.J.; Clark, M.P.; Wood, A.W.; Gupta, H.V.; Kumar, R.: (2019). On the choice of calibration metrics for "high-flow" estimation using hydrologic models, Hydrology Earth System Sciences 23, 2601-2614, doi:10.5194/hess-23-2601-2019.}

\cite{Moriasi, D.N.; Arnold, J.G.; van Liew, M.W.; Bingner, R.L.; Harmel, R.D.; Veith, T.L. (2007). Model evaluation guidelines for systematic quantification of accuracy in watershed simulations. Transactions of the ASABE. 50(3):885-900}

\cite{Nash, J.E. and Sutcliffe, J.V. (1970). River flow forecasting through conceptual models. Part 1: a discussion of principles, Journal of Hydrology 10, pp. 282-290. doi:10.1016/0022-1694(70)90255-6.}

\cite{Pearson, K. (1920). Notes on the history of correlation. Biometrika, 13(1), 25-45. doi:10.2307/2331722.}

\cite{Pfannerstill, M.; Guse, B.; Fohrer, N. (2014). Smart low flow signature metrics for an improved overall performance evaluation of hydrological models. Journal of Hydrology, 510, 447-458. doi:10.1016/j.jhydrol.2013.12.044.} 

\cite{Pizarro, A.; Jorquera, J. (2024). Advancing objective functions in hydrological modelling: Integrating knowable moments for improved simulation accuracy. Journal of Hydrology, 634, 131071. doi:10.1016/j.jhydrol.2024.131071.}

\cite{Pool, S.; Vis, M.; Seibert, J. (2018). Evaluating model performance: towards a non-parametric variant of the Kling-Gupta efficiency. Hydrological Sciences Journal, 63(13-14), pp.1941-1953. doi:/10.1080/02626667.2018.1552002.}

\cite{Pushpalatha, R.; Perrin, C.; Le Moine, N.; Andreassian, V. (2012). A review of efficiency criteria suitable for evaluating low-flow simulations. Journal of Hydrology, 420, 171-182. doi:10.1016/j.jhydrol.2011.11.055.}  

\cite{Royer-Gaspard, P., Andreassian, V., and Thirel, G. (2021). Technical note: PMR - a proxy metric to assess hydrological model robustness in a changing climate. Hydrology and Earth System Sciences, 25, 5703--5716. doi:10.5194/hess-25-5703-2021.}

\cite{Santos, L.; Thirel, G.; Perrin, C. (2018). Pitfalls in using log-transformed flows within the KGE criterion. doi:10.5194/hess-22-4583-2018.}

\cite{Schaefli, B., Gupta, H. (2007). Do Nash values have value?. Hydrological Processes 21, 2075-2080. doi:10.1002/hyp.6825.}

\cite{Schober, P.; Boer, C.; Schwarte, L.A. (2018). Correlation coefficients: appropriate use and interpretation. Anesthesia and Analgesia, 126(5), 1763-1768. doi:10.1213/ANE.0000000000002864.}

\cite{Schuol, J.; Abbaspour, K.C.; Srinivasan, R.; Yang, H. (2008b), Estimation of freshwater availability in the West African sub-continent using the SWAT hydrologic model, Journal of Hydrology, 352(1-2), 30, doi:10.1016/j.jhydrol.2007.12.025}

\cite{Sorooshian, S., Q. Duan, and V. K. Gupta. (1993). Calibration of rainfall-runoff models: Application of global optimization to the Sacramento Soil Moisture Accounting Model, Water Resources Research, 29 (4), 1185-1194, doi:10.1029/92WR02617}.

\cite{Spearman, C. (1961). The Proof and Measurement of Association Between Two Things. In J. J. Jenkins and D. G. Paterson (Eds.), Studies in individual differences: The search for intelligence (pp. 45-58). Appleton-Century-Crofts. doi:10.1037/11491-005}

\cite{Tang, G.; Clark, M.P.; Papalexiou, S.M. (2021). SC-earth: a station-based serially complete earth dataset from 1950 to 2019. Journal of Climate, 34(16), 6493-6511. doi:10.1175/JCLI-D-21-0067.1.}

\cite{Yapo P.O.; Gupta H.V.; Sorooshian S. (1996). Automatic calibration of conceptual rainfall-runoff models: sensitivity to calibration data. Journal of Hydrology. v181 i1-4. 23-48. doi:10.1016/0022-1694(95)02918-4}

\cite{Yilmaz, K.K., Gupta, H.V. ; Wagener, T. (2008), A process-based diagnostic approach to model evaluation: Application to the NWS distributed hydrologic model, Water Resources Research, 44, W09417, doi:10.1029/2007WR006716.}

\cite{Willmott, C.J. (1981). On the validation of models. Physical Geography, 2, 184--194. doi:10.1080/02723646.1981.10642213.}

\cite{Willmott, C.J. (1984). On the evaluation of model performance in physical geography. Spatial Statistics and Models, G. L. Gaile and C. J. Willmott, eds., 443-460. doi:10.1007/978-94-017-3048-8_23.}

\cite{Willmott, C.J.; Ackleson, S.G. Davis, R.E.; Feddema, J.J.; Klink, K.M.; Legates, D.R.; O'Donnell, J.; Rowe, C.M. (1985), Statistics for the Evaluation and Comparison of Models, J. Geophys. Res., 90(C5), 8995-9005. doi:10.1029/JC090iC05p08995.}

\cite{Willmott, C.J.; Matsuura, K. (2005). Advantages of the mean absolute error (MAE) over the root mean square error (RMSE) in assessing average model performance, Climate Research, 30, 79-82, doi:10.3354/cr030079.}

\cite{Willmott, C.J.; Matsuura, K.; Robeson, S.M. (2009). Ambiguities inherent in sums-of-squares-based error statistics, Atmospheric Environment, 43, 749-752, doi:10.1016/j.atmosenv.2008.10.005.}

\cite{Willmott, C.J.; Robeson, S.M.; Matsuura, K. (2012). A refined index of model performance. International Journal of climatology, 32(13), pp.2088-2094. doi:10.1002/joc.2419.}

\cite{Willmott, C.J.; Robeson, S.M.; Matsuura, K.; Ficklin, D.L. (2015). Assessment of three dimensionless measures of model performance. Environmental Modelling & Software, 73, pp.167-174. doi:10.1016/j.envsoft.2015.08.012}

\cite{Zambrano-Bigiarini, M.; Bellin, A. (2012). Comparing goodness-of-fit measures for calibration of models focused on extreme events. EGU General Assembly 2012, Vienna, Austria, 22-27 Apr 2012, EGU2012-11549-1.}
}
\author{
Mauricio Zambrano Bigiarini <mzb.devel@gmail.com>
}
%%\note{
%%
%%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{gof}}, \code{\link{plot2}}, 
\code{\link{ggof}}, \code{\link{me}}, \code{\link{mae}}, \code{\link{mse}}, \code{\link{rmse}}, \code{\link{ubRMSE}}, 
\code{\link{nrmse}}, \code{\link{pbias}}, \code{\link{rsr}}, \code{\link{rSD}}, \code{\link{NSE}}, \code{\link{mNSE}}, 
\code{\link{rNSE}}, \code{\link{wNSE}}, \code{\link{d}}, \code{\link{dr}}, \code{\link{md}}, \code{\link{rd}}, 
\code{\link{cp}}, \code{\link{rPearson}}, \code{\link{R2}}, \code{\link{br2}}, \code{\link{KGE}}, \code{\link{KGElf}},
 \code{\link{KGEnp}}, \code{\link{sKGE}}, \code{\link{VE}}, \code{\link{rSpearman}}, \code{\link{pbiasfdc}}
}
\examples{
obs <- 1:10
sim <- 2:11

\dontrun{
ggof(sim, obs)
}

##################
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Generating a simulated daily time series, initially equal to the observed series
sim <- obs 

# Getting the numeric goodness of fit for the "best" (unattainable) case
gof(sim=sim, obs=obs)

# Randomly changing the first 2000 elements of 'sim', by using a normal distribution 
# with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim[1:2000] <- obs[1:2000] + rnorm(2000, mean=10)

# Getting the new numeric goodness-of-fit measures
gof(sim=sim, obs=obs)

# Getting the graphical representation of 'obs' and 'sim' along with the numeric 
# goodness-of-fit measures for the daily and monthly time series 
\dontrun{
ggof(sim=sim, obs=obs, ftype="dm", FUN=mean)
}

# Getting the graphical representation of 'obs' and 'sim' along with some numeric 
# goodness-of-fit measures for the seasonal time series 
\dontrun{
ggof(sim=sim, obs=obs, ftype="seasonal", FUN=mean)
}

# Computing the daily residuals 
# even if this is a dummy example, it is enough for illustrating the capability
r <- sim-obs

# Summarizing and plotting the residuals
\dontrun{
library(hydroTSM)

# summary
smry(r) 

# daily, monthly and annual plots, boxplots and histograms
hydroplot(r, FUN=mean)

# seasonal plots and boxplots
hydroplot(r, FUN=mean, pfreq="seasonal")
}

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{dplot}
\keyword{math}% __ONLY ONE__ keyword per line

%% File APFB.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2024-2026 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or late

\name{APFB}
\Rdversion{1.1}
\alias{APFB}
\alias{APFB.default}
\alias{APFB.matrix}
\alias{APFB.data.frame}
\alias{APFB.zoo}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Annual Peak Flow Bias
}
\description{
Annual peak flow bias between \code{sim} and \code{obs}, with treatment of missing values. 

This function was prposed by Mizukami et al. (2019) to identify differences in high (streamflow) values. See Details.
}
\usage{
APFB(sim, obs, ...)

\method{APFB}{default}(sim, obs, na.rm=TRUE, start.month=1, out.PerYear=FALSE,
             fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)

\method{APFB}{data.frame}(sim, obs, na.rm=TRUE, start.month=1, out.PerYear=FALSE,
             fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)

\method{APFB}{matrix}(sim, obs, na.rm=TRUE, start.month=1, out.PerYear=FALSE,
             fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)
             
\method{APFB}{zoo}(sim, obs, na.rm=TRUE, start.month=1, out.PerYear=FALSE,
             fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sim}{
numeric, zoo, matrix or data.frame with simulated values
}
  \item{obs}{
numeric, zoo, matrix or data.frame with observed values
}
  \item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
When an 'NA' value is found at the i-th position in \code{obs} \bold{OR} \code{sim}, the i-th value of \code{obs} \bold{AND} \code{sim} are removed before the computation.
}
  \item{start.month}{
[OPTIONAL]. Only used when the (hydrological) year of interest is different from the calendar year.

numeric in [1:12] indicating the starting month of the (hydrological) year. Numeric values in [1, 12] represent months in [January, December]. By default \code{start.month=1}.
}
\item{out.PerYear}{
logical value indicating whether the output should include the annual peak flow bias computed for each individual year or not.\cr

Valid values are:

-) \kbd{FALSE}: the output is a numeric with the mean annual peak flow bias.

-) \kbd{TRUE}: the output is a list including both the overall APFB value and the individual yearly values.
}
  \item{fun}{
function to be applied to \code{sim} and \code{obs} in order to obtain transformed values thereof before computing this goodness-of-fit index.

The first argument MUST BE a numeric vector with any name (e.g., \code{x}), and additional arguments are passed using \code{\dots}.
}
  \item{\dots}{
arguments passed to \code{fun}, in addition to the mandatory first numeric vector.
}
  \item{epsilon.type}{
argument used to define a numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. 

It is was  designed to allow the use of logarithm and other similar functions that do not work with zero values.

Valid values of \code{epsilon.type} are:

1) \kbd{"none"}: \code{sim} and \code{obs} are used by \code{fun} without the addition of any numeric value. This is the default option.

2) \kbd{"Pushpalatha2012"}: one hundredth (1/100) of the mean observed values is added to both \code{sim} and \code{obs} before applying \code{fun}, as described in Pushpalatha et al. (2012). 

3) \kbd{"otherFactor"}: the numeric value defined in the \code{epsilon.value} argument is used to multiply the the mean observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs}, before applying \code{fun}.

4) \kbd{"otherValue"}: the numeric value defined in the \code{epsilon.value} argument is directly added to both \code{sim} and \code{obs}, before applying \code{fun}.
}
  \item{epsilon.value}{
 -) when \code{epsilon.type="otherValue"} it represents the numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. \cr
 -) when \code{epsilon.type="otherFactor"} it represents the numeric factor used to multiply the mean of the observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs} before applying \code{fun}.
}
}
\details{
The annual peak flow bias (APFB; Mizukami et al., 2019) is designed to drive the calibration of hydrological models focused in the reproduction of high-flow events.

In the computation of this index, the annual peak flow is first identified for each hydrological year in both \code{sim} and \code{obs}. The mean of the resulting annual peak flow series is then computed separately for simulated and observed data.

The annual peak flow bias is defined as the absolute relative difference between the mean simulated annual peak flow and the mean observed annual peak flow.

\deqn{APFB = \sqrt{ \left( \frac{\mu_{peak\,Q_s}}{\mu_{peak\,Q_o}} - 1 \right)^2 }}

where:

\itemize{

\item \eqn{\mu_{peak\,Q_s}}: mean of the simulated annual peak flow series

\item \eqn{\mu_{peak\,Q_o}}: mean of the observed annual peak flow series

}

The APFB metric ranges from 0 to \kbd{Inf}. The optimal value is \kbd{0}, indicating perfect agreement between simulated and observed annual peak flows.

Essentially, the closer to 0, the more similar the magnitude of simulated and observed annual peak flows.

Because APFB focuses exclusively on annual maxima, it is particularly suitable for calibration tasks targeting flood estimation, extreme-flow simulation, or infrastructure design applications. However, because APFB evaluates only annual maxima, it does not assess overall hydrograph dynamics and is typically used in combination with complementary metrics (e.g., KGE or NSE) when broader performance evaluation is required.

}
\value{
If \code{out.PerYear=FALSE}: numeric with the mean annual peak flow bias between \code{sim} and \code{obs}. If \code{sim} and \code{obs} are matrices, the output value is a vector, with the  mean annual peak flow bias between each column of \code{sim} and \code{obs}.

If \code{out.PerYear=TRUE}: a list of two elements:
\item{APFB.value}{
numeric with the  mean annual peak flow bias between \code{sim} and \code{obs}. If \code{sim} and \code{obs} are matrices, the output value is a vector, with the mean annual peak flow bias  between each column of \code{sim} and \code{obs}.
}
\item{APFB.PerYear}{
-) If \code{sim} and \code{obs} are not data.frame/matrix, the output is numeric, with the mean annual peak flow bias obtained for the individual years between \code{sim} and \code{obs}. 

-) If \code{sim} and \code{obs} are data.frame/matrix, this output is a data.frame, with the  mean annual peak flow bias obtained for the individual years between \code{sim} and \code{obs}. 
}
}
\references{
\cite{Mizukami, N.; Rakovec, O.; Newman, A.J.; Clark, M.P.; Wood, A.W.; Gupta, H.V.; Kumar, R.: (2019). On the choice of calibration metrics for "high-flow" estimation using hydrologic models, Hydrology Earth System Sciences 23, 2601-2614, doi:10.5194/hess-23-2601-2019.}
}
\author{
Mauricio Zambrano-Bigiarini <mzb.devel@gmail.com>
}
\note{
\code{obs} and \code{sim} has to have the same length/dimension \cr

The missing values in \code{obs} and \code{sim} are removed before the computation proceeds, and only those positions with non-missing values in \code{obs} and \code{sim} are considered in the computation
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{NSE}}, \code{\link{wNSE}}, \code{\link{wsNSE}}, \code{\link{HFB}}, \code{\link{JDKGE}}, \code{\link{PMR}}, \code{\link{gof}}, \code{\link{ggof}}
}
\examples{
##################
# Example 1: Looking at the difference between 'NSE', 'wNSE', and 'APFB'
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Simulated daily time series, created equal to the observed values and then 
# random noise is added only to high flows, i.e., those equal or higher than 
# the quantile 0.9 of the observed values.
sim      <- obs
hQ.thr   <- quantile(obs, probs=0.9, na.rm=TRUE)
hQ.index <- which(obs >= hQ.thr)
hQ.n     <- length(hQ.index)
sim[hQ.index] <- sim[hQ.index] + rnorm(hQ.n, mean=mean(sim[hQ.index], na.rm=TRUE))

# Traditional Nash-Sutcliffe eficiency
NSE(sim=sim, obs=obs)

# Weighted Nash-Sutcliffe efficiency (Hundecha and Bardossy, 2004)
wNSE(sim=sim, obs=obs)

# APFB (Mizukami et al., 2019):
APFB(sim=sim, obs=obs)

##################
# Example 2: 
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Generating a simulated daily time series, initially equal to the observed series
sim <- obs 

# Computing the 'APFB' for the "best" (unattainable) case
APFB(sim=sim, obs=obs)

##################
# Example 3: APFB for simulated values created equal to the observed values and then 
#            random noise is added only to high flows, i.e., those equal or higher 
#            than the quantile 0.9 of the observed values.

sim           <- obs
hQ.thr        <- quantile(obs, probs=0.9, na.rm=TRUE)
hQ.index      <- which(obs >= hQ.thr)
hQ.n          <- length(hQ.index)
sim[hQ.index] <- sim[hQ.index] + rnorm(hQ.n, mean=mean(sim[hQ.index], na.rm=TRUE))
ggof(sim, obs)

APFB(sim=sim, obs=obs)

##################
# Example 4: APFB for simulated values created equal to the observed values and then 
#            random noise is added only to high flows, i.e., those equal or higher  
#            than the quantile 0.9 of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' during computations.

APFB(sim=sim, obs=obs, fun=log)

# Verifying the previous value:
lsim <- log(sim)
lobs <- log(obs)
APFB(sim=lsim, obs=lobs)


##################
# Example 5: APFB for simulated values created equal to the observed values and then 
#            random noise is added only to high flows, i.e., those equal or higher  
#            than the quantile 0.9 of the observed values and applying a 
#            user-defined function to 'sim' and 'obs' during computations

fun1 <- function(x) {sqrt(x+1)}

APFB(sim=sim, obs=obs, fun=fun1)

# Verifying the previous value, with the epsilon value following Pushpalatha2012
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
APFB(sim=sim1, obs=obs1)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

%% File JDKGE.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ;
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2026-2026 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{JDKGE}
\Rdversion{1.1}
\alias{JDKGE}
\alias{JDKGE.default}
\alias{JDKGE.matrix}
\alias{JDKGE.data.frame}
\alias{JDKGE.zoo}

\title{
Joint Divergence Kling-Gupta Efficiency
}

\description{
Joint Divergence Kling-Gupta Efficiency between \code{sim} and \code{obs}, with treatment of missing values. 

This implementation follows the technical formulation described by Ficchi et al. (2026), using by defualt the KGE-2012 variability term, and computing the distributional component from a histogram-based Jensen-Shannon divergence applied to log-transformed flows after paper-specific zero handling. However, this function also allows JDKGE-style variants based on the 2009 and 2021 KGE formulations, different methods for the distributional component, and  different methods for the handling of low streamflow values.

Results by Ficchi et al. (2026) show that calibrations using JDKGE significantly improve \bold{low-flow simulations} compared to KGE, NSE and other competitors, while maintaining comparable or improved performance in other regimes, including \bold{high flows}.
}

\usage{
JDKGE(sim, obs, ...)

\method{JDKGE}{default}(sim, obs, na.rm=TRUE, s=c(1,1,1,1),
        method=c("2012", "2009", "2021"), out.type=c("single", "full"), 
        density.method=c("hist", "kde", "wasserstein"), nbins="paper",
        timestep=86400, kde.n.grid=512, wasserstein.n.quantiles=512, fun=NULL, ...,
        epsilon.type=c("otherValue", "none", "Pushpalatha2012", "otherFactor"),
        epsilon.value=NA)

\method{JDKGE}{data.frame}(sim, obs, na.rm=TRUE, s=c(1,1,1,1),
        method=c("2012", "2009", "2021"), out.type=c("single", "full"), 
        density.method=c("hist", "kde", "wasserstein"), nbins="paper",
        timestep=86400, kde.n.grid=512, wasserstein.n.quantiles=512, fun=NULL, ...,
        epsilon.type=c("otherValue", "none", "Pushpalatha2012", "otherFactor"),
        epsilon.value=NA)

\method{JDKGE}{matrix}(sim, obs, na.rm=TRUE, s=c(1,1,1,1),
        method=c("2012", "2009", "2021"), out.type=c("single", "full"), 
        density.method=c("hist", "kde", "wasserstein"), nbins="paper",
        timestep=86400, kde.n.grid=512, wasserstein.n.quantiles=512, fun=NULL, ...,
        epsilon.type=c("otherValue", "none", "Pushpalatha2012", "otherFactor"),
        epsilon.value=NA)

\method{JDKGE}{zoo}(sim, obs, na.rm=TRUE, s=c(1,1,1,1),
        method=c("2012", "2009", "2021"), out.type=c("single", "full"), 
        density.method=c("hist", "kde", "wasserstein"), nbins="paper",
        timestep=86400, kde.n.grid=512, wasserstein.n.quantiles=512, fun=NULL, ...,
        epsilon.type=c("otherValue", "none", "Pushpalatha2012", "otherFactor"),
        epsilon.value=NA)
}

\arguments{
\item{sim}{numeric, zoo, matrix or data.frame with simulated values.}

\item{obs}{numeric, zoo, matrix or data.frame with observed values.}

\item{na.rm}{logical value indicating whether missing paired values should be removed before computing the metric.}

\item{s}{numeric of length 4 with scaling factors for the Euclidean distance in criteria space. If \code{s} differs from \code{c(1,1,1,1)}, then \code{sum(s)} must be equal to 1.}

\item{method}{character string indicating the Kling-Gupta formulation used by JDKGE. Valid values are \kbd{"2012"} (default, the paper's KGE' formulation), \kbd{"2009"}, and \kbd{"2021"}.}

\item{out.type}{character string indicating the output format. Use \kbd{"single"} to return the JDKGE value only, or \kbd{"full"} to also return the four diagnostic components.}

\item{density.method}{character, representing the method used to compute the divergence component. \kbd{"hist"} uses the paper-faithful histogram-based Jensen-Shannon divergence, \kbd{"kde"} uses a common-grid kernel density estimate followed by Jensen-Shannon divergence, and \kbd{"wasserstein"} uses a Wasserstein-distance similarity on log-flows.}

\item{nbins}{character, representing the binning rule used by the histogram divergence component. The default \kbd{"paper"} uses the procedure described by Ficchi et al. (2026). This argument is ignored for \code{density.method="kde"} and \code{density.method="wasserstein"}.}

\item{timestep}{numeric, representing the sampling time step in seconds used by the paper's bin-count adjustment. For \code{zoo} inputs this is inferred from the time index when omitted. The default for plain numeric vectors is one day (86400 seconds).}

\item{kde.n.grid}{integer, number of grid points used when \code{density.method="kde"}. Larger values provide a finer common support grid at higher computational cost.}

\item{wasserstein.n.quantiles}{integer, number of quantile levels used to approximate the first Wasserstein distance when \code{density.method="wasserstein"}. Larger values provide a finer approximation at higher computational cost.}

\item{fun}{optional function applied to \code{sim} and \code{obs} before computing JDKGE. The first argument of \code{fun} must be a numeric vector.}

\item{\dots}{additional arguments passed to \code{fun}.}

\item{epsilon.type}{rule used for zero-flow handling in the internal log-based divergence component, and also passed to \code{preproc} when \code{fun} needs an offset before transformation. The default is \kbd{"otherValue"}.}

\item{epsilon.value}{numeric value used when \code{epsilon.type="otherValue"} or \code{epsilon.type="otherFactor"}. When \code{epsilon.type="otherValue"} and \code{epsilon.value=NA} (the default), the value described by Ficchi et al. (2026), \eqn{\epsilon = \min(10^{-6}, 10^{-1} \min(c))}, is computed internally.}
}

\details{
JDKGE combines four components:

\enumerate{
\item the Pearson correlation coefficient \eqn{r},
\item the variability term, defined as \eqn{\gamma = (\sigma_s / \mu_s) / (\sigma_o / \mu_o)} for \kbd{method="2012"} and as \eqn{\alpha = \sigma_s / \sigma_o} for \kbd{method="2009"} and \kbd{method="2021"},
\item the bias term, defined as \eqn{\beta = \mu_s / \mu_o} for \kbd{method="2009"} and \kbd{method="2012"}, and as \eqn{\beta_{2021} = (\mu_s - \mu_o)/\sigma_o} for \kbd{method="2021"}, and
\item the distributional similarity component \eqn{\Delta}.
}

For the divergence component, this implementation follows the paper's workflow:

\enumerate{
\item exact zeros are replaced according to \code{epsilon.type}. With the default \kbd{"otherValue"} and \code{epsilon.value=NA}, \eqn{\epsilon = \min(10^{-6}, 10^{-1} \min(c))}, where \eqn{c} is the set of strictly positive simulated and observed values,
\item the transformed values \eqn{\log(x)} are binned using a histogram,
\item the Freedman-Diaconis width is lower-bounded by \eqn{h_{min} = \min(10^2 \epsilon, 10^{-1})},
\item the number of bins is adjusted by the time-scale factor and clipped to the interval \eqn{[25, 100]},
\item additive smoothing with \eqn{\alpha = \epsilon} is applied to the empirical densities, and
\item Jensen-Shannon divergence is computed with base-2 logarithms.
}

For \code{density.method="kde"}, simulated and observed log-flows are smoothed with Gaussian kernel density estimates evaluated on a common grid over the pooled support using a shared bandwidth estimated from the pooled sample. Jensen-Shannon divergence is then computed from the two resulting probability vectors.

For \code{density.method="wasserstein"}, the log-flow distributions are compared with the first Wasserstein distance computed from empirical quantiles. The resulting distance is converted into a similarity component through
\deqn{\Delta = \exp(-W_1 / s_w)}
where \eqn{s_w} is a robust scale estimated from the pooled log-flows using the interquartile range, with fallback to the standard deviation when needed.

The metric is then computed as:

\deqn{JDKGE = 1 - \sqrt{(s[1](r-1))^2 + (s[2](vr-1))^2 + (s[3](br-1))^2 + (s[4](\Delta-1))^2}}

Joint Divergence Kling-Gupta efficiencies range from \eqn{-\infty} to 1. Values closer to 1 indicate stronger agreement between simulated and observed values across correlation, variability, bias, and distributional similarity.
}

\value{
If \code{out.type="single"}: numeric with the Joint Divergence Kling-Gupta Efficiency between \code{sim} and \code{obs}. If \code{sim} and \code{obs} are matrices, the output is a vector with one efficiency value per column pair.

If \code{out.type="full"}: a list with two elements:

\item{JDKGE.value}{numeric with the Joint Divergence Kling-Gupta Efficiency.}
\item{JDKGE.elements}{numeric with 4 elements: \sQuote{r}, the selected bias term, the selected variability term, and \sQuote{Delta}.}
}

\references{
\cite{Ficchi, A.; Bavera, D.; Grimaldi, S.; Moschini, F.; Pistocchi, A.; Russo, C.; Salamon, P.; Toreti, A. (2026). Improving low and high flow simulations at once: An enhanced metric for hydrological model calibrations. EGUsphere [preprint], https://doi.org/10.5194/egusphere-2026-43.}

\cite{Kling, H.; Fuchs, M.; Paulin, M. (2012). Runoff conditions in the upper Danube basin under an ensemble of climate change scenarios. Journal of Hydrology, 424, 264-277, doi:10.1016/j.jhydrol.2012.01.011.}

\cite{Kling, H.; Fuchs, M.; Paulin, M. (2012). Runoff conditions in the upper Danube basin under an ensemble of climate change scenarios. Journal of Hydrology, 424, 264-277, doi:10.1016/j.jhydrol.2012.01.011.}

\cite{Tang, G.; Clark, M.P.; Papalexiou, S.M. (2021). SC-earth: a station-based serially complete earth dataset from 1950 to 2019. Journal of Climate, 34(16), 6493-6511. doi:10.1175/JCLI-D-21-0067.1.}
}

\seealso{
\code{\link{NSE}}, \code{\link{wNSE}}, \code{\link{wsNSE}}, \code{\link{HFB}}, \code{\link{JDKGE}}, \code{\link{KGElf}}, \code{\link{rNSE}}, \code{\link{gof}}, \code{\link{ggof}}
}

\examples{
# Example 0.1: ideal case
obs <- 1:10
sim <- 1:10

JDKGE(sim, obs)

##################
# Example 1: simulated values equal to twice the observations
sim <- 2*obs
JDKGE(sim=sim, obs=obs, out.type="full")

##################
# Example 2: using kernel density estimation, instead of histograms (the default)
JDKGE(sim=sim, obs=obs, density.method="kde")
JDKGE(sim=sim, obs=obs, density.method="kde", kde.n.grid=1024)
JDKGE(sim=sim, obs=obs, density.method="wasserstein")
JDKGE(sim=sim, obs=obs, density.method="wasserstein", wasserstein.n.quantiles=1024)

##################
# Example 3: Looking at the difference between JDKGE and KGE, both with 'method=2009' 
#            and 'method=2012'
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Simulated daily time series, initially equal to twice the observed values
sim <- 2*obs 

# KGE 2009
KGE(sim=sim, obs=obs, method="2009", out.type="full")

# JDKGE (Ficchi et al., 2026):
JDKGE(sim=sim, obs=obs, method="2009", out.type="full")

# KGE 2012
KGE(sim=sim, obs=obs, method="2012", out.type="full")

# JDKGE (Ficchi et al., 2026):
JDKGE(sim=sim, obs=obs, method="2012", out.type="full")

# KGE 2021
KGE(sim=sim, obs=obs, method="2021", out.type="full")

# JDKGE (Ficchi et al., 2026):
JDKGE(sim=sim, obs=obs, method="2021", out.type="full")

##################
# Example 4: 
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Generating a simulated daily time series, initially equal to the observed series
sim <- obs 

# Computing the 'JDKGE' for the "best" (unattainable) case
JDKGE(sim=sim, obs=obs)

##################
# Example 5: JDKGE for simulated values equal to observations plus random noise 
#            on the first half of the observed values. 
#            This random noise has more relative importance for ow flows than 
#            for medium and high flows.
  
# Randomly changing the first 1826 elements of 'sim', by using a normal distribution 
# with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim[1:1826] <- obs[1:1826] + rnorm(1826, mean=10)
ggof(sim, obs)

JDKGE(sim=sim, obs=obs)

##################
# Example 6: JDKGE for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying a 
#            user-defined function to 'sim' and 'obs' during computations

fun1 <- function(x) {sqrt(x+1)}

JDKGE(sim=sim, obs=obs, fun=fun1)

# Verifying the previous value
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
JDKGE(sim=sim1, obs=obs1)

##################
# Example 7: JDKGE for a two-column data frame where simulated values are equal to 
#            observations plus random noise on the first half of the observed values 

SIM <- cbind(sim, sim)
OBS <- cbind(obs, obs)

JDKGE(sim=SIM, obs=OBS)
}

%% File rfactor.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2008-2026 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later


\name{rfactor}
\Rdversion{1.1}
\alias{rfactor}
\alias{rfactor.default}
\alias{rfactor.matrix}
\alias{rfactor.data.frame}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
R-factor
}
\description{
\var{R-factor} represents the average width of the given uncertainty bounds divided by the standard deviation of the observations. \cr

Ideally, i.e., with a combination of model structure and parameter values that perfectly represents the catchment under study, and in absence of measurement errors and other additional sources of uncertainty, all the simulated values should be in a perfect match with the observations, leading to a \var{P-factor} equal to 1, and an \var{R-factor} equal to zero. However, in real-world applications we aim at encompassing as much observations as possible within the given uncertainty bounds (\var{P-factor} close to 1) while keeping the width of the uncertainty bounds as small as possible (\var{R-factor} close to 0), in order to avoid obtaining a good bracketing of observations at expense of uncertainty bounds too wide to be informative for the decision-making process.
}
\usage{
rfactor(x, ...)

\method{rfactor}{default}(x, lband, uband, na.rm=TRUE, ...)

\method{rfactor}{data.frame}(x, lband, uband, na.rm=TRUE, ...)

\method{rfactor}{matrix}(x, lband, uband, na.rm=TRUE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
ts or zoo object with the observed values.
}
  \item{lband}{
numeric, ts or zoo object with the values of the lower uncertainty bound
}
  \item{uband}{
numeric, ts or zoo object with the values of the upper uncertainty bound
}
  \item{na.rm}{
logical value indicating whether 'NA' values should be stripped before the computation proceeds.
}
  \item{\dots}{
further arguments passed to or from other methods.
}
}
\details{

The \var{R-factor} quantifies the average width of the prediction uncertainty band relative to the variability of the observed data. It is a measure of the magnitude of predictive uncertainty associated with a model simulation.

Mathematically, the R-factor is defined as:

\deqn{
R\text{-factor} = \frac{\overline{d_x}}{\sigma_x}
}

where \eqn{\sigma_x} is the standard deviation of the observed variable \eqn{x}, and \eqn{\overline{d_x}} is the average thickness of the uncertainty band, computed as:

\deqn{
\overline{d_x} = \frac{1}{N} \sum_{i=1}^{N} \left( uband_i - lband_i \right)
}

where \eqn{N} is the total number of observations, and \eqn{lband_i} and \eqn{uband_i} are the lower and upper uncertainty bounds, respectively, at time step \eqn{i}.

The \var{R-factor} ranges from 0 to infinity, with an optimal value of 0 indicating perfect agreement between simulated and observed values (i.e., zero prediction uncertainty). In practical applications, the \var{R-factor} represents the width of the uncertainty interval and should be as small as possible. Values close to or smaller than 1 are commonly considered indicative of an acceptable level of predictive uncertainty, although acceptable thresholds depend on the quality of observations and the modelling context.

Because a larger fraction of observations can often be bracketed by widening the uncertainty bounds, the \var{R-factor} is typically interpreted jointly with the \var{P-factor}. A balance between a high \var{P-factor} (good coverage) and a low \var{R-factor} (narrow uncertainty bounds) is therefore sought during model calibration and uncertainty analysis.
}
\value{
Average width of the given uncertainty bounds, given by \code{lband} and \code{uband}, divided by the standard deviation of the observations \code{x} \cr

If \code{sim} and \code{obs} are matrixes, the returned value is a vector, with the R-factor between each column of \code{sim} and \code{obs}.
}
\references{
\cite{Abbaspour, K.C.; Faramarzi, M.; Ghasemi, S.S.; Yang, H. (2009), Assessing the impact of climate change on water resources in Iran, Water Resources Research, 45(10), W10,434, doi:10.1029/2008WR007615.}

\cite{Abbaspour, K.C., Yang, J. ; Maximov, I.; Siber, R.; Bogner, K.; Mieleitner, J. ; Zobrist, J.; Srinivasan, R. (2007), Modelling hydrology and water quality in the pre-alpine/alpine Thur watershed using SWAT, Journal of Hydrology, 333(2-4), 413-430, doi:10.1016/j.jhydrol.2006.09.014.}

\cite{Schuol, J.; Abbaspour, K.C.; Srinivasan, R.; Yang, H. (2008b), Estimation of freshwater availability in the West African sub-continent using the SWAT hydrologic model, Journal of Hydrology, 352(1-2), 30, doi:10.1016/j.jhydrol.2007.12.025}

\cite{Abbaspour, K.C. (2007), User manual for SWAT-CUP, SWAT calibration and uncertainty analysis programs, 93pp, Eawag: Swiss Fed. Inst. of Aquat. Sci. and Technol. Dubendorf, Switzerland.}
}
\author{
Mauricio Zambrano Bigiarini <mzb.devel@gmail.com>
}
\note{
So far, the argument \code{na.rm} is not being taken into account.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{pfactor}}, \code{\link{plotbands}}
}
\examples{
x <- 1:10
lband <- x - 0.1
uband <- x + 0.1
rfactor(x, lband, uband)

lband <- x - rnorm(10)
uband <- x + rnorm(10)
rfactor(x, lband, uband)

#############
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Selecting only the daily values belonging to the year 1961
obs <- window(obs, end=as.Date("1961-12-31"))

# Generating the lower and upper uncertainty bounds, centred at the observations
lband <- obs - 5
uband <- obs + 5

rfactor(obs, lband, uband)

# Randomly generating the lower and upper uncertainty bounds
uband <- obs + rnorm(length(obs))
lband <- obs - rnorm(length(obs))

rfactor(obs, lband, uband)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

% File valindex.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2008-2024 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{valindex}
\Rdversion{1.1}
\alias{valindex}
\alias{valindex.default}
\alias{valindex.matrix}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Valid Indexes
}
\description{
Identify the indexes that are simultaneously valid (not missing) in \code{sim} and \code{obs}.
}
\usage{
valindex(sim, obs, ...)

\method{valindex}{default}(sim, obs, ...)

\method{valindex}{matrix}(sim, obs, ...)

}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sim}{
zoo, xts, numeric, matrix or data.frame with simulated values
}
  \item{obs}{
zoo, xts, numeric, matrix or data.frame with observed values
}
  \item{\dots}{
further arguments passed to or from other methods.
}
}
%%\details{
%%  ~~ If necessary, more details than the description above ~~
%%}
\value{
A vector with the indexes that are simultaneously valid (not missing) in \code{obs} and \code{sim}.
}
%%\references{
%% ~put references to the literature/web site here ~
%%}
\author{
Mauricio Zambrano Bigiarini <mauricio.zambrano@ing.unitn.it>
}
\note{
This function is used in the functions of this package for removing missing values from the observed and simulated time series.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{is.na}}, \code{\link{which}}
}
\examples{
sim <- 1:5
obs <- c(1, NA, 3, NA, 5)
valindex(sim, obs)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

%% File PMR.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2026-2026 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{PMR}
\Rdversion{1.1}
\alias{PMR}
\alias{PMRrob}
\alias{PMR.default}
\alias{PMR.matrix}
\alias{PMR.data.frame}
\alias{PMR.zoo}

\title{
Proxy for Model Robustness
}

\description{
Proxy for model robustness (PMR) between \code{sim} and \code{obs}, with treatment of missing values.
}

\usage{
PMR(sim, obs, ...)

\method{PMR}{default}(sim, obs, na.rm=TRUE, k=NULL, min.years=5, 
             days.per.year=365, fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"),
             epsilon.value=NA)

\method{PMR}{data.frame}(sim, obs, na.rm=TRUE, k=NULL, min.years=5, 
             days.per.year=365, fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"),
             epsilon.value=NA)

\method{PMR}{matrix}(sim, obs, na.rm=TRUE, k=NULL, min.years=5, 
             days.per.year=365, fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"),
             epsilon.value=NA)

\method{PMR}{zoo}(sim, obs, na.rm=TRUE, k=NULL, min.years=5, 
             days.per.year=365, fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"),
             epsilon.value=NA)
}

\arguments{

  \item{sim}{
zoo object with simulated values. Multicolumn \code{zoo} objects are allowed.
}

  \item{obs}{
zoo object with observed values. Multicolumn \code{zoo} objects are allowed.
}

  \item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
For the full-period bias, only positions with valid paired values in \code{obs} and \code{sim} are used. For the moving-window biases, each fixed-length window is selected first, and invalid pairs are then removed inside that window.
}

  \item{k}{
integer value representing the length of the moving window (number of time steps) used to compute the bias over sub-periods. \cr

By default \code{k=NULL}, which means that its value is automatically computed based on the minimum numbers of years defined by \code{min.years}.

The k argument should reflect the temporal scale at which robustness is intended to be evaluated, and therefore depends primarily on the time resolution of the data. Royer-Gaspard et al. (2021) recommended to use multi-year windows, typically in the range of 3 to 5 years, to ensure that each sub-period captures meaningful hydroclimatic variability while still allowing enough windows for comparison.
}
  \item{min.years}{
Numeric, only used when the user does not explicitly define the value of \code{k}, i.e., when \code{k=NULL}. \cr

Minimum numbers of years used to ensure that each sub-period used int eh computation of PMR captures meaningful hydroclimatic variability while still allowing enough windows for comparison. By default, \code{min.years=5}.
}
  \item{days.per.year}{
Numeric, only used when the user does not explicitly define the value of \code{k}, i.e., when \code{k=NULL}.  \cr

Number of days in a year. A value of Use 365.25 is recoomended instead of the default value of 365 when \code{sim} and \code{obs} are long climatological series.
}
  \item{fun}{
function to be applied to \code{sim} and \code{obs} in order to obtain transformed values thereof before computing the proxy for model robustness.

The first argument MUST BE a numeric vector with any name (e.g., \code{x}), and additional arguments are passed using \code{\dots}.
}

  \item{\dots}{
arguments passed to \code{fun}, in addition to the mandatory first numeric vector.
}

  \item{epsilon.type}{
argument used to define a numeric value to be added to both \code{sim} and \code{obs} before applying \code{FUN}.

It was designed to allow the use of logarithm and other similar functions that do not work with zero values.

Valid values of \code{epsilon.type} are:

1) \kbd{"none"}: \code{sim} and \code{obs} are used by \code{fun} without the addition of any numeric value. This is the default option.

2) \kbd{"Pushpalatha2012"}: one hundredth (1/100) of the mean observed values is added to both \code{sim} and \code{obs} before applying \code{fun}, as described in Pushpalatha et al. (2012).

3) \kbd{"otherFactor"}: the numeric value defined in the \code{epsilon.value} argument is used to multiply the mean of the observed values. The resulting value is then added to both \code{sim} and \code{obs} before applying \code{fun}.

4) \kbd{"otherValue"}: the numeric value defined in the \code{epsilon.value} argument is directly added to both \code{sim} and \code{obs} before applying \code{fun}.
}

  \item{epsilon.value}{

 -) when \code{epsilon.type="otherValue"} it represents the numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. \cr

 -) when \code{epsilon.type="otherFactor"} it represents the numeric factor used to multiply the mean of the observed values to obtain the constant to be added to both \code{sim} and \code{obs} before applying \code{fun}.
}

}

\details{

\deqn{
PMR = 2 \times \frac{1}{N} \sum_{i=1}^{N} \left| (\bar{S}_i - \bar{O}_i) - (\bar{S} - \bar{O}) \right| \frac{1}{ \bar{O} }
}{
PMR = 2 * mean( abs( moving.bias - mean.bias ) ) / mean(obs)
}

where:

\itemize{

\item \eqn{\bar{S}_i} and \eqn{\bar{O}_i} are the mean simulated and observed values computed over the i-th moving window of length \code{k},

\item \eqn{\bar{S}} and \eqn{\bar{O}} are the overall mean simulated and observed values,

\item \eqn{N} is the number of moving windows.
}

The proxy for model robustness (PMR) is a dimensionless statistic that quantifies the temporal stability of model bias by measuring the average deviation of sub-period bias from the overall bias.

PMR indicates how consistent the model performance is across different time periods or hydrological conditions.

The proxy for model robustness ranges from 0 to positive infinity. Essentially, the closer to 0, the more temporally robust the model is. \cr

-) PMR = 0 corresponds to a perfectly robust model, in which the model bias is identical across all sub-periods. \cr

-) 0 < PMR < 1 indicates relatively stable model performance with moderate temporal variability in bias. \cr

-) PMR > 1 indicates increasing variability in model bias across time periods, suggesting reduced robustness of model performance.
}

\value{

Proxy for model robustness between \code{sim} and \code{obs}. \cr

If \code{sim} and \code{obs} are multicolumn \code{zoo} objects, the returned value is a vector with the proxy for model robustness between each column of \code{sim} and \code{obs}.
}

\references{

\cite{Royer-Gaspard, P., Andreassian, V., and Thirel, G. (2021). Technical note: PMR - a proxy metric to assess hydrological model robustness in a changing climate. Hydrology and Earth System Sciences, 25, 5703--5716. doi:10.5194/hess-25-5703-2021. }

\cite{Pushpalatha, R.; Perrin, C.; Le Moine, N.; Andreassian, V. (2012). A review of efficiency criteria suitable for evaluating low-flow simulations. Journal of Hydrology, 420, 171--182. doi:10.1016/j.jhydrol.2011.11.055.}

}

\author{
Mauricio Zambrano Bigiarini <mzb.devel@gmail.com>
}

\note{

\code{obs} and \code{sim} have to have the same length/dimension. \cr

For the moving-window biases, the fixed-length window is selected before invalid pairs are removed inside that window.

The choice of window length \code{k} influences the temporal scale at which robustness is evaluated.
}

\seealso{

\code{\link{pbias}}, \code{\link{NSE}}, \code{\link{VE}}, \code{\link{JDKGE}}, \code{\link{gof}}, \code{\link{ggof}}

}

\examples{

##################
# Example 1: Looking at the difference between PMR and KGE, both with 'method=2009' 
#            and 'method=2012'

# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Simulated daily time series, initially equal to twice the observed values
sim <- 2*obs 

# KGE 2009
KGE(sim=sim, obs=obs, method="2009", out.type="full")

# KGE 2012
KGE(sim=sim, obs=obs, method="2012", out.type="full")

# PMR (Royer-Gaspard et al., 2021):
PMR(sim=sim, obs=obs)

\dontrun{ 
##################
# Example 2: 
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Generating a simulated daily time series, initially equal to the observed series
sim <- obs 

# Computing the 'PMR' for the "best" (unattainable) case
PMR(sim=sim, obs=obs)

##################
# Example 3: PMR for simulated values equal to observations plus random noise 
#            on the first half of the observed values. 
#            This random noise has more relative importance for low flows than 
#            for medium and high flows.
  
# Randomly changing the first 1826 elements of 'sim', by using a normal distribution 
# with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim[1:1826] <- obs[1:1826] + rnorm(1826, mean=10)
ggof(sim, obs)

PMR(sim=sim, obs=obs)

##################
# Example 4: PMR for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' during computations.

PMR(sim=sim, obs=obs, fun=log)

# Verifying the previous value:
lsim <- log(sim)
lobs <- log(obs)
PMR(sim=lsim, obs=lobs)

##################
# Example 5: PMR for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding the Pushpalatha2012 constant
#            during computations

PMR(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012")

# Verifying the previous value, with the epsilon value following Pushpalatha2012
eps  <- mean(obs, na.rm=TRUE)/100
lsim <- log(sim+eps)
lobs <- log(obs+eps)
PMR(sim=lsim, obs=lobs)

##################
# Example 6: PMR for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding a user-defined constant
#            during computations

eps <- 0.01
PMR(sim=sim, obs=obs, fun=log, epsilon.type="otherValue", epsilon.value=eps)

# Verifying the previous value:
lsim <- log(sim+eps)
lobs <- log(obs+eps)
PMR(sim=lsim, obs=lobs)

##################
# Example 7: PMR for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and using a user-defined factor
#            to multiply the mean of the observed values to obtain the constant
#            to be added to 'sim' and 'obs' during computations

fact <- 1/50
PMR(sim=sim, obs=obs, fun=log, epsilon.type="otherFactor", epsilon.value=fact)

# Verifying the previous value:
eps  <- fact*mean(obs, na.rm=TRUE)
lsim <- log(sim+eps)
lobs <- log(obs+eps)
PMR(sim=lsim, obs=lobs)

##################
# Example 8: PMR for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying a 
#            user-defined function to 'sim' and 'obs' during computations

fun1 <- function(x) {sqrt(x+1)}

PMR(sim=sim, obs=obs, fun=fun1)

# Verifying the previous value
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
PMR(sim=sim1, obs=obs1)
##################
# Example 9: PMR for a two-column data frame where simulated values are equal to 
#            observations plus random noise on the first half of the observed values 

SIM <- cbind(sim, sim)
OBS <- cbind(obs, obs)

PMR(sim=SIM, obs=OBS)
}
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

%% File me.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2008-2024 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{me}
\Rdversion{1.1}
\alias{me}
\alias{me.default}
\alias{me.matrix}
\alias{me.data.frame}
\alias{me.zoo}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Mean Error
}
\description{
Mean error between \code{sim} and \code{obs}, in the same units of them, with treatment of missing values.
}
\usage{
me(sim, obs, ...)

\method{me}{default}(sim, obs, na.rm=TRUE, fun=NULL, ..., 
            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
            epsilon.value=NA)

\method{me}{data.frame}(sim, obs, na.rm=TRUE, fun=NULL, ..., 
            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
            epsilon.value=NA)

\method{me}{matrix}(sim, obs, na.rm=TRUE, fun=NULL, ..., 
            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
            epsilon.value=NA)

\method{me}{zoo}(sim, obs, na.rm=TRUE, fun=NULL, ..., 
            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
            epsilon.value=NA)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sim}{
numeric, zoo, matrix or data.frame with simulated values
}
  \item{obs}{
numeric, zoo, matrix or data.frame with observed values
}
  \item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
When an 'NA' value is found at the i-th position in \code{obs} \bold{OR} \code{sim}, the i-th value of \code{obs} \bold{AND} \code{sim} are removed before the computation.
}
  \item{fun}{
function to be applied to \code{sim} and \code{obs} in order to obtain transformed values thereof before computing this goodness-of-fit index.

The first argument MUST BE a numeric vector with any name (e.g., \code{x}), and additional arguments are passed using \code{\dots}.
}
  \item{\dots}{
arguments passed to \code{fun}, in addition to the mandatory first numeric vector.
}
  \item{epsilon.type}{
argument used to define a numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. 

It is was  designed to allow the use of logarithm and other similar functions that do not work with zero values.

Valid values of \code{epsilon.type} are:

1) \kbd{"none"}: \code{sim} and \code{obs} are used by \code{fun} without the addition of any numeric value. This is the default option.

2) \kbd{"Pushpalatha2012"}: one hundredth (1/100) of the mean observed values is added to both \code{sim} and \code{obs} before applying \code{fun}, as described in Pushpalatha et al. (2012). 

3) \kbd{"otherFactor"}: the numeric value defined in the \code{epsilon.value} argument is used to multiply the the mean observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs}, before applying \code{fun}.

4) \kbd{"otherValue"}: the numeric value defined in the \code{epsilon.value} argument is directly added to both \code{sim} and \code{obs}, before applying \code{fun}.
}
  \item{epsilon.value}{
 -) when \code{epsilon.type="otherValue"} it represents the numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. \cr
 -) when \code{epsilon.type="otherFactor"} it represents the numeric factor used to multiply the mean of the observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs} before applying \code{fun}.
}
}
\details{
\deqn{ me = \frac{1}{N} \sum_{i=1}^N { \left(S_i - O_i) \right) } }{%
me = mean( sim - obs), na.rm = TRUE) } 
}
\value{
Mean error between \code{sim} and \code{obs}. \cr

If \code{sim} and \code{obs} are matrixes, the returned value is a vector, with the mean error between each column of \code{sim} and \code{obs}.
}
\references{
\cite{Hill, T.; Lewicki, P.; Lewicki, P. (2006). Statistics: methods and applications: a comprehensive reference for science, industry, and data mining. StatSoft, Inc.}
}
\author{
Mauricio Zambrano Bigiarini <mzb.devel@gmail.com>
}
\note{
\code{obs} and \code{sim} has to have the same length/dimension \cr

The missing values in \code{obs} and \code{sim} are removed before the computation proceeds, and only those positions with non-missing values in \code{obs} and \code{sim} are considered in the computation
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{mae}}, \code{\link{gof}}, \code{\link{ggof}}
}
\examples{
##################
# Example 1: basic ideal case
obs <- 1:10
sim <- 1:10
me(sim, obs)

obs <- 1:10
sim <- 2:11
me(sim, obs)

##################
# Example 2: 
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Generating a simulated daily time series, initially equal to the observed series
sim <- obs 

# Computing the 'me' for the "best" (unattainable) case
me(sim=sim, obs=obs)

##################
# Example 3: me for simulated values equal to observations plus random noise 
#            on the first half of the observed values. 
#            This random noise has more relative importance for ow flows than 
#            for medium and high flows.
  
# Randomly changing the first 1826 elements of 'sim', by using a normal distribution 
# with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim[1:1826] <- obs[1:1826] + rnorm(1826, mean=10)
ggof(sim, obs)

me(sim=sim, obs=obs)

##################
# Example 4: me for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' during computations.

me(sim=sim, obs=obs, fun=log)

# Verifying the previous value:
lsim <- log(sim)
lobs <- log(obs)
me(sim=lsim, obs=lobs)

##################
# Example 5: me for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding the Pushpalatha2012 constant
#            during computations

me(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012")

# Verifying the previous value, with the epsilon value following Pushpalatha2012
eps  <- mean(obs, na.rm=TRUE)/100
lsim <- log(sim+eps)
lobs <- log(obs+eps)
me(sim=lsim, obs=lobs)

##################
# Example 6: me for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding a user-defined constant
#            during computations

eps <- 0.01
me(sim=sim, obs=obs, fun=log, epsilon.type="otherValue", epsilon.value=eps)

# Verifying the previous value:
lsim <- log(sim+eps)
lobs <- log(obs+eps)
me(sim=lsim, obs=lobs)

##################
# Example 7: me for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and using a user-defined factor
#            to multiply the mean of the observed values to obtain the constant
#            to be added to 'sim' and 'obs' during computations

fact <- 1/50
me(sim=sim, obs=obs, fun=log, epsilon.type="otherFactor", epsilon.value=fact)

# Verifying the previous value:
eps  <- fact*mean(obs, na.rm=TRUE)
lsim <- log(sim+eps)
lobs <- log(obs+eps)
me(sim=lsim, obs=lobs)

##################
# Example 8: me for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying a 
#            user-defined function to 'sim' and 'obs' during computations

fun1 <- function(x) {sqrt(x+1)}

me(sim=sim, obs=obs, fun=fun1)

# Verifying the previous value, with the epsilon value following Pushpalatha2012
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
me(sim=sim1, obs=obs1)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

%% File plotbands.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2008-2024 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later


\name{plotbands}
\Rdversion{1.1}
\alias{plotbands}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Plot a ts with observed values and two confidence bounds 
}
\description{
It plots a ts with observed values and two confidence bounds. Optionally can also add a simulated time series, in order to be compared with 'x'.
}
\usage{
plotbands(x, lband, uband, sim, 
          dates, date.fmt="\%Y-\%m-\%d",
          gof.leg= TRUE, gof.digits=2, 
          legend=c("Obs", "Sim", "95PPU"), leg.cex=1,
          bands.col="lightblue", border= NA,
          tick.tstep= "auto", lab.tstep= "auto", lab.fmt=NULL,
          cal.ini=NA, val.ini=NA, 
          main="Confidence Bounds for 'x'", 
          xlab="Time", ylab="Q, [m3/s]", ylim,
          col=c("black", "blue"), type= c("lines", "lines"),
          cex= c(0.5, 0.5), cex.axis=1.2, cex.lab=1.2,          
          lwd=c(0.6, 1), lty=c(3, 4), pch=c(1,9), ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
zoo or xts object with the observed values.
}
  \item{lband}{
zoo or xts object with the values of the lower band.
}
  \item{uband}{
zoo or xts object with the values of the upper band.
}
  \item{sim}{
OPTIONAL. zoo or xts object with the simulated values.
}
  \item{dates}{
OPTIONAL. Date, factor, or character object indicating the dates that will be assigned to \code{x}, \code{lband}, \code{uband}, and \code{sim} (when provided). \cr
If \code{dates} is a factor or character vector, its values are converted to dates using the date format specified by \code{date.fmt}. \cr
When \code{x}, \code{lband}, \code{uband}, and \code{sim} are already of zoo class, \bold{the values provided by \code{dates} over-write the original dates of the objects}.
}
  \item{date.fmt}{
OPTIONAL. Character indicating the format in which the dates entered are stored in \code{cal.ini} and \code{val.ini}. See \code{format} in \code{\link[base]{as.Date}}.\cr
Default value is \kbd{\%Y-\%m-\%d} \cr
ONLY required when \code{cal.ini}, \code{val.ini} or \code{dates} is provided.
}
  \item{gof.leg}{
logical indicating if the p-factor and r-factor have to be computed and plotted as legends on the graph.
}
  \item{gof.digits}{
OPTIONAL, numeric. Only used when \code{gof.leg=TRUE}. Decimal places used for rounding the goodness-of-fit indexes
}
  \item{legend}{
OPTIONAL. logical or character vector of length 3 with the strings that will be used for the legend of the plot. \cr
-) When \code{legend} is a character vector, the first element is used for labelling the observed series, the second for labelling the simulated series and the third one for the predictive uncertainty bounds. Default value is \code{c("obs", "sim", "95PPU")} \cr
-) When \code{legend=FALSE}, the legend is not drawn.
}
  \item{leg.cex}{
OPTIONAL. numeric. Used for the GoF legend. Character expansion factor *relative* to current 'par("cex")'. Used for text, and provides the default for 'pt.cex' and 'title.cex'. Default value is 1.
}
  \item{bands.col}{
See \code{\link[graphics]{polygon}}. Color to be used for filling the area between the lower and upper uncertainty bound.
}
  \item{border}{
See \code{\link[graphics]{polygon}}. The color to draw the border.  The default, 'NULL', means to  use 'par("fg")'.  Use 'border = NA' to omit borders.
}
  \item{tick.tstep}{
character, indicating the time step that have to be used for putting the ticks on the time axis. Valid values are: \kbd{auto}, \kbd{years}, \kbd{months},\kbd{weeks}, \kbd{days}, \kbd{hours}, \kbd{minutes}, \kbd{seconds}.
}
  \item{lab.tstep}{
character, indicating the time step that have to be used for putting the labels on the time axis. Valid values are: \kbd{auto}, \kbd{years}, \kbd{months},\kbd{weeks}, \kbd{days}, \kbd{hours}, \kbd{minutes}, \kbd{seconds}.
}
  \item{lab.fmt}{
Character indicating the format to be used for the label of the axis. See \code{lab.fmt} in \code{\link[hydroTSM]{drawTimeAxis}}.
}
 \item{cal.ini}{
OPTIONAL. Character with the date in which the calibration period started. \cr
ONLY used for drawing a vertical red line at this date. 
}
  \item{val.ini}{
OPTIONAL. Character with the date in which the validation period started. \cr
ONLY used for drawing a vertical red line at this date. 
}
  \item{main}{
an overall title for the plot: see 'title' 
}
  \item{xlab}{
a title for the x axis: see 'title'
}
  \item{ylab}{
a title for the y axis: see 'title'
}
  \item{ylim}{
the y limits of the plot. See \code{\link[graphics]{plot.default}}.
}
  \item{col}{
colors to be used for plotting the \code{x} and \code{sim} ts.
}
  \item{type}{
character.  Indicates if the observed and simulated series have to be plotted as lines or points. Possible values are: \cr
-) \kbd{lines} : the observed/simulated series are plotted as lines \cr
-) \kbd{points}: the observed/simulated series are plotted as points
}
  \item{cex}{
See code {\link[graphics]{plot.default}}. A numerical vector giving the amount by which plotting characters and symbols should be scaled relative to the default.  \cr
This works as a multiple of 'par("cex")'. 'NULL' and 'NA' are equivalent to '1.0'.  Note that this does not affect annotation.
}
  \item{cex.axis}{
magnification of axis annotation relative to 'cex'.
}
  \item{cex.lab}{
Magnification to be used for x and y labels relative to the current setting of 'cex'. See '?par'.
}
  \item{lwd}{
See \code{\link[graphics]{plot.default}}. The line width, see 'par'.
}
  \item{lty}{
See \code{\link[graphics]{plot.default}}. The line type, see 'par'. 
}
  \item{pch}{
numeric, with the type of symbol for \code{x} and \code{y}. (e.g.: 1: white circle; 9: white rhombus with a cross inside)
}
  \item{\dots}{
further arguments passed to the \code{\link[graphics]{points}} function for plotting \code{x}, or from other methods
}
}
%%\details{
%%  ~~ If necessary, more details than the description above ~~
%%}
%%\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
%%}
%%\references{
%% ~put references to the literature/web site here ~
%%}
\author{
Mauricio Zambrano Bigiarini <mzb.devel@gmail.com>
}
\note{
It requires the \pkg{hydroTSM} package
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{pfactor}}, \code{\link{rfactor}}
}
\examples{
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Selecting only the daily values belonging to the year 1961
obs <- window(obs, end=as.Date("1961-12-31"))

# Generating the lower and upper uncertainty bounds
lband <- obs - 5
uband <- obs + 5

\dontrun{
plotbands(obs, lband, uband)
}

# Randomly generating a simulated time series
sim <- obs + rnorm(length(obs), mean=3)

\dontrun{
plotbands(obs, lband, uband, sim)
}

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ dplot }

%% File NSE.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2008-2024 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{NSE}
\Rdversion{1.1}
\alias{NSeff}
\alias{NSE}
\alias{NSE.default}
\alias{NSE.matrix}
\alias{NSE.data.frame}
\alias{NSE.zoo}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Nash-Sutcliffe Efficiency
}
\description{
Nash-Sutcliffe efficiency between \code{sim} and \code{obs}, with treatment of missing values.
}
\usage{
NSE(sim, obs, ...)

\method{NSE}{default}(sim, obs, na.rm=TRUE, fun=NULL, ..., 
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)

\method{NSE}{data.frame}(sim, obs, na.rm=TRUE, fun=NULL, ..., 
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)

\method{NSE}{matrix}(sim, obs, na.rm=TRUE, fun=NULL, ..., 
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)

\method{NSE}{zoo}(sim, obs, na.rm=TRUE, fun=NULL, ..., 
            epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
            epsilon.value=NA)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sim}{
numeric, zoo, matrix or data.frame with simulated values
}
  \item{obs}{
numeric, zoo, matrix or data.frame with observed values
}
  \item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
When an 'NA' value is found at the i-th position in \code{obs} \bold{OR} \code{sim}, the i-th value of \code{obs} \bold{AND} \code{sim} are removed before the computation.
}
  \item{fun}{
function to be applied to \code{sim} and \code{obs} in order to obtain transformed values thereof before computing the Nash-Sutcliffe efficiency.

The first argument MUST BE a numeric vector with any name (e.g., \code{x}), and additional arguments are passed using \code{\dots}.
}
  \item{\dots}{
arguments passed to \code{fun}, in addition to the mandatory first numeric vector.
}
  \item{epsilon.type}{
argument used to define a numeric value to be added to both \code{sim} and \code{obs} before applying \code{FUN}. 

It is was  designed to allow the use of logarithm and other similar functions that do not work with zero values.

Valid values of \code{epsilon.type} are:

1) \kbd{"none"}: \code{sim} and \code{obs} are used by \code{fun} without the addition of any numeric value. This is the default option.

2) \kbd{"Pushpalatha2012"}: one hundredth (1/100) of the mean observed values is added to both \code{sim} and \code{obs} before applying \code{fun}, as described in Pushpalatha et al. (2012). 

3) \kbd{"otherFactor"}: the numeric value defined in the \code{epsilon.value} argument is used to multiply the mean of the observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs}, before applying \code{fun}.

4) \kbd{"otherValue"}: the numeric value defined in the \code{epsilon.value} argument is directly added to both \code{sim} and \code{obs}, before applying \code{fun}.
}
  \item{epsilon.value}{
 -) when \code{epsilon.type="otherValue"} it represents the numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. \cr
 -) when \code{epsilon.type="otherFactor"} it represents the numeric factor used to multiply the mean of the observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs} before applying \code{fun}.
}
}
\details{
\deqn{ NSE = 1 -\frac { \sum_{i=1}^N { \left( S_i - O_i \right)^2 } } { \sum_{i=1}^N { \left( O_i - \bar{O} \right)^2 } }  }{%
NSE = 1 - ( sum( (obs - sim)^2 ) / sum( (obs - mean(obs))^2 ) }

The Nash-Sutcliffe efficiency (NSE) is a normalized statistic that determines the relative magnitude of the residual variance ("noise") compared to the measured data variance ("information") (Nash and Sutcliffe, 1970). \cr

NSE indicates how well the plot of observed versus simulated data fits the 1:1 line.\cr

Nash-Sutcliffe efficiencies range from -Inf to 1. Essentially, the closer to 1, the more accurate the model is. \cr
-) NSE = 1, corresponds to a perfect match of modelled to the observed data. \cr
-) NSE = 0, indicates that the model predictions are as accurate as the mean of the observed data, \cr
-) -Inf < NSE < 0, indicates that the observed mean is better predictor than the model.
}
\value{
Nash-Sutcliffe efficiency between \code{sim} and \code{obs}. \cr

If \code{sim} and \code{obs} are matrixes, the returned value is a vector, with the Nash-Sutcliffe efficiency between each column of \code{sim} and \code{obs}.
}
\references{
\url{https://en.wikipedia.org/wiki/Nash\%E2\%80\%93Sutcliffe_model_efficiency_coefficient}

\cite{Nash, J.E. and Sutcliffe, J.V. (1970). River flow forecasting through conceptual models. Part 1: a discussion of principles, Journal of Hydrology 10, pp. 282-290. doi:10.1016/0022-1694(70)90255-6.}

\cite{Garrick, M.; Cunnane, C.; Nash, J.E. (1978). A criterion of efficiency for rainfall-runoff models. Journal of Hydrology 36, 375-381. doi:10.1016/0022-1694(78)90155-5.}

\cite{Schaefli, B., Gupta, H. (2007). Do Nash values have value?. Hydrological Processes 21, 2075-2080. doi:10.1002/hyp.6825.}

\cite{Criss, R. E.; Winston, W. E. (2008), Do Nash values have value? Discussion and alternate proposals. Hydrological Processes, 22: 2723-2725. doi:10.1002/hyp.7072.}

\cite{Gupta, H.V.; Kling, H. (2011). On typical range, sensitivity, and normalization of Mean Squared Error and Nash-Sutcliffe Efficiency type metrics. Water Resources Research, 47(10). doi:10.1029/2011WR010962.}

\cite{Pushpalatha, R.; Perrin, C.; Le Moine, N.; Andreassian, V. (2012). A review of efficiency criteria suitable for evaluating low-flow simulations. Journal of Hydrology, 420, 171-182. doi:10.1016/j.jhydrol.2011.11.055.}  

\cite{Knoben, W. J.; Freer, J. E.; Woods, R. A. (2019). Inherent benchmark or not? Comparing Nash-Sutcliffe and Kling-Gupta efficiency scores. Hydrology and Earth System Sciences, 23(10), 4323-4331. doi:10.5194/hess-23-4323-2019.}
}
\author{
Mauricio Zambrano Bigiarini <mzb.devel@gmail.com>
}
\note{
\code{obs} and \code{sim} has to have the same length/dimension \cr

The missing values in \code{obs} and \code{sim} are removed before the computation proceeds, and only those positions with non-missing values in \code{obs} and \code{sim} are considered in the computation
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{mNSE}}, \code{\link{rNSE}}, \code{\link{wNSE}}, \code{\link{KGE}}, \code{\link{gof}}, \code{\link{ggof}}
}
\examples{
##################
# Example 1: basic ideal case
obs <- 1:10
sim <- 1:10
NSE(sim, obs)

obs <- 1:10
sim <- 2:11
NSE(sim, obs)

##################
# Example 2: 
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Generating a simulated daily time series, initially equal to the observed series
sim <- obs 

# Computing the 'NSE' for the "best" (unattainable) case
NSE(sim=sim, obs=obs)

##################
# Example 3: NSE for simulated values equal to observations plus random noise 
#            on the first half of the observed values. 
#            This random noise has more relative importance for ow flows than 
#            for medium and high flows.
  
# Randomly changing the first 1826 elements of 'sim', by using a normal distribution 
# with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim[1:1826] <- obs[1:1826] + rnorm(1826, mean=10)
ggof(sim, obs)

NSE(sim=sim, obs=obs)

##################
# Example 4: NSE for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' during computations.

NSE(sim=sim, obs=obs, fun=log)

# Verifying the previous value:
lsim <- log(sim)
lobs <- log(obs)
NSE(sim=lsim, obs=lobs)

##################
# Example 5: NSE for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding the Pushpalatha2012 constant
#            during computations

NSE(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012")

# Verifying the previous value, with the epsilon value following Pushpalatha2012
eps  <- mean(obs, na.rm=TRUE)/100
lsim <- log(sim+eps)
lobs <- log(obs+eps)
NSE(sim=lsim, obs=lobs)

##################
# Example 6: NSE for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding a user-defined constant
#            during computations

eps <- 0.01
NSE(sim=sim, obs=obs, fun=log, epsilon.type="otherValue", epsilon.value=eps)

# Verifying the previous value:
lsim <- log(sim+eps)
lobs <- log(obs+eps)
NSE(sim=lsim, obs=lobs)

##################
# Example 7: NSE for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and using a user-defined factor
#            to multiply the mean of the observed values to obtain the constant
#            to be added to 'sim' and 'obs' during computations

fact <- 1/50
NSE(sim=sim, obs=obs, fun=log, epsilon.type="otherFactor", epsilon.value=fact)

# Verifying the previous value:
eps  <- fact*mean(obs, na.rm=TRUE)
lsim <- log(sim+eps)
lobs <- log(obs+eps)
NSE(sim=lsim, obs=lobs)

##################
# Example 8: NSE for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying a 
#            user-defined function to 'sim' and 'obs' during computations

fun1 <- function(x) {sqrt(x+1)}

NSE(sim=sim, obs=obs, fun=fun1)

# Verifying the previous value, with the epsilon value following Pushpalatha2012
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
NSE(sim=sim1, obs=obs1)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

%% File plotbandsonly.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2008-2024 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{plotbandsonly}
\Rdversion{1.1}
\alias{plotbandsonly}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Adds uncertainty bounds to an existing plot.
}
\description{
Adds a polygon representing uncertainty bounds to an existing plot.
}
\usage{
plotbandsonly(lband, uband, dates, date.fmt="\%Y-\%m-\%d",
          bands.col="lightblue", border= NA, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{lband}{
zoo or xts object with the values of the lower band.
}
  \item{uband}{
zoo or xts object with the values of the upper band.
}
  \item{dates}{
OPTIONAL. Date, factor, or character object indicating the dates that will be assigned to \code{lband} and \code{uband}. \cr
If \code{dates} is a factor or character vector, its values are converted to dates using the date format specified by \code{date.fmt}. \cr
When \code{lband} and \code{uband} are already of zoo class, \bold{the values provided by \code{dates} over-write the original dates of the objects}.
}
  \item{date.fmt}{
OPTIONAL. Character indicating the format of \code{dates}. See \code{format} in \code{\link[base]{as.Date}}.
}
  \item{bands.col}{
See \code{\link[graphics]{polygon}}. Color to be used for filling the area between the lower and upper uncertainty bound.
}
  \item{border}{
See \code{\link[graphics]{polygon}}. The color to draw the border.  The default, 'NULL', means to  use 'par("fg")'.  Use 'border = NA' to omit borders.
}
  \item{\dots}{
further arguments passed to the \code{\link[graphics]{polygon}} function for plotting the bands, or from other methods
}
}
%%\details{
%%  ~~ If necessary, more details than the description above ~~
%%}
%%\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
%%}
%%\references{
%% ~put references to the literature/web site here ~
%%}
\author{
Mauricio Zambrano Bigiarini <mzb.devel@gmail.com>
}
\note{
It requires the \pkg{hydroTSM} package
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{pfactor}}, \code{\link{rfactor}}
}
\examples{
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Selecting only the daily values belonging to the year 1961
obs <- window(obs, end=as.Date("1961-12-31"))

# Generating the lower and upper uncertainty bounds
lband <- obs - 5
uband <- obs + 5

\dontrun{
plot(obs, type="n")
plotbandsonly(lband, uband)
points(obs, col="blue", cex=0.6, type="o")
}

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ dplot }

%% File gof.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2011-2026 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{gof}
\Rdversion{1.1}
\alias{gof}
\alias{gof.default}
\alias{gof.matrix}
\alias{gof.data.frame}
\alias{gof.zoo}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Numerical Goodness-of-fit measures
}
\description{
Numerical goodness-of-fit measures between \code{sim} and \code{obs}, with treatment of missing values. Several performance indices for comparing two vectors, matrices or data.frames
}
\usage{
gof(sim, obs, ...)

\method{gof}{default}(sim, obs, na.rm=TRUE, do.spearman=FALSE, do.pbfdc=FALSE, 
        do.pmr=FALSE, j=1, lambda=0.95, norm="sd", s=c(1,1,1,1), 
        method=c("2009", "2012", "2021"), lQ.thr=0.6, hQ.thr=0.1, start.month=1, 
        k=NULL, min.years=5, days.per.year=365, 
        density.method=c("hist", "kde", "wasserstein"), 
        nbins="paper", timestep=86400, kde.n.grid=512, wasserstein.n.quantiles=512,
        digits=2, fun=NULL, ...,
        epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
        epsilon.value=NA)

\method{gof}{matrix}(sim, obs, na.rm=TRUE, do.spearman=FALSE, do.pbfdc=FALSE, 
        do.pmr=FALSE, j=1, lambda=0.95, norm="sd", s=c(1,1,1,1), 
        method=c("2009", "2012", "2021"), lQ.thr=0.6, hQ.thr=0.1, start.month=1, 
        k=NULL, min.years=5, days.per.year=365, 
        density.method=c("hist", "kde", "wasserstein"), 
        nbins="paper", timestep=86400, kde.n.grid=512, wasserstein.n.quantiles=512,
        digits=2, fun=NULL, ...,
        epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
        epsilon.value=NA)

\method{gof}{data.frame}(sim, obs, na.rm=TRUE, do.spearman=FALSE, do.pbfdc=FALSE, 
        do.pmr=FALSE, j=1, lambda=0.95, norm="sd", s=c(1,1,1,1), 
        method=c("2009", "2012", "2021"), lQ.thr=0.6, hQ.thr=0.1, start.month=1, 
        k=NULL, min.years=5, days.per.year=365, 
        density.method=c("hist", "kde", "wasserstein"), 
        nbins="paper", timestep=86400, kde.n.grid=512, wasserstein.n.quantiles=512,
        digits=2, fun=NULL, ...,
        epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
        epsilon.value=NA)

\method{gof}{zoo}(sim, obs, na.rm=TRUE, do.spearman=FALSE, do.pbfdc=FALSE, 
        do.pmr=FALSE, j=1, lambda=0.95, norm="sd", s=c(1,1,1,1), 
        method=c("2009", "2012", "2021"), lQ.thr=0.6, hQ.thr=0.1, start.month=1, 
        k=NULL, min.years=5, days.per.year=365, 
        density.method=c("hist", "kde", "wasserstein"), 
        nbins="paper", timestep=86400, kde.n.grid=512, wasserstein.n.quantiles=512,
        digits=2, fun=NULL, ...,
        epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
        epsilon.value=NA)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sim}{
numeric, zoo, matrix or data.frame with simulated values
}
  \item{obs}{
numeric, zoo, matrix or data.frame with observed values
}
  \item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
When an 'NA' value is found at the i-th position in \code{obs} \bold{OR} \code{sim}, the i-th value of \code{obs} \bold{AND} \code{sim} are removed before the computation.
}
  \item{do.spearman}{
logical. Indicates if the Spearman correlation has to be computed. The default is FALSE.
}
  \item{do.pbfdc}{
logical. Indicates if the Percent Bias in the Slope of the midsegment of the Flow Duration Curve (\code{\link{pbiasfdc}}) has to be computed. The default is FALSE.
}
  \item{do.pmr}{
logical. Indicates if the Proxy for Model Robustness (\code{\link{PMR}}) has to be computed. The default is FALSE.
}
  \item{j}{
argument passed to the \code{\link{mNSE}} and \code{\link{wsNSE}} functions.
}
  \item{lambda}{
argument passed to the \code{\link{wsNSE}} function.
}
  \item{norm}{
argument passed to the \code{\link{nrmse}} function
}
  \item{s}{
argument passed to the \code{\link{KGE}}, \code{\link{KGElf}}, \code{\link{sKGE}}, \code{\link{KGEkm}} and \code{\link{JDKGE}} functions. The fourth element in \code{s} is only used in the \code{\link{JDKGE}} function; while \code{\link{KGE}}, \code{\link{KGElf}}, \code{\link{sKGE}}, and \code{\link{KGEkm}} only uses the first three elements in \code{s}.
}
  \item{method}{
argument passed to the \code{\link{KGE}}, \code{\link{KGElf}}, \code{\link{sKGE}} and \code{\link{KGEkm}} functions.
}
  \item{lQ.thr}{
[OPTIONAL]. Only used for the computation of the \verb{pbiasFDC \%} (with the \code{pbiasfdc} function) and the weighted seasonal Nash-Sutcliffe Efficiency (with the \code{\link{wsNSE} function}.
}
  \item{hQ.thr}{
[OPTIONAL]. Only used for the computation of the \verb{pbiasFDC \%} (with the \code{pbiasfdc} function), the high flow bias (HFB, with the \code{HFB} function) and the weighted seasonal Nash-Sutcliffe Efficiency (with the \code{\link{wsNSE} function}.
}
  \item{start.month}{
[OPTIONAL]. Only used for the computation of the split KGE (\code{sKGE}), annual peak flow bias (\code{APFB}) and high flow bias (\code{HFB}) when the (hydrological) year of interest is different from the calendar year.

numeric in [1:12] indicating the starting month of the (hydrological) year. Numeric values in [1, 12] represent months in [January, December]. By default \code{start.month=1}.
}
  \item{k}{
Only used for the computation of the Proxy for Model Robustness (\code{PMR}). \cr

integer value representing the length of the moving window (number of time steps) used to compute the bias over sub-periods. \cr

The k argument should reflect the temporal scale at which robustness is intended to be evaluated, and therefore depends primarily on the time resolution of the data. Royer-Gaspard et al. (2021) recommended to use multi-year windows, typically in the range of 3 to 5 years, to ensure that each sub-period captures meaningful hydroclimatic variability while still allowing enough windows for comparison.
}
  \item{min.years}{
Only used for the computation of the Proxy for Model Robustness (\code{PMR}). \cr

Numeric, only used when the user does not explicitly define the value of \code{k}, i.e., when \code{k=NULL}. \cr

Minimum numbers of years used to ensure that each sub-period used int eh computation of PMR captures meaningful hydroclimatic variability while still allowing enough windows for comparison. By default, \code{min.years=5}.
}
  \item{days.per.year}{
Only used for the computation of the Proxy for Model Robustness (\code{PMR}). \cr

Numeric, only used when the user does not explicitly define the value of \code{k}, i.e., when \code{k=NULL}.  \cr

Number of days in a year. A value of Use 365.25 is recoomended instead of the default value of 365 when \code{sim} and \code{obs} are long climatological series.
}
\item{density.method}{
  Only used for the computation of the Joint Divergence Kling-Gupta Efficiency (\code{JDKGE}). \cr

  Character, representing the method used to compute the divergence component. \kbd{"hist"} uses the paper-faithful histogram-based Jensen-Shannon divergence, \kbd{"kde"} uses a common-grid kernel density estimate followed by Jensen-Shannon divergence, and \kbd{"wasserstein"} uses a Wasserstein-distance similarity on log-flows.}

\item{nbins}{
  Only used for the computation of the Joint Divergence Kling-Gupta Efficiency (\code{JDKGE}). \cr

  Character, representing the binning rule used by the histogram divergence component. The default \kbd{"paper"} uses the procedure described by Ficchi et al. (2026). This argument is ignored for \code{density.method="kde"} and \code{density.method="wasserstein"}.}

\item{timestep}{
  Only used for the computation of the Joint Divergence Kling-Gupta Efficiency (\code{JDKGE}). \cr

Numeric, representing the sampling time step in seconds used by the paper's bin-count adjustment. For \code{zoo} inputs this is inferred from the time index when omitted. The default for plain numeric vectors is one day (86400 seconds).}

\item{kde.n.grid}{
  Only used for the computation of the Joint Divergence Kling-Gupta Efficiency (\code{JDKGE}). \cr

Integer, number of grid points used when \code{density.method="kde"}. Larger values provide a finer common support grid at higher computational cost.}

\item{wasserstein.n.quantiles}{
  Only used for the computation of the Joint Divergence Kling-Gupta Efficiency (\code{JDKGE}). \cr

Integer, number of quantile levels used to approximate the first Wasserstein distance when \code{density.method="wasserstein"}. Larger values provide a finer approximation at higher computational cost.}

  \item{digits}{
decimal places used for rounding the goodness-of-fit indexes.
}
  \item{fun}{
function to be applied to \code{sim} and \code{obs} in order to obtain transformed values thereof before computing the all the goodness-of-fit functions.

The first argument MUST BE a numeric vector with any name (e.g., \code{x}), and additional arguments are passed using \code{\dots}.
}
  \item{\dots}{
arguments passed to \code{fun}, in addition to the mandatory first numeric vector.
}
  \item{epsilon.type}{
argument used to define a numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. 

It is was  designed to allow the use of logarithm and other similar functions that do not work with zero values.

Valid values of \code{epsilon.type} are:

1) \kbd{"none"}: \code{sim} and \code{obs} are used by \code{FUN} without the addition of any nummeric value.

2) \kbd{"Pushpalatha2012"}: one hundredth (1/100) of the mean observed values is added to both \code{sim} and \code{obs} before applying \code{FUN}, as described in Pushpalatha et al. (2012). 

3) \kbd{"otherFactor"}: the numeric value defined in the \code{epsilon.value} argument is used to multiply the the mean observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs}, before applying \code{FUN}.

4) \kbd{"otherValue"}: the numeric value defined in the \code{epsilon.value} argument is directly added to both \code{sim} and \code{obs}, before applying \code{FUN}.
}
  \item{epsilon.value}{
 -) when \code{epsilon.type="otherValue"} it represents the numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. \cr
 -) when \code{epsilon.type="otherFactor"} it represents the numeric factor used to multiply the mean of the observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs} before applying \code{fun}.
}
}
%%\details{
%%}
\value{
The output of the \code{gof} function is a matrix with one column only, and the following rows: 

\item{ME}{Mean Error}
\item{MAE}{Mean Absolute Error}
\item{MSE}{Mean Squared Error}
\item{RMSE}{Root Mean Square Error}
\item{ubRMSE}{Unbiased Root Mean Square Error}
\item{NRMSE}{Normalized Root Mean Square Error  ( -100\% <= NRMSE <= 100\% )}
\item{PBIAS}{Percent Bias ( -Inf <= PBIAS <= Inf [\%] )}
\item{RSR}{Ratio of RMSE to the Standard Deviation of the Observations, RSR = rms / sd(obs). ( 0 <= RSR <= +Inf )}
\item{rSD}{Ratio of Standard Deviations, rSD = sd(sim) / sd(obs)}
\item{NSE}{Nash-Sutcliffe Efficiency ( -Inf <= NSE <= 1 )}
\item{mNSE}{Modified Nash-Sutcliffe Efficiency ( -Inf <= mNSE <= 1 )}
\item{rNSE}{Relative Nash-Sutcliffe Efficiency ( -Inf <= rNSE <= 1 )}
\item{wNSE}{Weighted Nash-Sutcliffe Efficiency ( -Inf <= wNSE <= 1 )}
\item{wsNSE}{Weighted Seasonal Nash-Sutcliffe Efficiency ( -Inf <= wsNSE <= 1 )}
\item{d}{Index of Agreement ( 0 <= d <= 1 )}
\item{dr}{Refined Index of Agreement ( -1 <= dr <= 1 )}
\item{md}{Modified Index of Agreement ( 0 <= md <= 1 )}
\item{rd}{Relative Index of Agreement ( 0 <= rd <= 1 )}
\item{cp}{Persistence Index ( 0 <= cp <= 1 ) }
\item{r}{Pearson Correlation coefficient ( -1 <= r <= 1 )}
\item{R2}{Coefficient of Determination ( 0 <= R2 <= 1 )}
\item{bR2}{R2 multiplied by the coefficient of the regression line between \code{sim} and \code{obs} \cr ( 0 <= bR2 <= 1 )}
\item{VE}{Volumetric efficiency between \code{sim} and \code{obs} \cr ( -Inf <= VE <= 1)}
\item{KGE}{Kling-Gupta efficiency between \code{sim} and \code{obs} \cr ( -Inf <= KGE <= 1 )}
\item{KGElf}{Kling-Gupta Efficiency for low values between \code{sim} and \code{obs} \cr ( -Inf <= KGElf <= 1 )}
\item{KGEnp}{Non-parametric version of the Kling-Gupta Efficiency between \code{sim} and \code{obs} \cr ( -Inf <= KGEnp <= 1 )}
\item{KGEkm}{Knowable Moments Kling-Gupta Efficiency between \code{sim} and \code{obs} \cr ( -Inf <= KGEnp <= 1 )}

The following outputs are only produced when both \code{sim} and \code{obs} are zoo objects with sub-annual temporal frequency: 

\item{sKGE}{Split Kling-Gupta Efficiency between \code{sim} and \code{obs} \cr ( -Inf <= sKGE <= 1 )}
\item{APFB}{Annual Peak Flow Bias ( 0 <= APFB <= Inf )}
\item{HBF}{High Flow Bias ( 0 <= HFB <= Inf )}

The following outputs are only produced when defaul vlaues of a specific argument is changed by the user: 

\item{r.Spearman}{Spearman Correlation coefficient ( -1 <= r.Spearman <= 1 ). Only computed when \code{do.spearman=TRUE}}
\item{pbiasfdc}{PBIAS in the slope of the midsegment of the Flow Duration Curve. Only computed when \code{do.pbfdc=FALSE}}

%% ...
}
\references{
\cite{Abbaspour, K.C.; Faramarzi, M.; Ghasemi, S.S.; Yang, H. (2009), Assessing the impact of climate change on water resources in Iran, Water Resources Research, 45(10), W10,434, doi:10.1029/2008WR007615.}

\cite{Abbaspour, K.C., Yang, J. ; Maximov, I.; Siber, R.; Bogner, K.; Mieleitner, J. ; Zobrist, J.; Srinivasan, R. (2007), Modelling hydrology and water quality in the pre-alpine/alpine Thur watershed using SWAT, Journal of Hydrology, 333(2-4), 413-430, doi:10.1016/j.jhydrol.2006.09.014.}

\cite{Box, G.E. (1966). Use and abuse of regression. Technometrics, 8(4), 625-629. doi:10.1080/00401706.1966.10490407.}

\cite{Barrett, J.P. (1974). The coefficient of determination-some limitations. The American Statistician, 28(1), 19-20. doi:10.1080/00031305.1974.10479056.}

\cite{Chai, T.; Draxler, R.R. (2014). Root mean square error (RMSE) or mean absolute error (MAE)? - Arguments against avoiding RMSE in the literature, Geoscientific Model Development, 7, 1247-1250. doi:10.5194/gmd-7-1247-2014.}

\cite{Cinkus, G.; Mazzilli, N.; Jourde, H.; Wunsch, A.; Liesch, T.; Ravbar, N.; Chen, Z.; and Goldscheider, N. (2023). When best is the enemy of good - critical evaluation of performance criteria in hydrological models. Hydrology and Earth System Sciences 27, 2397-2411, doi:10.5194/hess-27-2397-2023.}

\cite{Criss, R. E.; Winston, W. E. (2008), Do Nash values have value? Discussion and alternate proposals. Hydrological Processes, 22: 2723-2725. doi:10.1002/hyp.7072.}

\cite{Entekhabi, D.; Reichle, R.H.; Koster, R.D.; Crow, W.T. (2010). Performance metrics for soil moisture retrievals and application requirements. Journal of Hydrometeorology, 11(3), 832-840. doi: 10.1175/2010JHM1223.1.}

\cite{Fowler, K.; Coxon, G.; Freer, J.; Peel, M.; Wagener, T.; Western, A.; Woods, R.; Zhang, L. (2018). Simulating runoff under changing climatic conditions: A framework for model improvement. Water Resources Research, 54(12), 812-9832. doi:10.1029/2018WR023989.}

\cite{Garcia, F.; Folton, N.; Oudin, L. (2017). Which objective function to calibrate rainfall-runoff models for low-flow index simulations?. Hydrological sciences journal, 62(7), 1149-1166. doi:10.1080/02626667.2017.1308511.}

\cite{Garrick, M.; Cunnane, C.; Nash, J.E. (1978). A criterion of efficiency for rainfall-runoff models. Journal of Hydrology 36, 375-381. doi:10.1016/0022-1694(78)90155-5.}

\cite{Gupta, H.V.; Kling, H.; Yilmaz, K.K.; Martinez, G.F. (2009). Decomposition of the mean squared error and NSE performance criteria: Implications for improving hydrological modelling. Journal of hydrology, 377(1-2), 80-91. doi:10.1016/j.jhydrol.2009.08.003. ISSN 0022-1694.}

\cite{Gupta, H.V.; Kling, H. (2011). On typical range, sensitivity, and normalization of Mean Squared Error and Nash-Sutcliffe Efficiency type metrics. Water Resources Research, 47(10). doi:10.1029/2011WR010962.}

\cite{Hahn, G.J. (1973). The coefficient of determination exposed. Chemtech, 3(10), 609-612. Aailable online at: \url{https://www2.hawaii.edu/~cbaajwe/Ph.D.Seminar/Hahn1973.pdf}.}

\cite{Hodson, T.O. (2022). Root-mean-square error (RMSE) or mean absolute error (MAE): when to use them or not, Geoscientific Model Development, 15, 5481-5487, doi:10.5194/gmd-15-5481-2022.}

\cite{Hundecha, Y., Bardossy, A. (2004). Modeling of the effect of land use changes on the runoff generation of a river basin through parameter regionalization of a watershed model. Journal of hydrology, 292(1-4), 281-295. doi:10.1016/j.jhydrol.2004.01.002.}

\cite{Kitanidis, P.K.; Bras, R.L. (1980). Real-time forecasting with a conceptual hydrologic model. 2. Applications and results. Water Resources Research, Vol. 16, No. 6, pp. 1034:1044. doi:10.1029/WR016i006p01034.} \cr

\cite{Kling, H.; Fuchs, M.; Paulin, M. (2012). Runoff conditions in the upper Danube basin under an ensemble of climate change scenarios. Journal of Hydrology, 424, 264-277, doi:10.1016/j.jhydrol.2012.01.011.}

\cite{Knoben, W.J.; Freer, J.E.; Woods, R.A. (2019). Inherent benchmark or not? Comparing Nash-Sutcliffe and Kling-Gupta efficiency scores. Hydrology and Earth System Sciences, 23(10), 4323-4331. doi:10.5194/hess-23-4323-2019.}

\cite{Krause, P.; Boyle, D.P.; Base, F. (2005). Comparison of different efficiency criteria for hydrological model assessment, Advances in Geosciences, 5, 89-97. doi:10.5194/adgeo-5-89-2005.} \cr

\cite{Krstic, G.; Krstic, N.S.; Zambrano-Bigiarini, M. (2016). The br2-weighting Method for Estimating the Effects of Air Pollution on Population Health. Journal of Modern Applied Statistical Methods, 15(2), 42. doi:10.22237/jmasm/1478004000}

\cite{Legates, D.R.; McCabe, G. J. Jr. (1999), Evaluating the Use of "Goodness-of-Fit" Measures in Hydrologic and Hydroclimatic Model Validation, Water Resour. Res., 35(1), 233-241. doi:10.1029/1998WR900018.} 

\cite{Ling, X.; Huang, Y.; Guo, W.; Wang, Y.; Chen, C.; Qiu, B.; Ge, J.; Qin, K.; Xue, Y.; Peng, J. (2021). Comprehensive evaluation of satellite-based and reanalysis soil moisture products using in situ observations over China. Hydrology and Earth System Sciences, 25(7), 4209-4229. doi:10.5194/hess-25-4209-2021.}

\cite{Mizukami, N.; Rakovec, O.; Newman, A.J.; Clark, M.P.; Wood, A.W.; Gupta, H.V.; Kumar, R.: (2019). On the choice of calibration metrics for "high-flow" estimation using hydrologic models, Hydrology Earth System Sciences 23, 2601-2614, doi:10.5194/hess-23-2601-2019.}

\cite{Moriasi, D.N.; Arnold, J.G.; van Liew, M.W.; Bingner, R.L.; Harmel, R.D.; Veith, T.L. (2007). Model evaluation guidelines for systematic quantification of accuracy in watershed simulations. Transactions of the ASABE. 50(3):885-900}

\cite{Nash, J.E. and Sutcliffe, J.V. (1970). River flow forecasting through conceptual models. Part 1: a discussion of principles, Journal of Hydrology 10, pp. 282-290. doi:10.1016/0022-1694(70)90255-6.}

\cite{Pearson, K. (1920). Notes on the history of correlation. Biometrika, 13(1), 25-45. doi:10.2307/2331722.}

\cite{Pfannerstill, M.; Guse, B.; Fohrer, N. (2014). Smart low flow signature metrics for an improved overall performance evaluation of hydrological models. Journal of Hydrology, 510, 447-458. doi:10.1016/j.jhydrol.2013.12.044.} 

\cite{Pizarro, A.; Jorquera, J. (2024). Advancing objective functions in hydrological modelling: Integrating knowable moments for improved simulation accuracy. Journal of Hydrology, 634, 131071. doi:10.1016/j.jhydrol.2024.131071.}

\cite{Pool, S.; Vis, M.; Seibert, J. (2018). Evaluating model performance: towards a non-parametric variant of the Kling-Gupta efficiency. Hydrological Sciences Journal, 63(13-14), pp.1941-1953. doi:/10.1080/02626667.2018.1552002.}

\cite{Pushpalatha, R.; Perrin, C.; Le Moine, N.; Andreassian, V. (2012). A review of efficiency criteria suitable for evaluating low-flow simulations. Journal of Hydrology, 420, 171-182. doi:10.1016/j.jhydrol.2011.11.055.}  

\cite{Santos, L.; Thirel, G.; Perrin, C. (2018). Pitfalls in using log-transformed flows within the KGE criterion. doi:10.5194/hess-22-4583-2018.}

\cite{Schaefli, B., Gupta, H. (2007). Do Nash values have value?. Hydrological Processes 21, 2075-2080. doi:10.1002/hyp.6825.}

\cite{Schober, P.; Boer, C.; Schwarte, L.A. (2018). Correlation coefficients: appropriate use and interpretation. Anesthesia and Analgesia, 126(5), 1763-1768. doi:10.1213/ANE.0000000000002864.}

\cite{Schuol, J.; Abbaspour, K.C.; Srinivasan, R.; Yang, H. (2008b), Estimation of freshwater availability in the West African sub-continent using the SWAT hydrologic model, Journal of Hydrology, 352(1-2), 30, doi:10.1016/j.jhydrol.2007.12.025}

\cite{Sorooshian, S., Q. Duan, and V. K. Gupta. (1993). Calibration of rainfall-runoff models: Application of global optimization to the Sacramento Soil Moisture Accounting Model, Water Resources Research, 29 (4), 1185-1194, doi:10.1029/92WR02617}.

\cite{Spearman, C. (1961). The Proof and Measurement of Association Between Two Things. In J. J. Jenkins and D. G. Paterson (Eds.), Studies in individual differences: The search for intelligence (pp. 45-58). Appleton-Century-Crofts. doi:10.1037/11491-005}

\cite{Tang, G.; Clark, M.P.; Papalexiou, S.M. (2021). SC-earth: a station-based serially complete earth dataset from 1950 to 2019. Journal of Climate, 34(16), 6493-6511. doi:10.1175/JCLI-D-21-0067.1.}

\cite{Yapo P.O.; Gupta H.V.; Sorooshian S. (1996). Automatic calibration of conceptual rainfall-runoff models: sensitivity to calibration data. Journal of Hydrology. v181 i1-4. 23-48. doi:10.1016/0022-1694(95)02918-4}

\cite{Yilmaz, K.K., Gupta, H.V. ; Wagener, T. (2008), A process-based diagnostic approach to model evaluation: Application to the NWS distributed hydrologic model, Water Resources Research, 44, W09417, doi:10.1029/2007WR006716.}

\cite{Willmott, C.J. (1981). On the validation of models. Physical Geography, 2, 184--194. doi:10.1080/02723646.1981.10642213.}

\cite{Willmott, C.J. (1984). On the evaluation of model performance in physical geography. Spatial Statistics and Models, G. L. Gaile and C. J. Willmott, eds., 443-460. doi:10.1007/978-94-017-3048-8_23.}

\cite{Willmott, C.J.; Ackleson, S.G. Davis, R.E.; Feddema, J.J.; Klink, K.M.; Legates, D.R.; O'Donnell, J.; Rowe, C.M. (1985), Statistics for the Evaluation and Comparison of Models, J. Geophys. Res., 90(C5), 8995-9005. doi:10.1029/JC090iC05p08995.}

\cite{Willmott, C.J.; Matsuura, K. (2005). Advantages of the mean absolute error (MAE) over the root mean square error (RMSE) in assessing average model performance, Climate Research, 30, 79-82, doi:10.3354/cr030079.}

\cite{Willmott, C.J.; Matsuura, K.; Robeson, S.M. (2009). Ambiguities inherent in sums-of-squares-based error statistics, Atmospheric Environment, 43, 749-752, doi:10.1016/j.atmosenv.2008.10.005.}

\cite{Willmott, C.J.; Robeson, S.M.; Matsuura, K. (2012). A refined index of model performance. International Journal of climatology, 32(13), pp.2088-2094. doi:10.1002/joc.2419.}

\cite{Willmott, C.J.; Robeson, S.M.; Matsuura, K.; Ficklin, D.L. (2015). Assessment of three dimensionless measures of model performance. Environmental Modelling & Software, 73, pp.167-174. doi:10.1016/j.envsoft.2015.08.012}

\cite{Zambrano-Bigiarini, M.; Bellin, A. (2012). Comparing goodness-of-fit measures for calibration of models focused on extreme events. EGU General Assembly 2012, Vienna, Austria, 22-27 Apr 2012, EGU2012-11549-1.}
}
\author{
Mauricio Zambrano Bigiarini <mzb.devel@gmail.com>
}
\note{
\code{obs} and \code{sim} has to have the same length/dimension. \cr

Missing values in \code{obs} and/or \code{sim} can be removed before the computations, depending on the value of \code{na.rm}. \cr

Although \code{r} and \code{r2} have been widely used for model evaluation, these statistics are over-sensitive to outliers and insensitive to additive and proportional differences between model predictions and measured data (Legates and McCabe, 1999)
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
\code{\link{ggof}}, \code{\link{me}}, \code{\link{mae}}, \code{\link{mse}}, \code{\link{rmse}}, \code{\link{ubRMSE}}, 
\code{\link{nrmse}}, \code{\link{pbias}}, \code{\link{rsr}}, \code{\link{rSD}}, \code{\link{NSE}}, \code{\link{mNSE}}, 
\code{\link{rNSE}}, \code{\link{wNSE}}, \code{\link{wsNSE}}, \code{\link{d}}, \code{\link{dr}}, \code{\link{md}}, 
\code{\link{rd}}, \code{\link{cp}}, \code{\link{rPearson}}, \code{\link{R2}}, \code{\link{br2}}, \code{\link{VE}}, 
\code{\link{KGE}}, \code{\link{KGElf}}, \code{\link{KGEnp}}, , \code{\link{KGEkm}}, \code{\link{sKGE}}, \code{\link{APFB}}, 
\code{\link{HFB}}, \code{\link{rSpearman}}, \code{\link{pbiasfdc}}
}
\examples{
##################
# Example 1: basic ideal case
obs <- 1:10
sim <- 1:10
gof(sim, obs)

obs <- 1:10
sim <- 2:11
gof(sim, obs)

##################
# Example 2: 
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Generating a simulated daily time series, initially equal to the observed series
sim <- obs 

# Computing the 'gof' for the "best" (unattainable) case
gof(sim=sim, obs=obs)

##################
# Example 3: gof for simulated values equal to observations plus random noise 
#            on the first half of the observed values. 
#            This random noise has more relative importance for low flows than 
#            for medium and high flows.
  
# Randomly changing the first 1826 elements of 'sim', by using a normal distribution 
# with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim[1:1826] <- obs[1:1826] + rnorm(1826, mean=10)
ggof(sim, obs)

gof(sim=sim, obs=obs)

##################
# Example 4: gof for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' during computations.

gof(sim=sim, obs=obs, fun=log)

# Verifying the previous value:
lsim <- log(sim)
lobs <- log(obs)
gof(sim=lsim, obs=lobs)

##################
# Example 5: gof for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding the Pushpalatha2012 constant
#            during computations

gof(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012")

# Verifying the previous value, with the epsilon value following Pushpalatha2012
eps  <- mean(obs, na.rm=TRUE)/100
lsim <- log(sim+eps)
lobs <- log(obs+eps)
gof(sim=lsim, obs=lobs)

\dontrun{
##################
# Example 6: gof for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding a user-defined constant
#            during computations

eps <- 0.01
gof(sim=sim, obs=obs, fun=log, epsilon.type="otherValue", epsilon.value=eps)

# Verifying the previous value:
lsim <- log(sim+eps)
lobs <- log(obs+eps)
gof(sim=lsim, obs=lobs)

##################
# Example 7: gof for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and using a user-defined factor
#            to multiply the mean of the observed values to obtain the constant
#            to be added to 'sim' and 'obs' during computations

fact <- 1/50
gof(sim=sim, obs=obs, fun=log, epsilon.type="otherFactor", epsilon.value=fact)

# Verifying the previous value:
eps  <- fact*mean(obs, na.rm=TRUE)
lsim <- log(sim+eps)
lobs <- log(obs+eps)
gof(sim=lsim, obs=lobs)

##################
# Example 8: gof for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying a 
#            user-defined function to 'sim' and 'obs' during computations

fun1 <- function(x) {sqrt(x+1)}

gof(sim=sim, obs=obs, fun=fun1)

# Verifying the previous value, with the epsilon value following Pushpalatha2012
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
gof(sim=sim1, obs=obs1)

# Storing a matrix object with all the GoFs:
g <-  gof(sim, obs)

# Getting only the RMSE
g[4,1]
g["RMSE",]


# Writing all the GoFs into a TXT file
write.table(g, "GoFs.txt", col.names=FALSE, quote=FALSE)

# Getting the graphical representation of 'obs' and 'sim' along with the 
# numeric goodness of fit 
ggof(sim=sim, obs=obs)
}

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

%% File KGElf.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2017-2024 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or late

\name{KGElf}
\Rdversion{1.1}
\alias{KGElf}
\alias{KGElf.default}
\alias{KGElf.matrix}
\alias{KGElf.data.frame}
\alias{KGElf.zoo}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Kling-Gupta Efficiency for low values
}
\description{
Kling-Gupta efficiency between \code{sim} and \code{obs}, with focus on low (streamflow) values and treatment of missing values. \cr

This goodness-of-fit measure was developed by Garcia et al. (2017), as a modification to the original Kling-Gupta efficiency (KGE) proposed by Gupta et al. (2009). See Details.
}
\usage{
KGElf(sim, obs, ...)

\method{KGElf}{default}(sim, obs, s=c(1,1,1), na.rm=TRUE, method=c("2009", "2012", "2021"), 
               epsilon.type=c("Pushpalatha2012", "otherFactor", "otherValue", "none"), 
               epsilon.value=NA, ...)

\method{KGElf}{data.frame}(sim, obs, s=c(1,1,1), na.rm=TRUE, method=c("2009", "2012", "2021"), 
               epsilon.type=c("Pushpalatha2012", "otherFactor", "otherValue", "none"), 
               epsilon.value=NA, ...)

\method{KGElf}{matrix}(sim, obs, s=c(1,1,1), na.rm=TRUE, method=c("2009", "2012", "2021"), 
               epsilon.type=c("Pushpalatha2012", "otherFactor", "otherValue", "none"), 
               epsilon.value=NA, ...)
             
\method{KGElf}{zoo}(sim, obs, s=c(1,1,1), na.rm=TRUE, method=c("2009", "2012", "2021"), 
               epsilon.type=c("Pushpalatha2012", "otherFactor", "otherValue", "none"), 
               epsilon.value=NA, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sim}{
numeric, zoo, matrix or data.frame with simulated values
}
  \item{obs}{
numeric, zoo, matrix or data.frame with observed values
}
  \item{s}{
numeric of length 3, representing the scaling factors to be used for re-scaling the criteria space before computing the Euclidean distance from the ideal point c(1,1,1), i.e., \code{s} elements are used for adjusting the emphasis on different components.
The first elements is used for rescaling the Pearson product-moment correlation coefficient (\code{r}), the second element is used for rescaling \code{Alpha} and the third element is used for re-scaling \code{Beta}
}
  \item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
When an 'NA' value is found at the i-th position in \code{obs} \bold{OR} \code{sim}, the i-th value of \code{obs} \bold{AND} \code{sim} are removed before the computation.
}
  \item{method}{
character, indicating the formula used to compute the variability ratio in the Kling-Gupta efficiency. Valid values are:

-) \kbd{2009}: the variability is defined as \sQuote{Alpha}, the ratio of the standard deviation of \code{sim} values to the standard deviation of \code{obs}. This is the default option. See Gupta et al. (2009).

-) \kbd{2012}: the variability is defined as \sQuote{Gamma}, the ratio of the coefficient of variation of \code{sim} values to the coefficient of variation of \code{obs}. See Kling et al. (2012). 

-) \kbd{2021}: the bias is defined as \sQuote{Beta}, the ratio of \code{mean(sim)} minus \code{mean(obs)} to the standard deviation of \code{obs}. The variability is defined as \sQuote{Alpha}, the ratio of the standard deviation of \code{sim} values to the standard deviation of \code{obs}. See Tang et al. (2021). 
}
  \item{epsilon.type}{
argument used to define a numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. 

It is designed to allow the use of logarithm and other similar functions that do not work with zero values.

Valid values of \code{epsilon.type} are:

1) \kbd{"Pushpalatha2012"}: one hundredth (1/100) of the mean observed values is added to both \code{sim} and \code{obs} before applying \code{fun}, as described in Pushpalatha et al. (2012). This is the default option.

2) \kbd{"otherFactor"}: the numeric value defined in the \code{epsilon.value} argument is used to multiply the the mean observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs}, before applying \code{FUN}.

3) \kbd{"otherValue"}: the numeric value defined in the \code{epsilon.value} argument is directly added to both \code{sim} and \code{obs}, before applying \code{fun}.

4) \kbd{"none"}: \code{sim} and \code{obs} are used by \code{fun} without the addition of any numeric value.

}
  \item{epsilon.value}{
 -) when \code{epsilon.type="otherValue"} it represents the numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. \cr
 -) when \code{epsilon.type="otherFactor"} it represents the numeric factor used to multiply the mean of the observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs} before applying \code{fun}.
}
  \item{\dots}{
further arguments passed to or from other methods.
}
}
\details{

Garcia et al. (2017) tested different objective functions and found that the mean value of the KGE applied to the streamflows (i.e., KGE(Q)) and the KGE applied to the inverse of the streamflows (i.e., KGE(1/Q) is able to provide a an aceptable representation of low-flow indices important for water management. They also found that KGE applied to a transformation of streamflow values (e.g., log)  is inadequate to capture low-flow indices important for water management. \cr

The robustness of their findings depends more on the climate variability rather than the objective function, and they are insensitive to the hydrological model used in the evaluation.

\deqn{KGE_{lf} =  \frac{KGE(Q) + KGE(1/Q)}{2} }{%
KGElf = 1 - sqrt[ (s[1]*(r-1))^2 + (s[2]*(vr-1))^2 + (s[3]*(Beta-1))^2] ; r=Pearson product-moment correlation coefficient ; alpha=sigma_s/sigma_o ; beta=mu_s/mu_o ; gamma=CV_s/CV_o}

Traditional Kling-Gupta efficiencies (Gupta et al., 2009; Kling et al., 2012) range from -Inf to 1 and, therefore, KGElf should also range from -Inf to 1. Essentially, the closer to 1, the more similar \code{sim} and \code{obs} are. \cr

Knoben et al. (2019) showed that traditional Kling-Gupta (Gupta et al., 2009; Kling et al., 2012) values greater than -0.41 indicate that a model improves upon the mean flow benchmark, even if the model's KGE value is negative.
}
\value{
numeric with the Kling-Gupta efficiency for low flows between \code{sim} and \code{obs}. \cr

If \code{sim} and \code{obs} are matrices, the output value is a vector, with the Kling-Gupta efficiency between each column of \code{sim} and \code{obs}
}
\references{

\cite{Garcia, F.; Folton, N.; Oudin, L. (2017). Which objective function to calibrate rainfall-runoff models for low-flow index simulations?. Hydrological sciences journal, 62(7), 1149-1166. doi:10.1080/02626667.2017.1308511.}

\cite{Pushpalatha, R., Perrin, C., Le Moine, N. and Andreassian, V. (2012). A review of efficiency criteria suitable for evaluating low-flow simulations. Journal of Hydrology, 420, 171-182. doi:10.1016/j.jhydrol.2011.11.055.}

\cite{Pfannerstill, M.; Guse, B.; Fohrer, N. (2014). Smart low flow signature metrics for an improved overall performance evaluation of hydrological models. Journal of Hydrology, 510, 447-458. doi:10.1016/j.jhydrol.2013.12.044.}

\cite{Gupta, H. V.; Kling, H.; Yilmaz, K. K.; Martinez, G. F. (2009). Decomposition of the mean squared error and NSE performance criteria: Implications for improving hydrological modelling. Journal of hydrology, 377(1-2), 80-91. doi:10.1016/j.jhydrol.2009.08.003. ISSN 0022-1694.}

\cite{Kling, H.; Fuchs, M.; Paulin, M. (2012). Runoff conditions in the upper Danube basin under an ensemble of climate change scenarios. Journal of Hydrology, 424, 264-277, doi:10.1016/j.jhydrol.2012.01.011.}

\cite{Santos, L.; Thirel, G.; Perrin, C. (2018). Pitfalls in using log-transformed flows within the KGE criterion. doi:10.5194/hess-22-4583-2018}.

\cite{Knoben, W. J.; Freer, J. E.; Woods, R. A. (2019). Inherent benchmark or not? Comparing Nash-Sutcliffe and Kling-Gupta efficiency scores. Hydrology and Earth System Sciences, 23(10), 4323-4331. doi:10.5194/hess-23-4323-2019.}
}
\author{
Mauricio Zambrano-Bigiarini <mzb.devel@gmail.com>
}
\note{
\code{obs} and \code{sim} has to have the same length/dimension \cr

The missing values in \code{obs} and \code{sim} are removed before the computation proceeds, and only those positions with non-missing values in \code{obs} and \code{sim} are considered in the computation
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{KGE}}, \code{\link{KGEnp}}, \code{\link{sKGE}}, \code{\link{gof}}, \code{\link{ggof}}
}
\examples{
##################
# Example1: basic ideal case
obs <- 1:10
sim <- 1:10
KGElf(sim, obs)

obs <- 1:10
sim <- 2:11
KGElf(sim, obs)

##################
# Example2: Looking at the difference between 'method=2009' and 'method=2012'
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Simulated daily time series, initially equal to twice the observed values
sim <- 2*obs 

# KGE 2009
KGE(sim=sim, obs=obs, method="2009", out.type="full")

# KGE 2012
KGE(sim=sim, obs=obs, method="2012", out.type="full")

# KGElf (Garcia et al., 2017):
KGElf(sim=sim, obs=obs, method="2012")

##################
# Example3: KGElf for simulated values equal to observations plus random noise 
#           on the first half of the observed values. 
#           This random noise has more relative importance for low flows than 
#           for medium and high flows.
  
# Randomly changing the first 1826 elements of 'sim', by using a normal distribution 
# with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim <- obs 
sim[1:1826] <- obs[1:1826] + rnorm(1826, mean=10)
ggof(sim, obs)

# Computing 'KGElf'
KGElf(sim=sim, obs=obs)

##################
# Example 4: KGElf for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' during computations.

KGElf(sim=sim, obs=obs, fun=log)

# Verifying the previous value:
lsim <- log(sim)
lobs <- log(obs)
KGElf(sim=lsim, obs=lobs)

##################
# Example 5: KGElf for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding the Pushpalatha2012 constant
#            during computations

KGElf(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012")

# Verifying the previous value, with the epsilon value following Pushpalatha2012
eps  <- mean(obs, na.rm=TRUE)/100
lsim <- log(sim+eps)
lobs <- log(obs+eps)
KGElf(sim=lsim, obs=lobs)

##################
# Example 6: KGElf for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and adding a user-defined constant
#            during computations

eps <- 0.01
KGElf(sim=sim, obs=obs, fun=log, epsilon.type="otherValue", epsilon.value=eps)

# Verifying the previous value:
lsim <- log(sim+eps)
lobs <- log(obs+eps)
KGElf(sim=lsim, obs=lobs)

##################
# Example 7: KGElf for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' and using a user-defined factor
#            to multiply the mean of the observed values to obtain the constant
#            to be added to 'sim' and 'obs' during computations

fact <- 1/50
KGElf(sim=sim, obs=obs, fun=log, epsilon.type="otherFactor", epsilon.value=fact)

# Verifying the previous value:
eps  <- fact*mean(obs, na.rm=TRUE)
lsim <- log(sim+eps)
lobs <- log(obs+eps)
KGElf(sim=lsim, obs=lobs)

##################
# Example 8: KGElf for simulated values equal to observations plus random noise 
#            on the first half of the observed values and applying a 
#            user-defined function to 'sim' and 'obs' during computations

fun1 <- function(x) {sqrt(x+1)}

KGElf(sim=sim, obs=obs, fun=fun1)

# Verifying the previous value, with the epsilon value following Pushpalatha2012
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
KGElf(sim=sim1, obs=obs1)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

%% File hydroGOF-package.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2009-2026 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{hydroGOF-package}
\Rdversion{1.1}
\alias{hydroGOF-package}
\alias{hydroGOF}
\docType{package}
\title{
Goodness-of-fit (GoF) functions for numerical and graphical comparison of simulated and observed time series, mainly focused on hydrological modelling.
}
\description{
S3 functions implementing both statistical and graphical goodness-of-fit measures between observed and simulated values, to be used during the calibration, validation, and application of hydrological models. \cr

Missing values in observed and/or simulated values can be removed before computations. \cr

}
\details{
\tabular{ll}{
Package: \tab hydroGOF\cr
Type: \tab Package\cr
Version: \tab 0.7-0\cr
Date: \tab 2026-04-30\cr
License: \tab GPL >= 2\cr
LazyLoad: \tab yes\cr
Packaged: \tab Thu Apr 30 14:31:35 -04 2026 ; MZB \cr
BuiltUnder: \tab R version 4.6.0 (2026-04-24) -- "Because it was There" ; aarch64-apple-darwin23 \cr
} 

Quantitative statistics included in this package are: 

  \tabular{ll}{
    \code{\link{me}}         Mean Error \cr
    \code{\link{mae}}        Mean Absolute Error \cr 
    \code{\link{mse}}        Mean Squared Error \cr
    \code{\link{rmse}}       Root Mean Square Error \cr
    \code{\link{ubRMSE}}     Unbiased Root Mean Square Error \cr
    \code{\link{nrmse}}      Normalized Root Mean Square Error \cr
    \code{\link{pbias}}      Percent Bias \cr
    \code{\link{rsr}}        Ratio of RMSE to the Standard Deviation of the Observations \cr
    \code{\link{rSD}}        Ratio of Standard Deviations \cr
    \code{\link{NSE}}        Nash-Sutcliffe Efficiency \cr
    \code{\link{mNSE}}       Modified Nash-Sutcliffe Efficiency \cr
    \code{\link{rNSE}}       Relative Nash-Sutcliffe Efficiency \cr
    \code{\link{wNSE}}       Weighted Nash-Sutcliffe Efficiency \cr
    \code{\link{wsNSE}}      Weighted Seasonal Nash-Sutcliffe Efficiency \cr
    \code{\link{d}}          Index of Agreement \cr
    \code{\link{dr}}         Refined Index of Agreement \cr
    \code{\link{md}}         Modified Index of Agreement  \cr
    \code{\link{rd}}         Relative Index of Agreement \cr
    \code{\link{cp}}         Persistence Index \cr
    \code{\link{rPearson}}   Pearson correlation coefficient  \cr
    \code{\link{R2}}         Coefficient of determination \cr
    \code{\link{br2}}        R2 multiplied by the coefficient of the regression line between \code{sim} and \code{obs} \cr
    \code{\link{VE}}         Volumetric efficiency  \cr
    \code{\link{KGE}}        Kling-Gupta efficiency \cr
    \code{\link{KGElf}}      Kling-Gupta Efficiency for low values \cr
    \code{\link{KGEnp}}      Non-parametric version of the Kling-Gupta Efficiency \cr
    \code{\link{KGEkm}}      Knowable Moments Kling-Gupta Efficiency \cr
    \code{\link{sKGE}}       Split Kling-Gupta Efficiency \cr
    \code{\link{JDKGE}}      Joint Divergence Kling-Gupta Efficiency \cr
    \code{\link{APFB}}       Annual Peak Flow Bias \cr
    \code{\link{HFB}}        High Flow Bias \cr
    \code{\link{LME}}        Liu-Mean Efficiency \cr
    \code{\link{LCE}}        Lee and Choi Efficiency \cr
    \code{\link{PMR}}        Proxy for Model Robustness \cr
    \code{\link{rSpearman}}  Spearman's rank correlation coefficient  \cr
    \code{\link{ssq}}        Sum of the Squared Residuals \cr
    \code{\link{pbiasfdc}}   PBIAS in the slope of the midsegment of the flow duration curve \cr
    \code{\link{pfactor}}    P-factor \cr
    \code{\link{rfactor}}    R-factor \cr
----------------------------------------------------------------------------------------------------------\cr
}
}
\author{
Mauricio Zambrano Bigiarini <mzb.devel@gmail.com>

Maintainer: Mauricio Zambrano Bigiarini <mzb.devel@gmail.com>
}
\references{
\cite{Abbaspour, K.C.; Faramarzi, M.; Ghasemi, S.S.; Yang, H. (2009), Assessing the impact of climate change on water resources in Iran, Water Resources Research, 45(10), W10,434, doi:10.1029/2008WR007615.}

\cite{Abbaspour, K.C., Yang, J. ; Maximov, I.; Siber, R.; Bogner, K.; Mieleitner, J. ; Zobrist, J.; Srinivasan, R. (2007), Modelling hydrology and water quality in the pre-alpine/alpine Thur watershed using SWAT, Journal of Hydrology, 333(2-4), 413-430, doi:10.1016/j.jhydrol.2006.09.014.}

\cite{Box, G.E. (1966). Use and abuse of regression. Technometrics, 8(4), 625-629. doi:10.1080/00401706.1966.10490407.}

\cite{Barrett, J.P. (1974). The coefficient of determination-some limitations. The American Statistician, 28(1), 19-20. doi:10.1080/00031305.1974.10479056.}

\cite{Chai, T.; Draxler, R.R. (2014). Root mean square error (RMSE) or mean absolute error (MAE)? - Arguments against avoiding RMSE in the literature, Geoscientific Model Development, 7, 1247-1250. doi:10.5194/gmd-7-1247-2014.}

\cite{Cinkus, G.; Mazzilli, N.; Jourde, H.; Wunsch, A.; Liesch, T.; Ravbar, N.; Chen, Z.; and Goldscheider, N. (2023). When best is the enemy of good - critical evaluation of performance criteria in hydrological models. Hydrology and Earth System Sciences 27, 2397-2411, doi:10.5194/hess-27-2397-2023.}

\cite{Criss, R. E.; Winston, W. E. (2008), Do Nash values have value? Discussion and alternate proposals. Hydrological Processes, 22: 2723-2725. doi:10.1002/hyp.7072.}

\cite{Entekhabi, D.; Reichle, R.H.; Koster, R.D.; Crow, W.T. (2010). Performance metrics for soil moisture retrievals and application requirements. Journal of Hydrometeorology, 11(3), 832-840. doi: 10.1175/2010JHM1223.1.}

\cite{Ficchi, A.; Bavera, D.; Grimaldi, S.; Moschini, F.; Pistocchi, A.; Russo, C.; Salamon, P.; Toreti, A. (2026). Improving low and high flow simulations at once: An enhanced metric for hydrological model calibrations. EGUsphere [preprint], https://doi.org/10.5194/egusphere-2026-43.}

\cite{Fowler, K.; Coxon, G.; Freer, J.; Peel, M.; Wagener, T.; Western, A.; Woods, R.; Zhang, L. (2018). Simulating runoff under changing climatic conditions: A framework for model improvement. Water Resources Research, 54(12), 812-9832. doi:10.1029/2018WR023989.}

\cite{Garcia, F.; Folton, N.; Oudin, L. (2017). Which objective function to calibrate rainfall-runoff models for low-flow index simulations?. Hydrological sciences journal, 62(7), 1149-1166. doi:10.1080/02626667.2017.1308511.}

\cite{Garrick, M.; Cunnane, C.; Nash, J.E. (1978). A criterion of efficiency for rainfall-runoff models. Journal of Hydrology 36, 375-381. doi:10.1016/0022-1694(78)90155-5.}

\cite{Gupta, H.V.; Kling, H.; Yilmaz, K.K.; Martinez, G.F. (2009). Decomposition of the mean squared error and NSE performance criteria: Implications for improving hydrological modelling. Journal of hydrology, 377(1-2), 80-91. doi:10.1016/j.jhydrol.2009.08.003. ISSN 0022-1694.}

\cite{Gupta, H.V.; Kling, H. (2011). On typical range, sensitivity, and normalization of Mean Squared Error and Nash-Sutcliffe Efficiency type metrics. Water Resources Research, 47(10). doi:10.1029/2011WR010962.}

\cite{Hahn, G.J. (1973). The coefficient of determination exposed. Chemtech, 3(10), 609-612. Aailable online at: \url{https://www2.hawaii.edu/~cbaajwe/Ph.D.Seminar/Hahn1973.pdf}.}

\cite{Hodson, T.O. (2022). Root-mean-square error (RMSE) or mean absolute error (MAE): when to use them or not, Geoscientific Model Development, 15, 5481-5487, doi:10.5194/gmd-15-5481-2022.}

\cite{Hundecha, Y., Bardossy, A. (2004). Modeling of the effect of land use changes on the runoff generation of a river basin through parameter regionalization of a watershed model. Journal of hydrology, 292(1-4), 281-295. doi:10.1016/j.jhydrol.2004.01.002.}

\cite{Kitanidis, P.K.; Bras, R.L. (1980). Real-time forecasting with a conceptual hydrologic model. 2. Applications and results. Water Resources Research, Vol. 16, No. 6, pp. 1034:1044. doi:10.1029/WR016i006p01034.} \cr

\cite{Kling, H.; Fuchs, M.; Paulin, M. (2012). Runoff conditions in the upper Danube basin under an ensemble of climate change scenarios. Journal of Hydrology, 424, 264-277, doi:10.1016/j.jhydrol.2012.01.011.}

\cite{Knoben, W.J.; Freer, J.E.; Woods, R.A. (2019). Inherent benchmark or not? Comparing Nash-Sutcliffe and Kling-Gupta efficiency scores. Hydrology and Earth System Sciences, 23(10), 4323-4331. doi:10.5194/hess-23-4323-2019.}

\cite{Krause, P.; Boyle, D.P.; Base, F. (2005). Comparison of different efficiency criteria for hydrological model assessment, Advances in Geosciences, 5, 89-97. doi:10.5194/adgeo-5-89-2005.} \cr

\cite{Krstic, G.; Krstic, N.S.; Zambrano-Bigiarini, M. (2016). The br2-weighting Method for Estimating the Effects of Air Pollution on Population Health. Journal of Modern Applied Statistical Methods, 15(2), 42. doi:10.22237/jmasm/1478004000}

\cite{Lee, J. S., & Choi, H. I. (2022). A rebalanced performance criterion for hydrological model calibration. Journal of Hydrology, 606, 127372. https://doi.org/10.1016/j.jhydrol.2021.127372}

\cite{Legates, D.R.; McCabe, G. J. Jr. (1999), Evaluating the Use of "Goodness-of-Fit" Measures in Hydrologic and Hydroclimatic Model Validation, Water Resour. Res., 35(1), 233-241. doi:10.1029/1998WR900018.} 

\cite{Ling, X.; Huang, Y.; Guo, W.; Wang, Y.; Chen, C.; Qiu, B.; Ge, J.; Qin, K.; Xue, Y.; Peng, J. (2021). Comprehensive evaluation of satellite-based and reanalysis soil moisture products using in situ observations over China. Hydrology and Earth System Sciences, 25(7), 4209-4229. doi:10.5194/hess-25-4209-2021.}

\cite{Liu, D.; Chen, X.; Lian, Y.; Lou, Z. (2020). A new performance measure for hydrologic models. Journal of Hydrology, 590, 125488. doi:10.1016/j.jhydrol.2020.125488.}

\cite{Mizukami, N.; Rakovec, O.; Newman, A.J.; Clark, M.P.; Wood, A.W.; Gupta, H.V.; Kumar, R.: (2019). On the choice of calibration metrics for "high-flow" estimation using hydrologic models, Hydrology Earth System Sciences 23, 2601-2614, doi:10.5194/hess-23-2601-2019.}

\cite{Moriasi, D.N.; Arnold, J.G.; van Liew, M.W.; Bingner, R.L.; Harmel, R.D.; Veith, T.L. (2007). Model evaluation guidelines for systematic quantification of accuracy in watershed simulations. Transactions of the ASABE. 50(3):885-900}

\cite{Nash, J.E. and Sutcliffe, J.V. (1970). River flow forecasting through conceptual models. Part 1: a discussion of principles, Journal of Hydrology 10, pp. 282-290. doi:10.1016/0022-1694(70)90255-6.}

\cite{Pearson, K. (1920). Notes on the history of correlation. Biometrika, 13(1), 25-45. doi:10.2307/2331722.}

\cite{Pfannerstill, M.; Guse, B.; Fohrer, N. (2014). Smart low flow signature metrics for an improved overall performance evaluation of hydrological models. Journal of Hydrology, 510, 447-458. doi:10.1016/j.jhydrol.2013.12.044.} 

\cite{Pizarro, A.; Jorquera, J. (2024). Advancing objective functions in hydrological modelling: Integrating knowable moments for improved simulation accuracy. Journal of Hydrology, 634, 131071. doi:10.1016/j.jhydrol.2024.131071.}

\cite{Pool, S.; Vis, M.; Seibert, J. (2018). Evaluating model performance: towards a non-parametric variant of the Kling-Gupta efficiency. Hydrological Sciences Journal, 63(13-14), pp.1941-1953. doi:/10.1080/02626667.2018.1552002.}

\cite{Pushpalatha, R.; Perrin, C.; Le Moine, N.; Andreassian, V. (2012). A review of efficiency criteria suitable for evaluating low-flow simulations. Journal of Hydrology, 420, 171-182. doi:10.1016/j.jhydrol.2011.11.055.}  

\cite{Royer-Gaspard, P., Andreassian, V., and Thirel, G. (2021). Technical note: PMR - a proxy metric to assess hydrological model robustness in a changing climate. Hydrology and Earth System Sciences, 25, 5703--5716. doi:10.5194/hess-25-5703-2021.}

\cite{Santos, L.; Thirel, G.; Perrin, C. (2018). Pitfalls in using log-transformed flows within the KGE criterion. doi:10.5194/hess-22-4583-2018.}

\cite{Schaefli, B., Gupta, H. (2007). Do Nash values have value?. Hydrological Processes 21, 2075-2080. doi:10.1002/hyp.6825.}

\cite{Schober, P.; Boer, C.; Schwarte, L.A. (2018). Correlation coefficients: appropriate use and interpretation. Anesthesia and Analgesia, 126(5), 1763-1768. doi:10.1213/ANE.0000000000002864.}

\cite{Schuol, J.; Abbaspour, K.C.; Srinivasan, R.; Yang, H. (2008b), Estimation of freshwater availability in the West African sub-continent using the SWAT hydrologic model, Journal of Hydrology, 352(1-2), 30, doi:10.1016/j.jhydrol.2007.12.025}

\cite{Sorooshian, S., Q. Duan, and V. K. Gupta. (1993). Calibration of rainfall-runoff models: Application of global optimization to the Sacramento Soil Moisture Accounting Model, Water Resources Research, 29 (4), 1185-1194, doi:10.1029/92WR02617}.

\cite{Spearman, C. (1961). The Proof and Measurement of Association Between Two Things. In J. J. Jenkins and D. G. Paterson (Eds.), Studies in individual differences: The search for intelligence (pp. 45-58). Appleton-Century-Crofts. doi:10.1037/11491-005}

\cite{Tang, G.; Clark, M.P.; Papalexiou, S.M. (2021). SC-earth: a station-based serially complete earth dataset from 1950 to 2019. Journal of Climate, 34(16), 6493-6511. doi:10.1175/JCLI-D-21-0067.1.}

\cite{Yapo P.O.; Gupta H.V.; Sorooshian S. (1996). Automatic calibration of conceptual rainfall-runoff models: sensitivity to calibration data. Journal of Hydrology. v181 i1-4. 23-48. doi:10.1016/0022-1694(95)02918-4}

\cite{Yilmaz, K.K., Gupta, H.V. ; Wagener, T. (2008), A process-based diagnostic approach to model evaluation: Application to the NWS distributed hydrologic model, Water Resources Research, 44, W09417, doi:10.1029/2007WR006716.}

\cite{Willmott, C.J. (1981). On the validation of models. Physical Geography, 2, 184--194. doi:10.1080/02723646.1981.10642213.}

\cite{Willmott, C.J. (1984). On the evaluation of model performance in physical geography. Spatial Statistics and Models, G. L. Gaile and C. J. Willmott, eds., 443-460. doi:10.1007/978-94-017-3048-8_23.}

\cite{Willmott, C.J.; Ackleson, S.G. Davis, R.E.; Feddema, J.J.; Klink, K.M.; Legates, D.R.; O'Donnell, J.; Rowe, C.M. (1985), Statistics for the Evaluation and Comparison of Models, J. Geophys. Res., 90(C5), 8995-9005. doi:10.1029/JC090iC05p08995.}

\cite{Willmott, C.J.; Matsuura, K. (2005). Advantages of the mean absolute error (MAE) over the root mean square error (RMSE) in assessing average model performance, Climate Research, 30, 79-82, doi:10.3354/cr030079.}

\cite{Willmott, C.J.; Matsuura, K.; Robeson, S.M. (2009). Ambiguities inherent in sums-of-squares-based error statistics, Atmospheric Environment, 43, 749-752, doi:10.1016/j.atmosenv.2008.10.005.}

\cite{Willmott, C.J.; Robeson, S.M.; Matsuura, K. (2012). A refined index of model performance. International Journal of climatology, 32(13), pp.2088-2094. doi:10.1002/joc.2419.}

\cite{Willmott, C.J.; Robeson, S.M.; Matsuura, K.; Ficklin, D.L. (2015). Assessment of three dimensionless measures of model performance. Environmental Modelling & Software, 73, pp.167-174. doi:10.1016/j.envsoft.2015.08.012}

\cite{Zambrano-Bigiarini, M.; Bellin, A. (2012). Comparing goodness-of-fit measures for calibration of models focused on extreme events. EGU General Assembly 2012, Vienna, Austria, 22-27 Apr 2012, EGU2012-11549-1.}

\cite{Zambrano-Bigiarini, Mauricio (2024). hydroGOF: Goodness-of-fit functions for comparison of simulated and observed hydrological time series. doi:10.5281/zenodo.839854, R package version 0.6-0.1 . doi:10.5281/zenodo.839854, https://cran.r-project.org/package=hydroGOF. }

}
%%~~ Optionally other standard keywords, one per line, from file KEYWORDS in the R documentation directory ~~
\keyword{ package }
\seealso{

\url{https://CRAN.R-project.org/package=hydroPSO} \cr
\url{https://CRAN.R-project.org/package=hydroTSM}
}
\examples{
obs <- 1:100
sim <- obs

# Numerical goodness of fit
gof(sim,obs)

# Reverting the order of simulated values
sim <- 100:1
gof(sim,obs)

\dontrun{
ggof(sim, obs)
}

##################
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
require(zoo)
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Generating a simulated daily time series, initially equal to observations
sim <- obs 

# Getting the numeric goodness-of-fit measures for the "best" (unattainable) case
gof(sim=sim, obs=obs)

# Randomly changing the first 2000 elements of 'sim', by using a normal 
# distribution  with mean 10 and standard deviation equal to 1 (default of 'rnorm').
sim[1:2000] <- obs[1:2000] + rnorm(2000, mean=10)

# Getting the new numeric goodness of fit
gof(sim=sim, obs=obs)

# Graphical representation of 'obs' vs 'sim', along with the numeric 
# goodness-of-fit measures
\dontrun{
ggof(sim=sim, obs=obs)
}
}

%% File HFB.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ; 
%%                                 https://cran.r-project.org/package=hydroGOF
%%                                 http://www.rforge.net/hydroGOF/
%% Copyright 2024-2026 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{HFB}
\Rdversion{1.1}
\alias{HFB}
\alias{HFB.default}
\alias{HFB.matrix}
\alias{HFB.data.frame}
\alias{HFB.zoo}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Median annual high-flow bias
}
\description{

Median annual high-flow bias between \code{sim} and \code{obs}, with treatment of missing values and explicit focus on the reproduction of high-flow events.

This function is designed to identify differences in high values. See Details.
}
\usage{
HFB(sim, obs, ...)

\method{HFB}{default}(sim, obs, na.rm=TRUE, 
             hQ.thr=0.1, start.month=1, out.PerYear=FALSE,
             fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)

\method{HFB}{data.frame}(sim, obs, na.rm=TRUE, 
             hQ.thr=0.1, start.month=1, out.PerYear=FALSE,
             fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)

\method{HFB}{matrix}(sim, obs, na.rm=TRUE, 
             hQ.thr=0.1, start.month=1, out.PerYear=FALSE,
             fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)
             
\method{HFB}{zoo}(sim, obs, na.rm=TRUE, 
             hQ.thr=0.1, start.month=1, out.PerYear=FALSE,
             fun=NULL, ...,
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"), 
             epsilon.value=NA)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sim}{
numeric, zoo, matrix or data.frame with simulated values
}
  \item{obs}{
numeric, zoo, matrix or data.frame with observed values
}
  \item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
When an 'NA' value is found at the i-th position in \code{obs} \bold{OR} \code{sim}, the i-th value of \code{obs} \bold{AND} \code{sim} are removed before the computation.
}
  \item{hQ.thr}{
numeric, representing the exceedence probabiliy used to identify high flows in \code{obs}. All values in \code{obs} that are equal or higher than \code{quantile(obs, probs=(1-hQ.thr))} are considered as high flows. By default \code{hQ.thr=0.1}. \cr
On the other hand, the high values in \code{sim} are those located at the same i-th position than the i-th value of the \code{obs} deemed as high flows. 
}
  \item{start.month}{
[OPTIONAL]. Only used when the (hydrological) year of interest is different from the calendar year.

numeric in [1:12] indicating the starting month of the (hydrological) year. Numeric values in [1, 12] represent months in [January, December]. By default \code{start.month=1}.
}
  \item{out.PerYear}{
logical, indicating whether the output of this function has to include the median annual high-flows bias obtained for the individual years in \code{sim} and \code{obs} or not.
}
  \item{fun}{
function to be applied to \code{sim} and \code{obs} in order to obtain transformed values thereof before computing this goodness-of-fit index.

The first argument MUST BE a numeric vector with any name (e.g., \code{x}), and additional arguments are passed using \code{\dots}.
}
  \item{\dots}{
arguments passed to \code{fun}, in addition to the mandatory first numeric vector.
}
  \item{epsilon.type}{
argument used to define a numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. 

It is was  designed to allow the use of logarithm and other similar functions that do not work with zero values.

Valid values of \code{epsilon.type} are:

1) \kbd{"none"}: \code{sim} and \code{obs} are used by \code{fun} without the addition of any numeric value. This is the default option.

2) \kbd{"Pushpalatha2012"}: one hundredth (1/100) of the mean observed values is added to both \code{sim} and \code{obs} before applying \code{fun}, as described in Pushpalatha et al. (2012). 

3) \kbd{"otherFactor"}: the numeric value defined in the \code{epsilon.value} argument is used to multiply the the mean observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs}, before applying \code{fun}.

4) \kbd{"otherValue"}: the numeric value defined in the \code{epsilon.value} argument is directly added to both \code{sim} and \code{obs}, before applying \code{fun}.
}
  \item{epsilon.value}{

 -) when \code{epsilon.type="otherValue"} it represents the numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. \cr

 -) when \code{epsilon.type="otherFactor"} it represents the numeric factor used to multiply the mean of the observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs} before applying \code{fun}.

}
}

\details{

The median annual high-flow bias (HFB) is a goodness-of-fit metric designed to support the calibration and evaluation of hydrological models with specific 
emphasis on the reproduction of high-flow conditions.

The HFB ranges from 0 to \kbd{Inf}, with an optimal value of \kbd{0}. Values close to 0 indicate that the simulated high flows closely match the observed high flows, whereas larger values indicate increasing discrepancies between the simulated and observed high-flow magnitudes.

The current formulation of the HFB function was proposed by Zambrano-Bigiarini (2026), inspired by the annual peak-flow bias (APFB) objective function proposed by Mizukami et al. (2019). However, HFB differs from APFB in four important aspects:

1) Instead of considering only the single observed annual peak flow in each year, it considers all high flows in each year, where "high flows" are defined as all values equal to or greater than a user-defined exceedance probability threshold of the observed values. By default, high flows correspond to the upper 10\% of observed flows (i.e., \code{hQ.thr=0.1}).

2) Instead of selecting simulated high flows independently of the observed events, it evaluates simulated flows occurring at the same time steps as the observed high flows, thereby preserving temporal correspondence between observed and simulated events.

3) For each year, the metric uses the median of the individual high-flow ratios rather than a single annual peak-flow value, providing a more robust summary of high-flow bias within that year.

4) When computing the final performance value, the metric uses the median of the annual values instead of the mean, reducing the influence of extreme years and improving robustness when the distribution of annual biases is asymmetric.

Mathematically, the annual high-flow bias for year \eqn{y} is defined as:

\deqn{
HFB_y = \sqrt{\left(\frac{\operatorname{median}(Q^{sim}_{y,i})}{\operatorname{median}(Q^{obs}_{y,i})} - 1\right)^2}
}

where \eqn{Q^{sim}_{y,i}} and \eqn{Q^{obs}_{y,i}} are the simulated and observed flows corresponding to the set of high-flow events \eqn{i} occurring in year \eqn{y}.

The overall HFB value is then computed as:

\deqn{
HFB = \operatorname{median}(HFB_y)
}

This formulation yields a non-negative bias metric, with the minimum value of 0 representing perfect agreement between simulated and observed high flows.
}

\value{
If \code{out.PerYear=FALSE}: numeric with the median annual high-flow bias between \code{sim} and \code{obs}. If \code{sim} and \code{obs} are matrices, the output value is a vector, with the high-flow bias between each column of \code{sim} and \code{obs}.

If \code{out.PerYear=TRUE}: a list of two elements:
\item{HFB.value}{
numeric with the median annual high flow bias between \code{sim} and \code{obs}. If \code{sim} and \code{obs} are matrices, the output value is a vector, with the median annual high flow bias between each column of \code{sim} and \code{obs}.
}
\item{HFB.PerYear}{
-) If \code{sim} and \code{obs} are not data.frame/matrix, the output is numeric, with the median high flow bias obtained for the individual years between \code{sim} and \code{obs}. 

-) If \code{sim} and \code{obs} are data.frame/matrix, this output is a data.frame, with the median high flow bias obtained for the individual years between \code{sim} and \code{obs}. 
}
}
\references{

\cite{Zambrano-Bigiarini, Mauricio (2026). hydroGOF: Goodness-of-fit functions for comparison of simulated and observed hydrological time series. R package version 0.7-0. URL:https://cran.r-project.org/package=hydroGOF. doi:10.32614/CRAN.package.hydroGOF.}

\cite{Mizukami, N.; Rakovec, O.; Newman, A.J.; Clark, M.P.; Wood, A.W.; Gupta, H.V.; Kumar, R.: (2019). On the choice of calibration metrics for "high-flow" estimation using hydrologic models, Hydrology Earth System Sciences 23, 2601-2614, doi:10.5194/hess-23-2601-2019.}

}
\author{
Mauricio Zambrano-Bigiarini <mzb.devel@gmail.com>
}
\note{
\code{obs} and \code{sim} has to have the same length/dimension \cr

The missing values in \code{obs} and \code{sim} are removed before the computation proceeds, and only those positions with non-missing values in \code{obs} and \code{sim} are considered in the computation
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{APFB}}, \code{\link{NSE}}, \code{\link{wNSE}}, \code{\link{wsNSE}}, \code{\link{JDKGE}}, \code{\link{PMR}}, \code{\link{gof}}, \code{\link{ggof}}
}
\examples{
##################
# Example 1: Looking at the difference between 'NSE', 'wNSE', and 'HFB'
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Simulated daily time series, created equal to the observed values and then 
# random noise is added only to high flows, i.e., those equal or higher than 
# the quantile 0.9 of the observed values.
sim      <- obs
hQ.thr   <- quantile(obs, probs=0.9, na.rm=TRUE)
hQ.index <- which(obs >= hQ.thr)
hQ.n     <- length(hQ.index)
sim[hQ.index] <- sim[hQ.index] + rnorm(hQ.n, mean=mean(sim[hQ.index], na.rm=TRUE))

# Traditional Nash-Sutcliffe eficiency
NSE(sim=sim, obs=obs)

# Weighted Nash-Sutcliffe efficiency (Hundecha and Bardossy, 2004)
wNSE(sim=sim, obs=obs)

# HFB (Garcia et al., 2017):
HFB(sim=sim, obs=obs)

##################
# Example 2: 
# Loading daily streamflows of the Ega River (Spain), from 1961 to 1970
data(EgaEnEstellaQts)
obs <- EgaEnEstellaQts

# Generating a simulated daily time series, initially equal to the observed series
sim <- obs 

# Computing the 'HFB' for the "best" (unattainable) case
HFB(sim=sim, obs=obs)

##################
# Example 3: HFB for simulated values created equal to the observed values and then 
#            random noise is added only to high flows, i.e., those equal or higher than 
#            the quantile 0.9 of the observed values.

sim           <- obs
hQ.thr        <- quantile(obs, hQ.thr=0.9, na.rm=TRUE)
hQ.index      <- which(obs >= hQ.thr)
hQ.n          <- length(hQ.index)
sim[hQ.index] <- sim[hQ.index] + rnorm(hQ.n, mean=mean(sim[hQ.index], na.rm=TRUE))
ggof(sim, obs)

HFB(sim=sim, obs=obs)

##################
# Example 4: HFB for simulated values created equal to the observed values and then 
#            random noise is added only to high flows, i.e., those equal or higher than 
#            the quantile 0.9 of the observed values and applying (natural) 
#            logarithm to 'sim' and 'obs' during computations.

HFB(sim=sim, obs=obs, fun=log)

# Verifying the previous value:
lsim <- log(sim)
lobs <- log(obs)
HFB(sim=lsim, obs=lobs)


##################
# Example 5: HFB for simulated values created equal to the observed values and then 
#            random noise is added only to high flows, i.e., those equal or higher than 
#            the quantile 0.9 of the observed values and applying a 
#            user-defined function to 'sim' and 'obs' during computations

fun1 <- function(x) {sqrt(x+1)}

HFB(sim=sim, obs=obs, fun=fun1)

# Verifying the previous value
sim1 <- sqrt(sim+1)
obs1 <- sqrt(obs+1)
HFB(sim=sim1, obs=obs1)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ math }

%% File LCE.Rd
%% Part of the hydroGOF R package, https://github.com/hzambran/hydroGOF ;
%% https://cran.r-project.org/package=hydroGOF
%% http://www.rforge.net/hydroGOF/
%% Copyright 2026-2026 Mauricio Zambrano-Bigiarini
%% Distributed under GPL 2 or later

\name{LCE}
\Rdversion{1.1}
\alias{LCE}
\alias{LCE.default}
\alias{LCE.matrix}
\alias{LCE.data.frame}
\alias{LCE.zoo}

\title{
Lee and Choi Efficiency
}

\description{
Lee and Choi Efficiency between \code{sim} and \code{obs}, with treatment of missing values.

This goodness-of-fit measure was proposed by Lee and Choi (2022) as an alternative to the Liu-Mean Efficiency (LME), designed to provide a multi-dimensional and diagnostically balanced evaluation of model performance; by jointly considering correlation, variability and bias; whereas LME is fundamentally a single-error-based metric.   

Unlike some single-error-based criteria, LCE explicitly combines the correlation coefficient and the variability ratio through two complementary terms, \code{r*Alpha} and \code{r/Alpha}, in order to penalize inconsistent representations of timing and variability.

For a short description of its components and the numeric range of values, please see Details.
}

\usage{
LCE(sim, obs, ...)

\method{LCE}{default}(sim, obs, na.rm=TRUE, out.type=c("single", "full"),
             fun=NULL, ..., 
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"),
             epsilon.value=NA)

\method{LCE}{data.frame}(sim, obs, na.rm=TRUE, out.type=c("single", "full"),
             fun=NULL, ..., 
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"),
             epsilon.value=NA)

\method{LCE}{matrix}(sim, obs, na.rm=TRUE, out.type=c("single", "full"),
             fun=NULL, ..., 
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"),
             epsilon.value=NA)

\method{LCE}{zoo}(sim, obs, na.rm=TRUE, out.type=c("single", "full"),
             fun=NULL, ..., 
             epsilon.type=c("none", "Pushpalatha2012", "otherFactor", "otherValue"),
             epsilon.value=NA)
}

\arguments{
\item{sim}{
numeric, zoo, matrix or data.frame with simulated values
}
\item{obs}{
numeric, zoo, matrix or data.frame with observed values
}
\item{na.rm}{
a logical value indicating whether 'NA' should be stripped before the computation proceeds. \cr
When an 'NA' value is found at the i-th position in \code{obs} \bold{OR} \code{sim}, the i-th value of \code{obs} \bold{AND} \code{sim} are removed before the computation.
}
\item{out.type}{
character, indicating whether the output of the function has to include each one of the terms used in the computation of the Lee and Choi Efficiency or not. Valid values are:

-) \kbd{single}: the output is a numeric with the Lee and Choi Efficiency only.

-) \kbd{full}: the output is a list of two elements: the first one with the Lee and Choi Efficiency, and the second is a numeric with 5 elements: the Pearson product-moment correlation coefficient (\sQuote{r}), the variability ratio (\sQuote{Alpha}), the bias ratio (\sQuote{Beta}), the product between correlation and variability (\sQuote{rAlpha}), and the ratio between correlation and variability (\sQuote{rOverAlpha}).
}
\item{fun}{
function to be applied to \code{sim} and \code{obs} in order to obtain transformed values thereof before computing the Lee and Choi Efficiency.

The first argument MUST BE a numeric vector with any name (e.g., \code{x}), and additional arguments are passed using \code{\dots}.
}
\item{\dots}{
arguments passed to \code{fun}, in addition to the mandatory first numeric vector.
}
\item{epsilon.type}{
argument used to define a numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}.

It was designed to allow the use of logarithm and other similar functions that do not work with zero values.

Valid values of \code{epsilon.type} are:

1) \kbd{"none"}: \code{sim} and \code{obs} are used by \code{fun} without the addition of any numeric value.

2) \kbd{"Pushpalatha2012"}: one hundredth (1/100) of the mean observed values is added to both \code{sim} and \code{obs} before applying \code{fun}, as described in Pushpalatha et al. (2012).

3) \kbd{"otherFactor"}: the numeric value defined in the \code{epsilon.value} argument is used to multiply the mean observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs}, before applying \code{fun}.

4) \kbd{"otherValue"}: the numeric value defined in the \code{epsilon.value} argument is directly added to both \code{sim} and \code{obs}, before applying \code{fun}.
}
\item{epsilon.value}{
-) when \code{epsilon.type="otherValue"} it represents the numeric value to be added to both \code{sim} and \code{obs} before applying \code{fun}. \cr
-) when \code{epsilon.type="otherFactor"} it represents the numeric factor used to multiply the mean of the observed values, instead of the one hundredth (1/100) described in Pushpalatha et al. (2012). The resulting value is then added to both \code{sim} and \code{obs} before applying \code{fun}.
}
}

\details{
In the computation of this index, there are three main diagnostic components involved:

1) \kbd{r} : the Pearson product-moment correlation coefficient. Ideal value is r=1.

2) \kbd{Alpha} : the variability ratio, defined as the ratio between the standard deviation of the simulated values and the standard deviation of the observed ones. Ideal value is Alpha=1.

3) \kbd{Beta} : the bias ratio, defined as the ratio between the mean of the simulated values and the mean of the observed ones. Ideal value is Beta=1.

The Lee and Choi Efficiency combines these terms through two additional correlation-variability components:

\deqn{r\alpha}

and

\deqn{r/\alpha}

Both terms have an ideal value of 1. The first term, \eqn{r\alpha}, penalizes cases where the combined effect of correlation and variability is inconsistent with the observed dynamics. The second term, \eqn{r/\alpha}, penalizes the opposite imbalance between correlation and variability. Together, these two terms make LCE sensitive to compensating errors between timing and dispersion.

Lee and Choi efficiencies range from -Inf to 1. Essentially, the closer to 1, the more similar \code{sim} and \code{obs} are in terms of timing, variability and bias.

\deqn{LCE = 1 - ED}

\deqn{
ED = \sqrt{ (r\alpha - 1)^2 + (r/\alpha - 1)^2 + (\beta - 1)^2 }
}

where:

\deqn{r=Pearson product-moment correlation coefficient}

\deqn{\alpha=\sigma_s/\sigma_o}

\deqn{\beta=\mu_s/\mu_o}

\deqn{r\alpha=r\times\alpha}

\deqn{r/\alpha=r/\alpha}

where \eqn{\mu_s} and \eqn{\mu_o} are the mean simulated and observed values, respectively, and \eqn{\sigma_s} and \eqn{\sigma_o} are their corresponding standard deviations.

A value of \kbd{LCE=1} indicates perfect agreement between simulated and observed values. Values close to 1 indicate strong agreement across correlation, variability and bias, whereas negative values indicate progressively poorer model performance.
}

\value{
If \code{out.type=single}: numeric with the Lee and Choi Efficiency between \code{sim} and \code{obs}. If \code{sim} and \code{obs} are matrices, the output value is a vector, with the Lee and Choi Efficiency between each column of \code{sim} and \code{obs}.

If \code{out.type=full}: a list of two elements:
\item{LCE.value}{
numeric with the Lee and Choi Efficiency. If \code{sim} and \code{obs} are matrices, the output value is a vector, with the Lee and Choi Efficiency between each column of \code{sim} and \code{obs}
}
\item{LCE.elements}{
numeric with 5 elements: the Pearson product-moment correlation coefficient (\sQuote{r}), the variability ratio (\sQuote{Alpha}), the bias ratio (\sQuote{Beta}), the product between correlation and variability (\sQuote{rAlpha}), and the ratio between correlation and variability (\sQuote{rOverAlpha}). If \code{sim} and \code{obs} are matrices, the output value is a matrix, with the previous five elements computed for each column of \code{sim} and \code{obs}\cr
}
}

\references{
\cite{Lee, J. S., & Choi, H. I. (2022). A rebalanced performance criterion for hydrological model calibration. Journal of Hydrology, 606, 127372. https://doi.org/10.1016/j.jhydrol.2021.127372}

\cite{Liu, D. (2020). A rational performance criterion for hydrological model. Journal of Hydrology, 590, 125488. https://doi.org/10.1016/j.jhydrol.2020.125488}

\cite{Choi, H. I. (2021). Comment on Liu (2020): A rational performance criterion for hydrological model. Journal of Hydrology, 606, 126927. https://doi.org/10.1016/j.jhydrol.2021.126927}

\cite{Liu, D. (2021). Reply to "Comment on Liu (2020): A rational performance criterion for a hydrological model" by HyunIl Choi. Journal of Hydrology, 603, 126935. https://doi.org/10.1016/j.jhydrol.2021.126927}

\cite{Gupta, H.V.; Kling, H.; Yilmaz, K.K.; Martinez, G.F. (2009). Decomposition of the mean squared error and NSE performance criteria: Implications for improving hydrological modelling. Journal of Hydrology, 377(1-2), 80-91. doi:10.1016/j.jhydrol.2009.08.003.}

\cite{Pushpalatha, R.; Perrin, C.; Le Moine, N.; Andreassian, V. (2012). A review of efficiency criteria suitable for evaluating low-flow simulations. Journal of Hydrology, 420-421, 171-182. doi:10.1016/j.jhydrol.2011.11.055.}
}

\author{
Mauricio Zambrano-Bigiarini <mzb.devel@gmail.com>
}

\note{
\code{obs} and \code{sim} have to have the same length/dimension \cr

The missing values in \code{obs} and \code{sim} are removed before the computation proceeds, and only those positions with non-missing values in \code{obs} and \code{sim} are considered in the computation.
}

\seealso{
\code{\link{LME}}, \code{\link{KGE}}, \code{\link{NSE}}, \code{\link{gof}}, \code{\link{ggof}}
}

\examples{
# Example1: basic ideal case
obs <- 1:10
sim <- 1:10
LCE(sim, obs)

obs <- 1:10
sim <- 2:11
LCE(sim, obs)

##################
# Example2: simulated values equal to observations plus random noise

set.seed(123)
obs <- 1:100
sim <- obs + rnorm(100, mean=0, sd=5)

LCE(sim=sim, obs=obs)

LCE(sim=sim, obs=obs, out.type="full")

##################
# Example3: applying logarithmic transformation

LCE(sim=sim, obs=obs, fun=log)

##################
# Example4: applying logarithmic transformation with Pushpalatha constant

LCE(sim=sim, obs=obs, fun=log, epsilon.type="Pushpalatha2012")

}
\keyword{ math }
